com_msomics_ms_app(/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 	};
/******/
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		"app": 0
/******/ 	};
/******/
/******/
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "" + chunkId + "." + "f8d7769117c034d4fdbf" + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var head = document.getElementsByTagName('head')[0];
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							var error = new Error('Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')');
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/bundledApps/com.msomics/ms_app/";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["webpackJsonpcom_msomics_ms_app"] = window["webpackJsonpcom_msomics_ms_app"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "../apps/module/ms_app/src/data-loaders/data-loader-demo-ms-hits.ts":
/*!**************************************************************************!*\
  !*** ../apps/module/ms_app/src/data-loaders/data-loader-demo-ms-hits.ts ***!
  \**************************************************************************/
/*! exports provided: DataLoaderDemoMSHits */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataLoaderDemoMSHits", function() { return DataLoaderDemoMSHits; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");




let DataLoaderDemoMSHits = class DataLoaderDemoMSHits {
    constructor(server) {
        this.server = server;
    }
    init(context) {
        this.context = context;
    }
    entitiesView() {
        return `
<template>
    <h1>Loading MS Hits</h1>
    <div class="view-group">
        <label>Step</label>
        <p><a href='/#/entity/step/\${step.id}'>\${step.name}</a></p>
    </div>

    <template if.bind="samplesWithoutResults.length > 0">
        <h3>The file did not contain results for these samples:</h3>
        <ul>
            <li repeat.for="s of samplesWithoutResults"><a href='/#/entity/sample/\${s.id}'>\${s.name}</a></li>
        </ul>
    </template>

    <div class="view-group">
        <label>Hits</label>
        <table>
            <thead>
                <tr>
                    <th>Sample</th>
                    <th repeat.for="hitNo of hitNos">\${hits[hitNo].CompoundID}</th>
                    <th>Check</th>
                </tr>
            </thead>
            <tbody>
                <tr repeat.for="sampleID of sampleIDs">
                    <th>\${sampleID}</th>
                    <td repeat.for="hitNo of hitNos">
                        \${quantities[sampleID][hitNo] | significant}<br/>
                        \${areas[sampleID][hitNo] | significant}
                    </td>
                    <td>\${sampleCheck(sampleID)}</td>
                </tr>
            </tbody>
        </table>
    </div>
</template>`;
    }
    readFiles() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let fi = this.context.fileInfos[0];
            let match = /^Hits((MS|ST)\d+)/.exec(fi.filename);
            if (!match)
                throw Error('Invalid filename: ' + fi.filename);
            let stepName = match[1];
            if (this.dataset)
                return;
            this.dataset = yield this.server.datasetQuery([
                { eClass: 'Step', alias: 'step', filters: [{ field: 'Name', value: stepName }] },
                { eClass: 'Sample', collection: 'samples', filters: [{ field: 'OriginID', value: '$step.ID' }] }
            ]);
            this.samples = this.dataset.samples;
            this.step = this.dataset.step;
            this.getResult();
        });
    }
    getResult() {
        return this.process(this.context.fileInfos[0], this.dataset);
    }
    process(fi, dataset) {
        this.readHits(fi.wb.Sheets['MSHits']);
        if (fi.wb.Sheets.Area)
            this.areas = this.readMatrix(fi.wb.Sheets.Area);
        if (fi.wb.Sheets.Quantity)
            this.quantities = this.readMatrix(fi.wb.Sheets.Quantity);
        this.samplesWithoutResults = this.samples.filter(s => !this.quantities[s.id] && !this.areas[s.id]);
        return { entities: this.createEntities() };
    }
    sampleCheck(sampleID) {
        if (!this.samples.find(s => s.id === sampleID))
            return 'Sample not in step';
    }
    createEntities() {
        let entities = [{
                eClass: 'ResultSet',
                id: '#idRS',
                type: this.step.type,
                originID: this.step.id
            }];
        for (let hitNo in this.hits) {
            let hit = this.hits[hitNo];
            entities.push(hit);
            for (let sample of this.samples) {
                let quantity = {
                    eClass: 'ResultMSQuantity',
                    hitID: '#idHit' + hitNo,
                    sampleID: sample.id,
                    resultSetID: '#idRS',
                    type: this.step.type
                };
                let hasResult = false;
                if (this.areas && this.areas[sample.id]) {
                    quantity.area = this.areas[sample.id][hitNo];
                    hasResult = true;
                }
                if (this.quantities && this.quantities[sample.id]) {
                    let q = this.quantities[sample.id][hitNo];
                    if (typeof q === 'string')
                        quantity.quantityText = q.substring(0, 10);
                    else
                        quantity.quantityText = q.toString().substring(0, 10);
                    if (typeof q === 'number')
                        quantity.quantity = q;
                    hasResult = true;
                }
                if (hasResult)
                    entities.push(quantity);
            }
        }
        return entities;
    }
    readHits(ws) {
        let colTitles = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].readColTitles(ws, 3);
        let xlrowMax = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].getXlrowMax(ws);
        this.hits = [];
        this.hitNos = [];
        for (let xlrow = 4; xlrow <= xlrowMax; xlrow++) {
            if (!ws['A' + xlrow])
                break;
            let hitNo = ws['A' + xlrow].w;
            let hit = {
                eClass: 'ResultMSHit',
                id: '#idHit' + hitNo,
                resultSetID: '#idRS'
            };
            for (let iCol = 1; iCol < colTitles.length; iCol++) {
                if (colTitles[iCol] === 'Name')
                    continue;
                let cell = ws[_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].ColNames[iCol] + xlrow];
                if (cell)
                    hit[colTitles[iCol]] = cell.v;
            }
            this.hits[hitNo] = hit;
            this.hitNos.push(hitNo);
        }
    }
    readMatrix(ws) {
        let colTitles = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].readColTitles(ws, 3);
        let xlrowMax = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].getXlrowMax(ws);
        let sampleIDSet = new Set();
        let matrix = {};
        for (let xlrow = 4; xlrow <= xlrowMax; xlrow++) {
            if (!ws['A' + xlrow])
                break;
            let sampleID = ws['A' + xlrow].v;
            sampleIDSet.add(sampleID);
            matrix[sampleID] = {};
            for (let iCol = 1; iCol < colTitles.length; iCol++) {
                let hitNo = ws[_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].ColNames[iCol] + '3'].w;
                if (ws[_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].ColNames[iCol] + xlrow]) {
                    matrix[sampleID][hitNo] = ws[_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].ColNames[iCol] + xlrow].v;
                }
            }
        }
        this.sampleIDs = Array.from(sampleIDSet);
        return matrix;
    }
};
DataLoaderDemoMSHits = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__["scifeonPlugin"])({
        name: 'DataLoaderDemoMSHits',
        description: 'Import MS hits from Excel file',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__["PLUGIN_TYPE"].DATA_LOADER,
        match: (context) => {
            if (context.fileInfos.length !== 1 || context.fileInfos[0].category !== 'ExcelImport')
                return false;
            let wb = context.fileInfos[0].wb;
            return wb.Sheets['MSHits'] &&
                (wb.Sheets['Area'] || wb.Sheets['Quantity']);
        }
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], DataLoaderDemoMSHits);



/***/ }),

/***/ "../apps/module/ms_app/src/data-loaders/data-loader-demo-ms-setup.ts":
/*!***************************************************************************!*\
  !*** ../apps/module/ms_app/src/data-loaders/data-loader-demo-ms-setup.ts ***!
  \***************************************************************************/
/*! exports provided: DataLoaderDemoMSSetup */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataLoaderDemoMSSetup", function() { return DataLoaderDemoMSSetup; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");



let DataLoaderDemoMSSetup = class DataLoaderDemoMSSetup {
    constructor() {
        this.entitiesView = () => `
<h2>Setup MS Experiment</h2>
<div class="view-group">
    <label>Type</label>
    <p>#{content.Type}</p>
</div>
<div class="view-group">
    <label>Scientist</label>
    <p>#{content.Scientist}</p>
</div>
<div class="view-group">
    <label>Description</label>
    <p>#{content.Description}</p>
</div>
<h2>Samples</h2>
<table>
    <thead>
        <tr>
            <th>Run</th>
            <th>Name</th>
            <th>Control Type</th>
            <th>Batch</th>
        </tr>
    </thead>
    <tbody>
        <tr repeat.for="smp of samples">
            <td>#{smp.attributes.run}</td>
            <td>#{smp.name}</td>
            <td>#{smp.controlType}</td>
            <td>#{smp.batchID}</td>
        </tr>
    </tbody>
</table>`;
    }
    init(context) {
        this.context = context;
    }
    readFiles() {
        let fi = this.context.fileInfos[0];
        this.content = new _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ReadExcelCommon"]().execute(fi.wb.Sheets['MSSetup'], {
            a1content: 'MS Setup',
            detailSections: ['Samples']
        });
        let match = /^Setup_(MS\d+)?/.exec(fi.filename);
        if (!match)
            throw Error('Invalid filename: ' + fi.filename);
        this.oldStepID = match[1];
        this.lookups = [];
        this.prepareSamples();
        this.lookups.push({ eClass: 'Method', alias: '#idMethod', name: this.content.Type });
    }
    getResult() {
        return {
            entities: this.samples.concat([
                {
                    eClass: 'Experiment',
                    id: '#idExp',
                    name: '!auto',
                    externalID: this.oldStepID,
                    scientistID: this.content.Scientist,
                    type: this.content.Type,
                    description: this.content.Description
                },
                {
                    eClass: 'Step',
                    id: '#idStep',
                    externalID: this.oldStepID,
                    experimentID: '#idExp',
                    type: this.content.Type,
                    input: this.sampleInput,
                    methodID: '#idMethod',
                    description: this.content.Description,
                    tags: ['MS']
                }
            ]),
            lookups: this.lookups
        };
    }
    prepareSamples() {
        this.samples = [];
        this.sampleRefs = [];
        this.sampleInput = [];
        for (let iSample = 0; iSample < this.content.Samples.length; iSample++) {
            let sampleRow = this.content.Samples[iSample];
            this.samples.push({
                eClass: 'Sample',
                id: `#idSmp${iSample}`,
                sortIndex: iSample + 1,
                type: 'Test',
                parentID: sampleRow.ParentID,
                name: sampleRow.Name,
                isControl: sampleRow.ControlType !== undefined,
                controlType: sampleRow.ControlType,
                format: 'Vial',
                batchID: sampleRow.Batch,
                originID: '#idStep',
                attributes: {
                    concPct: sampleRow.Conc_Pct,
                    run: sampleRow.Run
                }
            });
            if (sampleRow.ParentID)
                this.sampleInput.push({ eClass: 'Sample', id: sampleRow.ParentID });
            this.sampleRefs.push({ eClass: 'Sample', id: `#idSmp${iSample}` });
        }
    }
};
DataLoaderDemoMSSetup = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["scifeonPlugin"])({
        name: 'DataLoaderDemoMSSetup',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DATA_LOADER,
        match: (context) => context.fileInfos.length === 1 &&
            context.fileInfos[0].category === 'ExcelImport' &&
            context.fileInfos[0].wb.Sheets['MSSetup']
    })
], DataLoaderDemoMSSetup);



/***/ }),

/***/ "../apps/module/ms_app/src/entity/content/result-set.html":
/*!****************************************************************!*\
  !*** ../apps/module/ms_app/src/entity/content/result-set.html ***!
  \****************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"detail-panels\">\r\n\r\n        <div class=\"panel\">\r\n            <div class=\"panel-body\">\r\n                <div style=\"display: flex;\">\r\n                    <div style=\"flex: 1\">\r\n                        <shared-fields entity.bind=\"entity\"></shared-fields>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"panel full-width\">\r\n            <div class=\"panel-heading\">Quantities <collapsible default=\"collapsed\"/></div>\r\n            <div class=\"panel-body\">\r\n                <table class=\"table\">\r\n                    <thead>\r\n                        <tr>\r\n                            <th>Sample</th>\r\n                            <th>Name</th>\r\n                            <th repeat.for=\"hit of msHits\">${hit.compoundID}</th>\r\n                        </tr>\r\n                    </thead>\r\n                    <tbody>\r\n                        <tr repeat.for=\"sample of samples\">\r\n                            <td><a href=\"/#/entity/sample/${sample.id}\">${sample.id}</a></td>\r\n                            <td><a href=\"/#/entity/sample/${sample.id}\">${sample.name}</a></td>\r\n                            <td repeat.for=\"hit of msHits\">${getResult(sample.id, hit.id).quantityText}</td>\r\n                        </tr>\r\n                    </tbody>\r\n                </table>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"panel full-width\">\r\n            <div class=\"panel-heading\">Areas <collapsible default=\"collapsed\"/></div>\r\n            <div class=\"panel-body\">\r\n                <table class=\"table\">\r\n                    <thead>\r\n                        <tr>\r\n                            <th>Sample</th>\r\n                            <th>Name</th>\r\n                            <th repeat.for=\"hit of msHits\">${hit.compoundID}</th>\r\n                        </tr>\r\n                    </thead>\r\n                    <tbody>\r\n                        <tr repeat.for=\"sample of samples\">\r\n                            <td><a href=\"/#/entity/sample/${sample.id}\">${sample.id}</a></td>\r\n                            <td><a href=\"/#/entity/sample/${sample.id}\">${sample.name}</a></td>\r\n                            <td repeat.for=\"hit of msHits\">${getResult(sample.id, hit.id).area | significant}</td>\r\n                        </tr>\r\n                    </tbody>\r\n                </table>\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n</template>";

/***/ }),

/***/ "../apps/module/ms_app/src/entity/content/result-set.ts":
/*!**************************************************************!*\
  !*** ../apps/module/ms_app/src/entity/content/result-set.ts ***!
  \**************************************************************/
/*! exports provided: ResultSetMSDetailPlugin */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ResultSetMSDetailPlugin", function() { return ResultSetMSDetailPlugin; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let ResultSetMSDetailPlugin = class ResultSetMSDetailPlugin {
    constructor(server) {
        this.server = server;
    }
    static isMatch(context) {
        return context.entity.eClass === 'ResultSet' && context.entity.type === 'SCFA';
    }
    init(context) {
        this.entity = context.entity;
        this.update();
    }
    update() {
        this.server.datasetQuery([
            { eClass: 'ResultMSHit', collection: 'msHits', filters: [{ field: 'ResultSetID', value: this.entity.id }] },
            { eClass: 'ResultMSQuantity', collection: 'quantities', filters: [{ field: 'ResultSetID', value: this.entity.id }] },
            { eClass: 'Sample', collection: 'samples', filters: [{ field: 'ID', in: 'quantities.SampleID' }] }
        ]).then(dataset => {
            this.msHits = dataset.msHits;
            this.quantities = dataset.quantities;
            this.samples = dataset.samples;
        });
    }
    getResult(sampleID, hitID) {
        let quantity = this.quantities.find(q => q.sampleID === sampleID && q.hitID === hitID);
        if (!quantity)
            return sampleID + ',' + hitID;
        return quantity;
    }
};
ResultSetMSDetailPlugin = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], ResultSetMSDetailPlugin);



/***/ }),

/***/ "../apps/module/ms_app/src/entity/panels/request-detail.html":
/*!*******************************************************************!*\
  !*** ../apps/module/ms_app/src/entity/panels/request-detail.html ***!
  \*******************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>        \r\n    <div class=\"panel\" style=\"grid-column: span 2\">\r\n        <div class=\"panel-heading\">Request</div>\r\n        <div class=\"panel-body\">\r\n\r\n            <div class=\"view-group\">\r\n                <label>Customer</label>\r\n                <e-link e-class=\"Customer\" entity-id.bind=\"request.customerID\"/>\r\n            </div>\r\n\r\n            <div class=\"view-group\">\r\n                <label>Stats</label>\r\n                <p>\r\n                    Total Samples: ${samples.length}\r\n                </p>\r\n                <p>\r\n                    Completed Samples: ${completedSamples.length}\r\n                </p>\r\n            </div>\r\n\r\n            <h3>Processed in steps:</h3>\r\n            <ul>\r\n                <li repeat.for=\"id of stepIDs\"><e-link e-class=\"Step\" entity-id.bind=\"id\"/></li>\r\n            </ul>\r\n\r\n            <p>\r\n                <button>Mark Samples Received</button>\r\n            </p>\r\n\r\n            <p>\r\n                <button>Mark Request Completed</button>\r\n            </p>\r\n        </div>\r\n    </div>\r\n\r\n    <div class=\"panel\" style=\"grid-column: span 2\">\r\n        <div class=\"panel-heading\">Samples &amp; Selected Analyses <collapsible default=\"collapsed\"></collapsible></div>\r\n        <div class=\"panel-body\">\r\n            <div class=\"form-group\">\r\n                <table>\r\n                    <thead>\r\n                        <tr>\r\n                            <td></td>\r\n                            <td></td>\r\n                            <td repeat.for=\"method of methods\">\r\n                                <button click.delegate=\"downloadSampleSheet(method)\">Setup File</button>\r\n                            </td>                                        \r\n                        </tr>\r\n                        <tr>\r\n                            <th>Sample</th>\r\n                            <th>External ID</th>\r\n                            <th repeat.for=\"method of methods\">${method.name}</th>\r\n                        </tr>\r\n                    </thead>\r\n                    <tbody>\r\n                        <tr repeat.for=\"sample of samples\">\r\n                            <td><a href='/#/entity/Sample/${sample.id}'>${sample.name}</a></td>\r\n                            <td>${sample.externalID}</td>\r\n                            <td repeat.for=\"method of methods\">${getAssayStatus(sample.id, method.name)}</td>\r\n                        </tr>\r\n                    </tbody>\r\n                </table>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/module/ms_app/src/entity/panels/request-detail.ts":
/*!*****************************************************************!*\
  !*** ../apps/module/ms_app/src/entity/panels/request-detail.ts ***!
  \*****************************************************************/
/*! exports provided: DemoMSRequestDetail */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DemoMSRequestDetail", function() { return DemoMSRequestDetail; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! file-saver */ "./node_modules/file-saver/FileSaver.js");
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(file_saver__WEBPACK_IMPORTED_MODULE_3__);




let DemoMSRequestDetail = class DemoMSRequestDetail {
    constructor(server, user) {
        this.server = server;
        this.user = user;
    }
    static isMatch(context) {
        return context.entity.type === 'CustomerService';
    }
    init(context) {
        this.request = context.entity;
        this.loadData();
    }
    loadData() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'Note', collection: 'notes', filters: [{ field: 'SubjectID', value: this.request.id }] },
                { view: 'RequestPayload', collection: 'samples', filters: [{ field: 'RequestID', value: this.request.id }] }
            ]);
            this.methodIDs = this.request.payload.methods;
            this.samples = dataset.samples.sort((a, b) => a.id > b.id ? 1 : -1);
            this.completedSamples = dataset.samples.filter(sample => sample.status === 'Completed');
            this.note = dataset.notes.find(c => c.type === 'EntryNotes');
            const methodsAndAssays = yield this.server.datasetQuery([
                { eClass: 'Method', collection: 'methods', filters: [{ field: 'ID', values: this.methodIDs }] },
                { view: 'MSSampleAssayStatus', collection: 'assays', filters: [{ field: 'SampleID', values: this.samples.map(s => s.id) }] }
            ]);
            this.methods = methodsAndAssays.methods;
            this.assays = methodsAndAssays.assays;
            const stepSampleInput = yield this.server.datasetQuery([
                { view: 'StepSampleInput', collection: 'usage', filters: [{ field: 'RequestID', value: this.request.id }] }
            ]);
            let stepIDs = new Set();
            for (let entity of stepSampleInput.usage) {
                stepIDs.add(entity.stepID);
            }
            this.stepIDs = Array.from(stepIDs).sort();
        });
    }
    getAssayStatus(sampleID, method) {
        let assay = this.assays.find(a => a.sampleID === sampleID && a.type === method);
        if (assay)
            return assay.status;
        return '-';
    }
    downloadSampleSheet(method) {
        let wb = {
            SheetNames: [],
            Sheets: {}
        };
        let runSize = this.runSize(method.name);
        this.shuffle(this.samples);
        let ws = {
            'A1': { t: 's', v: 'MS Setup' },
            'A3': { t: 's', v: 'Scientist' },
            'B3': { t: 's', v: this.user.id },
            'A4': { t: 's', v: 'Run date' },
            'A5': { t: 's', v: 'Type' },
            'B5': { t: 's', v: method.name },
            'A6': { t: 's', v: 'Description' },
            'A8': { t: 's', v: 'Samples' },
            'B8': { t: 's', v: 'Run' },
            'C8': { t: 's', v: 'Name' },
            'D8': { t: 's', v: 'ParentID' },
            'E8': { t: 's', v: 'ControlType' },
            'F8': { t: 's', v: 'Batch' },
            'G8': { t: 's', v: 'Conc_Pct' },
            'H8': { t: 's', v: 'Spike' }
        };
        let sheetName = 'MSSetup';
        wb.Sheets[sheetName] = ws;
        wb.SheetNames.push(sheetName);
        if (this.request.description)
            ws.B6 = { t: 's', v: this.request.id + ': ' + this.request.description };
        this.xlrow = 9;
        this.xlrowLast = 8;
        this.nextQC = 1;
        for (let iRun = 0; iRun <= this.samples.length / runSize; iRun++) {
            let samples = this.samples.slice(iRun * runSize, (iRun + 1) * runSize);
            this.addRun(method, ws, iRun, samples);
        }
        ws['!ref'] = 'A1:H' + this.xlrowLast;
        let wbout = XLSX.write(wb, { bookType: 'xlsx', bookSST: false, type: 'binary' });
        Object(file_saver__WEBPACK_IMPORTED_MODULE_3__["saveAs"])(new Blob([this.s2ab(wbout)], { type: 'application/octet-stream' }), `Setup_${this.request.id}_${method.name}.xlsx`);
    }
    addRun(method, ws, iRun, samples) {
        this.addSamples(method, ws, this.headerSamples(method.name), iRun);
        let groupSize = this.determineGroupSize(method, samples);
        for (let iSample = 0; iSample < samples.length; iSample++) {
            if (iSample % groupSize === 0)
                this.addQCSample(method, ws, iRun);
            let sample = samples[iSample];
            ws['B' + this.xlrow] = { t: 'n', v: iRun + 1 };
            ws['C' + this.xlrow] = { t: 's', v: sample.name };
            ws['D' + this.xlrow] = { t: 's', v: sample.id };
            ws['G' + this.xlrow] = { t: 'n', v: 100.0 };
            this.xlrowLast = this.xlrow;
            this.xlrow++;
        }
        this.addQCSample(method, ws, iRun);
        this.addSamples(method, ws, this.footerSamples(method.name), iRun);
    }
    s2ab(s) {
        let buf = new ArrayBuffer(s.length);
        let view = new Uint8Array(buf);
        for (let i = 0; i != s.length; ++i)
            view[i] = s.charCodeAt(i) & 0xFF;
        return buf;
    }
    determineGroupSize(method, samples) {
        if (method.name === 'Vitamins')
            return 8;
        return 5;
    }
    addSamples(method, ws, sampleDict, iRun) {
        for (let i = 0; i < sampleDict.name.length; i++) {
            if (sampleDict.controlType[i] === 'QC')
                this.addQCSample(method, ws, iRun);
            else {
                ws['B' + this.xlrow] = { t: 'n', v: iRun + 1 };
                ws['C' + this.xlrow] = { t: 's', v: sampleDict.name[i] };
                ws['E' + this.xlrow] = { t: 's', v: sampleDict.controlType[i] };
                ws['F' + this.xlrow] = { t: 's', v: sampleDict.batch[i] };
                ws['G' + this.xlrow] = { t: 'n', v: sampleDict.concPct[i] };
                this.xlrowLast = this.xlrow;
                this.xlrow++;
            }
        }
    }
    addQCSample(method, ws, iRun) {
        if (method.name === 'Vitamins') {
            ws['B' + this.xlrow] = { t: 'n', v: iRun + 1 };
            ws['C' + this.xlrow] = { t: 's', v: `STD-D` };
            ws['E' + this.xlrow] = { t: 's', v: 'STD' };
            ws['G' + this.xlrow] = { t: 'n', v: 2 };
        }
        else {
            ws['B' + this.xlrow] = { t: 'n', v: iRun + 1 };
            ws['C' + this.xlrow] = { t: 's', v: `QC_${this.nextQC}` };
            ws['E' + this.xlrow] = { t: 's', v: 'QC' };
            ws['G' + this.xlrow] = { t: 'n', v: 100 };
        }
        this.xlrowLast = this.xlrow;
        this.xlrow++;
        this.nextQC++;
    }
    headerSamples(methodName) {
        switch (methodName) {
            case 'SCFA':
                return {
                    name: ['Blank_1', 'QC_1', 'Blank_1', 'STD0', 'STD01', 'STD025', 'STD05', 'STD1', 'STD25', 'STD5', 'STD116', 'STD25', 'STD50', 'STD100', 'Blank_2', 'Blank_2'],
                    controlType: ['Blank', 'QC', 'Blank', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'Blank', 'Blank'],
                    batch: ['', '', '', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', '', ''],
                    concPct: [100, 100, 100, 0, 0.1, 0.25, 0.5, 1, 2.5, 5, 11.6, 25, 50, 100, 100, 100]
                };
            case 'Vitamins':
                return {
                    name: ['Blank', 'Blank', 'Blank', 'STD-I', 'STD-H', 'STD-g', 'STD-F', 'STD-E', 'STD-D', 'STD-C', 'STD-B', 'STD-A', 'Blank', 'QC1', 'QC1s', 'QC2', 'QC2s', 'QC3', 'QC3s', 'QC4', 'QC4s', 'QC5', 'QC5s', 'STD-D'],
                    controlType: ['Blank', 'Blank', 'Blank', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'Blank', 'QC', 'QC', 'QC', 'QC', 'QC', 'QC', 'QC', 'QC', 'QC', 'QC', 'STD'],
                    batch: ['', '', '', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', '', '', '', '', '', '', '', '', '', '', '', ''],
                    concPct: [100, 100, 100, 0.01, 0.02, 0.1, 0.2, 1, 2, 10, 20, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100]
                };
            default:
                throw Error('Missing header samples for method: ' + methodName);
        }
    }
    footerSamples(methodName) {
        switch (methodName) {
            case 'SCFA':
                return {
                    name: ['D075', 'D050', 'D025', 'D010', 'QuantCtr_5mM', 'Spike00', 'Spike05', 'Spike10', 'QC_4', 'Blank_3', 'Blank_3', 'STD0', 'STD01', 'STD025', 'STD05', 'STD1', 'STD25', 'STD5', 'STD116', 'STD25', 'STD50', 'STD100', 'Blank_4', 'Blank_4', 'QC_4', 'Blank_4'],
                    controlType: ['Dilute', 'Dilute', 'Dilute', 'Dilute', 'QuantCtr-5', 'Spike', 'Spike', 'Spike', 'QC', 'Blank', 'Blank', 'Blank', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'Blank', 'Blank', 'QC', 'Blank'],
                    batch: ['', '', '', '', '', '', '', '', '', '', '', '', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', '', '', '', ''],
                    concPct: [75, 50, 25, 10, 0, 0, 0, 0, 100, 0, 0, 0, 0.1, 0.25, 0.5, 1, 2.5, 5, 11.6, 25, 50, 100, 0, 0, 100, 0]
                };
            case 'Vitamins':
                return {
                    name: ['STD-D', 'Blank', 'STD-I', 'STD-H', 'STD-g', 'STD-F', 'STD-E', 'STD-D', 'STD-C', 'STD-B', 'STD-A'],
                    controlType: ['STD', 'Blank', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD',],
                    batch: ['BT???', '', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???',],
                    concPct: [2, 100, 0.01, 0.02, 0.1, 0.2, 1, 2, 10, 20, 100]
                };
            default:
                throw Error('Missing footer samples for method: ' + methodName);
        }
    }
    runSize(methodName) {
        if (methodName === 'Vitamins')
            return 100;
        return 35;
    }
    shuffle(samples) {
        let remaining = samples.length;
        while (remaining) {
            remaining--;
            let iSwapWith = Math.floor(Math.random() * (remaining + 1));
            let temp = samples[remaining];
            samples[remaining] = samples[iSwapWith];
            samples[iSwapWith] = temp;
        }
    }
};
DemoMSRequestDetail = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], DemoMSRequestDetail);



/***/ }),

/***/ "../apps/module/ms_app/src/entity/panels/step-detail.html":
/*!****************************************************************!*\
  !*** ../apps/module/ms_app/src/entity/panels/step-detail.html ***!
  \****************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    \r\n    <div class=\"panel\">\r\n        <div class=\"panel-heading\">Download MatLab File</div>\r\n        <div class=\"panel-body\">\r\n            <button click.delegate=\"downloadMatLabFile()\">Download</button>\r\n        </div>\r\n    </div>\r\n\r\n</template>";

/***/ }),

/***/ "../apps/module/ms_app/src/entity/panels/step-detail.ts":
/*!**************************************************************!*\
  !*** ../apps/module/ms_app/src/entity/panels/step-detail.ts ***!
  \**************************************************************/
/*! exports provided: AppMSStepDetail */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AppMSStepDetail", function() { return AppMSStepDetail; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! file-saver */ "./node_modules/file-saver/FileSaver.js");
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(file_saver__WEBPACK_IMPORTED_MODULE_3__);




let AppMSStepDetail = class AppMSStepDetail {
    constructor(api) {
        this.api = api;
    }
    static isMatch(context) {
        return context.entity.eClass === 'Step' && context.entity.tags && context.entity.tags.indexOf('MS') !== -1;
    }
    init(context) {
        this.entity = context.entity;
        this.update();
    }
    downloadMatLabFile() {
        let attributeKeySet = new Set();
        for (let s of this.outputSamples.filter(s => s.attributes))
            for (let key in s.attributes)
                attributeKeySet.add(key);
        let attributeKeys = Array.from(attributeKeySet).sort();
        let wb = {
            SheetNames: ['MatLab'],
            Sheets: {
                MatLab: {
                    A1: { t: 's', v: 'Filename' },
                    B1: { t: 's', v: 'Rel Conc' },
                    C1: { t: 's', v: 'Type' },
                    D1: { t: 's', v: 'ControlType' },
                    E1: { t: 's', v: 'Injection' },
                    F1: { t: 's', v: 'Batch' },
                    G1: { t: 's', v: 'SampleID' },
                    H1: { t: 's', v: 'CS no' },
                    I1: { t: 's', v: 'ParentID' },
                    J1: { t: 's', v: 'Tags' },
                    K1: { t: 's', v: 'Chart Order' },
                    L1: { t: 's', v: 'ExternalID' },
                    '!cols': [
                        { wch: 30 },
                        { wch: 8 },
                        { wch: 10 },
                        { wch: 12 },
                        { wch: 10 },
                        { wch: 10 },
                        { wch: 10 },
                        { wch: 10 },
                        { wch: 10 },
                        { wch: 10 },
                        { wch: 10 },
                        { wch: 10 },
                    ]
                }
            }
        };
        let ws = wb.Sheets.MatLab;
        let nFixedCols = 12;
        for (let i = 0; i < attributeKeys.length; i++) {
            ws[_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].ColNames[i + nFixedCols] + '1'] = { t: 's', v: attributeKeys[i] };
        }
        let today = new Date();
        let dateString = [today.getFullYear(),
            today.getMonth() > 8 ? '' : '0', today.getMonth() + 1,
            today.getDate() > 9 ? '' : '0', today.getDate()
        ].join('');
        let xlRowLast = 1;
        for (let i = 0, xlRow = 2; i < this.outputSamples.length; i++, xlRow++) {
            const smp = this.outputSamples[i];
            ws['A' + xlRow] = { t: 's', v: `${this.entity.name}-${smp.sortIndex}-${smp.id}-${smp.name}.cdf` };
            ws['C' + xlRow] = { t: 's', v: smp.type };
            if (smp.controlType)
                ws['D' + xlRow] = { t: 's', v: smp.controlType || 'Sample' };
            ws['E' + xlRow] = { t: 'n', v: smp.sortIndex };
            if (smp.batchName)
                ws['F' + xlRow] = { t: 's', v: smp.batchID };
            ws['G' + xlRow] = { t: 's', v: smp.id };
            ws['H' + xlRow] = { t: 's', v: smp.name };
            if (smp.parentID)
                ws['I' + xlRow] = { t: 's', v: smp.parentID };
            if (smp.tags)
                ws['J' + xlRow] = { t: 's', v: smp.tags.join(', ') };
            ws['K' + xlRow] = { t: 'n', v: smp.sortIndex };
            if (smp.externalID)
                ws['L' + xlRow] = { t: 's', v: smp.externalID };
            for (let ai = 0; ai < attributeKeys.length; ai++) {
                const value = smp.attributes[attributeKeys[ai]];
                const type = typeof value === 'number' ? 'n' : 's';
                ws[_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].ColNames[ai + nFixedCols] + xlRow] = { t: type, v: smp.attributes[attributeKeys[ai]] };
            }
            xlRowLast = xlRow;
        }
        ws['!ref'] = 'A1:' + _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["XL"].ColNames[nFixedCols + attributeKeys.length] + xlRowLast;
        let wbout = XLSX.write(wb, { bookType: 'xlsx', bookSST: false, type: 'binary' });
        Object(file_saver__WEBPACK_IMPORTED_MODULE_3__["saveAs"])(new Blob([this.s2ab(wbout)], { type: 'application/octet-stream' }), `MatLab_${this.entity.name}_${this.entity.type}.xlsx`);
    }
    s2ab(s) {
        let buf = new ArrayBuffer(s.length);
        let view = new Uint8Array(buf);
        for (let i = 0; i != s.length; ++i)
            view[i] = s.charCodeAt(i) & 0xFF;
        return buf;
    }
    update() {
        this.api.get('/api/entity/' + this.entity.eClass + '/' + this.entity.id)
            .then(response => response.json())
            .then(response => {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
            this.entity = response;
            this.entity.createdDate = new Date(this.entity.createdDate);
            this.entity.modifiedDate = new Date(this.entity.modifiedDate);
        });
        this.api.datasetQuery([
            { eClass: 'Sample', collection: 'output', filters: [{ field: 'OriginID', value: this.entity.id }] },
            { view: 'MSSampleInput', collection: 'input', filters: [{ field: 'StepID', value: this.entity.id }] }
        ])
            .then(dataset => {
            this.outputSamples = dataset.output.sort((a, b) => a.sortIndex > b.sortIndex ? 1 : -1);
            this.inputSamples = dataset.input.sort((a, b) => a.sortIndex > b.sortIndex ? 1 : -1);
        });
    }
};
AppMSStepDetail = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], AppMSStepDetail);



/***/ }),

/***/ "../apps/module/ms_app/src/entity/panels/step-result-set-renderer.html":
/*!*****************************************************************************!*\
  !*** ../apps/module/ms_app/src/entity/panels/step-result-set-renderer.html ***!
  \*****************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    Quantities and Areas\r\n    \r\n    <table class=\"table\">\r\n        <thead>\r\n            <tr>\r\n                <th>Sample</th>\r\n                <th>Name</th>\r\n                <th repeat.for=\"hit of msHits\">${hit.compoundID}</th>\r\n            </tr>\r\n        </thead>\r\n        <tbody>\r\n            <tr repeat.for=\"sample of samples\">\r\n                <td><a href=\"/#/entity/sample/${sample.id}\">${sample.id}</a></td>\r\n                <td><a href=\"/#/entity/sample/${sample.id}\">${sample.name}</a></td>\r\n                <td repeat.for=\"hit of msHits\">\r\n                    ${getResult(sample.id, hit.id).quantityText}<br/>\r\n                    ${getResult(sample.id, hit.id).area | significant}\r\n                </td>\r\n            </tr>\r\n        </tbody>\r\n    </table>\r\n</template>";

/***/ }),

/***/ "../apps/module/ms_app/src/entity/panels/step-result-set-renderer.ts":
/*!***************************************************************************!*\
  !*** ../apps/module/ms_app/src/entity/panels/step-result-set-renderer.ts ***!
  \***************************************************************************/
/*! exports provided: StepResultSetRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StepResultSetRenderer", function() { return StepResultSetRenderer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let StepResultSetRenderer = class StepResultSetRenderer {
    constructor(server) {
        this.server = server;
    }
    static isMatch(context) {
        return context.resultSet && context.resultSet.type === 'SCFA' && context.position === _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["POSITIONS"].ELN_STEP_RESULTS;
    }
    init(context) {
        this.server.datasetQuery([
            { eClass: 'ResultMSHit', collection: 'msHits', filters: [{ field: 'ResultSetID', value: context.resultSet.id }] },
            { eClass: 'ResultMSQuantity', collection: 'quantities', filters: [{ field: 'ResultSetID', value: context.resultSet.id }] },
            { eClass: 'Sample', collection: 'samples', filters: [{ field: 'ID', in: 'quantities.SampleID' }] }
        ]).then(dataset => {
            this.msHits = dataset.msHits;
            this.quantities = dataset.quantities;
            this.samples = dataset.samples;
        });
    }
    getResult(sampleID, hitID) {
        let quantity = this.quantities.find(q => q.sampleID === sampleID && q.hitID === hitID);
        if (!quantity)
            return sampleID + ',' + hitID;
        return quantity;
    }
};
StepResultSetRenderer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], StepResultSetRenderer);



/***/ }),

/***/ "../apps/module/ms_app/temp/gen-app.js":
/*!*********************************************!*\
  !*** ../apps/module/ms_app/temp/gen-app.js ***!
  \*********************************************/
/*! exports provided: plugins, hot, moduleId */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(module) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "plugins", function() { return plugins; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hot", function() { return hot; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "moduleId", function() { return moduleId; });
const plugins = [
{
 id: 'data-loader-demo-ms-hits',
 func: __webpack_require__(/*! ../src/data-loaders/data-loader-demo-ms-hits.ts */ "../apps/module/ms_app/src/data-loaders/data-loader-demo-ms-hits.ts"),
 types: ["data_loader"],
},
{
 id: 'data-loader-demo-ms-setup',
 func: __webpack_require__(/*! ../src/data-loaders/data-loader-demo-ms-setup.ts */ "../apps/module/ms_app/src/data-loaders/data-loader-demo-ms-setup.ts"),
 types: ["data_loader"],
},
{
 id: 'msResultSet',
 func: __webpack_require__(/*! ../src/entity/content/result-set.ts */ "../apps/module/ms_app/src/entity/content/result-set.ts"),
 types: ["entity.content"],
 view: __webpack_require__(/*! ../src/entity/content/result-set.html */ "../apps/module/ms_app/src/entity/content/result-set.html"),
},
{
 id: 'msRequestDetail',
 func: __webpack_require__(/*! ../src/entity/panels/request-detail.ts */ "../apps/module/ms_app/src/entity/panels/request-detail.ts"),
 types: ["entity.panel"],
 view: __webpack_require__(/*! ../src/entity/panels/request-detail.html */ "../apps/module/ms_app/src/entity/panels/request-detail.html"),
},
{
 id: 'msStepDetail',
 func: __webpack_require__(/*! ../src/entity/panels/step-detail.ts */ "../apps/module/ms_app/src/entity/panels/step-detail.ts"),
 types: ["entity.panel"],
 view: __webpack_require__(/*! ../src/entity/panels/step-detail.html */ "../apps/module/ms_app/src/entity/panels/step-detail.html"),
},
{
 id: 'msResultSetRenderer',
 func: __webpack_require__(/*! ../src/entity/panels/step-result-set-renderer.ts */ "../apps/module/ms_app/src/entity/panels/step-result-set-renderer.ts"),
 types: ["entity.panel"],
 view: __webpack_require__(/*! ../src/entity/panels/step-result-set-renderer.html */ "../apps/module/ms_app/src/entity/panels/step-result-set-renderer.html"),
},
{
 id: 'PLUGIN_TYPE.DATA_LOADER_0',
 func: __webpack_require__(/*! ../src/data-loaders/data-loader-demo-ms-hits.ts */ "../apps/module/ms_app/src/data-loaders/data-loader-demo-ms-hits.ts"),
 types: ["data_loader"],
 name: 'DataLoaderDemoMSHits',
 description: 'Import MS hits from Excel file'
},
{
 id: 'PLUGIN_TYPE.DATA_LOADER_1',
 func: __webpack_require__(/*! ../src/data-loaders/data-loader-demo-ms-setup.ts */ "../apps/module/ms_app/src/data-loaders/data-loader-demo-ms-setup.ts"),
 types: ["data_loader"],
 name: 'DataLoaderDemoMSSetup',
},
{
 id: 'routePage_msIndex',
 func: () => __webpack_require__.e(/*! import() | routePage_msIndex */ "routePage_msIndex").then(__webpack_require__.bind(null, /*! ../src/pages/index.ts */ "../apps/module/ms_app/src/pages/index.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_msIndex */ "routePage_msIndex").then(__webpack_require__.t.bind(null, /*! ../src/pages/index.html */ "../apps/module/ms_app/src/pages/index.html", 7)),
},
{
 id: 'routePage_msLoDCheck',
 func: () => __webpack_require__.e(/*! import() | routePage_msLoDCheck */ "routePage_msLoDCheck").then(__webpack_require__.bind(null, /*! ../src/pages/lod-check.ts */ "../apps/module/ms_app/src/pages/lod-check.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_msLoDCheck */ "routePage_msLoDCheck").then(__webpack_require__.t.bind(null, /*! ../src/pages/lod-check.html */ "../apps/module/ms_app/src/pages/lod-check.html", 7)),
},
{
 id: 'routePage_msBatchRegistrationForm',
 func: () => __webpack_require__.e(/*! import() | routePage_msBatchRegistrationForm */ "routePage_msBatchRegistrationForm").then(__webpack_require__.bind(null, /*! ../src/pages/batch-registration-form.ts */ "../apps/module/ms_app/src/pages/batch-registration-form.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_msBatchRegistrationForm */ "routePage_msBatchRegistrationForm").then(__webpack_require__.t.bind(null, /*! ../src/pages/batch-registration-form.html */ "../apps/module/ms_app/src/pages/batch-registration-form.html", 7)),
},
{
 id: 'routePage_msDpCheck',
 func: () => __webpack_require__.e(/*! import() | routePage_msDpCheck */ "routePage_msDpCheck").then(__webpack_require__.bind(null, /*! ../src/pages/dp-check.ts */ "../apps/module/ms_app/src/pages/dp-check.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_msDpCheck */ "routePage_msDpCheck").then(__webpack_require__.t.bind(null, /*! ../src/pages/dp-check.html */ "../apps/module/ms_app/src/pages/dp-check.html", 7)),
},
];
const hot = module.hot;
const moduleId = module.i;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../../../../client/node_modules/webpack/buildin/harmony-module.js */ "./node_modules/webpack/buildin/harmony-module.js")(module)))

/***/ }),

/***/ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js":
/*!***********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js from dll-reference scifeon_vendor ***!
  \***********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");

/***/ }),

/***/ "./node_modules/file-saver/FileSaver.js":
/*!******************************************************************************************!*\
  !*** delegated ./node_modules/file-saver/FileSaver.js from dll-reference scifeon_vendor ***!
  \******************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/file-saver/FileSaver.js");

/***/ }),

/***/ "./node_modules/tslib/tslib.js":
/*!*************************************!*\
  !*** ./node_modules/tslib/tslib.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global global, define, System, Reflect, Promise */
var __extends;
var __assign;
var __rest;
var __decorate;
var __param;
var __metadata;
var __awaiter;
var __generator;
var __exportStar;
var __values;
var __read;
var __spread;
var __await;
var __asyncGenerator;
var __asyncDelegator;
var __asyncValues;
var __makeTemplateObject;
var __importStar;
var __importDefault;
(function (factory) {
    var root = typeof global === "object" ? global : typeof self === "object" ? self : typeof this === "object" ? this : {};
    if (true) {
        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports], __WEBPACK_AMD_DEFINE_RESULT__ = (function (exports) { factory(createExporter(root, createExporter(exports))); }).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    }
    else {}
    function createExporter(exports, previous) {
        if (exports !== root) {
            if (typeof Object.create === "function") {
                Object.defineProperty(exports, "__esModule", { value: true });
            }
            else {
                exports.__esModule = true;
            }
        }
        return function (id, v) { return exports[id] = previous ? previous(id, v) : v; };
    }
})
(function (exporter) {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    __extends = function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };

    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };

    __rest = function (s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
                t[p[i]] = s[p[i]];
        return t;
    };

    __decorate = function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };

    __param = function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };

    __metadata = function (metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    };

    __awaiter = function (thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    };

    __generator = function (thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    };

    __exportStar = function (m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    };

    __values = function (o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    };

    __read = function (o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    };

    __spread = function () {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    };

    __await = function (v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    };

    __asyncGenerator = function (thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);  }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    };

    __asyncDelegator = function (o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    };

    __asyncValues = function (o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    };

    __makeTemplateObject = function (cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    __importStar = function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result["default"] = mod;
        return result;
    };

    __importDefault = function (mod) {
        return (mod && mod.__esModule) ? mod : { "default": mod };
    };

    exporter("__extends", __extends);
    exporter("__assign", __assign);
    exporter("__rest", __rest);
    exporter("__decorate", __decorate);
    exporter("__param", __param);
    exporter("__metadata", __metadata);
    exporter("__awaiter", __awaiter);
    exporter("__generator", __generator);
    exporter("__exportStar", __exportStar);
    exporter("__values", __values);
    exporter("__read", __read);
    exporter("__spread", __spread);
    exporter("__await", __await);
    exporter("__asyncGenerator", __asyncGenerator);
    exporter("__asyncDelegator", __asyncDelegator);
    exporter("__asyncValues", __asyncValues);
    exporter("__makeTemplateObject", __makeTemplateObject);
    exporter("__importStar", __importStar);
    exporter("__importDefault", __importDefault);
});

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../webpack/buildin/global.js */ "./node_modules/webpack/buildin/global.js")))

/***/ }),

/***/ "./node_modules/webpack/buildin/global.js":
/*!********************************************************************************************!*\
  !*** delegated ./node_modules/webpack/buildin/global.js from dll-reference scifeon_vendor ***!
  \********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/webpack/buildin/global.js");

/***/ }),

/***/ "./node_modules/webpack/buildin/harmony-module.js":
/*!*******************************************!*\
  !*** (webpack)/buildin/harmony-module.js ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = function(originalModule) {
	if (!originalModule.webpackPolyfill) {
		var module = Object.create(originalModule);
		// module.parent = undefined by default
		if (!module.children) module.children = [];
		Object.defineProperty(module, "loaded", {
			enumerable: true,
			get: function() {
				return module.l;
			}
		});
		Object.defineProperty(module, "id", {
			enumerable: true,
			get: function() {
				return module.i;
			}
		});
		Object.defineProperty(module, "exports", {
			enumerable: true
		});
		module.webpackPolyfill = 1;
	}
	return module;
};


/***/ }),

/***/ "./packages/core/index.ts":
/*!**************************************************************************!*\
  !*** delegated ./packages/core/index.ts from dll-reference scifeon_core ***!
  \**************************************************************************/
/*! exports provided: Config, ScifeonConsoleLogger, ConsoleLogger, Status, Event, DataModel, ReadExcelCommon, XL, LoadingSpinner, ScifeonLoadingSpinner, ServerAPI, User, UserHelper, DSUtils, DateUtils, MathUtils, PLATE, PluginUtils, ScifeonUtils, Utils, SdkUtils, SpreadsheetUtils */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_core */ "dll-reference scifeon_core"))("./packages/core/index.ts");

/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ 0:
/*!***************************************************!*\
  !*** multi ../apps/module/ms_app/temp/gen-app.js ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! C:\agent\_work\3\s\apps\module\ms_app\temp\gen-app.js */"../apps/module/ms_app/temp/gen-app.js");


/***/ }),

/***/ "dll-reference scifeon_core":
/*!*******************************!*\
  !*** external "scifeon_core" ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_core;

/***/ }),

/***/ "dll-reference scifeon_plugins":
/*!**********************************!*\
  !*** external "scifeon_plugins" ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_plugins;

/***/ }),

/***/ "dll-reference scifeon_vendor":
/*!*********************************!*\
  !*** external "scifeon_vendor" ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_vendor;

/***/ })

/******/ }));;
//# sourceMappingURL=app.js.map