com_scifeon_scifeon_administration(/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 	};
/******/
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		"app": 0
/******/ 	};
/******/
/******/
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "" + chunkId + "." + "e28d4943052103ad78ee" + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var head = document.getElementsByTagName('head')[0];
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							var error = new Error('Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')');
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/bundledApps/com.scifeon/scifeon_administration/";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["webpackJsonpcom_scifeon_scifeon_administration"] = window["webpackJsonpcom_scifeon_scifeon_administration"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "../apps/core/administration/src/pages/administration/settings/elements/data-access-settings.html":
/*!********************************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/settings/elements/data-access-settings.html ***!
  \********************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel\">\r\n        <div class=\"panel-heading\">\r\n            Security\r\n        </div>\r\n        <div class=\"panel-body\">            \r\n            <div class=\"loading\" if.bind=\"!dataAccess\"></div>\r\n            <div class=\"form\" if.bind=\"dataAccess\">\r\n                <div class=\"form-group\">\r\n                    <label>\r\n                        <input type=\"radio\" name=\"dataAccess\" value=\"W\" checked.bind=\"dataAccess\"/>\r\n                        All can read & write\r\n                    </label>\r\n                </div>                \r\n                <div class=\"form-group\">\r\n                    <label>\r\n                        <input type=\"radio\" name=\"dataAccess\" value=\"R\" checked.bind=\"dataAccess\"/>\r\n                        All can read\r\n                    </label>\r\n                </div>                \r\n                <div class=\"form-group\">\r\n                    <label>\r\n                        <input type=\"radio\" name=\"dataAccess\" value=\"DP\" checked.bind=\"dataAccess\"/>\r\n                        Based on departments & projects\r\n                    </label>\r\n                </div>\r\n                <div class=\"form-group text-right\">\r\n                    <span class=\"loading\" if.bind=\"saving\">-</span>\r\n                    <button click.delegate=\"save()\">Save</button>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/settings/elements/data-access-settings.ts":
/*!******************************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/settings/elements/data-access-settings.ts ***!
  \******************************************************************************************************/
/*! exports provided: DataAccessSettings */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataAccessSettings", function() { return DataAccessSettings; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let DataAccessSettings = class DataAccessSettings {
    constructor(server) {
        this.server = server;
        this.saving = false;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const response = yield this.server.get('/api/settings/dataAccess');
            this.dataAccess = yield response.json();
        });
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.saving = true;
            yield this.server.post('/api/settings/dataAccess/' + this.dataAccess, null);
            this.saving = false;
        });
    }
};
DataAccessSettings = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('data-access-settings'),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], DataAccessSettings);



/***/ }),

/***/ "../apps/core/administration/src/pages/administration/settings/elements/instance-settings.html":
/*!*****************************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/settings/elements/instance-settings.html ***!
  \*****************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel\">\r\n        <div class=\"panel-heading\">\r\n            Server\r\n        </div>\r\n        <div class=\"panel-body\">            \r\n            <div class=\"loading\" if.bind=\"!instanceSettings.clusterID\"></div>\r\n            <div class=\"form\" if.bind=\"instanceSettings.clusterID\">\r\n                <div class=\"form-group\">\r\n                    <label>Name</label>\r\n                    <input type=\"text\" value.bind=\"instanceSettings.name & validate\"/>\r\n                </div>\r\n                <div class=\"form-group\">\r\n                    <label>ClusterID</label>\r\n                    <input type=\"text\" value.one-way=\"instanceSettings.clusterID\" disabled=\"disabled\"/>\r\n                </div>\r\n                <div class=\"form-group\">\r\n                    <label>Environment</label>\r\n                    <input type=\"text\" value.one-way=\"instanceSettings.env\" disabled=\"disabled\"/>\r\n                </div>\r\n                <div class=\"form-group text-right\">\r\n                    <span class=\"loading\" if.bind=\"saving\">-</span>\r\n                    <button click.delegate=\"saveInstanceSettings()\" disabled.bind=\"!canSave\">Save</button>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/settings/elements/instance-settings.ts":
/*!***************************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/settings/elements/instance-settings.ts ***!
  \***************************************************************************************************/
/*! exports provided: InstanceSettings */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InstanceSettings", function() { return InstanceSettings; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-validation */ "./node_modules/aurelia-validation/dist/commonjs/aurelia-validation.js");
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_validation__WEBPACK_IMPORTED_MODULE_3__);




let InstanceSettings = class InstanceSettings {
    constructor(server, validator, controllerFactory) {
        this.server = server;
        this.validator = validator;
        this.instanceSettings = {};
        this.canSave = false;
        this.saving = false;
        this.controller = controllerFactory.createForCurrentScope();
        this.controller.validateTrigger = aurelia_validation__WEBPACK_IMPORTED_MODULE_3__["validateTrigger"].changeOrBlur;
        this.controller.subscribe(event => this.validate());
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadInstanceSettings();
        });
    }
    loadInstanceSettings() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const response = yield this.server.get('/api/settings/instance');
            const json = yield response.json();
            this.instanceSettings = json;
            aurelia_validation__WEBPACK_IMPORTED_MODULE_3__["ValidationRules"]
                .ensure('name').required()
                .on(this.instanceSettings);
        });
    }
    saveInstanceSettings() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.saving = true;
            yield this.server.postJson('/api/settings/instance', this.instanceSettings);
            this.saving = false;
        });
    }
    validate() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const results = yield this.validator.validateObject(this.instanceSettings);
            this.canSave = results.every(result => result.valid);
        });
    }
};
InstanceSettings = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('instance-settings'),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], aurelia_validation__WEBPACK_IMPORTED_MODULE_3__["Validator"], aurelia_validation__WEBPACK_IMPORTED_MODULE_3__["ValidationControllerFactory"]])
], InstanceSettings);



/***/ }),

/***/ "../apps/core/administration/src/pages/administration/settings/elements/mail-settings.html":
/*!*************************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/settings/elements/mail-settings.html ***!
  \*************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel\">\r\n        <div class=\"panel-heading\">\r\n            Mail\r\n        </div>\r\n        <div class=\"panel-body\">                    \r\n            <div class=\"loading\" if.bind=\"!mailSettings\"></div>\r\n            <div if.bind=\"mailSettings\">\r\n                <label>\r\n                    <input type=\"checkbox\" checked.bind=\"custom\"/>\r\n                    <span if.bind=\"isCloud\">Use custom mail server</span>\r\n                    <span if.bind=\"!isCloud\">Override mail settings</span>\r\n                </label>\r\n                <div class=\"form\" if.bind=\"custom\">\r\n                    <div class=\"form-group\">\r\n                        <label>Server</label>\r\n                        <input type=\"text\" value.bind=\"mailSettings.server & validate\"/>\r\n                    </div>\r\n                    <div class=\"form-group\">\r\n                        <label>Port</label>\r\n                        <input type=\"text\" value.bind=\"mailSettings.port & validate\"/>\r\n                    </div>\r\n                    <div class=\"form-group\">\r\n                        <label>Username</label>\r\n                        <input type=\"text\" value.bind=\"mailSettings.username & validate\"/>\r\n                    </div>\r\n                    <div class=\"form-group\">\r\n                        <label>Password</label>\r\n                        <input type=\"password\" value.bind=\"mailSettings.password & validate\"/>\r\n                    </div>\r\n                    <div class=\"form-group\">\r\n                        <label>\r\n                            <input type=\"checkbox\" checked.bind=\"test.do\" />\r\n                            Test settings\r\n                        </label>\r\n                        <div if.bind=\"test.do\">\r\n                            <label>Send to email</label>\r\n                            <input type=\"text\" value.bind=\"test.email & validate\"/>\r\n                        </div>\r\n                        <div if.bind=\"test.do\" class=\"text-right\" style=\"margin-top: 5px;\">\r\n                            <span class=\"loading\" if.bind=\"test.loading\">-</span>\r\n                            <span if.bind=\"test.done\">\r\n                                <i class=\"fa fa-exclamation-triangle\" if.bind=\"!test.verified\"></i>\r\n                                <i class=\"fa fa-check\" if.bind=\"test.verified\"></i>\r\n                            </span>\r\n                            <button click.delegate=\"testMailSettings()\" class=\"small\" disabled.bind=\"test.loading || !test.valid || !test.email || !canSave\">Test settings</button><br/><br/>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"form\">\r\n                    <div class=\"form-group text-right\">\r\n                        <span class=\"loading\" if.bind=\"saving\">-</span>\r\n                        <button click.delegate=\"saveMailSettings()\" disabled.bind=\"!canSave\">Save</button>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/settings/elements/mail-settings.ts":
/*!***********************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/settings/elements/mail-settings.ts ***!
  \***********************************************************************************************/
/*! exports provided: MailSettings */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MailSettings", function() { return MailSettings; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-validation */ "./node_modules/aurelia-validation/dist/commonjs/aurelia-validation.js");
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_validation__WEBPACK_IMPORTED_MODULE_3__);




let MailSettings = class MailSettings {
    constructor(server, validator, controllerFactory) {
        this.server = server;
        this.validator = validator;
        this.isCloud = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].get().configuration.isCloud;
        this.canSave = false;
        this.saving = false;
        this.custom = false;
        this.test = {
            do: false,
            valid: false,
            email: ''
        };
        this.controller = controllerFactory.createForCurrentScope();
        this.controller.validateTrigger = aurelia_validation__WEBPACK_IMPORTED_MODULE_3__["validateTrigger"].changeOrBlur;
        this.controller.subscribe(event => this.validateTest());
        aurelia_validation__WEBPACK_IMPORTED_MODULE_3__["ValidationRules"]
            .ensure('email').email()
            .on(this.test);
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadMailSettings();
        });
    }
    testMailSettings() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            try {
                this.test.done = false;
                this.test.loading = true;
                const response = yield this.server.postJson('/api/settings/mail/test/' + this.test.email, this.mailSettings);
                this.test.verified = response.ok;
            }
            catch (error) {
                this.test.verified = false;
                this.test.error = error[0].message;
            }
            finally {
                this.test.done = true;
                this.test.loading = false;
            }
        });
    }
    saveMailSettings() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.saving = true;
            if (!this.custom) {
                yield this.server.delete('/api/settings/mail');
                this.mailSettings.server = null;
                this.mailSettings.port = null;
                this.mailSettings.username = null;
                this.mailSettings.password = null;
            }
            else {
                yield this.server.postJson('/api/settings/mail', this.mailSettings);
            }
            this.saving = false;
        });
    }
    loadMailSettings() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const response = yield this.server.get('/api/settings/mail');
            const json = yield response.json();
            this.mailSettings = json;
            if (!this.mailSettings) {
                this.mailSettings = {};
            }
            this.custom = !!this.mailSettings.server;
            aurelia_validation__WEBPACK_IMPORTED_MODULE_3__["ValidationRules"]
                .ensure('server').required()
                .ensure('port').required().satisfiesRule('integerRange', 1, 65535)
                .ensure('username').required()
                .ensure('password').required()
                .on(this.mailSettings);
            this.controller.subscribe(event => this.validate());
        });
    }
    validate() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const results = yield this.validator.validateObject(this.mailSettings);
            this.canSave = results.every(result => result.valid);
        });
    }
    validateTest() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const results = yield this.validator.validateObject(this.test);
            this.test.valid = results.every(result => result.valid);
        });
    }
};
MailSettings = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('mail-settings'),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], aurelia_validation__WEBPACK_IMPORTED_MODULE_3__["Validator"], aurelia_validation__WEBPACK_IMPORTED_MODULE_3__["ValidationControllerFactory"]])
], MailSettings);



/***/ }),

/***/ "../apps/core/administration/temp/gen-app.js":
/*!***************************************************!*\
  !*** ../apps/core/administration/temp/gen-app.js ***!
  \***************************************************/
/*! exports provided: plugins, hot, moduleId */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(module) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "plugins", function() { return plugins; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hot", function() { return hot; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "moduleId", function() { return moduleId; });
const plugins = [
{
 func: __webpack_require__(/*! ../src/pages/administration/settings/elements/data-access-settings.ts */ "../apps/core/administration/src/pages/administration/settings/elements/data-access-settings.ts"),
 types: ["html_element"],
 view: __webpack_require__(/*! ../src/pages/administration/settings/elements/data-access-settings.html */ "../apps/core/administration/src/pages/administration/settings/elements/data-access-settings.html"),
},
{
 func: __webpack_require__(/*! ../src/pages/administration/settings/elements/instance-settings.ts */ "../apps/core/administration/src/pages/administration/settings/elements/instance-settings.ts"),
 types: ["html_element"],
 view: __webpack_require__(/*! ../src/pages/administration/settings/elements/instance-settings.html */ "../apps/core/administration/src/pages/administration/settings/elements/instance-settings.html"),
},
{
 func: __webpack_require__(/*! ../src/pages/administration/settings/elements/mail-settings.ts */ "../apps/core/administration/src/pages/administration/settings/elements/mail-settings.ts"),
 types: ["html_element"],
 view: __webpack_require__(/*! ../src/pages/administration/settings/elements/mail-settings.html */ "../apps/core/administration/src/pages/administration/settings/elements/mail-settings.html"),
},
{
 id: 'routePage_src/pages/administration/apps/index',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/apps/index */ "routePage_src/pages/administration/apps/index").then(__webpack_require__.bind(null, /*! ../src/pages/administration/apps/index.ts */ "../apps/core/administration/src/pages/administration/apps/index.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/apps/index */ "routePage_src/pages/administration/apps/index").then(__webpack_require__.t.bind(null, /*! ../src/pages/administration/apps/index.html */ "../apps/core/administration/src/pages/administration/apps/index.html", 7)),
},
{
 id: 'routePage_src/pages/administration/audit-trail',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/audit-trail */ "routePage_src/pages/administration/audit-trail").then(__webpack_require__.bind(null, /*! ../src/pages/administration/audit-trail.ts */ "../apps/core/administration/src/pages/administration/audit-trail.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/audit-trail */ "routePage_src/pages/administration/audit-trail").then(__webpack_require__.t.bind(null, /*! ../src/pages/administration/audit-trail.html */ "../apps/core/administration/src/pages/administration/audit-trail.html", 7)),
},
{
 id: 'routePage_src/pages/administration/data-sync/index',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/data-sync/index */ "routePage_src/pages/administration/data-sync/index").then(__webpack_require__.bind(null, /*! ../src/pages/administration/data-sync/index.ts */ "../apps/core/administration/src/pages/administration/data-sync/index.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/data-sync/index */ "routePage_src/pages/administration/data-sync/index").then(__webpack_require__.t.bind(null, /*! ../src/pages/administration/data-sync/index.html */ "../apps/core/administration/src/pages/administration/data-sync/index.html", 7)),
},
{
 id: 'routePage_src/pages/administration/datamodel',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/datamodel */ "routePage_src/pages/administration/datamodel").then(__webpack_require__.bind(null, /*! ../src/pages/administration/datamodel.ts */ "../apps/core/administration/src/pages/administration/datamodel.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/datamodel */ "routePage_src/pages/administration/datamodel").then(__webpack_require__.t.bind(null, /*! ../src/pages/administration/datamodel.html */ "../apps/core/administration/src/pages/administration/datamodel.html", 7)),
},
{
 id: 'routePage_src/pages/administration/index',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/index */ "routePage_src/pages/administration/index").then(__webpack_require__.bind(null, /*! ../src/pages/administration/index.ts */ "../apps/core/administration/src/pages/administration/index.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/index */ "routePage_src/pages/administration/index").then(__webpack_require__.t.bind(null, /*! ../src/pages/administration/index.html */ "../apps/core/administration/src/pages/administration/index.html", 7)),
},
{
 id: 'routePage_src/pages/administration/plugins',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/plugins */ "routePage_src/pages/administration/plugins").then(__webpack_require__.bind(null, /*! ../src/pages/administration/plugins.ts */ "../apps/core/administration/src/pages/administration/plugins.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/plugins */ "routePage_src/pages/administration/plugins").then(__webpack_require__.t.bind(null, /*! ../src/pages/administration/plugins.html */ "../apps/core/administration/src/pages/administration/plugins.html", 7)),
},
{
 id: 'routePage_src/pages/administration/settings/index',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/settings/index */ "routePage_src/pages/administration/settings/index").then(__webpack_require__.bind(null, /*! ../src/pages/administration/settings/index.ts */ "../apps/core/administration/src/pages/administration/settings/index.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/settings/index */ "routePage_src/pages/administration/settings/index").then(__webpack_require__.t.bind(null, /*! ../src/pages/administration/settings/index.html */ "../apps/core/administration/src/pages/administration/settings/index.html", 7)),
},
{
 id: 'routePage_src/pages/administration/users/index',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/users/index */ "routePage_src/pages/administration/users/index").then(__webpack_require__.bind(null, /*! ../src/pages/administration/users/index.ts */ "../apps/core/administration/src/pages/administration/users/index.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/users/index */ "routePage_src/pages/administration/users/index").then(__webpack_require__.t.bind(null, /*! ../src/pages/administration/users/index.html */ "../apps/core/administration/src/pages/administration/users/index.html", 7)),
},
{
 id: 'routePage_src/pages/administration/users/user-roles',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/users/user-roles */ "routePage_src/pages/administration/users/user-roles").then(__webpack_require__.bind(null, /*! ../src/pages/administration/users/user-roles.ts */ "../apps/core/administration/src/pages/administration/users/user-roles.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/administration/users/user-roles */ "routePage_src/pages/administration/users/user-roles").then(__webpack_require__.t.bind(null, /*! ../src/pages/administration/users/user-roles.html */ "../apps/core/administration/src/pages/administration/users/user-roles.html", 7)),
},
{
 id: 'routePage_src/pages/data-administration/departments',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/data-administration/departments */ "routePage_src/pages/data-administration/departments").then(__webpack_require__.bind(null, /*! ../src/pages/data-administration/departments.ts */ "../apps/core/administration/src/pages/data-administration/departments.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/data-administration/departments */ "routePage_src/pages/data-administration/departments").then(__webpack_require__.t.bind(null, /*! ../src/pages/data-administration/departments.html */ "../apps/core/administration/src/pages/data-administration/departments.html", 7)),
},
{
 id: 'routePage_src/pages/data-administration/index',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/data-administration/index */ "routePage_src/pages/data-administration/index").then(__webpack_require__.bind(null, /*! ../src/pages/data-administration/index.ts */ "../apps/core/administration/src/pages/data-administration/index.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/data-administration/index */ "routePage_src/pages/data-administration/index").then(__webpack_require__.t.bind(null, /*! ../src/pages/data-administration/index.html */ "../apps/core/administration/src/pages/data-administration/index.html", 7)),
},
{
 id: 'routePage_src/pages/data-administration/projects',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/data-administration/projects */ "routePage_src/pages/data-administration/projects").then(__webpack_require__.bind(null, /*! ../src/pages/data-administration/projects.ts */ "../apps/core/administration/src/pages/data-administration/projects.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/data-administration/projects */ "routePage_src/pages/data-administration/projects").then(__webpack_require__.t.bind(null, /*! ../src/pages/data-administration/projects.html */ "../apps/core/administration/src/pages/data-administration/projects.html", 7)),
},
];
const hot = module.hot;
const moduleId = module.i;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../../../../client/node_modules/webpack/buildin/harmony-module.js */ "./node_modules/webpack/buildin/harmony-module.js")(module)))

/***/ }),

/***/ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js":
/*!***********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js from dll-reference scifeon_vendor ***!
  \***********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");

/***/ }),

/***/ "./node_modules/aurelia-validation/dist/commonjs/aurelia-validation.js":
/*!*************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-validation/dist/commonjs/aurelia-validation.js from dll-reference scifeon_vendor ***!
  \*************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-validation/dist/commonjs/aurelia-validation.js");

/***/ }),

/***/ "./node_modules/tslib/tslib.js":
/*!*************************************!*\
  !*** ./node_modules/tslib/tslib.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global global, define, System, Reflect, Promise */
var __extends;
var __assign;
var __rest;
var __decorate;
var __param;
var __metadata;
var __awaiter;
var __generator;
var __exportStar;
var __values;
var __read;
var __spread;
var __await;
var __asyncGenerator;
var __asyncDelegator;
var __asyncValues;
var __makeTemplateObject;
var __importStar;
var __importDefault;
(function (factory) {
    var root = typeof global === "object" ? global : typeof self === "object" ? self : typeof this === "object" ? this : {};
    if (true) {
        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports], __WEBPACK_AMD_DEFINE_RESULT__ = (function (exports) { factory(createExporter(root, createExporter(exports))); }).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    }
    else {}
    function createExporter(exports, previous) {
        if (exports !== root) {
            if (typeof Object.create === "function") {
                Object.defineProperty(exports, "__esModule", { value: true });
            }
            else {
                exports.__esModule = true;
            }
        }
        return function (id, v) { return exports[id] = previous ? previous(id, v) : v; };
    }
})
(function (exporter) {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    __extends = function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };

    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };

    __rest = function (s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
                t[p[i]] = s[p[i]];
        return t;
    };

    __decorate = function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };

    __param = function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };

    __metadata = function (metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    };

    __awaiter = function (thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    };

    __generator = function (thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    };

    __exportStar = function (m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    };

    __values = function (o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    };

    __read = function (o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    };

    __spread = function () {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    };

    __await = function (v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    };

    __asyncGenerator = function (thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);  }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    };

    __asyncDelegator = function (o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    };

    __asyncValues = function (o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    };

    __makeTemplateObject = function (cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    __importStar = function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result["default"] = mod;
        return result;
    };

    __importDefault = function (mod) {
        return (mod && mod.__esModule) ? mod : { "default": mod };
    };

    exporter("__extends", __extends);
    exporter("__assign", __assign);
    exporter("__rest", __rest);
    exporter("__decorate", __decorate);
    exporter("__param", __param);
    exporter("__metadata", __metadata);
    exporter("__awaiter", __awaiter);
    exporter("__generator", __generator);
    exporter("__exportStar", __exportStar);
    exporter("__values", __values);
    exporter("__read", __read);
    exporter("__spread", __spread);
    exporter("__await", __await);
    exporter("__asyncGenerator", __asyncGenerator);
    exporter("__asyncDelegator", __asyncDelegator);
    exporter("__asyncValues", __asyncValues);
    exporter("__makeTemplateObject", __makeTemplateObject);
    exporter("__importStar", __importStar);
    exporter("__importDefault", __importDefault);
});

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../webpack/buildin/global.js */ "./node_modules/webpack/buildin/global.js")))

/***/ }),

/***/ "./node_modules/webpack/buildin/global.js":
/*!********************************************************************************************!*\
  !*** delegated ./node_modules/webpack/buildin/global.js from dll-reference scifeon_vendor ***!
  \********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/webpack/buildin/global.js");

/***/ }),

/***/ "./node_modules/webpack/buildin/harmony-module.js":
/*!*******************************************!*\
  !*** (webpack)/buildin/harmony-module.js ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = function(originalModule) {
	if (!originalModule.webpackPolyfill) {
		var module = Object.create(originalModule);
		// module.parent = undefined by default
		if (!module.children) module.children = [];
		Object.defineProperty(module, "loaded", {
			enumerable: true,
			get: function() {
				return module.l;
			}
		});
		Object.defineProperty(module, "id", {
			enumerable: true,
			get: function() {
				return module.i;
			}
		});
		Object.defineProperty(module, "exports", {
			enumerable: true
		});
		module.webpackPolyfill = 1;
	}
	return module;
};


/***/ }),

/***/ "./packages/core/index.ts":
/*!**************************************************************************!*\
  !*** delegated ./packages/core/index.ts from dll-reference scifeon_core ***!
  \**************************************************************************/
/*! exports provided: Config, ScifeonConsoleLogger, ConsoleLogger, Status, Event, DataModel, ReadExcelCommon, XL, LoadingSpinner, ScifeonLoadingSpinner, ServerAPI, User, UserHelper, DSUtils, DateUtils, MathUtils, PLATE, PluginUtils, ScifeonUtils, Utils, SdkUtils, SpreadsheetUtils */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_core */ "dll-reference scifeon_core"))("./packages/core/index.ts");

/***/ }),

/***/ 0:
/*!*********************************************************!*\
  !*** multi ../apps/core/administration/temp/gen-app.js ***!
  \*********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! C:\agent\_work\3\s\apps\core\administration\temp\gen-app.js */"../apps/core/administration/temp/gen-app.js");


/***/ }),

/***/ "dll-reference scifeon_core":
/*!*******************************!*\
  !*** external "scifeon_core" ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_core;

/***/ }),

/***/ "dll-reference scifeon_plugins":
/*!**********************************!*\
  !*** external "scifeon_plugins" ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_plugins;

/***/ }),

/***/ "dll-reference scifeon_ui":
/*!*****************************!*\
  !*** external "scifeon_ui" ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_ui;

/***/ }),

/***/ "dll-reference scifeon_vendor":
/*!*********************************!*\
  !*** external "scifeon_vendor" ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_vendor;

/***/ })

/******/ }));;
//# sourceMappingURL=app.js.map