(window["webpackJsonpcom_scifeon_scifeon_administration"] = window["webpackJsonpcom_scifeon_scifeon_administration"] || []).push([["routePage_src/pages/administration/datamodel"],{

/***/ "../apps/core/administration/src/pages/administration/datamodel.html":
/*!***************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/datamodel.html ***!
  \***************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-panels\">\r\n        <div style=\"display: none\" class=\"panel\" style=\"margin-bottom: 10px;\">\r\n            <div class=\"panel-body\">\r\n                <p>You can find information about the different entity classes in the <a target=\"_blank\" href=\"http://docs.scifeon.com/guide-dm/datamodel/index\">Data Management Guide</a></p>\r\n                </div>\r\n        </div>\r\n\r\n        <div ref=\"columnsPopup\" class=\"popup\" click.delegate=\"hideColumns()\">\r\n            <div class=\"popup-content\" style=\"width: 600px; max-width: 90%;\">\r\n                <div class=\"panel catchy\" style=\"border: 1px solid #337ac1;\">\r\n                    <div class=\"panel-heading\">Columns in ${popupTable.name}</div>\r\n                    <div class=\"panel-body\">\r\n                        <table class=\"table compact\">\r\n                            <thead>\r\n                                <tr>\r\n                                    <th>Name</th>\r\n                                    <th>Type</th>\r\n                                    <th>Size</th>\r\n                                    <th>Type (CLR)</th>\r\n                                    <th>Required</th>\r\n                                    <th>Shared</th>\r\n                                    <th>FK</th>\r\n                                </tr>\r\n                            </thead>\r\n                            <tbody>\r\n                                <tr repeat.for=\"col of popupTable.columns\">\r\n                                    <th>${col.name}</th>\r\n                                    <th>${col.dbType}</th>\r\n                                    <th>${col.size}</th>\r\n                                    <th>${col.type}</th>\r\n                                    <th>${col.form.isRequired ? 'Yes' : ''}</th>\r\n                                    <th>${col.isShared ? 'Yes' : ''}</th>\r\n                                    <th>${col.foreignKeyTo}</th>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"detail-panels\" style=\"grid-template-columns: repeat(auto-fit, minmax(450px,1fr));\">\r\n            <div class=\"panel\" repeat.for=\"group of groups\">\r\n                <div class=\"panel-heading\">${group.name}: ${group.description}</div>\r\n                <div class=\"panel-body\">\r\n                    <table class=\"table compact\">\r\n                        <thead><tr><th>Name</th><th>Description</th></tr></thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"table of group.tables\">\r\n                                <td>\r\n                                    <a href=\"/#/entity/${table.name}/list\">${table.name}</a>\r\n                                    <span class=\"fa fa-columns\" click.trigger=\"showColumns(table)\" style=\"float: right; margin: 4px 0 0 3px; cursor:pointer;font-size:80%;\"></span>\r\n                                </td>\r\n                                <td>${table.description}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/datamodel.ts":
/*!*************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/datamodel.ts ***!
  \*************************************************************************/
/*! exports provided: DataModelView */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataModelView", function() { return DataModelView; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");



let DataModelView = class DataModelView {
    constructor(model) {
        this.model = model;
        this.model = model;
        this.popupTable = { name: '', columns: [] };
        let descriptions = {
            'MD': 'MasterData',
            'Core': 'Shared tables',
            'EvM': 'Event handling',
            'PnS': 'Stuff (Plates & Samples)',
            'WFM': 'Workflow management',
            'Bio': 'Biology',
            'Assay': 'Result management'
        };
        this.groups = [];
        for (let table of model.tables) {
            if (table.tableCategory !== 'PrimaryEntity' && table.tableCategory !== 'ResultEntity')
                continue;
            if (table.group === 'Test' || table.group === 'RLS')
                continue;
            let group = this.groups.find(g => g.name == table.group);
            if (!group) {
                group = { name: table.group, description: descriptions[table.group], tables: [] };
                this.groups.push(group);
            }
            group.tables.push(table);
        }
    }
    showColumns(table) {
        this.popupTable = table;
        this.columnsPopup.style.display = "block";
    }
    hideColumns() {
        this.columnsPopup.style.display = "none";
    }
};
DataModelView = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'admin/datamodel',
        title: 'Datamodel',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PAGE_TYPE"].ADMINISTRATION
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DataModel"]])
], DataModelView);



/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ })

}]);
//# sourceMappingURL=datamodel.e28d4943052103ad78ee.js.map