com_scifeon_scifeon_apps_demo(/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 	};
/******/
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		"app": 0
/******/ 	};
/******/
/******/
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "" + chunkId + "." + "5d0bc4c08e328465e5be" + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var head = document.getElementsByTagName('head')[0];
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							var error = new Error('Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')');
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/bundledApps/com.scifeon/scifeon_apps_demo/";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["webpackJsonpcom_scifeon_scifeon_apps_demo"] = window["webpackJsonpcom_scifeon_scifeon_apps_demo"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "../apps/demo/demo_app/src/widgets/demo-widget.html":
/*!**********************************************************!*\
  !*** ../apps/demo/demo_app/src/widgets/demo-widget.html ***!
  \**********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <h2>Demo Pages</h2>\r\n</template>";

/***/ }),

/***/ "../apps/demo/demo_app/src/widgets/demo-widget.ts":
/*!********************************************************!*\
  !*** ../apps/demo/demo_app/src/widgets/demo-widget.ts ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
const plugins_1 = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
let DemoPagesWidget = class DemoPagesWidget {
    constructor() {
        this.view = () => __webpack_require__(/*! ./demo-widget.html */ "../apps/demo/demo_app/src/widgets/demo-widget.html");
        this.defaultConfig = () => ({
            useHeader: false
        });
        this.configView = () => __webpack_require__(/*! ./demo-widget.html */ "../apps/demo/demo_app/src/widgets/demo-widget.html");
    }
};
DemoPagesWidget = tslib_1.__decorate([
    plugins_1.scifeonPlugin({
        id: 'DemoPagesWidget',
        type: plugins_1.PLUGIN_TYPE.DASHBOARD_WIDGET,
        name: 'Demo Pages',
        description: 'A static widget with links to demo pages'
    })
], DemoPagesWidget);
exports.DemoPagesWidget = DemoPagesWidget;


/***/ }),

/***/ "../apps/demo/demo_app/temp/gen-app.js":
/*!*********************************************!*\
  !*** ../apps/demo/demo_app/temp/gen-app.js ***!
  \*********************************************/
/*! exports provided: plugins, hot, moduleId */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(module) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "plugins", function() { return plugins; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hot", function() { return hot; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "moduleId", function() { return moduleId; });
const plugins = [
{
 id: 'DemoPagesWidget',
 func: __webpack_require__(/*! ../src/widgets/demo-widget.ts */ "../apps/demo/demo_app/src/widgets/demo-widget.ts"),
 types: ["dashboard.widget"],
 view: __webpack_require__(/*! ../src/widgets/demo-widget.html */ "../apps/demo/demo_app/src/widgets/demo-widget.html"),
 name: 'Demo Pages',
 description: 'A static widget with links to demo pages'
},
{
 id: 'routePage_src/pages/element/chart',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/chart */ "routePage_src/pages/element/chart").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/chart.ts */ "../apps/demo/demo_app/src/pages/element/chart.ts", 7)),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/chart */ "routePage_src/pages/element/chart").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/chart.html */ "../apps/demo/demo_app/src/pages/element/chart.html", 7)),
},
{
 id: 'routePage_src/pages/element/dataset-query',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/dataset-query */ "routePage_src/pages/element/dataset-query").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/dataset-query.ts */ "../apps/demo/demo_app/src/pages/element/dataset-query.ts", 7)),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/dataset-query */ "routePage_src/pages/element/dataset-query").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/dataset-query.html */ "../apps/demo/demo_app/src/pages/element/dataset-query.html", 7)),
},
{
 id: 'routePage_src/pages/element/dialog',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/dialog */ "routePage_src/pages/element/dialog").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/dialog.ts */ "../apps/demo/demo_app/src/pages/element/dialog.ts", 7)),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/dialog */ "routePage_src/pages/element/dialog").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/dialog.html */ "../apps/demo/demo_app/src/pages/element/dialog.html", 7)),
},
{
 id: 'routePage_src/pages/element/insert-entities',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/insert-entities */ "routePage_src/pages/element/insert-entities").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/insert-entities.ts */ "../apps/demo/demo_app/src/pages/element/insert-entities.ts", 7)),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/insert-entities */ "routePage_src/pages/element/insert-entities").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/insert-entities.html */ "../apps/demo/demo_app/src/pages/element/insert-entities.html", 7)),
},
{
 id: 'routePage_src/pages/element/list-view',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/list-view */ "routePage_src/pages/element/list-view").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/list-view.ts */ "../apps/demo/demo_app/src/pages/element/list-view.ts", 7)),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/list-view */ "routePage_src/pages/element/list-view").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/list-view.html */ "../apps/demo/demo_app/src/pages/element/list-view.html", 7)),
},
{
 id: 'routePage_src/pages/element/loading-spinner',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/loading-spinner */ "routePage_src/pages/element/loading-spinner").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/loading-spinner.ts */ "../apps/demo/demo_app/src/pages/element/loading-spinner.ts", 7)),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/loading-spinner */ "routePage_src/pages/element/loading-spinner").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/loading-spinner.html */ "../apps/demo/demo_app/src/pages/element/loading-spinner.html", 7)),
},
{
 id: 'routePage_src/pages/element/plate-editor',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/plate-editor */ "routePage_src/pages/element/plate-editor").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/plate-editor.ts */ "../apps/demo/demo_app/src/pages/element/plate-editor.ts", 7)),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/plate-editor */ "routePage_src/pages/element/plate-editor").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/plate-editor.html */ "../apps/demo/demo_app/src/pages/element/plate-editor.html", 7)),
},
{
 id: 'routePage_src/pages/element/record-editor-demo',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/record-editor-demo */ "routePage_src/pages/element/record-editor-demo").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/record-editor-demo.ts */ "../apps/demo/demo_app/src/pages/element/record-editor-demo.ts", 7)),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/record-editor-demo */ "routePage_src/pages/element/record-editor-demo").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/record-editor-demo.html */ "../apps/demo/demo_app/src/pages/element/record-editor-demo.html", 7)),
},
{
 id: 'routePage_src/pages/element/rich-text-editor',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/rich-text-editor */ "routePage_src/pages/element/rich-text-editor").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/rich-text-editor.ts */ "../apps/demo/demo_app/src/pages/element/rich-text-editor.ts", 7)),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/element/rich-text-editor */ "routePage_src/pages/element/rich-text-editor").then(__webpack_require__.t.bind(null, /*! ../src/pages/element/rich-text-editor.html */ "../apps/demo/demo_app/src/pages/element/rich-text-editor.html", 7)),
},
{
 id: 'routePage_src/pages/element/visual-data-loader',
 func: () => Promise.all(/*! import() | routePage_src/pages/element/visual-data-loader */[__webpack_require__.e("vendors~routePage_src/pages/element/visual-data-loader"), __webpack_require__.e("routePage_src/pages/element/visual-data-loader")]).then(__webpack_require__.t.bind(null, /*! ../src/pages/element/visual-data-loader.ts */ "../apps/demo/demo_app/src/pages/element/visual-data-loader.ts", 7)),
 types: ["page"],
 func: () => Promise.all(/*! import() | routePage_src/pages/element/visual-data-loader */[__webpack_require__.e("vendors~routePage_src/pages/element/visual-data-loader"), __webpack_require__.e("routePage_src/pages/element/visual-data-loader")]).then(__webpack_require__.t.bind(null, /*! ../src/pages/element/visual-data-loader.html */ "../apps/demo/demo_app/src/pages/element/visual-data-loader.html", 7)),
},
{
 id: 'routePage_src/pages/index',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/index */ "routePage_src/pages/index").then(__webpack_require__.t.bind(null, /*! ../src/pages/index.ts */ "../apps/demo/demo_app/src/pages/index.ts", 7)),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/index */ "routePage_src/pages/index").then(__webpack_require__.t.bind(null, /*! ../src/pages/index.html */ "../apps/demo/demo_app/src/pages/index.html", 7)),
},
];
const hot = module.hot;
const moduleId = module.i;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../../../../client/node_modules/webpack/buildin/harmony-module.js */ "./node_modules/webpack/buildin/harmony-module.js")(module)))

/***/ }),

/***/ "./node_modules/tslib/tslib.js":
/*!*************************************!*\
  !*** ./node_modules/tslib/tslib.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global global, define, System, Reflect, Promise */
var __extends;
var __assign;
var __rest;
var __decorate;
var __param;
var __metadata;
var __awaiter;
var __generator;
var __exportStar;
var __values;
var __read;
var __spread;
var __await;
var __asyncGenerator;
var __asyncDelegator;
var __asyncValues;
var __makeTemplateObject;
var __importStar;
var __importDefault;
(function (factory) {
    var root = typeof global === "object" ? global : typeof self === "object" ? self : typeof this === "object" ? this : {};
    if (true) {
        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports], __WEBPACK_AMD_DEFINE_RESULT__ = (function (exports) { factory(createExporter(root, createExporter(exports))); }).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    }
    else {}
    function createExporter(exports, previous) {
        if (exports !== root) {
            if (typeof Object.create === "function") {
                Object.defineProperty(exports, "__esModule", { value: true });
            }
            else {
                exports.__esModule = true;
            }
        }
        return function (id, v) { return exports[id] = previous ? previous(id, v) : v; };
    }
})
(function (exporter) {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    __extends = function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };

    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };

    __rest = function (s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
                t[p[i]] = s[p[i]];
        return t;
    };

    __decorate = function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };

    __param = function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };

    __metadata = function (metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    };

    __awaiter = function (thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    };

    __generator = function (thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    };

    __exportStar = function (m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    };

    __values = function (o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    };

    __read = function (o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    };

    __spread = function () {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    };

    __await = function (v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    };

    __asyncGenerator = function (thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);  }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    };

    __asyncDelegator = function (o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    };

    __asyncValues = function (o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    };

    __makeTemplateObject = function (cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    __importStar = function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result["default"] = mod;
        return result;
    };

    __importDefault = function (mod) {
        return (mod && mod.__esModule) ? mod : { "default": mod };
    };

    exporter("__extends", __extends);
    exporter("__assign", __assign);
    exporter("__rest", __rest);
    exporter("__decorate", __decorate);
    exporter("__param", __param);
    exporter("__metadata", __metadata);
    exporter("__awaiter", __awaiter);
    exporter("__generator", __generator);
    exporter("__exportStar", __exportStar);
    exporter("__values", __values);
    exporter("__read", __read);
    exporter("__spread", __spread);
    exporter("__await", __await);
    exporter("__asyncGenerator", __asyncGenerator);
    exporter("__asyncDelegator", __asyncDelegator);
    exporter("__asyncValues", __asyncValues);
    exporter("__makeTemplateObject", __makeTemplateObject);
    exporter("__importStar", __importStar);
    exporter("__importDefault", __importDefault);
});

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../webpack/buildin/global.js */ "./node_modules/webpack/buildin/global.js")))

/***/ }),

/***/ "./node_modules/webpack/buildin/global.js":
/*!********************************************************************************************!*\
  !*** delegated ./node_modules/webpack/buildin/global.js from dll-reference scifeon_vendor ***!
  \********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/webpack/buildin/global.js");

/***/ }),

/***/ "./node_modules/webpack/buildin/harmony-module.js":
/*!*******************************************!*\
  !*** (webpack)/buildin/harmony-module.js ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = function(originalModule) {
	if (!originalModule.webpackPolyfill) {
		var module = Object.create(originalModule);
		// module.parent = undefined by default
		if (!module.children) module.children = [];
		Object.defineProperty(module, "loaded", {
			enumerable: true,
			get: function() {
				return module.l;
			}
		});
		Object.defineProperty(module, "id", {
			enumerable: true,
			get: function() {
				return module.i;
			}
		});
		Object.defineProperty(module, "exports", {
			enumerable: true
		});
		module.webpackPolyfill = 1;
	}
	return module;
};


/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ 0:
/*!***************************************************!*\
  !*** multi ../apps/demo/demo_app/temp/gen-app.js ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! C:\agent\_work\3\s\apps\demo\demo_app\temp\gen-app.js */"../apps/demo/demo_app/temp/gen-app.js");


/***/ }),

/***/ "dll-reference scifeon_data":
/*!*******************************!*\
  !*** external "scifeon_data" ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_data;

/***/ }),

/***/ "dll-reference scifeon_plugins":
/*!**********************************!*\
  !*** external "scifeon_plugins" ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_plugins;

/***/ }),

/***/ "dll-reference scifeon_ui":
/*!*****************************!*\
  !*** external "scifeon_ui" ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_ui;

/***/ }),

/***/ "dll-reference scifeon_vendor":
/*!*********************************!*\
  !*** external "scifeon_vendor" ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_vendor;

/***/ })

/******/ }));;
//# sourceMappingURL=app.js.map