(window["webpackJsonpcom_scifeon_scifeon_apps_demo"] = window["webpackJsonpcom_scifeon_scifeon_apps_demo"] || []).push([["routePage_src/pages/element/dialog"],{

/***/ "../apps/demo/demo_app/src/pages/element/dialog.html":
/*!***********************************************************!*\
  !*** ../apps/demo/demo_app/src/pages/element/dialog.html ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header prototype\">\r\n        <div class=\"page-header\">\r\n            <h1>Scifeon Demo Pages</h1>\r\n        </div>\r\n        <div class=\"panel-group\">\r\n\r\n            <div class=\"page-panels grid full-width-panels\">\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Dialog Demo</div>\r\n                    <div class=\"panel-body\">This page shows the Scifeon dialog boxes. The first two are simple confirmation and messaging dialog\r\n                        boxes while the third box shows a custom dialog box implementation.</div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"page-panels grid\">\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Confirm Dialog</div>\r\n                    <div class=\"panel-body\">\r\n                        <button click.delegate=\"confirm()\">Open</button>\r\n                        <b>Answer:</b> ${answer}\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Message Dialog</div>\r\n                    <div class=\"panel-body\">\r\n                        <button click.delegate=\"message()\">Open</button>\r\n                        <b>Clicked?:</b> ${messagep}\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Custom Dialog</div>\r\n                    <div class=\"panel-body\">\r\n                        <button click.delegate=\"customDialog()\">Open</button>\r\n                        <b>Result:</b> ${result}\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/demo_app/src/pages/element/dialog.ts":
/*!*********************************************************!*\
  !*** ../apps/demo/demo_app/src/pages/element/dialog.ts ***!
  \*********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
const plugins_1 = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
const ui_1 = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
const aurelia_framework_1 = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
let DemoDialog = class DemoDialog {
    constructor(dialog) {
        this.dialog = dialog;
        this.answer = 'Not clicked yet';
        this.messagep = 'Not clicked yet';
        this.result = 'Not clicked yet';
    }
    confirm() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const result = yield this.dialog.confirm('Yes or no?');
            this.answer = result ? 'Yes' : 'No';
        });
    }
    message() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const result = yield this.dialog.message('Simple message');
            if (result) {
                this.messagep = 'Clicked';
            }
        });
    }
    customDialog() {
        this.dialog.open({
            viewModel: CustomDialog
        }).whenClosed(result => {
            this.result = result.wasCancelled ? 'Cancelled' : 'OK';
        });
    }
};
DemoDialog = tslib_1.__decorate([
    aurelia_framework_1.autoinject,
    plugins_1.route({
        route: 'demo/element/dialog',
        title: 'Demo - Dialog'
    }),
    tslib_1.__metadata("design:paramtypes", [ui_1.Dialog])
], DemoDialog);
exports.DemoDialog = DemoDialog;
class CustomDialog {
    constructor(dialog) {
        this.dialog = dialog;
        this.view = () => `
        <ux-dialog>
            <ux-dialog-header>Header</ux-dialog-header>
            <ux-dialog-body>Test</ux-dialog-body>
            <ux-dialog-footer>
                <button click.delegate="okPressed()">OK</button>
                <button class="btn-link" click.delegate="dialog.cancel()">Cancel</button>
            </ux-dialog-footer>
        </ux-dialog>`;
    }
    okPressed() {
        this.dialog.ok();
    }
}
tslib_1.__decorate([
    ui_1.Dialog.enterKeyPressedAction,
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", []),
    tslib_1.__metadata("design:returntype", void 0)
], CustomDialog.prototype, "okPressed", null);


/***/ }),

/***/ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js":
/*!*********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js from dll-reference scifeon_data ***!
  \*********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ })

}]);
//# sourceMappingURL=dialog.5d0bc4c08e328465e5be.js.map