(window["webpackJsonpcom_scifeon_scifeon_apps_demo"] = window["webpackJsonpcom_scifeon_scifeon_apps_demo"] || []).push([["routePage_src/pages/element/insert-entities"],{

/***/ "../apps/demo/demo_app/src/pages/element/insert-entities.html":
/*!********************************************************************!*\
  !*** ../apps/demo/demo_app/src/pages/element/insert-entities.html ***!
  \********************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header prototype\">\r\n\r\n        <div class=\"page-header\">\r\n            <h1>Scifeon Demo Pages</h1>\r\n        </div>\r\n        <div class=\"panel-group\">\r\n\r\n            <div class=\"page-panels grid full-width-panels\">\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Entity Insertion Demo</div>\r\n                    <div class=\"panel-body\">\r\n                        <p>\r\n                            This page shows how entities are created.\r\n                        </p>\r\n                        <p>\r\n                            The buttons below add new entities to the database. Each button adds different kinds of entities to the database.\r\n                        </p>\r\n                        <p>\r\n                            You can read the documentation on different kinds of entities\r\n                            <a href=\"https://docs.scifeon.com/developer/http-api/endpoints/entities\" target=\"_blank\">here</a>.\r\n                        </p>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"page-panels\">\r\n\r\n                <button click.delegate=\"insertSingleSample()\">Insert a Single Sample</button>\r\n                <button click.delegate=\"insertParentNChildSamples()\">Insert Parent &amp; Child Samples</button>\r\n                <button click.delegate=\"insertStepWithInput()\">Insert Step with Input</button>\r\n\r\n                <div class=\"panel\" if.bind=\"newEntities.length\">\r\n                    <div class=\"panel-heading\">New Entities</div>\r\n                    <div class=\"panel-body\">\r\n                        <table class=\"table compact\" style=\"max-width: 600px;\">\r\n                            <thead>\r\n                                <tr>\r\n                                    <th>ID</th>\r\n                                    <th>Class</th>\r\n                                    <th>Name</th>\r\n                                    <th>Type</th>\r\n                                </tr>\r\n                            </thead>\r\n                            <tbody repeat.for=\"e of newEntities\">\r\n                                <tr>\r\n                                    <td>\r\n                                        <a href='/#/entity/${e.eClass}/${e.id}'>${e.id}</a>\r\n                                    </td>\r\n                                    <td>${e.eClass}</td>\r\n                                    <td>${e.name}</td>\r\n                                    <td>${e.type}</td>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/demo_app/src/pages/element/insert-entities.ts":
/*!******************************************************************!*\
  !*** ../apps/demo/demo_app/src/pages/element/insert-entities.ts ***!
  \******************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
const core_1 = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
const plugins_1 = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
const aurelia_framework_1 = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
let DemoInsertEntities = class DemoInsertEntities {
    constructor(server) {
        this.server = server;
        this.newEntities = [];
    }
    insertSingleSample() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            core_1.LoadingSpinner.show();
            const response = yield this.server.saveEntities([{
                    eClass: 'Sample',
                    format: 'Vial',
                    type: 'Fermentation',
                    status: core_1.Status.COMPLETED,
                    description: 'Demo sample'
                }]);
            this.newEntities = response.newEntities;
            core_1.LoadingSpinner.hide();
        });
    }
    insertParentNChildSamples() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            core_1.LoadingSpinner.show();
            const response = yield this.server.saveEntities([{
                    id: '#idParent',
                    eClass: 'Sample',
                    format: 'Vial',
                    type: 'Fermentation',
                    status: core_1.Status.COMPLETED,
                    description: 'Demo parent sample'
                }, {
                    eClass: 'Sample',
                    format: 'Vial',
                    type: 'Supernatant',
                    status: core_1.Status.COMPLETED,
                    description: 'Demo child sample',
                    parentID: '#idParent'
                }]);
            this.newEntities = response.newEntities;
            core_1.LoadingSpinner.hide();
        });
    }
    insertStepWithInput() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            core_1.LoadingSpinner.show();
            const response = yield this.server.saveEntities([{
                    id: '#idSmp1',
                    eClass: 'Sample',
                    format: 'Vial',
                    type: 'Fermentation',
                    status: core_1.Status.COMPLETED,
                    description: 'Demo input sample'
                }, {
                    id: '#idSmp2',
                    eClass: 'Sample',
                    format: 'Vial',
                    type: 'Fermentation',
                    status: core_1.Status.COMPLETED,
                    description: 'Demo input sample 2'
                }, {
                    eClass: 'Experiment',
                    id: '#idExp',
                    type: 'Demo'
                }, {
                    eClass: 'Step',
                    id: '#idStep',
                    type: 'Demo',
                    experimentID: '#idExp',
                    input: []
                }
            ]);
            this.newEntities = response.newEntities;
            core_1.LoadingSpinner.hide();
        });
    }
};
DemoInsertEntities = tslib_1.__decorate([
    aurelia_framework_1.autoinject,
    plugins_1.route({
        route: 'demo/element/insert-entities',
        title: 'Demo - Insert Entities'
    }),
    tslib_1.__metadata("design:paramtypes", [core_1.ServerAPI])
], DemoInsertEntities);
exports.DemoInsertEntities = DemoInsertEntities;


/***/ }),

/***/ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js":
/*!*********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js from dll-reference scifeon_data ***!
  \*********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");

/***/ }),

/***/ "./packages/core/index.ts":
/*!**************************************************************************!*\
  !*** delegated ./packages/core/index.ts from dll-reference scifeon_data ***!
  \**************************************************************************/
/*! exports provided: Config, ScifeonConsoleLogger, ConsoleLogger, Status, Event, DataModel, ReadExcelCommon, XL, LoadingSpinner, ScifeonLoadingSpinner, ServerAPI, User, UserHelper, DSUtils, DateUtils, MathUtils, PLATE, PluginUtils, ScifeonUtils, Utils, SdkUtils, SpreadsheetUtils */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./packages/core/index.ts");

/***/ })

}]);
//# sourceMappingURL=insert-entities.5d0bc4c08e328465e5be.js.map