(window["webpackJsonpcom_scifeon_scifeon_apps_demo"] = window["webpackJsonpcom_scifeon_scifeon_apps_demo"] || []).push([["routePage_src/pages/element/record-editor-demo"],{

/***/ "../apps/demo/demo_app/src/pages/element/record-editor-demo.html":
/*!***********************************************************************!*\
  !*** ../apps/demo/demo_app/src/pages/element/record-editor-demo.html ***!
  \***********************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header prototype\">\r\n        <div class=\"page-header\">\r\n            <h1>Scifeon Demo Pages</h1>\r\n        </div>\r\n        <div class=\"panel-group\">\r\n            <div class=\"page-panels grid full-width-panels\">\r\n\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Record Editor Demo</div>\r\n                    <div class=\"panel-body\">\r\n                        <p>\r\n                            This page shows a record editor. The record editor is an interactive table element which can be used to transfer data to\r\n                            Scifeon.\r\n                            <br>\r\n                        </p>\r\n                        <p>\r\n                            It is row-based and can have custom columns.\r\n                        </p>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Record Editor Grid</div>\r\n                    <div class=\"panel-body\">\r\n                        <record-editor-grid n-rows=\"10\" records.bind=\"records\" fields.bind=\"fields\"></record-editor-grid>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">JavaScript Representation</div>\r\n                    <div class=\"panel-body\">\r\n                        <p>\r\n                            These panels show the JavaScript representations of the records table.\r\n                        </p>\r\n                        <p>\r\n                            The this.fields object defines the table itself, with each property representing a new data column in the matrix.\r\n                        </p>\r\n                        <p>\r\n                            The this.records lists the data entered into the table. Each object in the list is a data row in the matrix.\r\n                        </p>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"page-panels grid\">\r\n                <div class=\"panel\" style=\"grid-column: span 2\">\r\n                    <div class=\"panel-heading\">this.fields</div>\r\n                    <div class=\"panel-body\">\r\n                        <p>\r\n                            this.fields = [\r\n                            <br> {\r\n                            <br> &emsp; name: 'name',\r\n                            <br> &emsp; label: 'Name'\r\n                            <br> },\r\n                            <br> {\r\n                            <br> &emsp; name: 'content',\r\n                            <br> &emsp; label: 'Content'\r\n                            <br> },\r\n                            <br> {\r\n                            <br> &emsp; name: 'description',\r\n                            <br> &emsp; label: 'Description',\r\n                            <br> &emsp; width: '150px'\r\n                            <br> },\r\n                            <br> {\r\n                            <br> &emsp; name: 'bogus',\r\n                            <br> &emsp; label: 'Bogus'\r\n                            <br> }\r\n                            <br> ];\r\n                            <br>\r\n                        </p>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\" style=\"grid-column: span 2\">\r\n                    <div class=\"panel-heading\">this.records</div>\r\n                    <div class=\"panel-body\">\r\n                        <p>\r\n                            this.records = [\r\n                            <br> {\r\n                            <br> &emsp; name: 'ABC-1',\r\n                            <br> &emsp; content: 'C123',\r\n                            <br> &emsp; description: ''\r\n                            <br> },\r\n                            <br> {\r\n                            <br> &emsp; name: 'ABC-2',\r\n                            <br> &emsp; content: 'C122',\r\n                            <br> &emsp; description: ''\r\n                            <br> },\r\n                            <br> {\r\n                            <br> &emsp; name: 'ABC-3',\r\n                            <br> &emsp; content: 'C121',\r\n                            <br> &emsp; description: ''\r\n                            <br> }\r\n                            <br> ];\r\n                            <br>\r\n                        </p>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/demo_app/src/pages/element/record-editor-demo.ts":
/*!*********************************************************************!*\
  !*** ../apps/demo/demo_app/src/pages/element/record-editor-demo.ts ***!
  \*********************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
const plugins_1 = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
let RecordEditorDemo = class RecordEditorDemo {
    constructor() {
        this.fields = [
            {
                name: 'name',
                label: 'Name'
            },
            {
                name: 'content',
                label: 'Content'
            },
            {
                name: 'description',
                label: 'Description',
                width: '150px'
            },
            {
                name: 'bogus',
                label: 'Bogus'
            }
        ];
        this.records = [
            {
                name: 'ABC-1',
                content: 'C123',
                description: ''
            },
            {
                name: 'ABC-2',
                content: 'C122',
                description: ''
            },
            {
                name: 'ABC-3',
                content: 'C121',
                description: ''
            }
        ];
    }
};
RecordEditorDemo = tslib_1.__decorate([
    plugins_1.route({
        route: 'demo/element/record-editor-demo',
        title: 'Demo - Record Editor'
    })
], RecordEditorDemo);
exports.RecordEditorDemo = RecordEditorDemo;


/***/ })

}]);
//# sourceMappingURL=record-editor-demo.5d0bc4c08e328465e5be.js.map