(window["webpackJsonpcom_scifeon_scifeon_apps_facs"] = window["webpackJsonpcom_scifeon_scifeon_apps_facs"] || []).push([["routePage_src/pages/dilution-plates"],{

/***/ "../apps/module/facs/src/pages/dilution-plates.html":
/*!**********************************************************!*\
  !*** ../apps/module/facs/src/pages/dilution-plates.html ***!
  \**********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <style>\r\n        td {\r\n            -webkit-print-color-adjust: exact;\r\n        }\r\n    </style>\r\n\r\n    <div class=\"page-panels grid\">\r\n        <div class=\"panel full-width\">\r\n            <div class=\"panel-body\">\r\n                <div class=\"view-group\">\r\n                    <label>Experiment</label>\r\n                    <p><a href=\"/#/eln/${exp.id}\">${exp.name}</a></p>\r\n                </div>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"panel full-width\">\r\n            <div class=\"panel-body\">\r\n                <template repeat.for=\"plate of plates\" if.bind=\"plates\">\r\n                    <h3>Dilution Plate ${$index+1}</h3>\r\n                    <plate-view n-rows=\"8\"\r\n                                n-cols=\"12\"\r\n                                wells.bind=\"plate\"\r\n                                row-names.bind=\"rowNames[$index]\"\r\n                                well-template.bind=\"wellTemplate\"></plate-view>\r\n                </template>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"panel full-width\">\r\n            <div class=\"panel-heading\">Test Samples</div>\r\n            <div class=\"panel-body\">\r\n                <table>\r\n                    <thead>\r\n                        <tr>\r\n                            <th>LIMS ID</th>\r\n                            <th>Description</th>\r\n                            <th>Process Step</th>\r\n                            <th>Product Name</th>\r\n                            <th>Batch No.</th>\r\n                            <th>ExpectedTiter</th>\r\n                        </tr>\r\n                    </thead>\r\n                    <tbody>\r\n                        <tr repeat.for=\"sample of inputSamples\" css=\"background-color:${sample.backgroundColor}\">\r\n                            <td>${sample.name}</td>\r\n                            <td>${sample.description}</td>\r\n                            <td>${sample.attributes.processStep}</td>\r\n                            <td>${sample.attributes.productName}</td>\r\n                            <td>${sample.attributes.batchNo}</td>\r\n                            <td>${sample.attributes.expectedTiter}</td>\r\n                        </tr>\r\n                    </tbody>\r\n                </table>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>\r\n";

/***/ }),

/***/ "../apps/module/facs/src/pages/dilution-plates.ts":
/*!********************************************************!*\
  !*** ../apps/module/facs/src/pages/dilution-plates.ts ***!
  \********************************************************/
/*! exports provided: AppFACSDilutionPlates */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AppFACSDilutionPlates", function() { return AppFACSDilutionPlates; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _facs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../facs */ "../apps/module/facs/src/facs.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");





let AppFACSDilutionPlates = class AppFACSDilutionPlates {
    constructor(server) {
        this.server = server;
        this.rowNames = [];
        this.view = () => __webpack_require__(/*! ./dilution-plates.html */ "../apps/module/facs/src/pages/dilution-plates.html");
        this.wellTemplate = well => {
            const dilution = well.posCol === 0 ? '/' : well.dilution;
            return `<div class="text-center">${dilution}</div>`;
        };
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const ds = yield this.server.datasetQuery([
                { eClass: 'Step', alias: 'step', filters: [{ field: 'ID', value: context.params.id }] },
                { eClass: 'Experiment', alias: 'exp', filters: [{ field: 'ID', value: '$step.experimentID' }] },
                { view: 'StepSampleInput', collection: 'input', filters: [{ field: 'StepID', value: context.params.id }] },
                { eClass: 'Sample', collection: 'inputSamples', filters: [{ field: 'ID', in: 'input.ID' }] },
                { eClass: 'Sample', collection: 'cultureSamples', filters: [{ field: 'OriginID', value: context.params.id }] }
            ]);
            this.exp = ds.exp;
            this.inputSamples = ds.inputSamples;
            this.cultureSamples = ds.cultureSamples;
            this.updateDilutionWells();
        });
    }
    updateDilutionWells() {
        const plates = [];
        let rowNames = [];
        let plate = [];
        for (let i = 0; i < this.inputSamples.length + (_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["PLATE"].W96.NROWS - this.inputSamples.length % _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["PLATE"].W96.NROWS); i++) {
            if (i > 0 && i % _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["PLATE"].W96.NROWS === 0) {
                this.rowNames.push(rowNames);
                rowNames = [];
                plates.push(plate);
                plate = [];
            }
            let rowName = Math.ceil((i + 1) / 2) + '.';
            rowName += (i % 2 === 0) ? '1' : '2';
            rowNames.push(rowName);
            for (let posCol = 0; posCol < _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["PLATE"].W96.NCOLS; posCol++) {
                let dilution = posCol === 0 ? 0 : _facs__WEBPACK_IMPORTED_MODULE_3__["FACS"].DILUTIONS[11 - posCol];
                let backgroundColor = 'transparent';
                if (this.inputSamples.length > i) {
                    let inputSample = this.inputSamples[i];
                    let cultureSample = this.cultureSamples.find(s => s.parentID === inputSample.id && s.attributes.foldDilution === dilution);
                    if (cultureSample) {
                        backgroundColor = _facs__WEBPACK_IMPORTED_MODULE_3__["FACS"].DILUTION_COLORS[i % _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["PLATE"].W96.NROWS];
                        inputSample.backgroundColor = backgroundColor;
                    }
                }
                plate.push({
                    posRow: i % _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["PLATE"].W96.NROWS,
                    posCol: posCol,
                    dilution: dilution,
                    css: 'background-color: ' + backgroundColor
                });
            }
        }
        if (plate.length) {
            this.rowNames.push(rowNames);
            plates.push(plate);
        }
        this.plates = plates;
    }
};
AppFACSDilutionPlates = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_4__["route"])({
        route: 'facs/dilution-plates/:id',
        title: 'Dilution Plate Layout'
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], AppFACSDilutionPlates);



/***/ })

}]);
//# sourceMappingURL=dilution-plates.01ac3593419a3ad6c940.js.map