com_scifeon_scifeon_apps_fermentation(/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 	};
/******/
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		"app": 0
/******/ 	};
/******/
/******/
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "" + chunkId + "." + "2a2cda3d4495c207608c" + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var head = document.getElementsByTagName('head')[0];
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							var error = new Error('Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')');
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/bundledApps/com.scifeon/scifeon_apps_fermentation/";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["webpackJsonpcom_scifeon_scifeon_apps_fermentation"] = window["webpackJsonpcom_scifeon_scifeon_apps_fermentation"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "../apps/demo/fermentation_app/seed/attribute-fields-fermentation.json":
/*!*****************************************************************************!*\
  !*** ../apps/demo/fermentation_app/seed/attribute-fields-fermentation.json ***!
  \*****************************************************************************/
/*! exports provided: 0, default */
/***/ (function(module) {

module.exports = [{"eClass":"Template","name":"FermentationAttributeProduct","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"attributes.product","type":"string","form":{"label":"Product"}}}}];

/***/ }),

/***/ "../apps/demo/fermentation_app/seed/attribute-fields-strain.json":
/*!***********************************************************************!*\
  !*** ../apps/demo/fermentation_app/seed/attribute-fields-strain.json ***!
  \***********************************************************************/
/*! exports provided: 0, 1, 2, 3, 4, 5, 6, default */
/***/ (function(module) {

module.exports = [{"eClass":"Template","name":"StrainAttributePlasmid","type":"Field","status":"Active","content":{"eClass":"CellClone","column":{"name":"attributes.plasmid","type":"string","form":{"label":"Plasmid"}}}},{"eClass":"Template","name":"StrainAttributeGrowthConditions","type":"Field","status":"Active","content":{"eClass":"CellClone","column":{"name":"attributes.growthConditions","type":"string","form":{"label":"Growth Conditions"}}}},{"eClass":"Template","name":"StrainAttributeGenotype","type":"Field","status":"Active","content":{"eClass":"CellClone","column":{"name":"attributes.genotype","type":"string","form":{"label":"Genotype"}}}},{"eClass":"Template","name":"StrainAttributeResistance","type":"Field","status":"Active","content":{"eClass":"CellClone","column":{"name":"attributes.resistance","type":"string","form":{"label":"Resistance"}}}},{"eClass":"Template","name":"StrainAttributeELN","type":"Field","status":"Active","content":{"eClass":"CellClone","column":{"name":"attributes.eln","type":"string","form":{"label":"ELN"}}}},{"eClass":"Template","name":"StrainAttributeStorageLocation","type":"Field","status":"Active","content":{"eClass":"CellClone","column":{"name":"attributes.storageLocation","type":"string","form":{"label":"Storage Location"}}}},{"eClass":"Template","name":"StrainAttributeProduct","type":"Field","status":"Active","content":{"eClass":"CellClone","column":{"name":"attributes.product","type":"string","form":{"label":"Product"}}}}];

/***/ }),

/***/ "../apps/demo/fermentation_app/seed/setup-fields-fermentation.json":
/*!*************************************************************************!*\
  !*** ../apps/demo/fermentation_app/seed/setup-fields-fermentation.json ***!
  \*************************************************************************/
/*! exports provided: 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, default */
/***/ (function(module) {

module.exports = [{"eClass":"Template","name":"FermentationSetupAntibiotics","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.antibiotics","type":"string","form":{"label":"Antibiotics"}}}},{"eClass":"Template","name":"FermentationSetupBaseweight","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.baseWeightT0_g","type":"string","form":{"label":"Base Weight T0 [g]"}}}},{"eClass":"Template","name":"FermentationSetupDO","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.do_pct","type":"string","form":{"label":"DO [%]"}}}},{"eClass":"Template","name":"FermentationSetupFeedWeight","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.feedWeightT0_g","type":"string","form":{"label":"Feed Weight T0 [g]"}}}},{"eClass":"Template","name":"FermentationSetupFermentor","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.fermentor","type":"string","form":{"label":"Fermentor"}}}},{"eClass":"Template","name":"FermentationSetupIPTG","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.iptg","type":"string","form":{"label":"IPTG"}}}},{"eClass":"Template","name":"FermentationSetupPHStart","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.pHstart","type":"string","form":{"label":"pH Start"}}}},{"eClass":"Template","name":"FermentationSetupPHEnd","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.pHend","type":"string","form":{"label":"pH End"}}}},{"eClass":"Template","name":"FermentationSetupStrain","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.strain","type":"string","form":{"label":"Strain"}}}},{"eClass":"Template","name":"FermentationSetupTempGrowth","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.temp_growth","type":"string","form":{"label":"Temperature, growth"}}}},{"eClass":"Template","name":"FermentationSetupTempProd","type":"Field","status":"Active","content":{"eClass":"Fermentation","column":{"name":"setup.temp_prod","type":"string","form":{"label":"Temperature, product"}}}}];

/***/ }),

/***/ "../apps/demo/fermentation_app/src/bootstrapper.ts":
/*!*********************************************************!*\
  !*** ../apps/demo/fermentation_app/src/bootstrapper.ts ***!
  \*********************************************************/
/*! exports provided: BootstrapFermentation */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "BootstrapFermentation", function() { return BootstrapFermentation; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);




let BootstrapFermentation = class BootstrapFermentation {
    constructor(pluginManager) {
        this.pluginManager = pluginManager;
        this.initializeEditors();
        this.initializeListColumns();
    }
    initializeEditors() {
        this.pluginManager.add(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["KVPJsonFieldPanel"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].JSON_FIELD_EDITOR], {
            eClass: 'CellClone',
            entityType: 'Strain',
            field: 'attributes',
            columns: __webpack_require__(/*! ../seed/attribute-fields-strain.json */ "../apps/demo/fermentation_app/seed/attribute-fields-strain.json").map(t => {
                const column = JSON.parse(JSON.stringify(t.content.column));
                column.name = column.name.replace(/attributes\./ig, '');
                return column;
            })
        });
        this.pluginManager.add(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["KVPJsonFieldPanel"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].JSON_FIELD_EDITOR], {
            eClass: 'Fermentation',
            entityType: 'Default',
            field: 'attributes',
            columns: __webpack_require__(/*! ../seed/attribute-fields-fermentation.json */ "../apps/demo/fermentation_app/seed/attribute-fields-fermentation.json").map(t => {
                const column = JSON.parse(JSON.stringify(t.content.column));
                column.name = column.name.replace(/attributes\./ig, '');
                return column;
            })
        });
        this.pluginManager.add(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["KVPJsonFieldPanel"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].JSON_FIELD_EDITOR], {
            eClass: 'Fermentation',
            entityType: 'Default',
            field: 'setup',
            columns: __webpack_require__(/*! ../seed/setup-fields-fermentation.json */ "../apps/demo/fermentation_app/seed/setup-fields-fermentation.json").map(t => {
                const column = JSON.parse(JSON.stringify(t.content.column));
                column.name = column.name.replace(/setup\./ig, '');
                return column;
            })
        });
    }
    initializeListColumns() {
        for (const template of __webpack_require__(/*! ../seed/attribute-fields-strain.json */ "../apps/demo/fermentation_app/seed/attribute-fields-strain.json")) {
            this.pluginManager.add(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["ListColumnOptionsPlugin"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].LIST_COLUMN], {
                eClass: 'CellClone',
                column: template.content.column
            });
        }
        for (const template of __webpack_require__(/*! ../seed/attribute-fields-fermentation.json */ "../apps/demo/fermentation_app/seed/attribute-fields-fermentation.json")) {
            this.pluginManager.add(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["ListColumnOptionsPlugin"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].LIST_COLUMN], {
                eClass: 'Fermentation',
                column: template.content.column
            });
        }
        for (const template of __webpack_require__(/*! ../seed/setup-fields-fermentation.json */ "../apps/demo/fermentation_app/seed/setup-fields-fermentation.json")) {
            this.pluginManager.add(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["ListColumnOptionsPlugin"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].LIST_COLUMN], {
                eClass: 'Fermentation',
                column: template.content.column
            });
        }
    }
};
BootstrapFermentation = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PluginManager"]])
], BootstrapFermentation);



/***/ }),

/***/ "../apps/demo/fermentation_app/src/data-loaders/data-loader-ferm-online.ts":
/*!*********************************************************************************!*\
  !*** ../apps/demo/fermentation_app/src/data-loaders/data-loader-ferm-online.ts ***!
  \*********************************************************************************/
/*! exports provided: DemoFermentationFermOnlineLoader */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DemoFermentationFermOnlineLoader", function() { return DemoFermentationFermOnlineLoader; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let DemoFermentationFermOnlineLoader = class DemoFermentationFermOnlineLoader {
    constructor(server) {
        this.server = server;
        this.NAME = 'Fermentation-Online-Loader';
        this.DESCRIPTION = 'Load fermentation online data from CSV file';
    }
    static isMatch(context) {
        return context.experiment &&
            context.experiment.type === 'Fermentation' &&
            context.fileInfos.length === 1 &&
            context.fileInfos[0].filename.toLowerCase().endsWith('.csv') &&
            context.fileInfos[0].filename.toLowerCase().startsWith('fermentation');
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let csv = context.fileInfos[0].csv;
            let content = { timeSeries: [] };
            content.colTitles = csv.data[0];
            content.colTitles[1] = 'Age_h';
            for (let iRow = 1; iRow < csv.data.length; iRow++) {
                let col = [csv.data[iRow][0]];
                for (let iCol = 1; iCol < csv.data[iRow].length; iCol++)
                    col.push(Number.parseFloat(csv.data[iRow][iCol]));
                content.timeSeries.push(col);
            }
            let step = context.steps[0];
            let ds = yield this.server.datasetQuery([
                { eClass: 'Fermentation', alias: 'f', filters: [{ field: 'OriginID', value: step.id }] }
            ]);
            this.entities = [
                {
                    eClass: 'ResultSet',
                    originID: step.id,
                    type: 'FermentationOnline',
                    id: '#rsID'
                },
                {
                    eClass: 'ResultFermOnline',
                    resultSetID: '#rsID',
                    type: 'FermOnline',
                    content: content,
                    fermentationID: ds.f.id
                }
            ];
        });
    }
    getResult() {
        return { entities: this.entities };
    }
};
DemoFermentationFermOnlineLoader = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], DemoFermentationFermOnlineLoader);



/***/ }),

/***/ "../apps/demo/fermentation_app/src/data-loaders/data-loader-fermentation-setup.ts":
/*!****************************************************************************************!*\
  !*** ../apps/demo/fermentation_app/src/data-loaders/data-loader-fermentation-setup.ts ***!
  \****************************************************************************************/
/*! exports provided: DemoFermentationSetupLoader */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DemoFermentationSetupLoader", function() { return DemoFermentationSetupLoader; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let DemoFermentationSetupLoader = class DemoFermentationSetupLoader {
    constructor() {
        this.NAME = 'Fermentation-Setup-Loader';
        this.DESCRIPTION = 'Load fermentation setup from Excel file';
        this.TARGET_ECLASS = 'Experiment';
    }
    static isMatch(context) {
        if (context.targetEClass && context.targetEClass !== 'Experiment') {
            return false;
        }
        return context.fileInfos.length === 1 && context.fileInfos[0].filename.toLowerCase().endsWith('.xlsx') && context.fileInfos[0].wb.Sheets.Fermentation;
    }
    init(context) {
    }
    getResult() {
        return { entities: this.entities };
    }
    optionsView() {
        return '<h1>Fermentation Setup Info</h1>';
    }
};
DemoFermentationSetupLoader = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [])
], DemoFermentationSetupLoader);



/***/ }),

/***/ "../apps/demo/fermentation_app/src/panels/result-renderer-online.ts":
/*!**************************************************************************!*\
  !*** ../apps/demo/fermentation_app/src/panels/result-renderer-online.ts ***!
  \**************************************************************************/
/*! exports provided: FermentationResultRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FermentationResultRenderer", function() { return FermentationResultRenderer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let FermentationResultRenderer = class FermentationResultRenderer {
    constructor(server, dialog) {
        this.server = server;
        this.dialog = dialog;
        this.view = () => `
<h2>Fermentation - Online Result-set</h2>
<p><a href='/#/ferm/page-chart/#{context.resultSet.id}'>Show Chart</a></p>
`;
    }
    static isMatch(context) {
        return context.resultSet && context.resultSet.type === 'FermentationOnline';
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.context = context;
        });
    }
};
FermentationResultRenderer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], FermentationResultRenderer);



/***/ }),

/***/ "../apps/demo/fermentation_app/src/panels/setup-renderer-fermentation.ts":
/*!*******************************************************************************!*\
  !*** ../apps/demo/fermentation_app/src/panels/setup-renderer-fermentation.ts ***!
  \*******************************************************************************/
/*! exports provided: FermentationSetupRenderer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FermentationSetupRenderer", function() { return FermentationSetupRenderer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _popups_take_sample__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../popups/take-sample */ "../apps/demo/fermentation_app/src/popups/take-sample.ts");





let FermentationSetupRenderer = class FermentationSetupRenderer {
    constructor(server, dialog) {
        this.server = server;
        this.dialog = dialog;
        this.view = () => `
<h2>Fermentation - Inoculation Setup</h2>
<button click.delegate="takeSample()">Take Sample</button>

<h3>Planned samples</h3>
<table>
  <thead>
  </thead>
  <tbody>
    <tr><td>Day 1</td><td>Done</td></tr>
    <tr><td>Day 2</td>
      <td style="font-weight: bold; color: red;">Due
        <button class="small" click.delegate="takeSample()">Take Sample</button>
      </td>
    </tr>
    <tr><td>Day 3</td><td>-</td></tr>
  </tbody>
</table>
`;
    }
    static isMatch(context) {
        return context.position === 'eln.step.setup' && context.step.type === 'Inoculation';
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.context = context;
        });
    }
    takeSample() {
        this.dialog.open({
            viewModel: _popups_take_sample__WEBPACK_IMPORTED_MODULE_4__["PopupTakeSample"],
            model: {}
        }).whenClosed(result => {
        });
    }
};
FermentationSetupRenderer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], FermentationSetupRenderer);



/***/ }),

/***/ "../apps/demo/fermentation_app/src/popups/take-sample.ts":
/*!***************************************************************!*\
  !*** ../apps/demo/fermentation_app/src/popups/take-sample.ts ***!
  \***************************************************************/
/*! exports provided: PopupTakeSample */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PopupTakeSample", function() { return PopupTakeSample; });
class PopupTakeSample {
    constructor() {
        this.view = () => `
<ux-dialog>
    <ux-dialog-header>
        <h2>Take Fermentation Sample</h2>
    </ux-dialog-header>
    <ux-dialog-body>
        <div class="form-group">
            <label>Sampling Time</label>
            <p><input></p>
        </div>
        <div class="form-group">
            <label>Sample Name</label>
            <p><input></p>
        </div>
        <div class="form-group">
            <label>Notes</label>
            <textarea attach-focus="true" value.bind="model.reason" style="width: 400px;height: 140px;"></textarea>
        </div>
    </ux-dialog-body>
    <ux-dialog-footer>
        <button disabled.bind="!model.reason" click.delegate="dialog.ok(model)">OK</button>
        <button class="btn-link" click.delegate="dialog.cancel()">Cancel</button>
    </ux-dialog-footer>
</ux-dialog>`;
    }
}


/***/ }),

/***/ "../apps/demo/fermentation_app/temp/gen-app.js":
/*!*****************************************************!*\
  !*** ../apps/demo/fermentation_app/temp/gen-app.js ***!
  \*****************************************************/
/*! exports provided: plugins, hot, moduleId */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(module) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "plugins", function() { return plugins; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hot", function() { return hot; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "moduleId", function() { return moduleId; });
const plugins = [
{
 id: 'bootstrapper',
 func: __webpack_require__(/*! ../src/bootstrapper.ts */ "../apps/demo/fermentation_app/src/bootstrapper.ts"),
 types: ["bootstrapper"],
},
{
 id: 'fermentationSetupLoader',
 func: __webpack_require__(/*! ../src/data-loaders/data-loader-fermentation-setup.ts */ "../apps/demo/fermentation_app/src/data-loaders/data-loader-fermentation-setup.ts"),
 types: ["data_loader"],
 name: 'Fermentation-Setup-Loader',
 description: 'Load fermentation setup info from Excel file'
},
{
 id: 'fermentationOnlineLoader',
 func: __webpack_require__(/*! ../src/data-loaders/data-loader-ferm-online.ts */ "../apps/demo/fermentation_app/src/data-loaders/data-loader-ferm-online.ts"),
 types: ["data_loader"],
 name: 'Fermentation-Online-Loader',
 description: 'Load fermentation time-series info from CSV file'
},
{
 id: 'fermentationSetupRenderer',
 func: __webpack_require__(/*! ../src/panels/setup-renderer-fermentation.ts */ "../apps/demo/fermentation_app/src/panels/setup-renderer-fermentation.ts"),
 types: ["entity.panel"],
},
{
 id: 'fermentationOnlineResultRenderer',
 func: __webpack_require__(/*! ../src/panels/result-renderer-online.ts */ "../apps/demo/fermentation_app/src/panels/result-renderer-online.ts"),
 types: ["entity.panel"],
},
{
 id: 'routePage_fermOnlineQuery',
 func: () => __webpack_require__.e(/*! import() | pageQuery */ "pageQuery").then(__webpack_require__.bind(null, /*! ../src/pages/page-query.ts */ "../apps/demo/fermentation_app/src/pages/page-query.ts")),
 types: ["page"],
 view: () => __webpack_require__.e(/*! import() | pageQuery */ "pageQuery").then(__webpack_require__.t.bind(null, /*! ../src/pages/page-query.html */ "../apps/demo/fermentation_app/src/pages/page-query.html", 7)),
},
{
 id: 'routePage_fermOnlineChart',
 func: () => __webpack_require__.e(/*! import() | routePage_fermOnlineChart */ "routePage_fermOnlineChart").then(__webpack_require__.bind(null, /*! ../src/pages/page-chart.ts */ "../apps/demo/fermentation_app/src/pages/page-chart.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_fermOnlineChart */ "routePage_fermOnlineChart").then(__webpack_require__.t.bind(null, /*! ../src/pages/page-chart.html */ "../apps/demo/fermentation_app/src/pages/page-chart.html", 7)),
},
];
const hot = module.hot;
const moduleId = module.i;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../../../../client/node_modules/webpack/buildin/harmony-module.js */ "./node_modules/webpack/buildin/harmony-module.js")(module)))

/***/ }),

/***/ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js":
/*!***********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js from dll-reference scifeon_vendor ***!
  \***********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");

/***/ }),

/***/ "./node_modules/tslib/tslib.js":
/*!*************************************!*\
  !*** ./node_modules/tslib/tslib.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global global, define, System, Reflect, Promise */
var __extends;
var __assign;
var __rest;
var __decorate;
var __param;
var __metadata;
var __awaiter;
var __generator;
var __exportStar;
var __values;
var __read;
var __spread;
var __await;
var __asyncGenerator;
var __asyncDelegator;
var __asyncValues;
var __makeTemplateObject;
var __importStar;
var __importDefault;
(function (factory) {
    var root = typeof global === "object" ? global : typeof self === "object" ? self : typeof this === "object" ? this : {};
    if (true) {
        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports], __WEBPACK_AMD_DEFINE_RESULT__ = (function (exports) { factory(createExporter(root, createExporter(exports))); }).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    }
    else {}
    function createExporter(exports, previous) {
        if (exports !== root) {
            if (typeof Object.create === "function") {
                Object.defineProperty(exports, "__esModule", { value: true });
            }
            else {
                exports.__esModule = true;
            }
        }
        return function (id, v) { return exports[id] = previous ? previous(id, v) : v; };
    }
})
(function (exporter) {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    __extends = function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };

    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };

    __rest = function (s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
                t[p[i]] = s[p[i]];
        return t;
    };

    __decorate = function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };

    __param = function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };

    __metadata = function (metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    };

    __awaiter = function (thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    };

    __generator = function (thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    };

    __exportStar = function (m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    };

    __values = function (o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    };

    __read = function (o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    };

    __spread = function () {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    };

    __await = function (v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    };

    __asyncGenerator = function (thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);  }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    };

    __asyncDelegator = function (o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    };

    __asyncValues = function (o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    };

    __makeTemplateObject = function (cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    __importStar = function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result["default"] = mod;
        return result;
    };

    __importDefault = function (mod) {
        return (mod && mod.__esModule) ? mod : { "default": mod };
    };

    exporter("__extends", __extends);
    exporter("__assign", __assign);
    exporter("__rest", __rest);
    exporter("__decorate", __decorate);
    exporter("__param", __param);
    exporter("__metadata", __metadata);
    exporter("__awaiter", __awaiter);
    exporter("__generator", __generator);
    exporter("__exportStar", __exportStar);
    exporter("__values", __values);
    exporter("__read", __read);
    exporter("__spread", __spread);
    exporter("__await", __await);
    exporter("__asyncGenerator", __asyncGenerator);
    exporter("__asyncDelegator", __asyncDelegator);
    exporter("__asyncValues", __asyncValues);
    exporter("__makeTemplateObject", __makeTemplateObject);
    exporter("__importStar", __importStar);
    exporter("__importDefault", __importDefault);
});

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../webpack/buildin/global.js */ "./node_modules/webpack/buildin/global.js")))

/***/ }),

/***/ "./node_modules/webpack/buildin/global.js":
/*!********************************************************************************************!*\
  !*** delegated ./node_modules/webpack/buildin/global.js from dll-reference scifeon_vendor ***!
  \********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/webpack/buildin/global.js");

/***/ }),

/***/ "./node_modules/webpack/buildin/harmony-module.js":
/*!*******************************************!*\
  !*** (webpack)/buildin/harmony-module.js ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = function(originalModule) {
	if (!originalModule.webpackPolyfill) {
		var module = Object.create(originalModule);
		// module.parent = undefined by default
		if (!module.children) module.children = [];
		Object.defineProperty(module, "loaded", {
			enumerable: true,
			get: function() {
				return module.l;
			}
		});
		Object.defineProperty(module, "id", {
			enumerable: true,
			get: function() {
				return module.i;
			}
		});
		Object.defineProperty(module, "exports", {
			enumerable: true
		});
		module.webpackPolyfill = 1;
	}
	return module;
};


/***/ }),

/***/ "./packages/core/index.ts":
/*!**************************************************************************!*\
  !*** delegated ./packages/core/index.ts from dll-reference scifeon_core ***!
  \**************************************************************************/
/*! exports provided: Config, ScifeonConsoleLogger, ConsoleLogger, Status, Event, DataModel, ReadExcelCommon, XL, LoadingSpinner, ScifeonLoadingSpinner, ServerAPI, User, UserHelper, DSUtils, DateUtils, MathUtils, PLATE, PluginUtils, ScifeonUtils, Utils, SdkUtils, SpreadsheetUtils */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_core */ "dll-reference scifeon_core"))("./packages/core/index.ts");

/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ }),

/***/ 0:
/*!***********************************************************!*\
  !*** multi ../apps/demo/fermentation_app/temp/gen-app.js ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! C:\agent\_work\3\s\apps\demo\fermentation_app\temp\gen-app.js */"../apps/demo/fermentation_app/temp/gen-app.js");


/***/ }),

/***/ "dll-reference scifeon_core":
/*!*******************************!*\
  !*** external "scifeon_core" ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_core;

/***/ }),

/***/ "dll-reference scifeon_plugins":
/*!**********************************!*\
  !*** external "scifeon_plugins" ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_plugins;

/***/ }),

/***/ "dll-reference scifeon_ui":
/*!*****************************!*\
  !*** external "scifeon_ui" ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_ui;

/***/ }),

/***/ "dll-reference scifeon_vendor":
/*!*********************************!*\
  !*** external "scifeon_vendor" ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_vendor;

/***/ })

/******/ }));;
//# sourceMappingURL=app.js.map