(window["webpackJsonpcom_scifeon_scifeon_apps_fermentation"] = window["webpackJsonpcom_scifeon_scifeon_apps_fermentation"] || []).push([["pageQuery"],{

/***/ "../apps/demo/fermentation_app/src/pages/page-query.html":
/*!***************************************************************!*\
  !*** ../apps/demo/fermentation_app/src/pages/page-query.html ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n\r\n    <div class=\"page-panels\">\r\n        <div class=\"panel\">\r\n            <div class=\"panel-heading\">Querying Online Data</div>\r\n            <div class=\"panel-body\">\r\n                <h3>Result-set: ${rs.id}</h3>\r\n                <table>\r\n                    <thead>\r\n                        <tr>\r\n                            <th repeat.for=\"col of online[0].content.colTitles\">${col}</th>\r\n                        </tr>\r\n                    </thead>\r\n                    <tbody>\r\n                        <tr repeat.for=\"row of online[0].content.timeSeries\">\r\n                            <td>${row[0] | fixed:3}</td>\r\n                            <td>${row[1]}</td>\r\n                        </tr>\r\n                    </tbody>\r\n                </table>\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n</template>";

/***/ }),

/***/ "../apps/demo/fermentation_app/src/pages/page-query.ts":
/*!*************************************************************!*\
  !*** ../apps/demo/fermentation_app/src/pages/page-query.ts ***!
  \*************************************************************/
/*! exports provided: FermPageQuery */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FermPageQuery", function() { return FermPageQuery; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let FermPageQuery = class FermPageQuery {
    constructor(server) {
        this.server = server;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let resultSetID = context.params.id;
            const dataset = yield this.server.datasetQuery([
                { eClass: 'ResultSet', alias: 'rs', filters: [{ field: 'ID', value: resultSetID }] },
                { eClass: 'ResultFermOnline', collection: 'online',
                    filters: [{ field: 'ResultSetID', value: resultSetID }],
                    operations: [
                        {
                            field: 'Content',
                            type: 'slice',
                            columns: ['Age_h', 'pH_Value'],
                            rowFilters: [{ field: 'Age_h', min: 1, max: 3 }]
                        }
                    ]
                }
            ]);
            this.rs = dataset.rs;
            this.online = dataset.online;
        });
    }
};
FermPageQuery = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], FermPageQuery);



/***/ })

}]);
//# sourceMappingURL=pageQuery.2a2cda3d4495c207608c.js.map