com_scifeon_scifeon_apps_raw_data(/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 	};
/******/
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		"app": 0
/******/ 	};
/******/
/******/
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "" + chunkId + "." + "de6d265b36c210645d4b" + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var head = document.getElementsByTagName('head')[0];
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							var error = new Error('Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')');
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/bundledApps/com.scifeon/scifeon_apps_raw_data/";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["webpackJsonpcom_scifeon_scifeon_apps_raw_data"] = window["webpackJsonpcom_scifeon_scifeon_apps_raw_data"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "../apps/demo/raw_data_app/src/dialogs/experiment-create.html":
/*!********************************************************************!*\
  !*** ../apps/demo/raw_data_app/src/dialogs/experiment-create.html ***!
  \********************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog>\r\n        <ux-dialog-header><h1>Create Experiment</h1></ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <div class=\"form-horizontal\">\r\n                <div class=\"form-group\">\r\n                    <label>Title</label>\r\n                    <input type=\"text\" value.bind=\"experiment.description\" placeholder=\"Title\"/>\r\n                </div>\r\n                <div class=\"form-group\">\r\n                    <label>Request</label>\r\n                    <span>${request.id}</span>\r\n                </div>\r\n                <div class=\"form-group\">\r\n                    <label>Samples</label>\r\n                    <div>\r\n                        <p repeat.for=\"sample of samples\">${sample.id}: ${sample.name}</p>\r\n                    </div>\r\n                </div>\r\n                <div class=\"form-group\">\r\n                    <label>Steps</label>\r\n                    <div>\r\n                        These steps will automatically be created:\r\n                        <p>\r\n                            Initial...\r\n                        </p>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <button click.delegate=\"createExperiment()\">OK</button>\r\n            <button class=\"btn-link\" click.delegate=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "../apps/demo/raw_data_app/src/dialogs/experiment-create.ts":
/*!******************************************************************!*\
  !*** ../apps/demo/raw_data_app/src/dialogs/experiment-create.ts ***!
  \******************************************************************/
/*! exports provided: ExperimentCreatePage */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ExperimentCreatePage", function() { return ExperimentCreatePage; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");




let ExperimentCreatePage = class ExperimentCreatePage {
    constructor(server, dialog, logger, user) {
        this.server = server;
        this.dialog = dialog;
        this.logger = logger;
        this.user = user;
    }
    activate(request) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.request = request;
            this.experiment = {
                description: this.request.id + ': ' + this.request.description
            };
            const dataset = yield this.server.datasetQuery([
                { view: 'RequestPayload', collection: 'samples', filters: [{ field: 'RequestID', value: this.request.id }] }
            ]);
            this.samples = dataset.samples;
        });
    }
    createExperiment() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let entities = [{
                    eClass: 'Experiment',
                    id: '#idExp',
                    name: '!auto',
                    scientistID: this.user.id,
                    analystID: this.user.id,
                    type: 'Other',
                    description: this.experiment.description
                },
                {
                    eClass: 'Step',
                    id: '#idStep1',
                    experimentID: '#idExp',
                    name: 'Preparation',
                    type: 'Preparation',
                    input: this.samples.map(s => {
                        return { eClass: 'Sample', id: s.id };
                    }),
                    tags: ['IM']
                },
                {
                    eClass: 'Step',
                    id: '#idStep2',
                    experimentID: '#idExp',
                    parentID: '#idStep1',
                    name: 'Thaw',
                    type: 'Thaw',
                    tags: ['IM']
                },
                {
                    eClass: 'Step',
                    id: '#idStep3',
                    experimentID: '#idExp',
                    parentID: '#idStep2',
                    name: 'Analyze Nucleocounter',
                    type: 'Analyze',
                    tags: ['IM']
                },
                {
                    eClass: 'Step',
                    id: '#idStep4',
                    experimentID: '#idExp',
                    parentID: '#idStep2',
                    name: 'Stain',
                    type: 'Stain',
                    tags: ['IM']
                },
                {
                    eClass: 'Step',
                    id: '#idStep5',
                    experimentID: '#idExp',
                    parentID: '#idStep4',
                    name: 'Analyze Flow Cytometry',
                    type: 'Analyze',
                    tags: ['IM']
                }];
            this.logger.debug('Entities:', entities);
            const result = yield this.server.saveEntities(entities);
            if (result && result.newEntities) {
                const experiment = result.newEntities.find(e => e.eClass === 'Experiment');
                this.dialog.ok(experiment);
            }
        });
    }
};
ExperimentCreatePage = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ConsoleLogger"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], ExperimentCreatePage);



/***/ }),

/***/ "../apps/demo/raw_data_app/src/entity/panels/request-detail.html":
/*!***********************************************************************!*\
  !*** ../apps/demo/raw_data_app/src/entity/panels/request-detail.html ***!
  \***********************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel\">\r\n        <div class=\"panel-heading\">Experiment(s)</div>\r\n        <div class=\"panel-body\">\r\n            <p repeat.for=\"experiment of experiments\">\r\n                <a href=\"/#/eln/${experiment.id}\">${experiment.name}</a>\r\n            </p>\r\n            <button click.delegate=\"createExperiment()\">Create Experiment</button>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/raw_data_app/src/entity/panels/request-detail.ts":
/*!*********************************************************************!*\
  !*** ../apps/demo/raw_data_app/src/entity/panels/request-detail.ts ***!
  \*********************************************************************/
/*! exports provided: RequestDetailPlugin */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RequestDetailPlugin", function() { return RequestDetailPlugin; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _dialogs_experiment_create__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../../dialogs/experiment-create */ "../apps/demo/raw_data_app/src/dialogs/experiment-create.ts");






let RequestDetailPlugin = class RequestDetailPlugin {
    constructor(router, dialog, server) {
        this.router = router;
        this.dialog = dialog;
        this.server = server;
    }
    static isMatch(context) {
        return context.entity && context.entity.eClass === 'Request' && context.entity.description.startsWith('IM,');
    }
    init(context) {
        this.request = context.entity;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { view: 'StepSampleInput', collection: 'inputs', filters: [{ field: 'RequestID', value: this.request.id }] },
                { eClass: 'Step', collection: 'steps', filters: [{ field: 'ID', in: 'inputs.StepID' }] },
                { eClass: 'Experiment', collection: 'experiments', filters: [{ field: 'ID', in: 'steps.ExperimentID' }] }
            ]);
            this.experiments = dataset.experiments;
        });
    }
    createExperiment() {
        this.dialog.open({
            view: __webpack_require__(/*! ../../dialogs/experiment-create.html */ "../apps/demo/raw_data_app/src/dialogs/experiment-create.html"),
            viewModel: _dialogs_experiment_create__WEBPACK_IMPORTED_MODULE_5__["ExperimentCreatePage"],
            model: this.request
        }).whenClosed(result => {
            if (!result.wasCancelled) {
                this.router.navigate('eln/' + result.output.id);
            }
        });
    }
};
RequestDetailPlugin = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], RequestDetailPlugin);



/***/ }),

/***/ "../apps/demo/raw_data_app/temp/gen-app.js":
/*!*************************************************!*\
  !*** ../apps/demo/raw_data_app/temp/gen-app.js ***!
  \*************************************************/
/*! exports provided: plugins, hot, moduleId */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(module) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "plugins", function() { return plugins; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hot", function() { return hot; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "moduleId", function() { return moduleId; });
const plugins = [
{
 id: 'requestPanel',
 func: __webpack_require__(/*! ../src/entity/panels/request-detail.ts */ "../apps/demo/raw_data_app/src/entity/panels/request-detail.ts"),
 types: ["entity.panel"],
 view: __webpack_require__(/*! ../src/entity/panels/request-detail.html */ "../apps/demo/raw_data_app/src/entity/panels/request-detail.html"),
},
{
 id: 'routePage_rdIndex',
 func: () => __webpack_require__.e(/*! import() | routePage_rdIndex */ "routePage_rdIndex").then(__webpack_require__.bind(null, /*! ../src/pages/index.ts */ "../apps/demo/raw_data_app/src/pages/index.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_rdIndex */ "routePage_rdIndex").then(__webpack_require__.t.bind(null, /*! ../src/pages/index.html */ "../apps/demo/raw_data_app/src/pages/index.html", 7)),
},
{
 id: 'routePage_rdRequestCreate',
 func: () => __webpack_require__.e(/*! import() | routePage_rdRequestCreate */ "routePage_rdRequestCreate").then(__webpack_require__.bind(null, /*! ../src/pages/request-create.ts */ "../apps/demo/raw_data_app/src/pages/request-create.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_rdRequestCreate */ "routePage_rdRequestCreate").then(__webpack_require__.t.bind(null, /*! ../src/pages/request-create.html */ "../apps/demo/raw_data_app/src/pages/request-create.html", 7)),
},
];
const hot = module.hot;
const moduleId = module.i;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../../../../client/node_modules/webpack/buildin/harmony-module.js */ "./node_modules/webpack/buildin/harmony-module.js")(module)))

/***/ }),

/***/ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js":
/*!*********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js from dll-reference scifeon_data ***!
  \*********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");

/***/ }),

/***/ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js":
/*!*****************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-router/dist/commonjs/aurelia-router.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");

/***/ }),

/***/ "./node_modules/tslib/tslib.js":
/*!*************************************!*\
  !*** ./node_modules/tslib/tslib.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global global, define, System, Reflect, Promise */
var __extends;
var __assign;
var __rest;
var __decorate;
var __param;
var __metadata;
var __awaiter;
var __generator;
var __exportStar;
var __values;
var __read;
var __spread;
var __await;
var __asyncGenerator;
var __asyncDelegator;
var __asyncValues;
var __makeTemplateObject;
var __importStar;
var __importDefault;
(function (factory) {
    var root = typeof global === "object" ? global : typeof self === "object" ? self : typeof this === "object" ? this : {};
    if (true) {
        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports], __WEBPACK_AMD_DEFINE_RESULT__ = (function (exports) { factory(createExporter(root, createExporter(exports))); }).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    }
    else {}
    function createExporter(exports, previous) {
        if (exports !== root) {
            if (typeof Object.create === "function") {
                Object.defineProperty(exports, "__esModule", { value: true });
            }
            else {
                exports.__esModule = true;
            }
        }
        return function (id, v) { return exports[id] = previous ? previous(id, v) : v; };
    }
})
(function (exporter) {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    __extends = function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };

    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };

    __rest = function (s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
                t[p[i]] = s[p[i]];
        return t;
    };

    __decorate = function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };

    __param = function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };

    __metadata = function (metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    };

    __awaiter = function (thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    };

    __generator = function (thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    };

    __exportStar = function (m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    };

    __values = function (o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    };

    __read = function (o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    };

    __spread = function () {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    };

    __await = function (v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    };

    __asyncGenerator = function (thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);  }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    };

    __asyncDelegator = function (o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    };

    __asyncValues = function (o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    };

    __makeTemplateObject = function (cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    __importStar = function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result["default"] = mod;
        return result;
    };

    __importDefault = function (mod) {
        return (mod && mod.__esModule) ? mod : { "default": mod };
    };

    exporter("__extends", __extends);
    exporter("__assign", __assign);
    exporter("__rest", __rest);
    exporter("__decorate", __decorate);
    exporter("__param", __param);
    exporter("__metadata", __metadata);
    exporter("__awaiter", __awaiter);
    exporter("__generator", __generator);
    exporter("__exportStar", __exportStar);
    exporter("__values", __values);
    exporter("__read", __read);
    exporter("__spread", __spread);
    exporter("__await", __await);
    exporter("__asyncGenerator", __asyncGenerator);
    exporter("__asyncDelegator", __asyncDelegator);
    exporter("__asyncValues", __asyncValues);
    exporter("__makeTemplateObject", __makeTemplateObject);
    exporter("__importStar", __importStar);
    exporter("__importDefault", __importDefault);
});

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../webpack/buildin/global.js */ "./node_modules/webpack/buildin/global.js")))

/***/ }),

/***/ "./node_modules/webpack/buildin/global.js":
/*!********************************************************************************************!*\
  !*** delegated ./node_modules/webpack/buildin/global.js from dll-reference scifeon_vendor ***!
  \********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/webpack/buildin/global.js");

/***/ }),

/***/ "./node_modules/webpack/buildin/harmony-module.js":
/*!*******************************************!*\
  !*** (webpack)/buildin/harmony-module.js ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = function(originalModule) {
	if (!originalModule.webpackPolyfill) {
		var module = Object.create(originalModule);
		// module.parent = undefined by default
		if (!module.children) module.children = [];
		Object.defineProperty(module, "loaded", {
			enumerable: true,
			get: function() {
				return module.l;
			}
		});
		Object.defineProperty(module, "id", {
			enumerable: true,
			get: function() {
				return module.i;
			}
		});
		Object.defineProperty(module, "exports", {
			enumerable: true
		});
		module.webpackPolyfill = 1;
	}
	return module;
};


/***/ }),

/***/ "./packages/core/index.ts":
/*!**************************************************************************!*\
  !*** delegated ./packages/core/index.ts from dll-reference scifeon_data ***!
  \**************************************************************************/
/*! exports provided: Config, ScifeonConsoleLogger, ConsoleLogger, Status, Event, DataModel, ReadExcelCommon, XL, LoadingSpinner, ScifeonLoadingSpinner, ServerAPI, User, UserHelper, DSUtils, DateUtils, MathUtils, PLATE, PluginUtils, ScifeonUtils, Utils, SdkUtils, SpreadsheetUtils */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./packages/core/index.ts");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ }),

/***/ 0:
/*!*******************************************************!*\
  !*** multi ../apps/demo/raw_data_app/temp/gen-app.js ***!
  \*******************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! C:\agent\_work\3\s\apps\demo\raw_data_app\temp\gen-app.js */"../apps/demo/raw_data_app/temp/gen-app.js");


/***/ }),

/***/ "dll-reference scifeon_data":
/*!*******************************!*\
  !*** external "scifeon_data" ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_data;

/***/ }),

/***/ "dll-reference scifeon_ui":
/*!*****************************!*\
  !*** external "scifeon_ui" ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_ui;

/***/ }),

/***/ "dll-reference scifeon_vendor":
/*!*********************************!*\
  !*** external "scifeon_vendor" ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_vendor;

/***/ })

/******/ }));;
//# sourceMappingURL=app.js.map