(window["webpackJsonpcom_scifeon_scifeon_apps_validation"] = window["webpackJsonpcom_scifeon_scifeon_apps_validation"] || []).push([["routePage_sciquClaimCreate"],{

/***/ "../apps/demo/validation_app/src/pages/claim-create.html":
/*!***************************************************************!*\
  !*** ../apps/demo/validation_app/src/pages/claim-create.html ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\"><h1>Create Claim</h1><button click.delegate=\"save()\">Save</button></div>\r\n        <div class=\"page-panels grid\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Claim Text</div>\r\n                <div class=\"panel-body\">\r\n                    <div class=\"form-group\">\r\n                        <label>Document</label>\r\n                        <select value.bind=\"claim.documentID\" change.delegate=\"docChanged()\">\r\n                            <option repeat.for=\"doc of docs\" value.bind=\"doc.id\">${doc.name}</option>\r\n                        </select>\r\n                    </div>\r\n\r\n                    <div class=\"form-group\">\r\n                        <label>Section</label>\r\n                        <select value.bind=\"claim.sectionID\" change.delegate=\"sectionChanged()\">\r\n                            <option repeat.for=\"section of sectionsInDoc\" value.bind=\"section.id\">${section.name}</option>\r\n                        </select>\r\n                    </div>\r\n                    \r\n                    <div class=\"form-group\">\r\n                        <label>Type</label>\r\n                        <select value.bind=\"claim.type\">\r\n                            <option>URSClaim</option>\r\n                            <option>FSClaim</option>\r\n                            <option>DSClaim</option>\r\n                            <option>AutoTest</option>\r\n                            <option>ManualTest</option>\r\n                            <option>IQStep</option>\r\n                            <option>OQStep</option>\r\n                            <option>PQStep</option>\r\n                        </select>\r\n                    </div>\r\n                    <div class=\"form-group\">\r\n                        <label>Title</label>\r\n                        <input value.bind=\"claim.description\"/>\r\n                    </div>\r\n            \r\n                    <div class=\"form-group\">\r\n                        <label>Claim Text</label>\r\n                        <rich-text-editor value.bind=\"claim.content\"></rich-text-editor>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        \r\n            <div class=\"panel\" if.bind=\"parentClaim\">\r\n                <div class=\"panel-heading\">Parent Claim</div>\r\n                <div class=\"panel-body\">\r\n                    <div class=\"view-group\">\r\n                        <label><a href='/#/val/claim/${parentClaim.id}'>${parentClaim.name}</a></label>\r\n                    </div>\r\n                    \r\n                    <div class=\"view-group\">\r\n                        <label>Title</label>\r\n                        <p>${parentClaim.description}</p>\r\n                    </div>\r\n        \r\n                    <div class=\"view-group\">\r\n                        <label>Claim Text</label>\r\n                        <p innerHtml.bind=\"parentClaim.content\"></p>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/validation_app/src/pages/claim-create.ts":
/*!*************************************************************!*\
  !*** ../apps/demo/validation_app/src/pages/claim-create.ts ***!
  \*************************************************************/
/*! exports provided: SciQuClaimCreate */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SciQuClaimCreate", function() { return SciQuClaimCreate; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_3__);




let SciQuClaimCreate = class SciQuClaimCreate {
    constructor(server, router) {
        this.server = server;
        this.router = router;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.claim = {
                eClass: 'ValEntry',
                type: 'FSClaim',
                status: 'Draft',
            };
            if (context.params.parentID) {
                let ds = yield this.server.datasetQuery([
                    { eClass: 'ValEntry', alias: 'parentClaim', filters: [{ field: 'ID', value: context.params.parentID }] },
                    { eClass: 'ValDocument', collection: 'docs', filters: [{ field: 'ProjectID', value: '$parentClaim.ProjectID' }] },
                    { eClass: 'ValSection', collection: 'sections', filters: [{ field: 'ProjectID', value: '$parentClaim.ProjectID' }] }
                ]);
                this.docs = ds.docs;
                this.sections = ds.sections;
                this.parentClaim = ds.parentClaim;
                this.claim.valEntryRefs = [{ parentID: this.parentClaim.id, type: 'FS2URS' }];
                this.claim.projectID = this.parentClaim.projectID;
                this.claim.documentID = this.parentClaim.documentID;
                this.claim.sectionID = this.parentClaim.sectionID;
                this.claim.description = this.parentClaim.description;
                this.docChanged();
            }
            else {
                this.claim.projectID = context.params.projectID;
                this.claim.sectionID = context.params.sectionID;
                this.claim.documentID = context.params.documentID;
                let ds = yield this.server.datasetQuery([
                    { eClass: 'ValDocument', collection: 'docs', filters: [{ field: 'ProjectID', value: context.params.projectID }] },
                    { eClass: 'ValSection', collection: 'sections', filters: [{ field: 'ProjectID', value: context.params.projectID }] }
                ]);
                this.docs = ds.docs;
                this.sections = ds.sections;
                let section = this.sections.find(s => s.id === context.params.sectionID);
                this.claim.type = section.type + 'Claim';
                this.docChanged();
            }
        });
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.assignClaimName();
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            this.server.saveEntities([this.claim])
                .then(response => {
                _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
                this.router.navigate('val/claim/' + response.newEntities[0].id);
            });
        });
    }
    assignClaimName() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let ds = yield this.server.datasetQuery([
                { eClass: 'ValEntry', collection: 'claims',
                    filters: [{ field: 'Type', value: this.claim.type }, { field: 'DocumentID', value: this.claim.documentID }],
                    sortings: [{ field: 'Name', direction: 'desc' }], fetch: 1
                }
            ]);
            let doc = this.docs.find(d => d.id === this.claim.documentID);
            if (ds.claims.length === 0) {
                this.claim.name = doc.name + '-001';
            }
            else {
                let match = /(.*-)(\d+)$/.exec(ds.claims[0].name);
                if (match) {
                    let claimNo = "" + (parseInt(match[2]) + 1);
                    while (claimNo.length < 3)
                        claimNo = '0' + claimNo;
                    this.claim.name = doc.name + '-' + claimNo;
                }
                else
                    throw ("Can't assign names for this type of claim");
            }
        });
    }
    docChanged() {
        this.sectionsInDoc = this.sections.filter(s => s.documentID === this.claim.documentID);
        if (!this.sectionsInDoc.find(s => s.id === this.claim.sectionID))
            this.claim.sectionID = this.sectionsInDoc[0].id;
    }
};
SciQuClaimCreate = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_3__["Router"]])
], SciQuClaimCreate);



/***/ })

}]);
//# sourceMappingURL=routePage_sciquClaimCreate.5886312936a19e110910.js.map