(window["webpackJsonpcom_scifeon_scifeon_apps_validation"] = window["webpackJsonpcom_scifeon_scifeon_apps_validation"] || []).push([["routePage_sciquProject"],{

/***/ "../apps/demo/validation_app/src/pages/project.html":
/*!**********************************************************!*\
  !*** ../apps/demo/validation_app/src/pages/project.html ***!
  \**********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1>SciQu Project: ${projectID}</h1>\r\n        </div>\r\n\r\n        <div class=\"page-panels grid\" style=\"grid-template-columns: 1fr 1fr\">\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Documents</div>\r\n                <div class=\"panel-body\">\r\n\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                                <th>Content</th>\r\n                                <th>Title</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"di of docInfos\">\r\n                                <td><a href='/#/val/document/${di.doc.id}'>${di.doc.name}</a></td>\r\n                                <td>${di.doc.type}</td>\r\n                                <td>${di.doc.description}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                    <p><button click.delegate=\"addDocument()\">Add Document</button></p>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Active Message Threads</div>\r\n                <div class=\"panel-body\">\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th></th>\r\n                                <th>Entry</th>\r\n                                <th>Date</th>\r\n                                <th>User</th>\r\n                                <th>Status</th>\r\n                                <th>Topic</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <template repeat.for=\"ti of threadInfos\" containerless>\r\n                                <tr>\r\n                                    <td>\r\n                                        <span click.delegate=\"toggleDetails(ti)\" class=\"fa fa-toggle-off\" if.bind=\"!ti.detailsVisible\" title=\"Show details\"></span>\r\n                                        <span click.delegate=\"toggleDetails(ti)\" class=\"fa fa-toggle-on\" if.bind=\"ti.detailsVisible\" title=\"Hide details\"></span>    \r\n                                    </td>\r\n                                    <td><a href='/#/val/claim/${ti.entry.id}'>${ti.entry.name}</a></td>\r\n                                    <td>${ti.messages[0].createdUtc | dateTimeFormat}</td>\r\n                                    <td>${ti.messages[0].userID}</td>\r\n                                    <td>${ti.thread.status}</td>\r\n                                    <td>${ti.thread.description}</td>\r\n                                    <td>\r\n                                        <button if.bind=\"ti.showReply\" class=\"small\" click.delegate=\"reply(ti)\">Reply</button>\r\n                                        <button if.bind=\"ti.showResolve\" class=\"small\" click.delegate=\"resolve(ti)\">Resolved</button>\r\n                                        <button if.bind=\"ti.showReopen\" class=\"small\" click.delegate=\"reopen(ti)\">Re-open</button>\r\n                                    </td>\r\n                                </tr>\r\n                                <tr if.bind=\"ti.detailsVisible\">\r\n                                    <td colspan=\"6\">\r\n                                        <label>Messages</label>\r\n                                        <div repeat.for=\"m of ti.messages\">\r\n                                            <hr/>\r\n                                            <h3>Topic: ${m.description}</h3>\r\n                                            <p>${m.createdUtc | dateTimeFormat}: ${m.userID}</p>\r\n                                            <p><button click.delegate=\"markDecision(ti, m)\" class=\"small\">Decision</button></p>\r\n                                            <div innerHtml.bind=\"m.content\"></div>\r\n                                        </div>\r\n                                    </td>\r\n                                </tr>\r\n                            </template>\r\n                        </tbody>\r\n                    </table>\r\n\r\n                    <hr/>\r\n                    <button click.delegate=\"startMessageThread()\">Start New Thread</button>\r\n        \r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\" style=\"grid-column: span 2\">\r\n                <div class=\"panel-heading\">Traceability Matrix</div>\r\n                <div class=\"panel-body\">\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>URS</th>\r\n                                <th>FS</th>\r\n                                <th>DS</th>\r\n                                <th>Test</th>\r\n                                <th>Q-step</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"row of tm\">\r\n                                <td><a href='/#/val/claim/${row.urs.id}'>${row.urs.name}</a><br/>${row.urs.status}</td>\r\n                                <td><a href='/#/val/claim/${row.fs.id}'>${row.fs.name}</a><br/>${row.fs.status}</td>\r\n                                <td><a href='/#/val/claim/${row.ds.id}'>${row.ds.name}</a><br/>${row.ds.status}</td>\r\n                                <td></td>\r\n                                <td></td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n    \r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/validation_app/src/pages/project.ts":
/*!********************************************************!*\
  !*** ../apps/demo/validation_app/src/pages/project.ts ***!
  \********************************************************/
/*! exports provided: SciQuProject */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SciQuProject", function() { return SciQuProject; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _popups_popupAddDocument__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../popups/popupAddDocument */ "../apps/demo/validation_app/src/popups/popupAddDocument.ts");






let SciQuProject = class SciQuProject {
    constructor(server, router, dialog) {
        this.server = server;
        this.router = router;
        this.dialog = dialog;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let projectID = context.params.id;
            const ds = yield this.server.datasetQuery([
                { eClass: 'Project', alias: 'project', filters: [{ field: 'ID', value: projectID }] },
                { eClass: 'ValDocument', collection: 'docs', filters: [{ field: 'ProjectID', value: projectID }] },
                { eClass: 'ValSection', collection: 'sections', filters: [{ field: 'ProjectID', value: projectID }] },
                { eClass: 'ValEntry', collection: 'entries', filters: [{ field: 'ProjectID', value: projectID }] },
                { eClass: 'Message', collection: 'messages', filters: [{ field: 'ProjectID', value: projectID }] },
                { eClass: 'MessageThread', collection: 'threads',
                    filters: [
                        { field: 'ProjectID', value: projectID },
                        { field: 'Status', value: 'Open' }
                    ] },
                { eClass: 'ValRootClaimsHierarchy', collection: 'hierarchy', filters: [{ field: 'ProjectID', value: projectID }] }
            ]);
            this.project = ds.project;
            this.entries = ds.entries;
            this.docInfos = ds.docs.map(d => {
                return {
                    doc: d,
                    sections: ds.sections.filter(s => s.documentID === d.id)
                };
            });
            this.threadInfos = ds.threads.map(t => {
                return {
                    thread: t,
                    messages: ds.messages.filter(m => m.threadID === t.id).sort((a, b) => a.createdUtc > b.createdUtc ? -1 : 1),
                    entry: ds.entries.find(c => c.id === t.entryID),
                    detailsVisible: false,
                    showReopen: t.status === 'Resolved',
                    showReply: t.status !== 'Resolved',
                    showResolve: t.status !== 'Resolved'
                };
            });
            this.prepareTM(ds.hierarchy);
        });
    }
    toggleDetails(o) {
        o.detailsVisible = !o.detailsVisible;
    }
    addDocument() {
        let doc = {
            eClass: 'ValDocument',
            projectID: this.project.id,
            status: 'Draft'
        };
        this.dialog
            .open({
            viewModel: _popups_popupAddDocument__WEBPACK_IMPORTED_MODULE_5__["PopupAddDocument"],
            model: { doc: doc }
        })
            .whenClosed(result => {
            if (!result.wasCancelled)
                this.createDocument(doc);
        });
    }
    createDocument(doc) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            let response = yield this.server.saveEntities([doc]);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
            this.router.navigate(`/val/document/${response.newEntities[0].id}`);
        });
    }
    prepareTM(hierarchy) {
        this.tm = [];
        hierarchy.filter(claim => claim.type === 'URSClaim').forEach(claim => {
            this.tm.push({ urs: claim });
        });
        hierarchy.filter(claim => claim.type === 'FSClaim').forEach(claim => {
            let row = this.tm.find(row => row.urs && row.urs.id === claim.parentID);
            if (row) {
                if (row.fs)
                    this.tm.push({ urs: row.urs, fs: claim });
                else
                    row.fs = claim;
            }
            else
                this.tm.push({ fs: claim });
        });
        hierarchy.filter(claim => claim.type === 'DSClaim').forEach(claim => {
            let row = this.tm.find(row => row.fs && row.fs.id === claim.parentID);
            if (row) {
                if (row.ds)
                    this.tm.push({ urs: row.urs, fs: row.fs, ds: claim });
                else
                    row.ds = claim;
            }
            else
                this.tm.push({ ds: claim });
        });
    }
};
SciQuProject = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], SciQuProject);



/***/ }),

/***/ "../apps/demo/validation_app/src/popups/popupAddDocument.ts":
/*!******************************************************************!*\
  !*** ../apps/demo/validation_app/src/popups/popupAddDocument.ts ***!
  \******************************************************************/
/*! exports provided: PopupAddDocument */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PopupAddDocument", function() { return PopupAddDocument; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");


class PopupAddDocument {
    constructor(dialog) {
        this.dialog = dialog;
        this.view = () => `
<ux-dialog>
    <ux-dialog-header>
        <h2>Add Document</h2>
    </ux-dialog-header>
    <ux-dialog-body>
        <div class="form-group">
            <label>Name</label>
            <input value.bind="doc.name" focus="true"></input>
        </div>
        <div class="form-group">
            <label>Title</label>
            <input value.bind="doc.description"></input>
        </div>
        <div class="form-group">
            <label>Type</label>
            <input value.bind="doc.type"></input>
        </div>
    </ux-dialog-body>
    <ux-dialog-footer>
        <button click.delegate="dialog.ok()">Create</button>
        <button class="btn-link" click.delegate="dialog.cancel()">Cancel</button>
    </ux-dialog-footer>
</ux-dialog>`;
    }
    init(model) {
        this.doc = model.doc;
    }
    enter() { this.dialog.ok(); }
}
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    _scifeon_ui__WEBPACK_IMPORTED_MODULE_1__["Dialog"].enterKeyPressedAction,
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Function),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", []),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:returntype", void 0)
], PopupAddDocument.prototype, "enter", null);


/***/ })

}]);
//# sourceMappingURL=routePage_sciquProject.5886312936a19e110910.js.map