com_scifeon_scifeon_logistics(/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 	};
/******/
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		"app": 0
/******/ 	};
/******/
/******/
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "" + chunkId + "." + "1689f8bda2b220050734" + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var head = document.getElementsByTagName('head')[0];
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							var error = new Error('Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')');
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/bundledApps/com.scifeon/scifeon_logistics/";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["webpackJsonpcom_scifeon_scifeon_logistics"] = window["webpackJsonpcom_scifeon_scifeon_logistics"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "../apps/demo/logistics_app/src/entity/panels/box-detail.html":
/*!********************************************************************!*\
  !*** ../apps/demo/logistics_app/src/entity/panels/box-detail.html ***!
  \********************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel\">\r\n        <div class=\"panel-heading\">Samples</div>\r\n        <div class=\"panel-body\">\r\n            <div class=\"form-group\">\r\n                <table>\r\n                    <thead>\r\n                        <tr>\r\n                            <th>Name</th>\r\n                            <th>External ID</th>\r\n                            <th>Type</th>\r\n                            <th>Content</th>\r\n                        </tr>\r\n                    </thead>\r\n                    <tbody>\r\n                        <tr repeat.for=\"sample of samples\">\r\n                            <td><a href=\"#/entity/Sample/${sample.id}\">${sample.name}</a></td>\r\n                            <td>${sample.externalID}</td>\r\n                            <td>${sample.type}</td>\r\n                            <td>${sample.content}</td>\r\n                        </tr>\r\n                    </tbody>\r\n                </table>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/logistics_app/src/entity/panels/box-detail.ts":
/*!******************************************************************!*\
  !*** ../apps/demo/logistics_app/src/entity/panels/box-detail.ts ***!
  \******************************************************************/
/*! exports provided: BoxDetail */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "BoxDetail", function() { return BoxDetail; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let BoxDetail = class BoxDetail {
    constructor(api) {
        this.api = api;
    }
    init(context) {
        this.location = context.entity;
        this.findSamples();
    }
    findSamples() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.api.datasetQuery([
                { eClass: 'Sample', collection: 'samples', filters: [{ field: 'LocationID', value: this.location.id }] },
            ]);
            this.samples = dataset.samples;
        });
    }
};
BoxDetail = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["scifeonPlugin"])({
        name: 'Box Content Details',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL,
        match: (context) => context.entity.eClass === 'StorageLocation' && context.entity.type === 'Box'
    }),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], BoxDetail);



/***/ }),

/***/ "../apps/demo/logistics_app/src/entity/panels/container-view.html":
/*!************************************************************************!*\
  !*** ../apps/demo/logistics_app/src/entity/panels/container-view.html ***!
  \************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <style>\r\n        ul { margin-bottom: 20px; margin-top: 5px; }\r\n        li { line-height: 0; }\r\n        p { margin-top: 2px; }\r\n    </style>\r\n    <div class=\"panel\">\r\n        <div class=\"panel-heading\">Container View</div>\r\n        <div class=\"panel-body\">\r\n                \r\n            <div class=\"form-group\" if.bind=\"dataset.contents.length>0\">\r\n                <label>Containers</label>\r\n\r\n                <div repeat.for=\"content of dataset.contents\">\r\n                    <p>\r\n                        <u><a href=\"#/entity/StorageLocation/${content.id}\">${content.name}</a></u>\r\n                        <span click.delegate=\"toggleDetails(content)\" class=\"fa fa-toggle-off\" if.bind=\"!content.detailsVisible\" title=\"Show contents\"></span>\r\n                        <span click.delegate=\"toggleDetails(content)\" class=\"fa fa-toggle-on\" if.bind=\"content.detailsVisible\" title=\"Hide contents\"></span>\r\n                    </p>\r\n\r\n                    <ul repeat.for=\"child of content.children\" if.bind=\"content.detailsVisible\">\r\n                        <li><a href=\"#/entity/StorageLocation/${child.id}\">${child.name}</a></li>\r\n                    </ul>\r\n                    <ul repeat.for=\"sample of content.samples\" if.bind=\"content.detailsVisible\">\r\n                        <li><a href=\"#/entity/Sample/${sample.id}\">${sample.name}</a></li>\r\n                    </ul>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"form-group\" if.bind=\"dataset.samples.length>0\">\r\n                <label>Samples</label>\r\n                <div repeat.for=\"sample of dataset.samples\">\r\n                    <p><a href=\"#/entity/Sample/${sample.id}\">${sample.name}</a></p>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/logistics_app/src/entity/panels/container-view.ts":
/*!**********************************************************************!*\
  !*** ../apps/demo/logistics_app/src/entity/panels/container-view.ts ***!
  \**********************************************************************/
/*! exports provided: ContainerView */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ContainerView", function() { return ContainerView; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let ContainerView = class ContainerView {
    constructor(api) {
        this.api = api;
    }
    init(context) {
        this.location = context.entity;
        this.findSamples();
    }
    toggleDetails(sampleInfo) {
        sampleInfo.detailsVisible = !sampleInfo.detailsVisible;
    }
    findSamples() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.dataset = yield this.api.datasetQuery([
                { eClass: 'StorageLocation', collection: 'contents', filters: [{ field: 'LocationID', value: this.location.id }] },
                { eClass: 'Sample', collection: 'samples', filters: [{ field: 'LocationID', value: this.location.id }] },
                { eClass: 'StorageLocation', collection: 'nestedContents', filters: [{ field: 'LocationID', in: 'contents.id' }] },
                { eClass: 'Sample', collection: 'nestedSamples', filters: [{ field: 'LocationID', in: 'contents.id' }] }
            ]);
            this.dataset.contents.forEach(c => {
                c.children = this.dataset.nestedContents.filter(n => n.locationID === c.id);
                c.samples = this.dataset.nestedSamples.filter(n => n.locationID === c.id);
                c.detailsVisible = false;
            });
        });
    }
};
ContainerView = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["scifeonPlugin"])({
        name: 'ContainerView',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL,
        match: (context) => context.entity.eClass === 'StorageLocation' && context.entity.type !== 'Freezer' && context.entity.type !== 'Rack' && context.entity.type !== 'Box'
    }),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], ContainerView);



/***/ }),

/***/ "../apps/demo/logistics_app/src/entity/panels/freezer-rack-detail.html":
/*!*****************************************************************************!*\
  !*** ../apps/demo/logistics_app/src/entity/panels/freezer-rack-detail.html ***!
  \*****************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <style>\r\n        .freezer {\r\n            width: 300px;\r\n            background-color: #ccc;\r\n            padding: 15px;\r\n        }\r\n        .drawer {\r\n            background-color: #555;\r\n            padding: 5px;\r\n            margin-bottom: 10px;\r\n            min-height: 80px;\r\n        }\r\n        .drawer .rack {\r\n            background-color: #eee;\r\n            padding: 3px;\r\n            margin-bottom: 3px;\r\n            display: flex;\r\n        }\r\n        .drawer .rack span {\r\n            margin: 2px 10px;\r\n        }\r\n\r\n        .rack {\r\n            background-color: #ccc;\r\n            padding: 15px;\r\n            display: inline-block;\r\n        }\r\n        .row {\r\n            display: flex;\r\n        }\r\n        .slot {\r\n            background-color: #555;\r\n            width: 40px;\r\n            height: 20px;\r\n            margin: 0 5px 5px 0;\r\n        }\r\n        .slot.filled {\r\n            background-color: #f00;\r\n        }\r\n    </style>\r\n\r\n    <div class=\"panel\" if.bind=\"location.type==='Freezer'\">\r\n        <div class=\"panel-heading\">Freezer Content</div>\r\n        <div class=\"panel-body\">\r\n            <div class=\"freezer\">\r\n                <div class=\"drawer\" repeat.for=\"drawer of tableFreezer\" >\r\n                    <span class=\"name\"><a href=\"#/entity/StorageLocation/${drawer.id}\" style=\"color:#ccc\">${drawer.name}</a></span>\r\n                    <div class=\"rack\" repeat.for=\"rack of drawer.racks\" >\r\n                        <span class=\"name\"><a href=\"#/entity/StorageLocation/${rack.id}\">${rack.name}</a></span>\r\n                        <span class=\"fill-level full\">${rack.boxes.length} / ${rack.capacity? rack.capacity : 100 }</span>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n    <div class=\"panel\" if.bind=\"location.type==='Rack'\">\r\n            <div class=\"panel-heading\">Rack Content</div>\r\n            <div class=\"panel-body\">\r\n                <div class=\"rack\">\r\n                    <div class=\"row\" repeat.for=\"row of tableRack\">\r\n                        <div repeat.for=\"box of row\" class.bind=\"box ? 'slot filled' : 'slot'\" style=\"overflow: hidden; \">\r\n                            <span class=\"name\"><a href=\"#/entity/StorageLocation/${box.id}\" title=\"${box.name}\">${box.name}</a></span>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/logistics_app/src/entity/panels/freezer-rack-detail.ts":
/*!***************************************************************************!*\
  !*** ../apps/demo/logistics_app/src/entity/panels/freezer-rack-detail.ts ***!
  \***************************************************************************/
/*! exports provided: FreezerDetail */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FreezerDetail", function() { return FreezerDetail; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let FreezerDetail = class FreezerDetail {
    constructor(api) {
        this.api = api;
    }
    init(context) {
        this.location = context.entity;
        if (this.location.type === "Freezer") {
            this.visualizeFreezer();
        }
        else if (this.location.type === "Rack") {
            this.visualizeRack();
        }
    }
    visualizeFreezer() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.api.datasetQuery([
                { eClass: 'StorageLocation', collection: 'drawers', filters: [{ field: 'Type', value: 'Drawer' }, { field: 'LocationID', value: this.location.id }] },
                { eClass: 'StorageLocation', collection: 'racks', filters: [{ field: 'Type', value: 'Rack' }, { field: 'LocationID', in: 'drawers.ID' }] },
                { eClass: 'StorageLocation', collection: 'boxes', filters: [{ field: 'Type', value: 'Box' }, { field: 'LocationID', in: 'racks.id' }] }
            ]);
            let drawers = dataset.drawers;
            let racks = dataset.racks;
            let boxes = dataset.boxes;
            racks.forEach(r => r.boxes = boxes.filter(b => b.locationID === r.id));
            this.tableFreezer = Array(drawers.length);
            for (let d of drawers) {
                d.racks = racks.filter(r => r.locationID == d.id);
                if (d.position) {
                    this.tableFreezer[d.position - 1] = d;
                }
                else {
                    this.tableFreezer[this.tableFreezer.findIndex(t => !t)] = d;
                }
            }
        });
    }
    visualizeRack() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let letters = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J"];
            const dataset = yield this.api.datasetQuery([
                { eClass: 'StorageLocation', collection: 'boxes', filters: [{ field: 'Type', value: 'Box' }, { field: 'LocationID', value: this.location.id }] }
            ]);
            let boxes = dataset.boxes;
            let nCols, nRows;
            if (this.location.attributes) {
                nCols = this.location.attributes.nCols;
                nRows = this.location.attributes.nRows;
            }
            if (!this.location.capacity) {
                this.location.capacity = 18;
            }
            if (!nCols || !nRows) {
                nCols = [10, 5, 4, 3, 2, 1].find(n => this.location.capacity % n === 0);
                nRows = this.location.capacity / nCols;
            }
            let boxesInList = Array(this.location.capacity);
            for (let box of boxes) {
                if (box.position) {
                    boxesInList[(box.position.match(/\d+/) - 1) * nCols + letters.indexOf(box.position.slice(0, 1))] = box;
                }
                else {
                    boxesInList[boxesInList.findIndex(t => !t)] = box;
                }
            }
            this.tableRack = [];
            while (boxesInList.length > 0) {
                this.tableRack.push(boxesInList.splice(0, nCols));
            }
        });
    }
};
FreezerDetail = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["scifeonPlugin"])({
        name: 'Content Visualization',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].ENTITY_PANEL,
        match: (context) => context.entity.eClass === 'StorageLocation' && (context.entity.type === 'Freezer' || context.entity.type === 'Rack')
    }),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], FreezerDetail);



/***/ }),

/***/ "../apps/demo/logistics_app/src/entity/panels/request-detail.html":
/*!************************************************************************!*\
  !*** ../apps/demo/logistics_app/src/entity/panels/request-detail.html ***!
  \************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>        \r\n        <div class=\"panel\" style=\"grid-column: span 2\" if.bind=\"request.status==='Completed'\">\r\n            <div class=\"panel-heading\">Request</div>\r\n            <div class=\"panel-body\">\r\n                <p>\r\n                    Request completed.\r\n                </p>\r\n                <p if.bind=\"transaction.transactionID\">\r\n                    Transaction at <a href='/#/entity/storagetransaction/${transaction.transactionID}'>${transaction.transactionID}</a>\r\n                </p>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"panel\" style=\"grid-column: span 2\" if.bind=\"request.status!=='Completed'\">\r\n            <div class=\"panel-heading\">Request</div>\r\n            <div class=\"panel-body\">\r\n                <p>\r\n                    <button click.delegate=\"samplesReceived()\">Samples Received</button>\r\n                </p>\r\n                <p>\r\n                    <input class=\"form-control\" ref=\"text\" value.bind=\"barcode\">\r\n                </p>\r\n                <p>\r\n                    <button click.delegate=\"requestCompleted()\">Complete Request</button>\r\n                </p>\r\n            </div>\r\n        </div>        \r\n    \r\n        <div class=\"panel\" style=\"grid-column: span 2\">\r\n            <div class=\"panel-heading\">Samples &amp; Selected Analyses <collapsible default=\"collapsed\"></collapsible></div>\r\n            <div class=\"panel-body\">\r\n                <div class=\"form-group\">\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <td></td>\r\n                                <td></td>\r\n                                <td repeat.for=\"method of methods\">\r\n                                    <button click.delegate=\"downloadSampleSheet(method)\">Setup File</button>\r\n                                </td>                                        \r\n                            </tr>\r\n                            <tr>\r\n                                <th>Sample</th>\r\n                                <th>External ID</th>\r\n                                <th repeat.for=\"method of methods\">${method.name}</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"sample of samples\">\r\n                                <td><a href='/#/entity/Sample/${sample.id}'>${sample.name}</a></td>\r\n                                <td>${sample.externalID}</td>\r\n                                <td repeat.for=\"method of methods\">${getAssayStatus(sample.id, method.name)}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </template>";

/***/ }),

/***/ "../apps/demo/logistics_app/src/entity/panels/request-detail.ts":
/*!**********************************************************************!*\
  !*** ../apps/demo/logistics_app/src/entity/panels/request-detail.ts ***!
  \**********************************************************************/
/*! exports provided: DemoLogRequestDetail */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DemoLogRequestDetail", function() { return DemoLogRequestDetail; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! file-saver */ "./node_modules/file-saver/FileSaver.js");
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(file_saver__WEBPACK_IMPORTED_MODULE_3__);




let DemoLogRequestDetail = class DemoLogRequestDetail {
    constructor(server, user) {
        this.server = server;
        this.user = user;
    }
    static isMatch(context) {
        return context.entity.eClass === 'Request' && context.entity.type === 'Other';
    }
    init(context) {
        this.request = context.entity;
        this.loadData();
    }
    loadData() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            const dataset = yield this.server.datasetQuery([
                { eClass: 'Note', collection: 'notes', filters: [{ field: 'SubjectID', value: this.request.id }] },
                { view: 'RequestPayload', collection: 'samples', filters: [{ field: 'RequestID', value: this.request.id }] }
            ]);
            this.methodIDs = this.request.payload.methods;
            this.samples = dataset.samples.sort((a, b) => a.id > b.id ? 1 : -1);
            this.completedSamples = dataset.samples.filter(sample => sample.status === 'Completed');
            this.note = dataset.notes.find(c => c.type === 'EntryNotes');
            const methodsAndAssays = yield this.server.datasetQuery([
                { eClass: 'Method', collection: 'methods', filters: [{ field: 'ID', values: this.methodIDs }] },
                { view: 'MSSampleAssayStatus', collection: 'assays', filters: [{ field: 'SampleID', values: this.samples.map(s => s.id) }] }
            ]);
            this.methods = methodsAndAssays.methods;
            this.assays = methodsAndAssays.assays;
            const stepSampleInput = yield this.server.datasetQuery([
                { view: 'StepSampleInput', collection: 'usage', filters: [{ field: 'RequestID', value: this.request.id }] }
            ]);
            let stepIDs = new Set();
            for (let entity of stepSampleInput.usage) {
                stepIDs.add(entity.stepID);
            }
            this.stepIDs = Array.from(stepIDs).sort();
            if (this.request.status === "Completed") {
                this.getTransaction();
            }
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
        });
    }
    getAssayStatus(sampleID, method) {
        let assay = this.assays.find(a => a.sampleID === sampleID && a.type === method);
        if (assay)
            return assay.status;
        return '-';
    }
    downloadSampleSheet(method) {
        let wb = {
            SheetNames: [],
            Sheets: {}
        };
        let runSize = this.runSize(method.name);
        this.shuffle(this.samples);
        let ws = {
            'A1': { t: 's', v: 'MS Setup' },
            'A3': { t: 's', v: 'Scientist' },
            'B3': { t: 's', v: this.user.id },
            'A4': { t: 's', v: 'Run date' },
            'A5': { t: 's', v: 'Type' },
            'B5': { t: 's', v: method.name },
            'A6': { t: 's', v: 'Description' },
            'A8': { t: 's', v: 'Samples' },
            'B8': { t: 's', v: 'Run' },
            'C8': { t: 's', v: 'Name' },
            'D8': { t: 's', v: 'ParentID' },
            'E8': { t: 's', v: 'ControlType' },
            'F8': { t: 's', v: 'Batch' },
            'G8': { t: 's', v: 'Conc_Pct' },
            'H8': { t: 's', v: 'Spike' }
        };
        let sheetName = 'MSSetup';
        wb.Sheets[sheetName] = ws;
        wb.SheetNames.push(sheetName);
        if (this.request.description)
            ws.B6 = { t: 's', v: this.request.id + ': ' + this.request.description };
        this.xlrow = 9;
        this.xlrowLast = 8;
        this.nextQC = 1;
        for (let iRun = 0; iRun <= this.samples.length / runSize; iRun++) {
            let samples = this.samples.slice(iRun * runSize, (iRun + 1) * runSize);
            this.addRun(method, ws, iRun, samples);
        }
        ws['!ref'] = 'A1:H' + this.xlrowLast;
        let wbout = XLSX.write(wb, { bookType: 'xlsx', bookSST: false, type: 'binary' });
        Object(file_saver__WEBPACK_IMPORTED_MODULE_3__["saveAs"])(new Blob([this.s2ab(wbout)], { type: 'application/octet-stream' }), `Setup_${this.request.id}_${method.name}.xlsx`);
    }
    addRun(method, ws, iRun, samples) {
        this.addSamples(method, ws, this.headerSamples(method.name), iRun);
        let groupSize = this.determineGroupSize(method, samples);
        for (let iSample = 0; iSample < samples.length; iSample++) {
            if (iSample % groupSize === 0)
                this.addQCSample(method, ws, iRun);
            let sample = samples[iSample];
            ws['B' + this.xlrow] = { t: 'n', v: iRun + 1 };
            ws['C' + this.xlrow] = { t: 's', v: sample.name };
            ws['D' + this.xlrow] = { t: 's', v: sample.id };
            ws['G' + this.xlrow] = { t: 'n', v: 100.0 };
            this.xlrowLast = this.xlrow;
            this.xlrow++;
        }
        this.addQCSample(method, ws, iRun);
        this.addSamples(method, ws, this.footerSamples(method.name), iRun);
    }
    s2ab(s) {
        let buf = new ArrayBuffer(s.length);
        let view = new Uint8Array(buf);
        for (let i = 0; i != s.length; ++i)
            view[i] = s.charCodeAt(i) & 0xFF;
        return buf;
    }
    determineGroupSize(method, samples) {
        if (method.name === 'Vitamins')
            return 8;
        return 5;
    }
    addSamples(method, ws, sampleDict, iRun) {
        for (let i = 0; i < sampleDict.name.length; i++) {
            if (sampleDict.controlType[i] === 'QC')
                this.addQCSample(method, ws, iRun);
            else {
                ws['B' + this.xlrow] = { t: 'n', v: iRun + 1 };
                ws['C' + this.xlrow] = { t: 's', v: sampleDict.name[i] };
                ws['E' + this.xlrow] = { t: 's', v: sampleDict.controlType[i] };
                ws['F' + this.xlrow] = { t: 's', v: sampleDict.batch[i] };
                ws['G' + this.xlrow] = { t: 'n', v: sampleDict.concPct[i] };
                this.xlrowLast = this.xlrow;
                this.xlrow++;
            }
        }
    }
    addQCSample(method, ws, iRun) {
        if (method.name === 'Vitamins') {
            ws['B' + this.xlrow] = { t: 'n', v: iRun + 1 };
            ws['C' + this.xlrow] = { t: 's', v: `STD-D` };
            ws['E' + this.xlrow] = { t: 's', v: 'STD' };
            ws['G' + this.xlrow] = { t: 'n', v: 2 };
        }
        else {
            ws['B' + this.xlrow] = { t: 'n', v: iRun + 1 };
            ws['C' + this.xlrow] = { t: 's', v: `QC_${this.nextQC}` };
            ws['E' + this.xlrow] = { t: 's', v: 'QC' };
            ws['G' + this.xlrow] = { t: 'n', v: 100 };
        }
        this.xlrowLast = this.xlrow;
        this.xlrow++;
        this.nextQC++;
    }
    headerSamples(methodName) {
        switch (methodName) {
            case 'SCFA':
                return {
                    name: ['Blank_1', 'QC_1', 'Blank_1', 'STD0', 'STD01', 'STD025', 'STD05', 'STD1', 'STD25', 'STD5', 'STD116', 'STD25', 'STD50', 'STD100', 'Blank_2', 'Blank_2'],
                    controlType: ['Blank', 'QC', 'Blank', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'Blank', 'Blank'],
                    batch: ['', '', '', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', '', ''],
                    concPct: [100, 100, 100, 0, 0.1, 0.25, 0.5, 1, 2.5, 5, 11.6, 25, 50, 100, 100, 100]
                };
            case 'Vitamins':
                return {
                    name: ['Blank', 'Blank', 'Blank', 'STD-I', 'STD-H', 'STD-g', 'STD-F', 'STD-E', 'STD-D', 'STD-C', 'STD-B', 'STD-A', 'Blank', 'QC1', 'QC1s', 'QC2', 'QC2s', 'QC3', 'QC3s', 'QC4', 'QC4s', 'QC5', 'QC5s', 'STD-D'],
                    controlType: ['Blank', 'Blank', 'Blank', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'Blank', 'QC', 'QC', 'QC', 'QC', 'QC', 'QC', 'QC', 'QC', 'QC', 'QC', 'STD'],
                    batch: ['', '', '', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', '', '', '', '', '', '', '', '', '', '', '', ''],
                    concPct: [100, 100, 100, 0.01, 0.02, 0.1, 0.2, 1, 2, 10, 20, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100]
                };
            default:
                throw Error('Missing header samples for method: ' + methodName);
        }
    }
    footerSamples(methodName) {
        switch (methodName) {
            case 'SCFA':
                return {
                    name: ['D075', 'D050', 'D025', 'D010', 'QuantCtr_5mM', 'Spike00', 'Spike05', 'Spike10', 'QC_4', 'Blank_3', 'Blank_3', 'STD0', 'STD01', 'STD025', 'STD05', 'STD1', 'STD25', 'STD5', 'STD116', 'STD25', 'STD50', 'STD100', 'Blank_4', 'Blank_4', 'QC_4', 'Blank_4'],
                    controlType: ['Dilute', 'Dilute', 'Dilute', 'Dilute', 'QuantCtr-5', 'Spike', 'Spike', 'Spike', 'QC', 'Blank', 'Blank', 'Blank', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'Blank', 'Blank', 'QC', 'Blank'],
                    batch: ['', '', '', '', '', '', '', '', '', '', '', '', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', 'STD000', '', '', '', ''],
                    concPct: [75, 50, 25, 10, 0, 0, 0, 0, 100, 0, 0, 0, 0.1, 0.25, 0.5, 1, 2.5, 5, 11.6, 25, 50, 100, 0, 0, 100, 0]
                };
            case 'Vitamins':
                return {
                    name: ['STD-D', 'Blank', 'STD-I', 'STD-H', 'STD-g', 'STD-F', 'STD-E', 'STD-D', 'STD-C', 'STD-B', 'STD-A'],
                    controlType: ['STD', 'Blank', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD', 'STD',],
                    batch: ['BT???', '', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???', 'BT???',],
                    concPct: [2, 100, 0.01, 0.02, 0.1, 0.2, 1, 2, 10, 20, 100]
                };
            default:
                throw Error('Missing footer samples for method: ' + methodName);
        }
    }
    runSize(methodName) {
        if (methodName === 'Vitamins')
            return 100;
        return 35;
    }
    shuffle(samples) {
        let remaining = samples.length;
        while (remaining) {
            remaining--;
            let iSwapWith = Math.floor(Math.random() * (remaining + 1));
            let temp = samples[remaining];
            samples[remaining] = samples[iSwapWith];
            samples[iSwapWith] = temp;
        }
    }
    getTransaction() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.samples.length === 0) {
                this.transaction = null;
                return;
            }
            const response = yield this.server.datasetQuery([{
                    view: 'StorageTransactionItem',
                    collection: 'items',
                    filters: [{
                            field: 'SubjectID',
                            value: this.samples[0].id
                        }]
                }]);
            this.transaction = response.items[0];
        });
    }
    samplesReceived() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.request.status === _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].RECEIVED) {
                throw new Error("Request is already received.");
            }
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            if (this.samples.length !== 0) {
                for (let s of this.samples) {
                    s.status = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].RECEIVED;
                    yield this.server.updateEntity(s);
                }
                ;
            }
            ;
            this.request.status = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].RECEIVED;
            yield this.server.updateEntity(this.request);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
        });
    }
    requestCompleted() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
        });
    }
};
DemoLogRequestDetail = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], DemoLogRequestDetail);



/***/ }),

/***/ "../apps/demo/logistics_app/src/panels/dashboard.ts":
/*!**********************************************************!*\
  !*** ../apps/demo/logistics_app/src/panels/dashboard.ts ***!
  \**********************************************************/
/*! exports provided: DashboardPanelLogistics */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DashboardPanelLogistics", function() { return DashboardPanelLogistics; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let DashboardPanelLogistics = class DashboardPanelLogistics {
    constructor(api) {
        this.api = api;
        this.inboxName = "FNLs Inbox";
    }
    static isMatch(context) {
        return true;
    }
    static getConfig(location) {
        return {
            header: 'Logistics Inbox',
            rank: 120
        };
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
        });
    }
    view(location) {
        return `
        <h2>${this.inboxName}</h2>
        <table class="table compact">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Type</th>
                    <th>Status</th>
                </tr>
            </thead>
            <tbody>
                <tr repeat.for="request of requests">
                    <td><a href="/#/entity/Request/#{request.id}">#{request.name}</a></td>
                    <td>#{request.type}</td>
                    <td>#{request.status}</td>
                </tr>
            </tbody>
        </table>
            `;
    }
};
DashboardPanelLogistics = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], DashboardPanelLogistics);



/***/ }),

/***/ "../apps/demo/logistics_app/src/panels/locations-dashboard.ts":
/*!********************************************************************!*\
  !*** ../apps/demo/logistics_app/src/panels/locations-dashboard.ts ***!
  \********************************************************************/
/*! exports provided: DashboardPanelLogistics */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DashboardPanelLogistics", function() { return DashboardPanelLogistics; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let DashboardPanelLogistics = class DashboardPanelLogistics {
    constructor(server) {
        this.server = server;
    }
    static getConfig(location) {
        return {
            header: 'Container Contents',
            rank: 500
        };
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'StorageLocation', collection: 'freezers', filters: [{ field: 'Type', value: 'Freezer' }] },
                { eClass: 'StorageLocation', collection: 'racks', filters: [{ field: 'Type', value: 'Rack' }] },
                { eClass: 'StorageLocation', collection: 'boxes', filters: [{ field: 'Type', value: 'Box' }] }
            ]);
            this.locations = [{ name: " " }].concat(dataset.freezers, dataset.racks, dataset.boxes);
        });
    }
    findContent() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.selectedLocation.name === " ") {
                this.data = [];
                return;
            }
            const dataset = yield this.server.datasetQuery([
                { eClass: 'Sample', collection: 'samples', filters: [{ field: 'locationID', value: this.selectedLocation.id }] },
                { eClass: 'StorageLocation', collection: 'containers', filters: [{ field: 'locationID', value: this.selectedLocation.id }] }
            ]);
            this.data = dataset.samples.concat(dataset.containers);
        });
    }
    view(location) {
        return `
        <div class="form-group">
            <label>Location</label>
            <select value.bind="selectedLocation" change.delegate="findContent()">
                <option repeat.for="location of locations" model.bind="location">#{location.name}</option>
            </select>
        </div>
        <div if.bind='selectedLocation.name!=" "'>
            <table class="table compact">
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Class</th>
                        <th>Type</th>
                        <th>Status</th>
                    </tr>
                </thead>
                <tbody>
                    <tr repeat.for="unit of data">
                        <td><a href="/#/entity/#{unit.eClass}/#{unit.id}">#{unit.name}</a></td>
                        <td>#{unit.eClass}</td>
                        <td>#{unit.type}</td>
                        <td>#{unit.status}</td>
                    </tr>
                </tbody>
            </table>
        </div>`;
    }
};
DashboardPanelLogistics = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["scifeonPlugin"])({
        name: 'Container Contents',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DASHBOARD_PANEL,
        match: () => true
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], DashboardPanelLogistics);



/***/ }),

/***/ "../apps/demo/logistics_app/temp/gen-app.js":
/*!**************************************************!*\
  !*** ../apps/demo/logistics_app/temp/gen-app.js ***!
  \**************************************************/
/*! exports provided: plugins, hot, moduleId */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(module) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "plugins", function() { return plugins; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hot", function() { return hot; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "moduleId", function() { return moduleId; });
const plugins = [
{
 id: 'dashboardPanel',
 func: __webpack_require__(/*! ../src/panels/dashboard.ts */ "../apps/demo/logistics_app/src/panels/dashboard.ts"),
 types: ["dashboard.panel"],
},
{
 id: 'logRequestDetail',
 func: __webpack_require__(/*! ../src/entity/panels/request-detail.ts */ "../apps/demo/logistics_app/src/entity/panels/request-detail.ts"),
 types: ["entity.panel"],
 view: __webpack_require__(/*! ../src/entity/panels/request-detail.html */ "../apps/demo/logistics_app/src/entity/panels/request-detail.html"),
},
{
 id: 'PLUGIN_TYPE.ENTITY_PANEL_0',
 func: __webpack_require__(/*! ../src/entity/panels/box-detail.ts */ "../apps/demo/logistics_app/src/entity/panels/box-detail.ts"),
 types: ["entity.panel"],
 view: __webpack_require__(/*! ../src/entity/panels/box-detail.html */ "../apps/demo/logistics_app/src/entity/panels/box-detail.html"),
 name: 'Box Content Details',
},
{
 id: 'PLUGIN_TYPE.ENTITY_PANEL_1',
 func: __webpack_require__(/*! ../src/entity/panels/container-view.ts */ "../apps/demo/logistics_app/src/entity/panels/container-view.ts"),
 types: ["entity.panel"],
 view: __webpack_require__(/*! ../src/entity/panels/container-view.html */ "../apps/demo/logistics_app/src/entity/panels/container-view.html"),
 name: 'ContainerView',
},
{
 id: 'PLUGIN_TYPE.ENTITY_PANEL_2',
 func: __webpack_require__(/*! ../src/entity/panels/freezer-rack-detail.ts */ "../apps/demo/logistics_app/src/entity/panels/freezer-rack-detail.ts"),
 types: ["entity.panel"],
 view: __webpack_require__(/*! ../src/entity/panels/freezer-rack-detail.html */ "../apps/demo/logistics_app/src/entity/panels/freezer-rack-detail.html"),
 name: 'Content Visualization',
},
{
 id: 'PLUGIN_TYPE.DASHBOARD_PANEL_3',
 func: __webpack_require__(/*! ../src/panels/locations-dashboard.ts */ "../apps/demo/logistics_app/src/panels/locations-dashboard.ts"),
 types: ["dashboard.panel"],
 name: 'Container Contents',
},
{
 id: 'routePage_logisticsFront',
 func: () => __webpack_require__.e(/*! import() | routePage_logisticsFront */ "routePage_logisticsFront").then(__webpack_require__.bind(null, /*! ../src/pages/index.ts */ "../apps/demo/logistics_app/src/pages/index.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_logisticsFront */ "routePage_logisticsFront").then(__webpack_require__.t.bind(null, /*! ../src/pages/index.html */ "../apps/demo/logistics_app/src/pages/index.html", 7)),
},
{
 id: 'routePage_logisticsCheckin',
 func: () => __webpack_require__.e(/*! import() | routePage_logisticsCheckin */ "routePage_logisticsCheckin").then(__webpack_require__.bind(null, /*! ../src/pages/checkin.ts */ "../apps/demo/logistics_app/src/pages/checkin.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_logisticsCheckin */ "routePage_logisticsCheckin").then(__webpack_require__.t.bind(null, /*! ../src/pages/checkin.html */ "../apps/demo/logistics_app/src/pages/checkin.html", 7)),
},
{
 id: 'routePage_logisticsRequest',
 func: () => __webpack_require__.e(/*! import() | routePage_logisticsRequest */ "routePage_logisticsRequest").then(__webpack_require__.bind(null, /*! ../src/pages/request.ts */ "../apps/demo/logistics_app/src/pages/request.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_logisticsRequest */ "routePage_logisticsRequest").then(__webpack_require__.t.bind(null, /*! ../src/pages/request.html */ "../apps/demo/logistics_app/src/pages/request.html", 7)),
},
{
 id: 'routePage_src/pages/add-container',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/add-container */ "routePage_src/pages/add-container").then(__webpack_require__.bind(null, /*! ../src/pages/add-container.ts */ "../apps/demo/logistics_app/src/pages/add-container.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/add-container */ "routePage_src/pages/add-container").then(__webpack_require__.t.bind(null, /*! ../src/pages/add-container.html */ "../apps/demo/logistics_app/src/pages/add-container.html", 7)),
},
{
 id: 'routePage_src/pages/fill-box',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/fill-box */ "routePage_src/pages/fill-box").then(__webpack_require__.bind(null, /*! ../src/pages/fill-box.ts */ "../apps/demo/logistics_app/src/pages/fill-box.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/fill-box */ "routePage_src/pages/fill-box").then(__webpack_require__.t.bind(null, /*! ../src/pages/fill-box.html */ "../apps/demo/logistics_app/src/pages/fill-box.html", 7)),
},
{
 id: 'routePage_src/pages/visualization',
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/visualization */ "routePage_src/pages/visualization").then(__webpack_require__.bind(null, /*! ../src/pages/visualization.ts */ "../apps/demo/logistics_app/src/pages/visualization.ts")),
 types: ["page"],
 func: () => __webpack_require__.e(/*! import() | routePage_src/pages/visualization */ "routePage_src/pages/visualization").then(__webpack_require__.t.bind(null, /*! ../src/pages/visualization.html */ "../apps/demo/logistics_app/src/pages/visualization.html", 7)),
},
];
const hot = module.hot;
const moduleId = module.i;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../../../../client/node_modules/webpack/buildin/harmony-module.js */ "./node_modules/webpack/buildin/harmony-module.js")(module)))

/***/ }),

/***/ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js":
/*!*********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js from dll-reference scifeon_data ***!
  \*********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");

/***/ }),

/***/ "./node_modules/file-saver/FileSaver.js":
/*!******************************************************************************************!*\
  !*** delegated ./node_modules/file-saver/FileSaver.js from dll-reference scifeon_vendor ***!
  \******************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/file-saver/FileSaver.js");

/***/ }),

/***/ "./node_modules/tslib/tslib.js":
/*!*************************************!*\
  !*** ./node_modules/tslib/tslib.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global global, define, System, Reflect, Promise */
var __extends;
var __assign;
var __rest;
var __decorate;
var __param;
var __metadata;
var __awaiter;
var __generator;
var __exportStar;
var __values;
var __read;
var __spread;
var __await;
var __asyncGenerator;
var __asyncDelegator;
var __asyncValues;
var __makeTemplateObject;
var __importStar;
var __importDefault;
(function (factory) {
    var root = typeof global === "object" ? global : typeof self === "object" ? self : typeof this === "object" ? this : {};
    if (true) {
        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports], __WEBPACK_AMD_DEFINE_RESULT__ = (function (exports) { factory(createExporter(root, createExporter(exports))); }).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
    }
    else {}
    function createExporter(exports, previous) {
        if (exports !== root) {
            if (typeof Object.create === "function") {
                Object.defineProperty(exports, "__esModule", { value: true });
            }
            else {
                exports.__esModule = true;
            }
        }
        return function (id, v) { return exports[id] = previous ? previous(id, v) : v; };
    }
})
(function (exporter) {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    __extends = function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };

    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };

    __rest = function (s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
                t[p[i]] = s[p[i]];
        return t;
    };

    __decorate = function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };

    __param = function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };

    __metadata = function (metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    };

    __awaiter = function (thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    };

    __generator = function (thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    };

    __exportStar = function (m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    };

    __values = function (o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    };

    __read = function (o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    };

    __spread = function () {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    };

    __await = function (v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    };

    __asyncGenerator = function (thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);  }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    };

    __asyncDelegator = function (o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    };

    __asyncValues = function (o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    };

    __makeTemplateObject = function (cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    __importStar = function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result["default"] = mod;
        return result;
    };

    __importDefault = function (mod) {
        return (mod && mod.__esModule) ? mod : { "default": mod };
    };

    exporter("__extends", __extends);
    exporter("__assign", __assign);
    exporter("__rest", __rest);
    exporter("__decorate", __decorate);
    exporter("__param", __param);
    exporter("__metadata", __metadata);
    exporter("__awaiter", __awaiter);
    exporter("__generator", __generator);
    exporter("__exportStar", __exportStar);
    exporter("__values", __values);
    exporter("__read", __read);
    exporter("__spread", __spread);
    exporter("__await", __await);
    exporter("__asyncGenerator", __asyncGenerator);
    exporter("__asyncDelegator", __asyncDelegator);
    exporter("__asyncValues", __asyncValues);
    exporter("__makeTemplateObject", __makeTemplateObject);
    exporter("__importStar", __importStar);
    exporter("__importDefault", __importDefault);
});

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! ./../webpack/buildin/global.js */ "./node_modules/webpack/buildin/global.js")))

/***/ }),

/***/ "./node_modules/webpack/buildin/global.js":
/*!********************************************************************************************!*\
  !*** delegated ./node_modules/webpack/buildin/global.js from dll-reference scifeon_vendor ***!
  \********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/webpack/buildin/global.js");

/***/ }),

/***/ "./node_modules/webpack/buildin/harmony-module.js":
/*!*******************************************!*\
  !*** (webpack)/buildin/harmony-module.js ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = function(originalModule) {
	if (!originalModule.webpackPolyfill) {
		var module = Object.create(originalModule);
		// module.parent = undefined by default
		if (!module.children) module.children = [];
		Object.defineProperty(module, "loaded", {
			enumerable: true,
			get: function() {
				return module.l;
			}
		});
		Object.defineProperty(module, "id", {
			enumerable: true,
			get: function() {
				return module.i;
			}
		});
		Object.defineProperty(module, "exports", {
			enumerable: true
		});
		module.webpackPolyfill = 1;
	}
	return module;
};


/***/ }),

/***/ "./packages/core/index.ts":
/*!**************************************************************************!*\
  !*** delegated ./packages/core/index.ts from dll-reference scifeon_data ***!
  \**************************************************************************/
/*! exports provided: Config, ScifeonConsoleLogger, ConsoleLogger, Status, Event, DataModel, ReadExcelCommon, XL, LoadingSpinner, ScifeonLoadingSpinner, ServerAPI, User, UserHelper, DSUtils, DateUtils, MathUtils, PLATE, PluginUtils, ScifeonUtils, Utils, SdkUtils, SpreadsheetUtils */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./packages/core/index.ts");

/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ 0:
/*!********************************************************!*\
  !*** multi ../apps/demo/logistics_app/temp/gen-app.js ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! C:\agent\_work\3\s\apps\demo\logistics_app\temp\gen-app.js */"../apps/demo/logistics_app/temp/gen-app.js");


/***/ }),

/***/ "dll-reference scifeon_data":
/*!*******************************!*\
  !*** external "scifeon_data" ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_data;

/***/ }),

/***/ "dll-reference scifeon_plugins":
/*!**********************************!*\
  !*** external "scifeon_plugins" ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_plugins;

/***/ }),

/***/ "dll-reference scifeon_ui":
/*!*****************************!*\
  !*** external "scifeon_ui" ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_ui;

/***/ }),

/***/ "dll-reference scifeon_vendor":
/*!*********************************!*\
  !*** external "scifeon_vendor" ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_vendor;

/***/ })

/******/ }));;
//# sourceMappingURL=app.js.map