(window["webpackJsonpcom_scifeon_scifeon_logistics"] = window["webpackJsonpcom_scifeon_scifeon_logistics"] || []).push([["routePage_src/pages/add-container"],{

/***/ "../apps/demo/logistics_app/src/pages/add-container.html":
/*!***************************************************************!*\
  !*** ../apps/demo/logistics_app/src/pages/add-container.html ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header prototype\">\r\n        <div class=\"page-header\"><h1>Add Container</h1></div>\r\n        <div class=\"panel-group\">\r\n            <div class=\"page-panels grid\">\r\n                <div class=\"panel\" style=\"grid-column: span 4\">\r\n                    <div class=\"panel-heading\">Details</div>\r\n                    <div class=\"panel-body\">\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Name</label>\r\n                            <p><input class=\"form-control\" ref=\"text\" value.bind=\"containerName\"/></p>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Type</label>\r\n                            <select value.bind=\"selectedType\" change.delegate=\"findLocation()\">\r\n                                <option repeat.for=\"type of types\" model.bind=\"type\">${type}</option>\r\n                            </select>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\" if.bind=\"selectedType=='Freezer'\">\r\n                            <label>Drawers</label>\r\n                            <select value.bind=\"containerCapacity\">\r\n                                <option repeat.for=\"drawerNum of drawerNums\" model.bind=\"drawerNum\">${drawerNum}</option>\r\n                            </select>\r\n                        </div>\r\n                        \r\n                        <div class=\"form-group\" if.bind=\"selectedType=='Rack'\">\r\n                            <label>Size</label>\r\n                            <p>Columns<input class=\"form-control\" ref=\"text\" value.bind=\"nCols\"></p>\r\n                            <p>Rows<input class=\"form-control\" ref=\"text\" value.bind=\"nRows\"></p>\r\n                        </div>\r\n                        \r\n                        <div class=\"form-group\">\r\n                            <label>Description</label>\r\n                            <p><input class=\"form-control\" ref=\"text\" value.bind=\"containerDescription\"></p>\r\n                        </div>\r\n\r\n                    </div>\r\n                </div>\r\n                <div class=\"panel\" style=\"grid-column: span 4\">\r\n                    <div class=\"panel-heading\">Location</div>\r\n                    <div class=\"panel-body\">\r\n                        \r\n                        <div class=\"form-group\">\r\n                            <select value.bind=\"selectedLocation\">\r\n                                <option repeat.for=\"location of locations\" model.bind=\"location\">${location.name}</option>\r\n                            </select>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Hierarchy tag</label>\r\n                            <p><input class=\"form-control\" ref=\"text\" value.bind=\"hierarchyTag\"></p>\r\n                        </div>\r\n\r\n                        <div>\r\n                            <p>${selectedLocation.storageHierarchy}.${hierarchyTag}</p>\r\n                        </div>\r\n\r\n                    </div>\r\n                </div>\r\n            </div>\r\n            <div class=\"page-panels full-width-panels\">\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-body\">\r\n                        <p class=\"text-center\">\r\n                            <button click.delegate=\"addContainer()\">Add Container</button>\r\n                        </p>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\" style=\"grid-column: 1 / -1\" if.bind=\"newEntities\">\r\n                <div class=\"panel-heading\">Created Entities</div>\r\n                <div class=\"panel-body\">\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>ID</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"entity of newEntities.newEntities\">\r\n                                <td><a href=\"#/entity/${entity.eClass}/${entity.id}\">${entity.id}</a></td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/logistics_app/src/pages/add-container.ts":
/*!*************************************************************!*\
  !*** ../apps/demo/logistics_app/src/pages/add-container.ts ***!
  \*************************************************************/
/*! exports provided: AddContainer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AddContainer", function() { return AddContainer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");



let AddContainer = class AddContainer {
    constructor(server) {
        this.server = server;
        this.types = [" ", "Freezer", "Rack"];
        this.drawerNums = [" ", 1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
    }
    findLocation() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let locationTag;
            switch (this.selectedType) {
                case "Freezer": {
                    locationTag = "Room";
                    break;
                }
                case "Rack": {
                    locationTag = "Drawer";
                    break;
                }
            }
            const dataset = yield this.server.datasetQuery([
                { eClass: 'StorageLocation', collection: 'locations', filters: [{ field: 'Type', value: locationTag }] },
                { eClass: 'StorageLocation', collection: 'similar', filters: [{ field: 'Type', value: this.selectedType }] }
            ]);
            this.locations = [{ name: " " }].concat(dataset.locations);
            this.hierarchyTag = String(this.selectedType).substring(0, 2) + dataset.similar.length;
        });
    }
    addContainer() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (this.selectedType === " ") {
                throw new Error("Please select a type for the container");
            }
            if (this.selectedLocation.name === " ") {
                throw new Error("Please select a location for the container.");
            }
            let entities = [];
            entities.push({
                name: this.containerName,
                description: this.containerDescription,
                locationID: this.selectedLocation.id,
                eClass: 'StorageLocation',
                storageSystemID: '-',
                type: this.selectedType,
                id: "#thisID",
                storageHierarchy: this.selectedLocation.storageHierarchy + "." + this.hierarchyTag,
                hierarchyTag: this.hierarchyTag
            });
            if (this.selectedType === "Rack") {
                entities[0].attributes = {
                    nCols: this.nCols,
                    nRows: this.nRows
                };
            }
            if (this.selectedType == 'Freezer') {
                for (let i = 0; i < this.containerCapacity; i++) {
                    entities.push({
                        name: (this.containerName) + "_D" + i,
                        eClass: 'StorageLocation',
                        type: 'Drawer',
                        storageSystemID: '-',
                        LocationID: '#thisID',
                        storageHierarchy: this.selectedLocation.storageHierarchy + "." + this.hierarchyTag + ".DR" + i,
                        hierarchyTag: "DR" + i
                    });
                }
            }
            this.newEntities = yield this.server.saveEntities(entities);
        });
    }
};
AddContainer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'logistics/container',
        title: 'Logistics - Add Container'
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], AddContainer);



/***/ })

}]);
//# sourceMappingURL=add-container.1689f8bda2b220050734.js.map