(window["webpackJsonpcom_scifeon_scifeon_logistics"] = window["webpackJsonpcom_scifeon_scifeon_logistics"] || []).push([["routePage_src/pages/fill-box"],{

/***/ "../apps/demo/logistics_app/src/pages/fill-box.html":
/*!**********************************************************!*\
  !*** ../apps/demo/logistics_app/src/pages/fill-box.html ***!
  \**********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n\r\n    <style>\r\n        .box table td {\r\n            background-color: #eee;\r\n            border: 2px solid #666;\r\n            width: 40px;\r\n            height: 40px;\r\n        }\r\n    </style>\r\n\r\n    <div class=\"page-with-header prototype\">\r\n        <div class=\"page-header\">Sample Deposit</div>\r\n        <div class=\"panel-group\">\r\n\r\n            <div class=\"page-panels grid\">\r\n                <div class=\"panel\" style=\"grid-column: 1 / -1\">\r\n                    <div class=\"panel-heading\">Freezer Box</div>\r\n                    <div class=\"panel-body\">\r\n                        <form>\r\n                            <label>\r\n                                <input type=\"radio\" name=\"group1\" model.bind=\"true\" checked.bind=\"newBox\" change.delegate=\"getLocations()\">\r\n                                New\r\n                            </label>\r\n                            <label>\r\n                            <input type=\"radio\" name=\"group1\" model.bind=\"false\" checked.bind=\"newBox\" change.delegate=\"getBoxes()\">\r\n                                Existing\r\n                            </label>\r\n                        </form>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\" style=\"grid-column: 1 / -1\" if.bind=\"newBox===true\">\r\n                    <div class=\"panel-heading\">Create Box</div>\r\n                    <div class=\"panel-body\">\r\n                        \r\n                        <div class=\"form-group\">\r\n                            <label>Name</label>\r\n                            <p><input class=\"form-control\" ref=\"text\" value.bind=\"boxName\" change.delegate=\"setName()\"/></p>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Location</label>\r\n                            <select value.bind=\"boxLocation\" change.delegate=\"setLocation()\">\r\n                                <option repeat.for=\"location of locations\" model.bind=\"location\">${location.name}</option>\r\n                            </select>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Position in Rack</label>\r\n                            <p><input class=\"form-control\" ref=\"text\" value.bind=\"position\"</p>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Hierarchy Tag</label>\r\n                            <p><input class=\"form-control\" ref=\"text\" value.bind=\"hierarchyTag\"</p>\r\n                        </div>\r\n                        <div>\r\n                            <p>${boxLocation.storageHierarchy}.${hierarchyTag}</p>\r\n                        </div>\r\n                        \r\n                        <div class=\"form-group\">\r\n                            <label>Description</label>\r\n                            <p><input class=\"form-control\" ref=\"text\" value.bind=\"boxDescription\" change.delegate=\"setDescription()\"></p>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Capacity</label>\r\n                            <select value.bind=\"boxCapacity\" change.delegate=\"setCapacity()\">\r\n                                <option repeat.for=\"dimension of dimensions\" model.bind=\"dimension\">${dimension.s}</option>\r\n                            </select> \r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\" style=\"grid-column: 1 / -1\" if.bind=\"newBox===false\">\r\n                    <div class=\"panel-heading\">Choose Box</div>\r\n                    <div class=\"panel-body\">\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Box</label>\r\n                            <select value.bind=\"selectedBox\" change.delegate=\"boxChanged()\">\r\n                                <option repeat.for=\"box of boxes\" model.bind=\"box\">${box.name}</option>\r\n                            </select>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Location</label>\r\n                            <p>${selectedBox.storageHierarchy}</p>\r\n                        </div>\r\n                        \r\n                        <div class=\"form-group\">\r\n                            <label>Description</label>\r\n                            <p>${selectedBox.description}</p>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Maximum Capacity</label>\r\n                            <p>${selectedBox.capacity}</p>\r\n                        </div>\r\n\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\" style=\"grid-column: 1 / -1\" if.bind=\"newBox!==null\">\r\n                    <div class=\"panel-heading\">Samples</div>\r\n                    <div class=\"panel-body\">\r\n\r\n                        <div class=\"form-group\">\r\n                            <dropzone dropfiles.trigger=\"dropped($event)\" title=\"Drop File Here\" style=\"height: 100%\"></dropzone>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <button click.delegate=\"showAddSamplesPopup()\">Edit Samples</button>\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <table>\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th>Name</th>\r\n                                        <th>External ID</th>\r\n                                        <th>Type</th>\r\n                                        <th>Content</th>\r\n                                        <th>Tags</th>\r\n                                        <th>Description</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <tr repeat.for=\"sample of samples\">\r\n                                        <td>${sample.name}</td>\r\n                                        <td>${sample.externalID}</td>\r\n                                        <td>${sample.type}</td>\r\n                                        <td>${sample.content}</td>\r\n                                        <td>${sample.tags}</td>\r\n                                        <td>${sample.description}</td>\r\n                                        <td><button class=\"btn sm\" click.delegate=\"removeItem(sample.externalID)\">Remove</button></td>\r\n                                    </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n                \r\n                <div class=\"panel\" style=\"grid-column: 1 / -1\" if.bind=\"newBox!==null\">\r\n                    <div class=\"panel-heading\">Box View</div>\r\n                    <div class=\"panel-body\">\r\n                        \r\n                        <div class=\"form-group\">\r\n                            <plate-view  class=\"box\" n-rows.bind=\"nRows\" n-cols.bind=\"nCols\" wells.bind=\"samples\" well-template.bind=\"wellTemplate\"></plate-view>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\" style=\"grid-column: 1 / -1\" if.bind=\"newBox===true\">\r\n                    <div class=\"panel-body\">\r\n                        <p class=\"text-center\"><button click.delegate=\"addBox()\">Add Box</button></p>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\" style=\"grid-column: 1 / -1\" if.bind=\"newBox===false\">\r\n                    <div class=\"panel-body\" >\r\n                        <p class=\"text-center\"><button click.delegate=\"updateBox()\">Update Box</button></p>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\" style=\"grid-column: 1 / -1\" if.bind=\"newEntities\">\r\n                    <div class=\"panel-heading\">Created Entities</div>\r\n                    <div class=\"panel-body\">\r\n                        <table>\r\n                            <thead>\r\n                                <tr>\r\n                                    <th>Class</th>\r\n                                    <th>ID</th>\r\n                                </tr>\r\n                            </thead>\r\n                            <tbody>\r\n                                <tr repeat.for=\"entity of newEntities.newEntities\">\r\n                                    <td>${entity.eClass}</td>\r\n                                    <td><a href=\"#/entity/${entity.eClass}/${entity.id}\">${entity.id}</a></td>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/logistics_app/src/pages/fill-box.ts":
/*!********************************************************!*\
  !*** ../apps/demo/logistics_app/src/pages/fill-box.ts ***!
  \********************************************************/
/*! exports provided: FillBox */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FillBox", function() { return FillBox; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");




let FillBox = class FillBox {
    constructor(server, sis) {
        this.server = server;
        this.sis = sis;
        this.newBox = null;
        this.samples = [];
        this.selectedBox = {};
        this.dimensions = [{ n: 81, s: "9x9" }, { n: 100, s: "10x10" }];
    }
    getBoxes() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'StorageLocation', collection: 'boxes', filters: [{ field: 'Type', value: 'Box' }] },
            ]);
            this.boxes = [{ name: " " }].concat(dataset.boxes);
        });
    }
    boxChanged() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'Sample', collection: 'samples', filters: [{ field: 'locationID', value: this.selectedBox.id }] }
            ]);
            this.samples = this.samples.concat(dataset.samples);
            this.nCols = this.nRows = Math.ceil(Math.sqrt(this.selectedBox.capacity));
        });
    }
    setName() {
        this.selectedBox.name = this.boxName;
    }
    setLocation() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.selectedBox.locationID = this.boxLocation.id;
            const dataset = yield this.server.datasetQuery([
                { eClass: 'StorageLocation', collection: 'boxes', filters: [{ field: 'locationID', value: this.boxLocation.id }] }
            ]);
            this.hierarchyTag = "Bo" + dataset.boxes.length;
        });
    }
    setDescription() {
        this.selectedBox.description = this.boxDescription;
    }
    setCapacity() {
        this.selectedBox.capacity = this.boxCapacity.n;
        this.nCols = Number(this.boxCapacity.s.split("x")[0]);
        this.nRows = Number(this.boxCapacity.s.split("x")[1]);
    }
    getLocations() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'StorageLocation', collection: 'racks', filters: [{ field: 'Type', value: 'Rack' }] }
            ]);
            this.locations = [{ name: " " }].concat(dataset.freezers, dataset.racks);
        });
    }
    wellTemplate(well) {
        return `<a href='/#/entity/sample/${well.id}'>${well.name}</a>`;
    }
    showAddSamplesPopup() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const newSamples = yield this.sis.editSamples('name, externalID, type, content, tags, description', this.samples.slice(0));
            this.samples = newSamples.filter(s => s.type || s.externalID || s.content);
            this.setPositions();
        });
    }
    setPositions() {
        if (this.samples.length > 0) {
            let pRow = 0;
            let pCol = 0;
            for (let s of this.samples) {
                if (typeof (s.posRow) != "number" && typeof (s.posCol) != "number") {
                    while (this.samples.some(s => pRow === s.posRow && pCol === s.posCol)) {
                        if (pCol >= this.nCols - 1) {
                            pRow++;
                            pCol = 0;
                        }
                        else {
                            pCol++;
                        }
                    }
                    s.posRow = pRow;
                    s.posCol = pCol;
                    if (pCol >= this.nCols - 1) {
                        pRow++;
                        pCol = 0;
                    }
                    else {
                        pCol++;
                    }
                }
            }
        }
    }
    removeItem(externalID) {
        this.samples = this.samples.filter(i => i.externalID !== externalID);
    }
    addBox() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!this.selectedBox.name) {
                throw new Error("Please give the box a name.");
            }
            if (!this.selectedBox.locationID) {
                throw new Error("Please give the box a location.");
            }
            let entities = [];
            this.selectedBox.eClass = "StorageLocation";
            this.selectedBox.StorageSystemID = "-";
            this.selectedBox.type = "Box";
            this.selectedBox.id = "#boxid";
            this.selectedBox.storageHierarchy = this.boxLocation.storageHierarchy + "." + this.hierarchyTag;
            this.selectedBox.hierarchyTag = this.hierarchyTag;
            this.selectedBox.position = this.position;
            this.selectedBox.attributes = {};
            this.selectedBox.attributes.nCols = this.nCols;
            this.selectedBox.attributes.nRows = this.nRows;
            entities.push(this.selectedBox);
            this.samples.map(s => {
                s.format = "-";
                s.locationID = "#boxid";
            });
            entities = entities.concat(this.samples);
            this.newEntities = yield this.server.saveEntities(entities);
        });
    }
    dropped(e) {
        console.log(e);
    }
    updateBox() {
    }
};
FillBox = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'logistics/fillbox',
        title: 'Logistics - Fill Freezer Box'
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["SampleInputSelectorDialogService"]])
], FillBox);



/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ })

}]);
//# sourceMappingURL=fill-box.1689f8bda2b220050734.js.map