import { User } from './user';
export declare class Config {
    user: User;
    apps: {
        installed: any[];
        disabled: string[];
    };
    configuration: {
        windowsAuthentication: boolean;
        isCloud: boolean;
        isRegulated: boolean;
        name: string;
        version: string;
        env: string;
        clusterID: string;
        backgroundColor: string;
        format: {
            date: string;
            datetime: string;
        };
    };
    static set(config: any): void;
    static get(): Config;
}
