import * as moment from 'moment';
export declare class DateUtils {
    static dateFormat: string;
    static dateTimeFormat: string;
    static createDotNetDate(): string;
    static createDotNetUtc(): string;
    static createDateString(): string;
    static from(input: string, format?: string, strict?: boolean): moment.Moment;
    static format(input: string, format: string): string;
    static toDateFormat(input: string): string;
    static toDateTimeFormat(input: string): string;
    static readonly local: {
        get: () => moment.Moment;
        toDateFormat: () => string;
        toDateTimeFormat: () => string;
    };
    static readonly utc: {
        get: () => moment.Moment;
        toDateFormat: () => string;
        toDateTimeFormat: () => string;
    };
}
