export declare class PluginUtils {
    /**
     *  Allow #{} instead of \${} in function "(view) = () => ''"" templates
     */
    static replaceHashWithDollar(view: string): string;
    static removeStartAndEndTemplateTag(view: string): string;
    /**
     * Replace #{} with ${} and remove starting and ending <template>
     */
    static cleanView(view: string): string;
}
