import { EntityInfo } from '@scifeon/core';
import { WorkflowEngine } from '../workflow-engine';
export declare class StepBuilderPlates2PlatesDirect {
    private engine;
    private template;
    private stepInfo;
    constructor(engine: WorkflowEngine);
    execute(stepInfo: EntityInfo): void;
    processOutputPlateDefinition(): void;
    processSample(plateIn: any, posRow: number, posCol: number): void;
    plateDef: any;
    plateOutCurrent: any;
    iRowOutNext: number;
    iColOutNext: number;
    iOutputPlate: number;
    addSamplePosition(): void;
    addOutputPlate(): void;
    resetOutputPlates(plateDef: any): void;
}
