import { DataModel, Entity, ServerAPI } from '@scifeon/core';
import { TaskQueue } from 'aurelia-framework';
import { Dialog } from './dialog';
export declare class SampleInputSelectorDialog {
    private dialog;
    private datamodel;
    private server;
    private queue;
    private hot;
    private samplesList;
    sampleTable: any;
    fields: any[];
    samples: Entity[];
    customFieldName: string;
    searchMode: boolean;
    searchResult: any[];
    searchQuery: string;
    searchLoading: boolean;
    searchInput: HTMLElement;
    constructor(dialog: Dialog, datamodel: DataModel, server: ServerAPI, queue: TaskQueue);
    view: () => any;
    init(model: {
        fieldIDs?: string;
        samples?: Entity[];
    }): void;
    private addSample;
    attached(): void;
    close(): void;
    private loadFields;
    private addCustomField;
    addField(): void;
    search(): Promise<void>;
    toggleSearchMode(): void;
    addSelectedSamples(): void;
}
