(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["data-upload"],{

/***/ "./SPA/module/data-upload/templates/template-excel-entities.js":
/*!*********************************************************************!*\
  !*** ./SPA/module/data-upload/templates/template-excel-entities.js ***!
  \*********************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.TemplateExcelEntities = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fileSaver = __webpack_require__(/*! file-saver */ "./node_modules/file-saver/FileSaver.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TemplateExcelEntities = exports.TemplateExcelEntities = function () {
    function TemplateExcelEntities() {
        _classCallCheck(this, TemplateExcelEntities);

        this.colNames = ['not/used', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'AA', 'AB', 'AC', 'AD', 'AE', 'AF', 'AG', 'AH', 'AI', 'AJ', 'AK', 'AL', 'AM', 'AN', 'AO', 'AP', 'AQ', 'AR', 'AS', 'AT', 'AU', 'AV', 'AW', 'AX', 'AY', 'AZ'];
    }

    _createClass(TemplateExcelEntities, [{
        key: 'execute',
        value: function execute(model, entities) {
            var _this = this;

            this.ws = {};
            this.ws['A1'] = { t: 's', v: 'Insert Your Title Here' };
            this.xlrowNext = 3;
            this.xlcolMax = 1;

            var wb = {};
            wb.SheetNames = [];
            wb.SheetNames.push('ScifeonEntities');
            wb.Sheets = { 'ScifeonEntities': this.ws };

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                var _loop = function _loop() {
                    var tableName = _step.value;

                    _this.addTable(model.tables.find(function (t) {
                        return t.name == tableName;
                    }));
                };

                for (var _iterator = entities[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    _loop();
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            this.ws['!ref'] = 'A1:' + this.cell(this.xlrowNext, this.xlcolMax);

            var wbout = XLSX.write(wb, { bookType: 'xlsx', bookSST: false, type: 'binary' });
            (0, _fileSaver.saveAs)(new Blob([this.s2ab(wbout)], { type: 'application/octet-stream' }), 'Template.xlsx');
        }
    }, {
        key: 'addTable',
        value: function addTable(table) {
            this.ws[this.cell(this.xlrowNext, 1)] = { t: 's', v: 'Class' };
            this.ws[this.cell(this.xlrowNext, 2)] = { t: 's', v: table.name };

            var xlcolNext = 3;
            for (var iCol = 9; iCol < table.columns.length; iCol++) {
                this.ws[this.cell(this.xlrowNext, xlcolNext)] = { t: 's', v: table.columns[iCol].name };
                xlcolNext++;
            }

            this.xlrowNext += 2;
        }
    }, {
        key: 'cell',
        value: function cell(xlrow, xlcol) {
            if (xlcol >= this.colNames.length) throw new Error('Exceeded col name array length');

            if (xlcol > this.xlcolMax) this.xlcolMax = xlcol;

            return this.colNames[xlcol] + xlrow;
        }
    }, {
        key: 's2ab',
        value: function s2ab(s) {
            var buf = new ArrayBuffer(s.length);
            var view = new Uint8Array(buf);
            for (var i = 0; i != s.length; ++i) {
                view[i] = s.charCodeAt(i) & 0xFF;
            }return buf;
        }
    }]);

    return TemplateExcelEntities;
}();

/***/ }),

/***/ "./SPA/module/data-upload/templates/template-excel-step-n-results.js":
/*!***************************************************************************!*\
  !*** ./SPA/module/data-upload/templates/template-excel-step-n-results.js ***!
  \***************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.TemplateExcelStepNResults = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fileSaver = __webpack_require__(/*! file-saver */ "./node_modules/file-saver/FileSaver.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TemplateExcelStepNResults = exports.TemplateExcelStepNResults = function () {
    function TemplateExcelStepNResults(model) {
        _classCallCheck(this, TemplateExcelStepNResults);

        this.model = model;

        this.colNames = ['not/used', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'AA', 'AB', 'AC', 'AD', 'AE', 'AF', 'AG', 'AH', 'AI', 'AJ', 'AK', 'AL', 'AM', 'AN', 'AO', 'AP', 'AQ', 'AR', 'AS', 'AT', 'AU', 'AV', 'AW', 'AX', 'AY', 'AZ'];
    }

    _createClass(TemplateExcelStepNResults, [{
        key: 'execute',
        value: function execute(options) {

            this.prepareSheet();

            if (options.createExperiment) this.addExperiment();
            if (options.createStep) this.addStep(options.createExperiment);

            this.addInput(options.inputClasses);
            this.addOutput(options.outputClasses);
            this.addResults(options.resultClasses);

            if (options.createTransfer) this.addTransfer(options.useA1WellNotation);

            this.generateDownload();
        }

        ////////////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'prepareSheet',
        value: function prepareSheet() {
            this.ws = {};
            this.ws['A1'] = { t: 's', v: 'Insert Your Title Here' };
            this.xlrowNext = 1;
            this.xlcolMax = 1;

            this.wb = {};
            this.wb.SheetNames = [];
            this.wb.SheetNames.push('Scifeon');
            this.wb.Sheets = { 'Scifeon': this.ws };
        }
    }, {
        key: 'addRow',
        value: function addRow(content, emptyRow) {

            for (var iCol = 0; iCol < content.length; iCol++) {
                this.ws[this.cell(this.xlrowNext, iCol + 1)] = { t: 's', v: content[iCol] };
            }this.ws[this.cell(this.xlrowNext, 1)].s = { font: { bold: true } };

            this.xlrowNext++;
            if (emptyRow) this.xlrowNext++;
        }
    }, {
        key: 'addSection',
        value: function addSection(name) {

            this.ws[this.cell(this.xlrowNext, 1)] = { t: 's', v: 'Section', s: { font: { bold: true }, border: { top: { style: 'thick' } } } };
            this.ws[this.cell(this.xlrowNext, 2)] = { t: 's', v: name, s: { font: { bold: true }, border: { top: { style: 'thick' } } } };

            this.xlrowNext++;
        }
    }, {
        key: 'generateDownload',
        value: function generateDownload() {
            this.ws['!ref'] = 'A1:' + this.cell(this.xlrowNext, this.xlcolMax);

            var wbout = XLSX.write(this.wb, { bookType: 'xlsx', bookSST: false, type: 'binary' });
            (0, _fileSaver.saveAs)(new Blob([this.s2ab(wbout)], { type: 'application/octet-stream' }), 'Template.xlsx');
        }

        ////////////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'addExperiment',
        value: function addExperiment() {
            this.addRow(['Experiment'], true);
            this.addSection('Experiment');
            this.addRow(['Name']);
            this.addRow(['Study No']);
            this.addRow(['ELN']);
            this.addRow(['Title']);
            this.addRow(['Project']);
            this.addRow(['Type'], true);
            this.addRow(['Scientist']);
            this.addRow(['Analyst']);
            this.addRow(['Department'], true);
            this.addRow(['Date Started']);
            this.addRow(['Date Completed']);
        }

        ////////////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'addStep',
        value: function addStep(createExperiment) {
            if (!createExperiment) this.addRow(['Step']); // Cell A1

            this.xlrowNext++;

            this.addSection('Step');
            if (!createExperiment) {
                this.addRow(['Experiment']);
                this.addRow(['Parent Step']);
            }
            this.addRow(['Name']);
            this.addRow(['Title']);
            this.addRow(['Type']);
            this.addRow(['Method']);

            this.addRow(['Analyst']);
            this.addRow(['Date Started']);
            this.addRow(['Date Completed']);
        }

        ////////////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'addInput',
        value: function addInput(inputClasses) {
            if (!inputClasses || inputClasses.length == 0) return;

            this.xlrowNext++;
            this.addSection('Input');

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = inputClasses[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var name = _step.value;

                    this.xlrowNext++;
                    switch (name) {
                        case 'Animal':
                            this.addRow(['Animals', 'ID', 'Name', 'Barcode', 'Type']);
                            break;
                        case 'Compound':
                            this.addRow(['Compounds', 'Name']);
                            break;
                        case 'Batch':
                            this.addRow(['Batches', 'Name']);
                            break;
                        case 'Sample':
                            this.addRow(['Samples', 'ID', 'Name', 'Barcode', 'Type', 'Content']);
                            break;
                        case 'Plate':
                            this.addRow(['Plates', 'ID', 'Name', 'Barcode', 'Type']);
                            break;
                    }
                    this.xlrowNext++;
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }

        ////////////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'addOutput',
        value: function addOutput(outputClasses) {
            if (!outputClasses || outputClasses.length == 0) return;

            this.xlrowNext++;
            this.addSection('Output');

            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                for (var _iterator2 = outputClasses[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var name = _step2.value;

                    this.xlrowNext++;
                    switch (name) {
                        case 'Animal':
                            this.addRow(['Animals', 'Name', 'Barcode', 'Type']);
                            break;
                        case 'Batch':
                            this.addRow(['Batches', 'Name', 'Compound']);
                            break;
                        case 'Plate':
                            this.addRow(['Plates', 'Name', 'Barcode', 'Type']);
                            break;
                        case 'Sample':
                            this.addRow(['Samples', 'Name', 'Barcode', 'Type', 'Content', 'Plate', 'Well', 'Row', 'Col']);
                            break;
                    }
                    this.xlrowNext++;
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }
        }

        ////////////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'addResults',
        value: function addResults(resultClasses) {
            var _this = this;

            if (!resultClasses || resultClasses.length == 0) return;

            this.xlrowNext++;
            this.addSection('Results');

            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
                var _loop = function _loop() {
                    var name = _step3.value;

                    _this.xlrowNext++;

                    switch (name) {
                        case 'PlateLayer':
                        case 'ResultDataSeries':
                        case 'ResultFileContent':
                        case 'ResultImage':
                            _this.addRow([name, 'Not supported, yet']);
                            break;
                        default:
                            var table = _this.model.tables.find(function (t) {
                                return t.name == name;
                            });
                            var colTitles = [name, 'Name', 'Type'];
                            for (var iDBCol = 14; iDBCol < table.columns.length; iDBCol++) {
                                colTitles.push(table.columns[iDBCol].name);
                            }_this.addRow(colTitles);
                    }

                    _this.xlrowNext++;
                };

                for (var _iterator3 = resultClasses[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    _loop();
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }
        }

        ////////////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'addTransfer',
        value: function addTransfer() {}

        ////////////////////////////////////////////////////////////////////////////////////

    }, {
        key: 'cell',
        value: function cell(xlrow, xlcol) {
            if (xlcol >= this.colNames.length) throw new Error('Exceeded col name array length');

            if (xlcol > this.xlcolMax) this.xlcolMax = xlcol;

            return this.colNames[xlcol] + xlrow;
        }
    }, {
        key: 's2ab',
        value: function s2ab(s) {
            var buf = new ArrayBuffer(s.length);
            var view = new Uint8Array(buf);
            for (var i = 0; i != s.length; ++i) {
                view[i] = s.charCodeAt(i) & 0xFF;
            }return buf;
        }
    }]);

    return TemplateExcelStepNResults;
}();

/***/ }),

/***/ "entity/shared-fields.html":
/*!***************************************!*\
  !*** ./SPA/entity/shared-fields.html ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template bindable=\"entity\">\r\n\r\n    <div class=\"view-group\">\r\n        <label>Type</label>\r\n        <p>${entity.type}</p>\r\n    </div>\r\n\r\n    <div class=\"view-group\">\r\n        <label>Status</label>\r\n        <p>${entity.status}</p>\r\n    </div>\r\n\r\n    <div class=\"view-group\">\r\n        <label>Description</label>\r\n        <p>${entity.description}</p>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "entity/unique-fields":
/*!*************************************!*\
  !*** ./SPA/entity/unique-fields.ts ***!
  \*************************************/
/*! exports provided: UniqueFields */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "UniqueFields", function() { return UniqueFields; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");



let UniqueFields = class UniqueFields {
    constructor(dataModel) {
        this.dataModel = dataModel;
        this.uniqueFields = [];
    }
    entityChanged() {
        let lcEClass = this.entity.eClass.toLowerCase();
        let table = this.dataModel.tables.find(t => t.name.toLowerCase() == lcEClass);
        let excludedNames = [];
        if (this.exclude)
            excludedNames = this.exclude.split(',');
        this.uniqueFields = [];
        for (let column of table.columns.filter(c => !c.isShared)) {
            if (excludedNames.find(n => n == column.name.toLowerCase()))
                continue;
            let value = this.entity[column.nameLCF];
            let html = '';
            if (value) {
                if (column.foreignKeyTo)
                    html = `<a href='/#/entity/${column.foreignKeyTo}/${value}'>${value}</a>`;
                else if (column.dbType === 'HTML')
                    html = this.formatParagraphs(value);
                else if (column.dbType === 'JSON')
                    continue;
                else if (column.dbType === 'DATE')
                    html = _scifeon_core__WEBPACK_IMPORTED_MODULE_2__["DateUtils"].toDateFormat(value);
                else if (column.dbType === 'DATETIME2')
                    html = _scifeon_core__WEBPACK_IMPORTED_MODULE_2__["DateUtils"].toDateTimeFormat(value);
                else
                    html = value;
            }
            this.uniqueFields.push({ label: column.name, html: html });
        }
    }
    formatParagraphs(value) {
        if (value === null)
            return '<p></p>';
        let html = '';
        for (let paragraph of value.split('\n')) {
            html += '<p>' + paragraph + '</p>';
        }
        return html;
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], UniqueFields.prototype, "entity", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], UniqueFields.prototype, "exclude", void 0);
UniqueFields = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_2__["DataModel"]])
], UniqueFields);



/***/ }),

/***/ "entity/unique-fields.html":
/*!***************************************!*\
  !*** ./SPA/entity/unique-fields.html ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"view-group\" repeat.for=\"f of uniqueFields\">\r\n        <label>${f.label}</label>\r\n        <p innerHtml.bind=\"f.html\"></p>\r\n    </div>\r\n\r\n</template>";

/***/ }),

/***/ "module/data-upload/elements/data-loader-setup":
/*!**************************************************************!*\
  !*** ./SPA/module/data-upload/elements/data-loader-setup.ts ***!
  \**************************************************************/
/*! exports provided: DataLoaderSetup */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataLoaderSetup", function() { return DataLoaderSetup; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _data_upload_info__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../data-upload-info */ "./SPA/module/data-upload/data-upload-info.ts");




let DataLoaderSetup = class DataLoaderSetup {
    bind() {
        this.dataUploadInfoChanged();
    }
    dataUploadInfoChanged() {
        if (this.dataUploadInfo.hasPlugins()) {
            this.dataUploadInfo.selectedPlugin = this.dataUploadInfo.plugins[0];
            this.updateViews(this.dataUploadInfo.selectedPlugin);
        }
    }
    pluginSelected(selectedPlugin) {
        this.updateViews(selectedPlugin);
        return true;
    }
    updateOptionsView(plugin) {
        if (plugin.optionsView) {
            let view = plugin.optionsView();
            if (view) {
                view = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["PluginUtils"].cleanView(view);
                this.optionsView = new aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["InlineViewStrategy"](`<template>${view}</template>`);
            }
        }
    }
    updateViews(plugin) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.entitiesView = null;
            this.optionsView = null;
            try {
                this.dataUploadInfo.hasPluginExecuted = false;
                this.dataUploadInfo.error = null;
                if (plugin.readFiles) {
                    yield plugin.readFiles();
                }
                if (plugin.entitiesView) {
                    let view = plugin.entitiesView();
                    if (view) {
                        view = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["PluginUtils"].cleanView(view);
                        this.entitiesView = new aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["InlineViewStrategy"](`<template>${view}</template>`);
                    }
                }
                this.dataUploadInfo.hasPluginExecuted = true;
            }
            catch (error) {
                this.dataUploadInfo.error = error;
                console.error(error);
            }
            finally {
                this.updateOptionsView(plugin);
            }
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", _data_upload_info__WEBPACK_IMPORTED_MODULE_3__["DataUploadInfo"])
], DataLoaderSetup.prototype, "dataUploadInfo", void 0);
DataLoaderSetup = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('data-loader-setup')
], DataLoaderSetup);



/***/ }),

/***/ "module/data-upload/elements/data-loader-setup.html":
/*!****************************************************************!*\
  !*** ./SPA/module/data-upload/elements/data-loader-setup.html ***!
  \****************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <form if.bind=\"dataUploadInfo.hasPlugins()\">\r\n        <div class=\"data-loader-settings\">\r\n            <div class=\"data-loader-select\" if.bind=\"dataUploadInfo.plugins.length > 1 || dataUploadInfo.selectedPlugin && dataUploadInfo.selectedPlugin.optionsView\">\r\n                <h4>Choose data loader</h4>\r\n                <div repeat.for=\"plugin of dataUploadInfo.plugins\">\r\n                    <label>\r\n                        <input type=\"radio\" name=\"dataLoader\" model.bind=\"plugin\" checked.bind=\"dataUploadInfo.selectedPlugin\" click.delegate=\"pluginSelected(plugin)\" />\r\n                        ${plugin.$METADATA.name}\r\n                    </label>\r\n                    <span class=\"plugin-description\">\r\n                        ${plugin.$METADATA.description}\r\n                    </span>\r\n                </div>\r\n            </div>\r\n            <div class=\"data-loader-options\" if.bind=\"optionsView\">\r\n                <form>\r\n                    <compose repeat.for=\"plugin of dataUploadInfo.plugins\" \r\n                        if.bind=\"plugin === dataUploadInfo.selectedPlugin\" \r\n                        view-model.bind=\"plugin\" \r\n                        view.bind=\"optionsView\"\r\n                        containerLess></compose>\r\n                </form>\r\n            </div>\r\n            <div class=\"loading\" if.bind=\"!optionsView && !dataUploadInfo.hasPluginExecuted && !dataUploadInfo.error\"></div>\r\n        </div>\r\n    </form>\r\n    <div class=\"data-loader-no-plugins\" else>\r\n        <br/>\r\n        No matching data loaders for file(s).\r\n    </div>\r\n    \r\n    <br/>\r\n    <div class=\"error\" if.bind=\"dataUploadInfo.error\">\r\n        <label>Error</label>\r\n        <p innerhtml.bind=\"dataUploadInfo.error.message\"></p>\r\n    </div>\r\n\r\n    <div if.bind=\"!dataUploadInfo.error && entitiesView\">\r\n        <br/>\r\n        <compose repeat.for=\"plugin of dataUploadInfo.plugins\" \r\n                    if.bind=\"plugin === dataUploadInfo.selectedPlugin\" \r\n                    view-model.bind=\"plugin\" \r\n                    view.bind=\"entitiesView\"\r\n                    containerLess></compose>\r\n    </div>\r\n    \r\n    <br/>\r\n    <div style=\"background-color: #dddddd; border-radius: 5px; padding: 8px;\">\r\n        <table class=\"full-width\" style=\"font-size:90%;\">\r\n            <thead>\r\n                <tr>\r\n                    <th>Filename</th>\r\n                    <th>Date modified</th>\r\n                    <th class=\"number\">Size</th>\r\n                </tr>\r\n            </thead>\r\n            <tbody>\r\n                <tr repeat.for=\"fileInfo of dataUploadInfo.context.fileInfos\">\r\n                    <td>${fileInfo.filename}</td>\r\n                    <td>${fileInfo.file.lastModifiedDate | dateTimeFormat }</td>\r\n                    <td class=\"number\">${fileInfo.file.size / 1000 | fixed: 1} KB</td>\r\n                </tr>\r\n            </tbody>\r\n        </table>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/data-upload/index":
/*!******************************************************************************!*\
  !*** ./node_modules/ts-loader?silent=true!./SPA/module/data-upload/index.ts ***!
  \******************************************************************************/
/*! exports provided: DataUploadIndex */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataUploadIndex", function() { return DataUploadIndex; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var module_data_upload_templates_template_excel_entities__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! module/data-upload/templates/template-excel-entities */ "./SPA/module/data-upload/templates/template-excel-entities.js");
/* harmony import */ var module_data_upload_templates_template_excel_entities__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(module_data_upload_templates_template_excel_entities__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var module_data_upload_templates_template_excel_step_n_results__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! module/data-upload/templates/template-excel-step-n-results */ "./SPA/module/data-upload/templates/template-excel-step-n-results.js");
/* harmony import */ var module_data_upload_templates_template_excel_step_n_results__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(module_data_upload_templates_template_excel_step_n_results__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var module_error_error_manager__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! module/error/error-manager */ "./SPA/module/error/error-manager.ts");
/* harmony import */ var _file_processor__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./file-processor */ "./SPA/module/data-upload/file-processor.ts");









let DataUploadIndex = class DataUploadIndex {
    constructor(server, pluginManager, model, error, router, fileProcessor) {
        this.server = server;
        this.pluginManager = pluginManager;
        this.model = model;
        this.error = error;
        this.router = router;
        this.fileProcessor = fileProcessor;
        this.waitingLookups = [];
        this.waitingEntities = [];
        this.selectedEntityClasses = [];
        this.tablesResult = [];
        this.tablesGeneric = [];
        this.templateOptions = {
            createExperiment: true,
            createStep: true,
            inputClasses: [],
            outputClasses: [],
            resultClasses: [],
            useA1WellNotation: true
        };
        this.newEntities = [];
        for (let table of model.tables) {
            if (table.tableCategory === 'ResultEntity')
                this.tablesResult.push(table);
            if ((table.tableCategory === 'PrimaryEntity' || table.tableCategory === 'ResultEntity') &&
                table.group !== 'Test' && table.group !== 'RLS')
                this.tablesGeneric.push(table);
        }
    }
    setState(newState) {
        this.router.navigateToRoute(this.router.currentInstruction.config.name, { 'state': newState }, { trigger: false, replace: false });
        this.state = newState;
    }
    determineActivationStrategy() {
        return aurelia_router__WEBPACK_IMPORTED_MODULE_4__["activationStrategy"].invokeLifecycle;
    }
    activate(params) {
        this.state = params.state || 'new';
        if (this.state === 'waiting' && !this.waitingEntities.length
            || this.state === 'uploaded' && !this.newEntities.length) {
            this.state = 'new';
        }
    }
    upload() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            this.newEntities = [];
            try {
                this.dataUploadInfo.selectedPlugin = this.dataUploadInfo.plugins[0];
                const result = yield this.dataUploadInfo.selectedPlugin.getResult();
                this.waitingEntities = this.waitingEntities.concat(result.entities);
                if (result.lookups) {
                    this.waitingLookups = this.waitingLookups.concat(result.lookups);
                }
            }
            catch (error) {
                this.dataUploadInfo.error = error;
            }
            try {
                const response = yield this.server.saveEntities(this.waitingEntities, this.waitingLookups);
                this.newEntities = response.newEntities;
                this.setState('uploaded');
            }
            catch (err) {
                this.newEntities = [];
                throw err;
            }
            finally {
                this.waitingEntities = [];
                this.waitingLookups = [];
                _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
            }
        });
    }
    downloadTemplate() {
        switch (this.templateType) {
            case 'stepsNResults':
                new module_data_upload_templates_template_excel_step_n_results__WEBPACK_IMPORTED_MODULE_6__["TemplateExcelStepNResults"](this.model).execute(this.templateOptions);
                break;
            case 'generic':
                new module_data_upload_templates_template_excel_entities__WEBPACK_IMPORTED_MODULE_5__["TemplateExcelEntities"]().execute(this.model, this.selectedEntityClasses);
                break;
            default:
                throw new Error('Invalid template category: ' + this.templateType);
        }
    }
    templateTypeChanged(setType) {
        if (setType === 'stepsNResults') {
            this.resultTemplates.style.display = "grid";
            this.genericTemplates.style.display = "none";
        }
        else {
            this.resultTemplates.style.display = "none";
            this.genericTemplates.style.display = "block";
        }
        this.templateType = setType;
        this.buttonDownloadTemplate.style.display = 'block';
        return true;
    }
    dropped(event) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            this.newEntities = [];
            this.waitingEntities = [];
            this.waitingLookups = [];
            let promises = [];
            this.dataUploadInfo = yield this.fileProcessor.preprocessFiles(event.detail.files);
            this.setState('waiting');
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        });
    }
};
DataUploadIndex = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["singleton"])(),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginManager"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DataModel"], module_error_error_manager__WEBPACK_IMPORTED_MODULE_7__["ErrorManager"], aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"], _file_processor__WEBPACK_IMPORTED_MODULE_8__["FileProcessor"]])
], DataUploadIndex);



/***/ }),

/***/ "module/data-upload/index.html":
/*!*******************************************!*\
  !*** ./SPA/module/data-upload/index.html ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"../../entity/shared-fields.html\"></require>\r\n    <require from=\"../../entity/unique-fields\"></require>\r\n    <require from=\"./elements/data-loader-setup\"></require>\r\n\r\n    <style>\r\n        .snr-select {\r\n            display: none;\r\n            grid-gap: 10px;\r\n            grid-template-columns: repeat(auto-fill, minmax(350px,1fr));\r\n        }\r\n    </style>\r\n\r\n    <div class=\"page-with-header\">\r\n\r\n        <div class=\"page-header\"><h1>Upload Data</h1></div>\r\n\r\n        <div class=\"page-panels\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-body\">\r\n                    <p>\r\n                        Drop your data files below to upload data. Please see the\r\n                        <a target=\"_blank\" href=\"https://docs.scifeon.com/data_manager/data-upload/\">Scifeon Docs page</a> for a detailed guide.\r\n                    </p>\r\n                    <dropzone dropfiles.trigger=\"dropped($event)\" title=\"Drop Data Files Here\"></dropzone>\r\n                </div>\r\n            </div>\r\n<br/>\r\n            <div class=\"panel full-width\" if.bind=\"state === 'new'\" ref=\"panelTemplate\">\r\n                <div class=\"panel-heading\">Create Data Upload Templates</div>\r\n                <div class=\"panel-body\">\r\n                    <div>\r\n                        <div class=\"scidocs-link\">\r\n                            <a target=\"_blank\" href=\"https://docs.scifeon.com/guide-dm/function/data-upload\"\r\n                               class=\"glyphicon glyphicon-question-sign\"></a>\r\n                        </div>\r\n\r\n                        <p>\r\n                            <input type=\"radio\" value=\"stepsNResults\" name=\"templateType\"\r\n                                   click.delegate=\"templateTypeChanged('stepsNResults')\" />Steps &amp; Results\r\n                        </p>\r\n                        <p>\r\n                            <input type=\"radio\" value=\"generic\" name=\"templateType\"\r\n                                   click.delegate=\"templateTypeChanged('generic')\" />Generic Template\r\n                        </p>\r\n\r\n                        <button style=\"margin: 10px auto; display:none\" ref=\"buttonDownloadTemplate\" class=\"primary\" click.delegate=\"downloadTemplate()\">Create Template</button>\r\n                    </div>\r\n\r\n                    <div ref=\"resultTemplates\" class=\"snr-select\">\r\n                        <div>\r\n                            <h3>Steps and Results</h3>\r\n                            <p>You can use these templates for creating experiment, step and result records.</p>\r\n\r\n                            <p>\r\n                                You can create result records\r\n                                without creating an experiment or a step; in that case, they must be linked to an existing step in the\r\n                                system (the template will have a field for that).\r\n                            </p>\r\n\r\n                            <p>You can also create experiments and steps without uploading results, then do the result upload later.</p>\r\n\r\n                            <p><input type=\"checkbox\" checked.bind=\"templateOptions.createExperiment\" /> Create experiment</p>\r\n                            <p><input type=\"checkbox\" checked.bind=\"templateOptions.createStep\" /> Create step</p>\r\n                        </div>\r\n\r\n                        <div>\r\n                            <h3>Step Input</h3>\r\n                            <p>Select which entity classes to use as step input:</p>\r\n                            <table class=\"table compact\">\r\n                                <thead> <tr> <th></th> <th>Entity Class</th> </tr> </thead>\r\n                                <tbody>\r\n                                    <tr> <td><input type=\"checkbox\" value=\"Animal\" checked.bind=\"templateOptions.inputClasses\" /></td> <td>Animal</td> </tr>\r\n                                    <tr> <td><input type=\"checkbox\" value=\"Compound\" checked.bind=\"templateOptions.inputClasses\" /></td> <td>Compound</td> </tr>\r\n                                    <tr> <td><input type=\"checkbox\" value=\"Batch\" checked.bind=\"templateOptions.inputClasses\" /></td> <td>Batch</td> </tr>\r\n                                    <tr> <td><input type=\"checkbox\" value=\"Plate\" checked.bind=\"templateOptions.inputClasses\" /></td> <td>Plate</td> </tr>\r\n                                    <tr> <td><input type=\"checkbox\" value=\"Sample\" checked.bind=\"templateOptions.inputClasses\" /></td> <td>Sample</td> </tr>\r\n                                </tbody>\r\n                            </table>\r\n\r\n                            <h3>Step Output</h3>\r\n                            <p>Select which entity classes to use as step output:</p>\r\n                            <table class=\"table compact\">\r\n                                <thead> <tr> <th></th> <th>Entity Class</th> </tr> </thead>\r\n                                <tbody>\r\n                                    <tr> <td><input type=\"checkbox\" value=\"Animal\" checked.bind=\"templateOptions.outputClasses\" /></td> <td>Animal</td> </tr>\r\n                                    <tr> <td><input type=\"checkbox\" value=\"Compound\" checked.bind=\"templateOptions.outputClasses\" /></td> <td>Compound</td> </tr>\r\n                                    <tr> <td><input type=\"checkbox\" value=\"Batch\" checked.bind=\"templateOptions.outputClasses\" /></td> <td>Batch</td> </tr>\r\n                                    <tr> <td><input type=\"checkbox\" value=\"Plate\" checked.bind=\"templateOptions.outputClasses\" /></td> <td>Plate</td> </tr>\r\n                                    <tr> <td><input type=\"checkbox\" value=\"Sample\" checked.bind=\"templateOptions.outputClasses\" /></td> <td>Sample</td> </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n\r\n                        <div>\r\n                            <h3>Results</h3>\r\n                            <p>Select which result classes to include in the template:</p>\r\n                            <table class=\"table compact\">\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th></th>\r\n                                        <th>Group</th>\r\n                                        <th>Entity Class</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <tr>\r\n                                        <td><input type=\"checkbox\" value.bind=\"PlateLayer\" checked.bind=\"templateOptions.resultClasses\" /></td>\r\n                                        <td>PnS</td>\r\n                                        <td>PlateLayer</td>\r\n                                    </tr>\r\n                                    <tr repeat.for=\"table of tablesResult\">\r\n                                        <td><input type=\"checkbox\" value.bind=\"table.name\" checked.bind=\"templateOptions.resultClasses\" /></td>\r\n                                        <td>${table.group}</td>\r\n                                        <td>${table.name}</td>\r\n                                    </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </div>\r\n\r\n                    <div ref=\"genericTemplates\" style=\"display: none\">\r\n                        <h3>Generic Entity Upload</h3>\r\n                        <p>Select which entity classes to include in the template:</p>\r\n                        <table class=\"table compact\">\r\n                            <thead>\r\n                                <tr>\r\n                                    <th></th>\r\n                                    <th>Group</th>\r\n                                    <th>Entity Class</th>\r\n                                </tr>\r\n                            </thead>\r\n                            <tbody>\r\n                                <tr repeat.for=\"table of tablesGeneric\">\r\n                                    <td><input type=\"checkbox\" value.bind=\"table.name\" checked.bind=\"selectedEntityClasses\" /></td>\r\n                                    <td>${table.group}</td>\r\n                                    <td>${table.name}</td>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel files\" if.bind=\"state === 'waiting'\">\r\n                <div class=\"panel-body\">\r\n                    <data-loader-setup data-upload-info.bind=\"dataUploadInfo\"></data-loader-setup>\r\n                    \r\n                    <div if.bind=\"dataUploadInfo.hasPlugins()\">\r\n                        <button style=\"margin: 10px auto;\" click.delegate=\"upload()\">Upload</button>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel new-entities\" if.bind=\"state === 'uploaded'\">\r\n                <div class=\"panel-heading\">New Entities</div>\r\n                <div class=\"panel-body\">\r\n                    <table class=\"table compact\" style=\"max-width: 600px;\">\r\n                        <thead>\r\n                            <tr>\r\n                                <th>ID</th>\r\n                                <th>Class</th>\r\n                                <th>Name</th>\r\n                                <th>Type</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody repeat.for=\"e of newEntities\">\r\n                            <tr>\r\n                                <td><a href=\"/#/entity/${e.eClass}/${e.id}\">${e.id}</a></td>\r\n                                <td>${e.eClass}</td>\r\n                                <td>${e.name}</td>\r\n                                <td>${e.type}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ })

}]);
//# sourceMappingURL=data-upload.7d2e17d8ae74be98b4b6.js.map