(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["entity~module/assayadm"],{

/***/ "./SPA/services/sci-calc-api.js":
/*!**************************************!*\
  !*** ./SPA/services/sci-calc-api.js ***!
  \**************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Promise) {

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SciCalcApi = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _aureliaFetchClient = __webpack_require__(/*! aurelia-fetch-client */ "./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js");

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SciCalcApi = exports.SciCalcApi = (_dec = (0, _aureliaFramework.inject)(_aureliaFetchClient.HttpClient), _dec(_class = function () {
    function SciCalcApi(http) {
        _classCallCheck(this, SciCalcApi);

        this.http = http;
    }

    _createClass(SciCalcApi, [{
        key: 'convertResults_R_4PL',
        value: function convertResults_R_4PL(resultsResponse) {
            //Get results.csv
            var resultsCsvRecord = resultsResponse.outputData.find(function (r) {
                return r.name === 'results.csv';
            });
            var resultsCsv = window.atob(resultsCsvRecord.base64Content).toString();

            //Insert into results
            var results = { series: [] };
            var lines = resultsCsv.split('\n');
            for (var i = 1; i < lines.length; i++) {
                var fields = lines[i].split(',');
                if (fields.length === 5) {
                    var seriesKey = fields[0].substr(1, fields[0].length - 2);
                    var seriesRecord = {
                        key: seriesKey,
                        parameters: {
                            slope: parseFloat(fields[1]),
                            bottom: parseFloat(fields[2]),
                            top: parseFloat(fields[3]),
                            ec50: parseFloat(fields[4]),
                            logEC50: Math.log10(parseFloat(fields[4]))
                        }
                    };
                    results.series.push(seriesRecord);
                }
            }

            return results;
        }
    }, {
        key: 'convertResults_R_Script',
        value: function convertResults_R_Script(resultsResponse) {
            return resultsResponse;
        }
    }, {
        key: 'doJob',
        value: function doJob(params) {
            var _this = this;

            var timerId = null;

            //Figure out the type of job to start
            var p = new Promise(function (resolve, reject) {
                var pJob = null;

                if (!params.jobType && params.jobData) {
                    pJob = _this.startJob(params.jobData);
                } else if (params.jobType) {
                    switch (params.jobType) {
                        case 'R_Script':
                            pJob = _this.startJob_R_Script(params.jobData);
                            break;
                        case 'R_4PL':
                            pJob = _this.startJob_R_4PL(params.jobData);
                            break;
                    }
                }

                //Start job monitoring
                var monitorInterval = 2000;
                var classThis = _this;
                if (pJob) {
                    pJob.then(function (response) {
                        timerId = setInterval(function () {
                            classThis.getJobStatus(response.jobId).then(function (statusResponse) {
                                if (timerId && statusResponse.status === 'completed') {
                                    clearInterval(timerId);
                                    //Get and return job results
                                    classThis.getJobResults(response.jobId).then(function (resultsResponse) {
                                        //Convert results into usable JSON
                                        var convertedResults = null;
                                        if (params.jobType) {
                                            switch (params.jobType) {
                                                case 'R_Script':
                                                    convertedResults = classThis.convertResults_R_Script(resultsResponse);
                                                    break;
                                                case 'R_4PL':
                                                    convertedResults = classThis.convertResults_R_4PL(resultsResponse);
                                                    break;
                                            }
                                        }
                                        if (convertedResults) {
                                            resolve(convertedResults);
                                        } else {
                                            resolve(resultsResponse);
                                        }
                                    });
                                }
                            });
                        }, monitorInterval);
                    });
                }
            });

            return p;
        }
    }, {
        key: 'getJobResults',
        value: function getJobResults(jobId) {
            var _this2 = this;

            var p = new Promise(function (resolve, reject) {
                _this2.http.fetch('/SciCalc/GetJobResults?jobId=' + jobId).then(function (response) {
                    return response.json();
                }).then(function (response) {
                    resolve(response);
                });
            });

            return p;
        }
    }, {
        key: 'getJobStatus',
        value: function getJobStatus(jobId) {
            var _this3 = this;

            var p = new Promise(function (resolve, reject) {
                _this3.http.fetch('/SciCalc/GetJobStatus?jobId=' + jobId).then(function (response) {
                    return response.json();
                }).then(function (response) {
                    resolve(response);
                });
            });

            return p;
        }
    }, {
        key: 'startJob',
        value: function startJob(data) {
            var _this4 = this;

            var p = new Promise(function (resolve, reject) {
                _this4.http.fetch('/SciCalc/StartJob', {
                    body: (0, _aureliaFetchClient.json)(data),
                    headers: { 'Content-Type': 'application/json' },
                    method: 'post' }).then(function (response) {
                    return response.json();
                }).then(function (response) {
                    resolve(response);
                });
            });

            return p;
        }
    }, {
        key: 'startJob_R_4PL',
        value: function startJob_R_4PL(resultsDS) {
            var fieldSep = ';';
            var lineSep = '\n';

            var flatRecords = [];
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = resultsDS[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var result = _step.value;
                    var _iteratorNormalCompletion2 = true;
                    var _didIteratorError2 = false;
                    var _iteratorError2 = undefined;

                    try {
                        for (var _iterator2 = result.entity.content.points[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                            var point = _step2.value;

                            if (point.isExcluded) continue;

                            if (!point.valueX || !point.valueY) continue;
                            //throw new Error(`Missing X og Y value in point: ${point.valueX}, ${point.valueY}`); TODO: Re-enable

                            flatRecords.push(flatRecords.length + fieldSep + point.valueX + fieldSep + point.valueY + fieldSep + result.key);
                        }
                    } catch (err) {
                        _didIteratorError2 = true;
                        _iteratorError2 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                _iterator2.return();
                            }
                        } finally {
                            if (_didIteratorError2) {
                                throw _iteratorError2;
                            }
                        }
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            var series = 'ID' + fieldSep + 'x' + fieldSep + 'y' + fieldSep + 'series' + lineSep + flatRecords.join(lineSep) + lineSep;

            var inputData = [{
                content: window.btoa(series),
                file: 'data.csv'
            }];

            var jobData = {
                engine: 'R',
                inputData: inputData,
                script: 'dose-response'
            };

            return this.startJob(jobData);
        }
    }, {
        key: 'startJob_R_Script',
        value: function startJob_R_Script(script) {
            var inputData = [{
                content: window.btoa(script),
                file: 'script.R'
            }];

            var jobData = {
                engine: 'R',
                inputData: inputData
            };

            return this.startJob(jobData);
        }
    }, {
        key: 'test',
        value: function test() {
            //Type: No Type
            var pJob_NoType = this.doJob({
                jobData: {
                    engine: 'R',
                    inputData: [{ content: window.btoa('version'), file: 'script.R' }]
                }
            });
            pJob_NoType.then(function (response) {
                console.log('Job_NoType:::');
                console.log(response);
            });

            //Type: R_Script
            var pJob_R_Script = this.doJob({
                jobType: 'R_Script',
                jobData: 'version'
            });
            pJob_R_Script.then(function (response) {
                console.log('R_Script:::');
                console.log(response);
            });

            //Type: R_4PL
            var dataSeries = [];
            var ds1 = {
                eClass: 'ResultDataSeries',
                resultSetID: '#idRSDS',
                name: 'ds1',
                status: 'Completed',
                subjectID: null,
                subjectClass: null,
                content: {
                    replicates: 1,
                    points: [{ valueX: 0.0, valueY: 7.6 }, { valueX: 1.0, valueY: 8.4 }, { valueX: 1.9, valueY: 6.9 }, { valueX: 3.8, valueY: 1.9 }, { valueX: 7.5, valueY: 1.2 }, { valueX: 15, valueY: 0.69 }, { valueX: 30, valueY: 0.25 }]
                }
            };
            dataSeries.push(ds1);
            var ds2 = {
                eClass: 'ResultDataSeries',
                resultSetID: '#idRSDS',
                name: 'ds2',
                status: 'Completed',
                subjectID: null,
                subjectClass: null,
                content: {
                    replicates: 1,
                    points: [{ valueX: 0.0, valueY: 8.3 }, { valueX: 1.0, valueY: 6.9 }, { valueX: 1.9, valueY: 6.5 }, { valueX: 3.8, valueY: 2.9 }, { valueX: 7.5, valueY: 0.9 }, { valueX: 15, valueY: 0.52 }, { valueX: 30, valueY: 0.22 }]
                }
            };
            dataSeries.push(ds2);
            var ds3 = {
                eClass: 'ResultDataSeries',
                resultSetID: '#idRSDS',
                name: 'ds3',
                status: 'Completed',
                subjectID: null,
                subjectClass: null,
                content: {
                    replicates: 1,
                    points: [{ valueX: 0.0, valueY: 7.4 }, { valueX: 1.0, valueY: 7.8 }, { valueX: 1.9, valueY: 5.9 }, { valueX: 3.8, valueY: 4.2 }, { valueX: 7.5, valueY: 1.1 }, { valueX: 15, valueY: 0.83 }, { valueX: 30, valueY: 0.44 }]
                }
            };
            dataSeries.push(ds3);

            var pJob_R_4PL = this.doJob({
                jobType: 'R_4PL',
                jobData: dataSeries
            });
            pJob_R_4PL.then(function (response) {
                console.log('R_4PL:::');
                console.log(response);
            });
        }
    }]);

    return SciCalcApi;
}()) || _class);
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! bluebird */ "./node_modules/bluebird/js/browser/bluebird.js")))

/***/ })

}]);
//# sourceMappingURL=assayadm.7d2e17d8ae74be98b4b6.js.map