(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["module/pns"],{

/***/ "./SPA/module/wfm/old-ui/step-create-base.js":
/*!***************************************************!*\
  !*** ./SPA/module/wfm/old-ui/step-create-base.js ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.StepCreateBase = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

var _core = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");

var _aureliaRouter = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StepCreateBase = exports.StepCreateBase = (_dec = (0, _aureliaFramework.inject)(_core.ServerAPI, _aureliaRouter.Router), _dec(_class = function () {
    function StepCreateBase(api, router) {
        _classCallCheck(this, StepCreateBase);

        this.api = api;
        this.router = router;

        this.input = {
            samples: [],
            plates: []
        };

        this.output = {
            samples: [],
            plates: [],
            resultSets: []
        };

        this.experiment = { eClass: 'Experiment', id: '#idExp', status: 'Initial' };
        this.step = { eClass: 'Step', id: '#idStep', status: 'Initial', input: [] };
        this.operation = {};
    }

    _createClass(StepCreateBase, [{
        key: 'activate',
        value: function activate(params) {
            this.context = params.context;

            if (this.context.experiment === 'new') {
                this.experiment = { eClass: 'Experiment', id: '#idExp' };
                this.step.experimentID = '#idExp';
            } else {
                this.experiment = { eClass: 'Experiment', id: params.experimentID };
                this.step.experimentID = params.experimentID;
                this.step.parentStepID = params.parentStepID;
            }
        }
    }, {
        key: 'createStep',
        value: function createStep() {
            var _this = this;

            this.entities = [this.experiment, this.step];

            this.createOutputEntities();

            this.api.saveEntities(this.entities).then(function (response) {
                var stepID = void 0;
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = response.newEntities[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var entity = _step.value;

                        if (entity.eClass === 'Step') stepID = entity.id;
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }

                _this.router.navigate('entity/step/' + stepID);
            });
        }
    }]);

    return StepCreateBase;
}()) || _class);

/***/ }),

/***/ "element/flow-page":
/*!**********************************!*\
  !*** ./SPA/element/flow-page.js ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.FlowPage = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _class, _desc, _value, _class2, _descriptor;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable,
        writable: descriptor.writable,
        value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
        desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
        desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
        return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
        desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
        desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
        Object['define' + 'Property'](target, property, desc);
        desc = null;
    }

    return desc;
}

function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var FlowPage = exports.FlowPage = (_dec = (0, _aureliaFramework.customElement)('flow-page'), _dec2 = (0, _aureliaFramework.inject)(Element), _dec(_class = _dec2(_class = (_class2 = function () {
    function FlowPage(element) {
        _classCallCheck(this, FlowPage);

        _initDefineProp(this, 'title', _descriptor, this);

        this.element = element;
        this.panels = {};
        this.panelNames = [];
    }

    _createClass(FlowPage, [{
        key: 'attached',
        value: function attached() {
            this.collectPanels();
            this.buildSidePanels();
            this.showPanel(this.panelNames[0]);
        }

        // //////////////////////////////////////////////////////////////////

    }, {
        key: 'showPanel',
        value: function showPanel(name) {
            //Before switching to new, alert the old about dismissing
            if (this.currentPanel && this.currentPanel.viewModel.dismissPanel) this.currentPanel.viewModel.dismissPanel();

            //Switch to new panel
            this.currentPanel = this.panels[name];
            $('#main-content').contents().detach();
            $('#main-content').empty();
            $('#main-content').append($(this.currentPanel.mainContent));

            $('#flow-side-panels .panel').removeClass('active');
            $('#side-panel-' + name).addClass('active');

            if (this.currentPanel.viewModel.showPanel) this.currentPanel.viewModel.showPanel();
        }

        // //////////////////////////////////////////////////////////////////

    }, {
        key: 'buildSidePanels',
        value: function buildSidePanels() {
            var _this = this;

            var panels = $('#flow-side-panels');
            var template = $('#side-panel-template').contents();

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                var _loop = function _loop() {
                    var name = _step.value;

                    var panel = _this.panels[name];

                    var panelElement = template.clone();
                    panelElement.attr('id', 'side-panel-' + name);
                    var titleElement = panelElement.find('.title')[0];
                    titleElement.textContent = panel.label;
                    $(titleElement).on('click', function () {
                        _this.showPanel(name);
                    });

                    var contentElement = panelElement.find('.content')[0];
                    $(contentElement).append(panel.sideContent);

                    panels.append(panelElement);

                    //Panel expansion state
                    panelElement.find('.expander').on('click', function (e) {
                        panelElement.toggleClass('collapsed');
                    });
                };

                for (var _iterator = this.panelNames[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    _loop();
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            panels.append($('#side-panel-footer').contents());
        }

        // //////////////////////////////////////////////////////////////////

    }, {
        key: 'collectPanels',
        value: function collectPanels() {
            var _this2 = this;

            $('div.flow-panel').each(function (index, panel) {
                var name = panel.attributes.name.value;
                //$(panel).detach();
                _this2.panelNames.push(name);

                var viewModel = {};
                if (panel.children[0].au) viewModel = panel.children[0].au.controller.viewModel;

                var sideContent = $(panel).find('.side-content')[0];
                var mainContent = $(panel).find('.main-content')[0];
                _this2.panels[name] = {
                    name: name,
                    label: panel.attributes.label.value,
                    sideContent: sideContent,
                    mainContent: mainContent,
                    viewModel: viewModel
                };
            });
        }
    }]);

    return FlowPage;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'title', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
})), _class2)) || _class) || _class);

/***/ }),

/***/ "element/flow-page.html":
/*!************************************!*\
  !*** ./SPA/element/flow-page.html ***!
  \************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    \r\n    <h2>${title}</h2>\r\n\r\n    <div class=\"grid grid-flow-page\">\r\n\r\n        <div id=\"flow-side-panels\" class=\"grid-fp-side-panels\">\r\n        </div>\r\n\r\n        <div class=\"grid-fp-content\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-body\" id=\"main-content\">\r\n                    <h1>Main Content</h1>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n    <div style=\"display: none;\">\r\n        <div id=\"side-panel-template\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\" style=\"display:flex;flex-direction:row;\">\r\n                    <div class=\"title\" style=\"flex:1;\"></div>\r\n                    <div class=\"expander\" style=\"flex:0 0 20px;\">\r\n                        <span class=\"glyphicon glyphicon-chevron-up\"></span>\r\n                        <span class=\"glyphicon glyphicon-chevron-down\"></span>\r\n                    </div>\r\n                </div>\r\n                <div class=\"panel-body content\"></div>\r\n            </div>\r\n        </div>\r\n\r\n        <div id=\"side-panel-footer\">\r\n            <slot name=\"side-panel-footer\"/>\r\n        </div>\r\n\r\n        <slot name=\"flow-panels\"/>\r\n    </div>\r\n\r\n</template>";

/***/ }),

/***/ "module/pns/panel-op-cherry-pick":
/*!************************************************!*\
  !*** ./SPA/module/pns/panel-op-cherry-pick.js ***!
  \************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PanelOpCherryPick = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable,
        writable: descriptor.writable,
        value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
        desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
        desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
        return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
        desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
        desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
        Object['define' + 'Property'](target, property, desc);
        desc = null;
    }

    return desc;
}

function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var PanelOpCherryPick = exports.PanelOpCherryPick = (_dec = (0, _aureliaFramework.customElement)('panel-op-cherry-pick'), _dec2 = (0, _aureliaFramework.inject)(_aureliaFramework.BindingEngine), _dec(_class = _dec2(_class = (_class2 = function () {
    function PanelOpCherryPick(binding) {
        _classCallCheck(this, PanelOpCherryPick);

        _initDefineProp(this, 'input', _descriptor, this);

        _initDefineProp(this, 'output', _descriptor2, this);

        _initDefineProp(this, 'operation', _descriptor3, this);

        //console.log('PanelCherryPick.Constructor()')
        this.binding = binding;
        this.nSelected = 0;
    }

    _createClass(PanelOpCherryPick, [{
        key: 'operationChanged',
        value: function operationChanged() {
            this.operation.checkedIDs = {};
        }
    }, {
        key: 'inputChanged',
        value: function inputChanged() {
            var _this = this;

            //console.log('PanelCherryPick.InputChanged()')

            if (this.subscription) this.subscription.dispose();
            this.subscription = this.binding.collectionObserver(this.input.samples).subscribe(function () {
                _this.inputIsDirty = true;
            });
        }
    }, {
        key: 'showPanel',
        value: function showPanel() {
            //console.log('PanelCherryPick.ShowPanel()')
            if (this.inputIsDirty) this.updateGrid();
        }
    }, {
        key: 'updateGrid',
        value: function updateGrid() {
            if (!$('#grid')) {
                //console.log('PanelCherryPick.UpdateGrid() Before Attached')
                return;
            }

            //this.dataSource = new kndo.data.DataSource({
            //    data: this.input.samples
            //});

            //console.log('PanelCherryPick.UpdateGrid()')
            //var grid = $('#grid').kndoGrid({
            //    dataSource: this.dataSource,
            //    selectable: "multiple",
            //    height: 800,
            //    scrollable: true,
            //    sortable: true,
            //    filterable: true,
            //    pageable: {
            //        input: true,
            //        numeric: false
            //    },
            //    dataBound: this.onDataBound.bind(this),
            //    columns: [
            //        { template: "<input type='checkbox' class='checkbox' />" },
            //        { field: 'id', title: 'ID', template: '<a href="/\\#/entity/sample/#=id#">#=id#</a>'},
            //        { field: 'name', title: 'Name' },
            //        { field: 'content', title: 'Content' },
            //        { field: 'type', title: 'Type' },
            //        { field: 'status', title: 'Status' },
            //        { field: 'description', title: 'Description' }
            //    ]
            //}).data('kndoGrid');

            grid.table.on("click", ".checkbox", this.selectRow.bind(this));
        }
    }, {
        key: 'selectRow',
        value: function selectRow(e) {
            var checked = e.currentTarget.checked,
                row = $(e.currentTarget).closest("tr"),
                grid = $("#grid").data("kndoGrid"),
                dataItem = grid.dataItem(row);

            this.operation.checkedIDs[dataItem.id] = checked;
            if (checked) {
                //-select the row
                row.addClass("k-state-selected");
                this.nSelected++;
            } else {
                //-remove selection
                row.removeClass("k-state-selected");
                this.nSelected--;
            }
        }
    }, {
        key: 'onDataBound',
        value: function onDataBound(e) {
            var view = this.dataSource.view();
            for (var i = 0; i < view.length; i++) {
                if (this.operation.checkedIDs[view[i].id]) {
                    $('#grid').find("tr[data-uid='" + view[i].uid + "']").addClass("k-state-selected").find(".checkbox").attr("checked", "checked");
                }
            }
        }
    }]);

    return PanelOpCherryPick;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'input', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'output', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'operation', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
})), _class2)) || _class) || _class);

/***/ }),

/***/ "module/pns/panel-op-cherry-pick.html":
/*!**************************************************!*\
  !*** ./SPA/module/pns/panel-op-cherry-pick.html ***!
  \**************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"side-content\">\r\n        <table class=\"table compact no-head\">\r\n            <tbody>\r\n                <tr><th>Selected samples</th><td>${nSelected}</td></tr>\r\n            </tbody>\r\n        </table>\r\n    </div>\r\n    <div class=\"main-content\">\r\n        <h3>Cherry Pick Samples</h3>\r\n        <div id=\"grid\"></div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/pns/panel-op-plate-transfer":
/*!***************************************************!*\
  !*** ./SPA/module/pns/panel-op-plate-transfer.js ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PanelOpPlateTransfer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable,
        writable: descriptor.writable,
        value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
        desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
        desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
        return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
        desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
        desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
        Object['define' + 'Property'](target, property, desc);
        desc = null;
    }

    return desc;
}

function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var PanelOpPlateTransfer = exports.PanelOpPlateTransfer = (_dec = (0, _aureliaFramework.customElement)('panel-op-plate-transfer'), _dec(_class = (_class2 = function () {
    function PanelOpPlateTransfer() {
        _classCallCheck(this, PanelOpPlateTransfer);

        _initDefineProp(this, 'input', _descriptor, this);

        _initDefineProp(this, 'output', _descriptor2, this);

        _initDefineProp(this, 'operation', _descriptor3, this);
    }

    _createClass(PanelOpPlateTransfer, [{
        key: 'operationChanged',
        value: function operationChanged() {
            this.operation.outputType = 'Other';
            this.operation.fillDirection = 'byRow';
            this.operation.expandSamples = 1;
        }
    }, {
        key: 'click',
        value: function click() {
            alert(this.operation.fillDirection);
        }
    }]);

    return PanelOpPlateTransfer;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'input', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'output', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'operation', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
})), _class2)) || _class);

/***/ }),

/***/ "module/pns/panel-op-plate-transfer.html":
/*!*****************************************************!*\
  !*** ./SPA/module/pns/panel-op-plate-transfer.html ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"side-content\">\r\n        <table class=\"table compact no-head\">\r\n            <tbody>\r\n                <tr><th>Output type</th><td>${operation.outputType}</td></tr>\r\n                <tr><th>Fill direction</th><td>${operation.fillDirection}</td></tr>\r\n                <tr><th>Output pr input</th><td>${operation.expandSamples}</td></tr>\r\n            </tbody>\r\n        </table>\r\n    </div>\r\n    <div class=\"main-content\">\r\n        <h3>Plate Transfer</h3>\r\n        <div class=\"form-group\">\r\n            <label>Output sample/plate type</label>\r\n            <p><input value.bind=\"operation.outputType\" /></p>\r\n        </div>\r\n\r\n        <div class=\"form-group\">\r\n            <label>Fill Direction</label>\r\n            <p><input type=\"radio\" name=\"fillDirection\" value=\"byRow\" checked.bind=\"operation.fillDirection\" />By Row</p>\r\n            <p><input type=\"radio\" name=\"fillDirection\" value=\"byColumn\" checked.bind=\"operation.fillDirection\" />By Column</p>\r\n        </div>\r\n\r\n        <div class=\"form-group\">\r\n            <label>Output Samples pr Input Sample</label>\r\n            <p><input value.bind=\"operation.expandSamples\" /></p>\r\n        </div>\r\n\r\n        <button click.delegate=\"click()\">Click</button>\r\n\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/pns/step-create-cherry-pick":
/*!***********************************************************************************!*\
  !*** ./node_modules/babel-loader/lib!./SPA/module/pns/step-create-cherry-pick.js ***!
  \***********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.StepCreateCherryPick = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

var _shoppingCart = __webpack_require__(/*! module/shoppingcart/shopping-cart */ "./SPA/module/shoppingcart/shopping-cart.js");

var _core = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");

var _aureliaRouter = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StepCreateCherryPick = exports.StepCreateCherryPick = (_dec = (0, _aureliaFramework.inject)(_shoppingCart.ShoppingCart, _core.ServerAPI, _aureliaRouter.Router), _dec(_class = function () {
    function StepCreateCherryPick(cart, api, router) {
        _classCallCheck(this, StepCreateCherryPick);

        this.cart = cart;
        this.api = api;
        this.router = router;

        this.input = {
            samples: [],
            plates: []
        };

        this.output = {
            samples: [],
            plates: [],
            resultSets: []
        };

        this.entity = { eClass: 'Step', id: '#idStep', input: [] };
        this.operation = {};
    }

    _createClass(StepCreateCherryPick, [{
        key: 'activate',
        value: function activate(params) {
            this.context = params.context;

            if (this.context.experiment === 'new') {
                this.experiment = { eClass: 'Experiment', id: '#idExp' };
                this.entity.experimentID = '#idExp';
            } else {
                this.experiment = { eClass: 'Experiment', id: params.experimentID };
                this.entity.experimentID = params.experimentID;
                this.entity.parentStepID = params.parentStepID;
            }
        }

        ////////////////////////////////////////////////////////////////////

    }, {
        key: 'createStep',
        value: function createStep() {
            var _this = this;

            this.createOutputPlates();

            var entities = [this.experiment, this.entity];

            entities = entities.concat(this.output.plates);
            entities = entities.concat(this.output.samples);

            this.api.saveEntities(entities).then(function (response) {
                var stepID = void 0;
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = response.newEntities[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var entity = _step.value;

                        if (entity.eClass === 'Step') stepID = entity.id;
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }

                _this.router.navigate('entity/step/' + stepID);
            });
        }
    }, {
        key: 'createOutputPlates',
        value: function createOutputPlates() {
            this.output.samples = [];
            this.output.plates = [];
            this.entity.input = [];

            var iPlate = -1;
            var currentPlate = null;
            var nextRow = 0;
            var nextCol = 0;

            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                for (var _iterator2 = this.input.samples[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var sample = _step2.value;

                    if (!this.operation.checkedIDs[sample.id]) continue;

                    // Create plate
                    if (nextRow == 0 && nextCol == 0) {
                        iPlate++;
                        currentPlate = { eClass: 'Plate', id: '#Plate' + iPlate, format: 'Plate', nRows: 8, nCols: 12, originID: '#idStep', type: 'Other' };
                        this.output.plates.push(currentPlate);
                    }

                    // Create sample
                    this.entity.input.push({ id: sample.id, eClass: 'Sample' });
                    this.output.samples.push({ eClass: 'Sample', format: 'Well', parents: [sample.id], type: sample.type,
                        status: 'Initial', originID: '#idStep',
                        plateID: '#' + currentPlate.id, posRow: nextRow, posCol: nextCol, name: sample.name,
                        content: sample.content, compoundID: sample.compoundID, plasmidID: sample.plasmidID,
                        cellCloneID: sample.cellCloneID, primerID: sample.primerID, batchID: sample.batchID,
                        isControl: sample.isControl, controlType: sample.controlType
                    });

                    // Move to next position
                    nextRow++;
                    if (nextRow == 8) {
                        nextRow = 0;
                        nextCol++;
                        if (nextCol == 12) {
                            nextCol = 0;
                            currentPlate = null;
                        }
                    }
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }
        }
    }]);

    return StepCreateCherryPick;
}()) || _class);

/***/ }),

/***/ "module/pns/step-create-cherry-pick.html":
/*!*****************************************************!*\
  !*** ./SPA/module/pns/step-create-cherry-pick.html ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/flow-page\"></require>\r\n    <require from=\"./panel-op-cherry-pick\"></require>\r\n    <require from=\"../wfm/panels/std-panel-input-plates\"></require>\r\n\r\n    <flow-page title=\"Create Cherry Pick Step\">\r\n\r\n        <div slot=\"side-panel-footer\">\r\n            <button class=\"primary\" style=\"width: 100%;\" click.delegate=\"createStep()\">Create Step</button>\r\n        </div>\r\n\r\n        <div slot=\"flow-panels\">\r\n            <div class=\"flow-panel\" name=\"step\" label=\"Step\">\r\n                <!--<compose view=\"../wfm/panels/std-panel-step.html\"></compose>-->\r\n            </div>\r\n\r\n            <div class=\"flow-panel\" name=\"input\" label=\"Input\">\r\n                <std-panel-input-plates input.bind=\"input\"></std-panel-input-plates>\r\n            </div>\r\n\r\n            <div class=\"flow-panel\" name=\"operation\" label=\"Operation\">\r\n                <panel-op-cherry-pick input.bind=\"input\" operation.bind=\"operation\" output.bind=\"output\"></panel-op-cherry-pick>\r\n            </div>\r\n\r\n            <div class=\"flow-panel\" name=\"output\" label=\"Output\">\r\n                <compose view=\"../wfm/panels/std-panel-output.html\"></compose>\r\n            </div>\r\n        </div>\r\n\r\n    </flow-page>\r\n\r\n</template>";

/***/ }),

/***/ "module/pns/step-create-plate-transfer":
/*!**************************************************************************************!*\
  !*** ./node_modules/babel-loader/lib!./SPA/module/pns/step-create-plate-transfer.js ***!
  \**************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.StepCreatePlateTransfer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _stepCreateBase = __webpack_require__(/*! ../wfm/old-ui/step-create-base */ "./SPA/module/wfm/old-ui/step-create-base.js");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StepCreatePlateTransfer = exports.StepCreatePlateTransfer = function (_StepCreateBase) {
    _inherits(StepCreatePlateTransfer, _StepCreateBase);

    function StepCreatePlateTransfer() {
        var _ref;

        _classCallCheck(this, StepCreatePlateTransfer);

        for (var _len = arguments.length, rest = Array(_len), _key = 0; _key < _len; _key++) {
            rest[_key] = arguments[_key];
        }

        return _possibleConstructorReturn(this, (_ref = StepCreatePlateTransfer.__proto__ || Object.getPrototypeOf(StepCreatePlateTransfer)).call.apply(_ref, [this].concat(rest)));
    }

    ///////////////////////////////////////////////////////////////////////


    _createClass(StepCreatePlateTransfer, [{
        key: 'createOutputEntities',
        value: function createOutputEntities() {
            var _this2 = this;

            this.nextRow = 0;
            this.nextCol = 0;
            var iPlate = 0;
            var currentPlate = null;

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                var _loop = function _loop() {
                    var plate = _step.value;

                    var samples = $.grep(_this2.input.samples, function (sample) {
                        return sample.plateID === plate.id;
                    });

                    _this2.step.input.push({ id: plate.id, eClass: 'Plate' });

                    var _iteratorNormalCompletion2 = true;
                    var _didIteratorError2 = false;
                    var _iteratorError2 = undefined;

                    try {
                        for (var _iterator2 = samples[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                            var sample = _step2.value;

                            _this2.step.input.push({ id: sample.id, eClass: 'Sample' });

                            for (var iExpand = 0; iExpand < _this2.operation.expandSamples; iExpand++) {
                                if (_this2.nextRow == 0 && _this2.nextCol == 0) {
                                    currentPlate = {
                                        eClass: 'Plate',
                                        name: plate.name,
                                        parents: [],
                                        format: 'Plate',
                                        type: _this2.operation.outputType,
                                        nRows: plate.nRows,
                                        nCols: plate.nCols,
                                        id: '#idPlate' + iPlate,
                                        originID: '#idStep'
                                    };
                                    _this2.entities.push(currentPlate);
                                    iPlate++;
                                }

                                if (currentPlate.parents.indexOf(plate.id) < 0) currentPlate.parents.push(plate.id);

                                _this2.entities.push({
                                    eClass: 'Sample',
                                    name: sample.name,
                                    type: _this2.operation.outputType,
                                    format: 'Well',
                                    posRow: _this2.nextRow,
                                    posCol: _this2.nextCol,
                                    parents: [sample.id],
                                    plateID: '#' + currentPlate.id,
                                    originID: '#idStep'
                                });

                                _this2.moveToNextWell();
                            }
                        }
                    } catch (err) {
                        _didIteratorError2 = true;
                        _iteratorError2 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                _iterator2.return();
                            }
                        } finally {
                            if (_didIteratorError2) {
                                throw _iteratorError2;
                            }
                        }
                    }
                };

                for (var _iterator = this.input.plates[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    _loop();
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }, {
        key: 'moveToNextWell',
        value: function moveToNextWell() {
            if (this.operation.fillDirection == 'byRow') {
                this.nextCol++;
                this.nextRow += Math.floor(this.nextCol / 12); // TODO: Plate layout / support non-96W-plates
            } else {
                this.nextRow++;
                this.nextCol += Math.floor(this.nextRow / 8); // TODO: Plate layout / support non-96W-plates
            }
            this.nextCol = this.nextCol % 12;
            this.nextRow = this.nextRow % 8;
        }
    }]);

    return StepCreatePlateTransfer;
}(_stepCreateBase.StepCreateBase);

/***/ }),

/***/ "module/pns/step-create-plate-transfer.html":
/*!********************************************************!*\
  !*** ./SPA/module/pns/step-create-plate-transfer.html ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/flow-page\"></require>\r\n    <require from=\"./panel-op-plate-transfer\"></require>\r\n    <require from=\"../wfm/panels/std-panel-input-plates\"></require>\r\n\r\n    <flow-page title=\"Create Plate Transfer Step\">\r\n\r\n        <div slot=\"side-panel-footer\">\r\n            <button class=\"primary\" style=\"width: 100%;\" click.delegate=\"createStep()\">Create Step</button>\r\n        </div>\r\n\r\n        <div slot=\"flow-panels\">\r\n            <div class=\"flow-panel\" name=\"step\" label=\"Step\">\r\n                <std-panel-input-plates input.bind=\"input\"></std-panel-input-plates>\r\n            </div>\r\n\r\n            <div class=\"flow-panel\" name=\"input\" label=\"Input\">\r\n                <std-panel-input-plates input.bind=\"input\"></std-panel-input-plates>\r\n            </div>\r\n\r\n            <div class=\"flow-panel\" name=\"operation\" label=\"Operation\">\r\n                <panel-op-plate-transfer operation.bind=\"operation\" output.bind=\"output\"></panel-op-plate-transfer>\r\n            </div>\r\n\r\n            <div class=\"flow-panel\" name=\"output\" label=\"Output\">\r\n                <compose view=\"../wfm/panels/std-panel-output.html\"></compose>\r\n            </div>\r\n        </div>\r\n\r\n    </flow-page>\r\n\r\n</template>\r\n";

/***/ }),

/***/ "module/wfm/panels/std-panel-input-plates":
/*!*********************************************************!*\
  !*** ./SPA/module/wfm/panels/std-panel-input-plates.js ***!
  \*********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.StdPanelInputPlates = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _class, _desc, _value, _class2, _descriptor;

var _aureliaFramework = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");

var _shoppingCart = __webpack_require__(/*! module/shoppingcart/shopping-cart */ "./SPA/module/shoppingcart/shopping-cart.js");

var _core = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");

function _initDefineProp(target, property, descriptor, context) {
    if (!descriptor) return;
    Object.defineProperty(target, property, {
        enumerable: descriptor.enumerable,
        configurable: descriptor.configurable,
        writable: descriptor.writable,
        value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
    });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
    var desc = {};
    Object['ke' + 'ys'](descriptor).forEach(function (key) {
        desc[key] = descriptor[key];
    });
    desc.enumerable = !!desc.enumerable;
    desc.configurable = !!desc.configurable;

    if ('value' in desc || desc.initializer) {
        desc.writable = true;
    }

    desc = decorators.slice().reverse().reduce(function (desc, decorator) {
        return decorator(target, property, desc) || desc;
    }, desc);

    if (context && desc.initializer !== void 0) {
        desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
        desc.initializer = undefined;
    }

    if (desc.initializer === void 0) {
        Object['define' + 'Property'](target, property, desc);
        desc = null;
    }

    return desc;
}

function _initializerWarningHelper(descriptor, context) {
    throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var StdPanelInputPlates = exports.StdPanelInputPlates = (_dec = (0, _aureliaFramework.customElement)('std-panel-input-plates'), _dec2 = (0, _aureliaFramework.inject)(_shoppingCart.ShoppingCart, _core.ServerAPI), _dec(_class = _dec2(_class = (_class2 = function () {
    function StdPanelInputPlates(cart, api) {
        _classCallCheck(this, StdPanelInputPlates);

        _initDefineProp(this, 'input', _descriptor, this);

        this.cart = cart;
        this.api = api;
    }

    // INPUT ////////////////////////////////////////////////////////////


    _createClass(StdPanelInputPlates, [{
        key: 'addCartToInput',
        value: function addCartToInput() {
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this.cart.entities[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var entity = _step.value;

                    switch (entity.eClass) {
                        case 'Plate':
                            this.input.plates.push(entity);
                            this.loadPlateInfo(entity.id);
                            break;
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }, {
        key: 'loadPlateInfo',
        value: function loadPlateInfo(plateID) {
            var _this = this;

            this.api.get('/api/query/view/Sample?$filter=PlateID eq \'' + plateID + '\'').then(function (response) {
                return response.json();
            }).then(function (response) {
                var _iteratorNormalCompletion2 = true;
                var _didIteratorError2 = false;
                var _iteratorError2 = undefined;

                try {
                    for (var _iterator2 = response.data[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                        var sample = _step2.value;

                        _this.input.samples.push(sample);
                    }
                } catch (err) {
                    _didIteratorError2 = true;
                    _iteratorError2 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }
                    } finally {
                        if (_didIteratorError2) {
                            throw _iteratorError2;
                        }
                    }
                }
            });
        }
    }]);

    return StdPanelInputPlates;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'input', [_aureliaFramework.bindable], {
    enumerable: true,
    initializer: null
})), _class2)) || _class) || _class);

/***/ }),

/***/ "module/wfm/panels/std-panel-input-plates.html":
/*!***********************************************************!*\
  !*** ./SPA/module/wfm/panels/std-panel-input-plates.html ***!
  \***********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"side-content\">\r\n        <table class=\"table compact no-head\">\r\n            <tbody>\r\n                <tr><th>Plates</th><td>${input.plates.length}</td></tr>\r\n                <tr><th>Samples</th><td>${input.samples.length}</td></tr>\r\n            </tbody>\r\n        </table>\r\n    </div>\r\n    <div class=\"main-content\">\r\n        <div style=\"float: right\"><button class=\"btn-default\" click.delegate=\"addCartToInput()\">Add Plates From Cart</button></div>\r\n        <h2>Input</h2>\r\n\r\n        <h3>Plates</h3>\r\n        <table class=\"table compact\">\r\n            <thead>\r\n                <tr>\r\n                    <th>ID</th>\r\n                    <th>Type</th>\r\n                    <th>Status</th>\r\n                    <th>Owner</th>\r\n                    <th>Description</th>\r\n                </tr>\r\n            </thead>\r\n            <tbody>\r\n                <tr repeat.for=\"entity of setup.input.plates\">\r\n                    <td><a href=\"/#/entity/${entity.eClass}/${entity.id}\">${entity.id}</a></td>\r\n                    <td>${entity.type}</td>\r\n                    <td>${entity.status}</td>\r\n                    <td>${entity.userID}</td>\r\n                    <td>${entity.description}</td>\r\n                </tr>\r\n            </tbody>\r\n        </table>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/wfm/panels/std-panel-output.html":
/*!*****************************************************!*\
  !*** ./SPA/module/wfm/panels/std-panel-output.html ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"element/plate-view\"></require>\r\n\r\n    <div class=\"side-content\">\r\n        <table class=\"table compact no-head\">\r\n            <tbody>\r\n                <tr><th>Plates</th><td>${setup.output.plates.length}</td></tr>\r\n                <tr><th>Samples</th><td>${setup.output.samples.length}</td></tr>\r\n            </tbody>\r\n        </table>\r\n    </div>\r\n    <div class=\"main-content\">\r\n        <h2>Output</h2>\r\n\r\n        <template repeat.for=\"plate of setup.output.plates\">\r\n            <h3>${plate.name}</h3>\r\n\r\n            <plate-view n-rows.bind=\"plate.nRows\"\r\n                         n-cols.bind=\"plate.nCols\"\r\n                         readonly.bind=\"1\"\r\n                         well-view-template.bind=\"outputWellTemplate\"\r\n                         wells.bind=\"getSamples(plate)\"\r\n                         ></plate-layer>\r\n        </template>\r\n\r\n</template>";

/***/ })

}]);
//# sourceMappingURL=pns.7d2e17d8ae74be98b4b6.js.map