(window["webpackJsonpcom_msomics_ms_app"] = window["webpackJsonpcom_msomics_ms_app"] || []).push([["routePage_msDpCheck"],{

/***/ "../apps/module/ms_app/src/pages/dp-check.html":
/*!*****************************************************!*\
  !*** ../apps/module/ms_app/src/pages/dp-check.html ***!
  \*****************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <h1>DP Check</h1>\r\n\r\n    <div class=\"panel\">\r\n        <div class=\"panel-heading\">Ala Descriptive Power</div>\r\n        <div class=\"panel-body\">\r\n            <table class=\"table\">\r\n                <thead>\r\n                    <tr>\r\n                        <th>Result set</th>\r\n                        <th>DP - Ala</th>\r\n                    </tr>\r\n                </thead>\r\n                <tbody>\r\n                    <tr repeat.for=\"c of compounds\">\r\n                        <td><e-link entity-id.bind=\"c.resultSetID\" e-class=\"ResultSet\"></e-link></td>\r\n                        <td>${c.descriptivePower}</td>\r\n                    </tr>\r\n                </tbody>\r\n            </table>\r\n        </div>\r\n    </div>\r\n\r\n    <div class=\"panel\">\r\n        <div class=\"panel-body\">\r\n            <chart series.bind=\"chartSeries\" type=\"xy\" axis-ranges.bind=\"ranges\" options.bind=\"options\"></chart>\r\n        </div>\r\n    </div>\r\n    \r\n</template>";

/***/ }),

/***/ "../apps/module/ms_app/src/pages/dp-check.ts":
/*!***************************************************!*\
  !*** ../apps/module/ms_app/src/pages/dp-check.ts ***!
  \***************************************************/
/*! exports provided: MsoDPCheck */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MsoDPCheck", function() { return MsoDPCheck; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let MsoDPCheck = class MsoDPCheck {
    constructor(server) {
        this.server = server;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'ResultMSCompound', collection: 'compounds', filters: [{ field: 'CompoundID', value: 'Alanine' }] }
            ]);
            if (dataset.compounds) {
                this.compounds = dataset.compounds;
                this.chartSeries = [{ chartLabel: 'DP', content: { points: this.compounds.map(c => { return { valueX: c.resultSetID.substring(3), valueY: c.descriptivePower }; })
                        } }];
                this.ranges = { minValueY: 3.0, maxValueY: 33.0 };
                this.options = { refLines: [{ valueY: 17.5, name: 'Min' }, { valueY: 21.3, name: 'Max' }] };
            }
        });
    }
};
MsoDPCheck = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], MsoDPCheck);



/***/ })

}]);
//# sourceMappingURL=routePage_msDpCheck.f8d7769117c034d4fdbf.js.map