SELECT si.StepID, step.DepartmentID, si.SortIndex,
  smp.ID AS SampleID, smp.Name AS SampleName, smp.Type, smp.Status, smp.Description,
  smp.Attributes AS JsonAttributes, smp.ParentID, smp.IsControl, smp.ControlType,
  b.ID AS BatchID, b.Name AS BatchName
FROM WFM_StepInput AS si
JOIN WFM_Step AS step ON step.ID = si.StepID
JOIN PnS_Sample AS smp ON smp.ID = si.EntityID
LEFT JOIN PnS_Batch AS b ON b.ID = smp.BatchID