(window["webpackJsonpcom_scifeon_scifeon_administration"] = window["webpackJsonpcom_scifeon_scifeon_administration"] || []).push([["routePage_src/pages/administration/apps/index"],{

/***/ "../apps/core/administration/src/pages/administration/apps/index.html":
/*!****************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/apps/index.html ***!
  \****************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"grid\">\r\n        <div class=\"panel col-span-3\">\r\n            <div class=\"panel-body\">\r\n                <button type=\"submit\" click.delegate=\"installApp()\" class=\"float-right\">Install App</button>\r\n                <p>\r\n                    Read the documentation on creating your own apps either by clicking the <span class=\"fa fa-question-circle\"></span>-icon in the lower left corner, or by <a href=\"https://docs.scifeon.com/developer/apps/\" target=\"_blank\">clicking here</a>.\r\n                </p>\r\n                <p>\r\n                    Below is currently installed apps. Demo apps are disabled by default - enable them to explore additional features of Scifeon.\r\n                </p>\r\n            </div> \r\n        </div>\r\n\r\n        <div if.bind=\"loadingApps\" class=\"empty panel col-span-3 row-2\">\r\n            <h4 class=\"empty-title\">Loading Apps...</h4>\r\n            <div class=\"loading loading-lg\"></div>\r\n        </div>\r\n\r\n        <div if.bind=\"!loadingApps && apps.length === 0\" class=\"empty panel col-span-3 row-2\">\r\n            <h4 class=\"empty-title\">No Apps installed yet</h4>\r\n            <p class=\"empty-subtitle\">Click the 'Install App' button to install an App.</p>\r\n        </div>\r\n        \r\n        <ul class=\"list-group accordion panel col-span-3 row-2\">\r\n            <li aria-expanded=\"false\" class=\"accordion-item\" repeat.for=\"app of apps\">\r\n                <input type=\"checkbox\" name=\"accordion-checkbox\" id=\"accordion-${$index}\" hidden />\r\n                <label for=\"accordion-${$index}\" class=\"accordion-header link\">\r\n                    <h3 css=\"margin:0; color:${app.isEnabled || app.isSdkApp ? 'black' : 'gray' };\">\r\n                        ${app.name} \r\n                        <span class=\"float-right\" style=\"color:gray\">\r\n                            ${app.type === 'sdk' ? '[installed through SDK]' : ''}                                \r\n                            ${app.type === 'demo' ? '[demo] ' : ''}\r\n                            ${app.type === 'module' ? '[module] ' : ''}\r\n                            ${app.type === 'core' ? '[core] ' : ''}\r\n                            ${!app.isEnabled ? '(disabled)' : ''}\r\n                        </span>\r\n                    </h3>\r\n                </label>\r\n                <div class=\"accordion-body\">\r\n                    <div class=\"float-right\">\r\n                        <button click.delegate=\"toggleEnable(app)\" disabled.bind=\"app.type === 'sdk' || app.type === 'core'\">${app.isEnabled ? 'Disable' : 'Enable' }</button>\r\n                        <button click.delegate=\"remove(app)\" disabled.bind=\"app.type !== 'installed'\">Remove</button>\r\n                    </div>\r\n                    <dl>\r\n                        <dt><b>Description</b></dt>\r\n                        <dd>${app.description}</dd>\r\n                        <dt><b>Version</b></dt>\r\n                        <dd>${app.version}</dd>\r\n                        <dt><b>Full name</b></dt>\r\n                        <dd>${app.namespace}.${app.name}</dd>\r\n                        <dt><b>Author</b></dt>\r\n                        <dd>${app.author}</dd>\r\n                        <dt if.bind=\"app.scifeon.contributions.entities\"><b>Entities</b></dt>\r\n                        <dd if.bind=\"app.scifeon.contributions.entities\"><button class=\"sm\" click.delegate=\"loadEntities(app)\">Load entities</button></dd>\r\n                        <dt><b>Plugins</b></dt>\r\n                        <dd>\r\n                            ${Object.keys(appPlugins[app.namespace + '.' + app.name]) | json}\r\n                            <template repeat.for=\"type of appPlugins[app.namespace + '.' + app.name] | objectKeys\">\r\n                                <b>${type}</b>\r\n                                <pre style=\"white-space: pre-wrap; word-wrap: break-word;\">${appPlugins[app.namespace + '.' + app.name][type] | json}</pre>\r\n                            </template>\r\n                        </dd>\r\n                    </dl>\r\n                </div>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/apps/index.ts":
/*!**************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/apps/index.ts ***!
  \**************************************************************************/
/*! exports provided: AppsIndex */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AppsIndex", function() { return AppsIndex; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! string-natural-compare */ "./node_modules/string-natural-compare/natural-compare.js");
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(string_natural_compare__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _install_app_dialog__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./install-app-dialog */ "../apps/core/administration/src/pages/administration/apps/install-app-dialog.ts");
/* harmony import */ var _load_entities_dialog__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./load-entities-dialog */ "../apps/core/administration/src/pages/administration/apps/load-entities-dialog.ts");







let AppsIndex = class AppsIndex {
    constructor(server, dialog) {
        this.server = server;
        this.dialog = dialog;
        this.loadingApps = true;
        this.apps = [];
        this.appPlugins = {};
    }
    activate() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadApps();
        });
    }
    loadApps() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const response = yield this.server.get('api/app');
            this.apps = yield response.json();
            this.apps.sort((a, b) => string_natural_compare__WEBPACK_IMPORTED_MODULE_4__(a.name, b.name));
            for (let i = 0; i < this.apps.length; i++) {
                const app = this.apps[i];
                let appPlugins = {};
                if (app.scifeon.contributions.menu) {
                    for (let menuItem in app.scifeon.contributions.menu) {
                        appPlugins['menu.' + menuItem] = app.scifeon.contributions.menu[menuItem];
                    }
                }
                if (app.scifeon.contributions.routes) {
                    appPlugins['routes'] = app.scifeon.contributions.routes;
                }
                if (app.scifeon.contributions.plugins) {
                    app.scifeon.contributions.plugins.forEach(plugin => {
                        plugin.types.forEach(type => {
                            if (!appPlugins[type]) {
                                appPlugins[type] = [];
                            }
                            let stripPlugin = Object.assign({}, plugin);
                            delete stripPlugin.types;
                            appPlugins[type].push(stripPlugin);
                        });
                    });
                }
                this.appPlugins[app.namespace + '.' + app.name] = appPlugins;
            }
            this.loadingApps = false;
        });
    }
    installApp() {
        this.dialog.open({
            viewModel: _install_app_dialog__WEBPACK_IMPORTED_MODULE_5__["InstallAppDialog"],
            view: __webpack_require__(/*! ./install-app-dialog.html */ "../apps/core/administration/src/pages/administration/apps/install-app-dialog.html"),
            lock: false,
            header: 'Install App',
            style: 'min-width:400px;'
        })
            .whenClosed(response => {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
            if (!response.wasCancelled) {
                window.location.reload();
            }
        });
    }
    toggleEnable(app) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const confirmed = yield this.dialog.confirm(`Are you sure you want to ${app.isEnabled ? 'disable' : 'enable'} the App '${app.name}'?`);
            if (confirmed) {
                app.isEnabled = !app.isEnabled;
                const appWithoutVersion = JSON.parse(JSON.stringify(app));
                delete appWithoutVersion.version;
                yield this.server.putJson(`api/app/${app.id}`, appWithoutVersion);
                window.location.reload();
            }
        });
    }
    remove(app) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const confirmed = yield this.dialog.confirm(`Are you sure you want to delete the App '${app.name}'?`);
            if (confirmed) {
                yield this.server.delete(`api/app/${app.id}`);
                window.location.reload();
            }
        });
    }
    loadEntities(app) {
        this.dialog.open({
            viewModel: _load_entities_dialog__WEBPACK_IMPORTED_MODULE_6__["LoadEntitiesDialog"],
            model: app
        });
    }
};
AppsIndex = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'admin/apps',
        title: 'Apps',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PAGE_TYPE"].ADMINISTRATION
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"]])
], AppsIndex);



/***/ }),

/***/ "../apps/core/administration/src/pages/administration/apps/install-app-dialog.html":
/*!*****************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/apps/install-app-dialog.html ***!
  \*****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog-body>\r\n        <p>\r\n            Documentation...\r\n        </p>\r\n        <div class=\"form-group ${validationErrors !== null ? 'has-error' : ''}\">\r\n            <input type=\"file\" name=\"files\" files.bind=\"files\" id=\"app-file\" />\r\n            <p if.bind=\"validationErrors !== null\" class=\"form-input-hint\">${validationErrors}</p>\r\n        </div>            \r\n    </ux-dialog-body>\r\n    <ux-dialog-footer>\r\n        <button click.trigger=\"upload()\" disabled.bind=\"!canUpload\">Install</button>\r\n        <button click.trigger=\"validate()\" disabled.bind=\"!canUpload\" class=\"tooltip\" data-tooltip=\"Validate the contents of the app before installing.\">Validate</button>\r\n        <button click.trigger=\"dialog.cancel()\" class=\"btn-link\">Close</button>\r\n    </ux-dialog-footer>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/apps/install-app-dialog.ts":
/*!***************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/apps/install-app-dialog.ts ***!
  \***************************************************************************************/
/*! exports provided: InstallAppDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "InstallAppDialog", function() { return InstallAppDialog; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");

class InstallAppDialog {
    constructor(api, dialog) {
        this.api = api;
        this.dialog = dialog;
        this.api = api;
        this.dialog = dialog;
        this.files = [];
    }
    get canUpload() {
        if (this.files.length === 1) {
            let file = this.files[0];
            if (file.name.endsWith('.zip') && file.type.indexOf('zip') !== -1) {
                return true;
            }
        }
        return false;
    }
    get validationErrors() {
        if (this.files.length === 1 && !this.canUpload) {
            return 'The file is not a zip-file.';
        }
        return null;
    }
    upload() {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["LoadingSpinner"].show();
        if (this.files.length === 1) {
            let formData = new FormData();
            formData.set('apps', this.files[0]);
            this.api.fetch('api/app/validate', {
                method: 'POST',
                body: formData
            })
                .then(response => this.api.fetch('api/app', {
                method: 'POST',
                body: formData
            })
                .then(response => response.json())
                .then(data => this.dialog.ok(data))
                .catch(error => _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["LoadingSpinner"].hide(true)))
                .catch(error => this.handleVerificationErrors(error));
        }
    }
    validate() {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["LoadingSpinner"].show();
        if (this.files.length === 1) {
            let formData = new FormData();
            formData.set('apps', this.files[0]);
            this.api.fetch('api/app/validate', {
                method: 'POST',
                body: formData
            })
                .then(response => response.json())
                .then(data => {
                _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["LoadingSpinner"].hide(true);
                this.dialog.message('The app is validated!');
            })
                .catch(error => this.handleVerificationErrors(error));
        }
    }
    handleVerificationErrors(error) {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["LoadingSpinner"].hide(true);
        error.json().then(json => {
            let errors = json.message.split('\n');
            if (errors) {
                errors = errors.join('</li><li>');
                errors = `<ul><li>${errors}</li></ul>`;
            }
            else {
                errors = json.message;
            }
            this.dialog.message(`<b style="color:red;">The app has the following errors:</b> ${errors}`);
        });
    }
}


/***/ }),

/***/ "../apps/core/administration/src/pages/administration/apps/load-entities-dialog.ts":
/*!*****************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/apps/load-entities-dialog.ts ***!
  \*****************************************************************************************/
/*! exports provided: LoadEntitiesDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "LoadEntitiesDialog", function() { return LoadEntitiesDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let LoadEntitiesDialog = class LoadEntitiesDialog {
    constructor(dialog, server) {
        this.dialog = dialog;
        this.server = server;
        this.loading = true;
        this.showHide = {};
        this.view = () => `
<ux-dialog style="width: 600px;">
    <ux-dialog-header><h2>Load entities</h2></ux-dialog-header>
    <ux-dialog-body>
        <table class="full-width" if.bind="entities">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Class</th>
                    <th>Type</th>
                    <th></th>
                </tr>
            </thead>
            <tbody>
                <template repeat.for="e of entities">
                    <tr>
                        <td>#{e.name}</td>
                        <td>#{e.eClass}</td>
                        <td>#{e.type}</td>
                        <td><a click.delegate="showHide[e.name + e.eClass] = !showHide[e.name + e.eClass]">Show/hide Details</a></td>
                    </tr>
                    <tr if.bind="showHide[e.name + e.eClass]">
                        <td colspan="4"><pre>#{e | json}</pre></td>
                    </tr>
                </template>
            </tbody>
        </table>
    </ux-dialog-body>
    <ux-dialog-footer>
        <span class="loading" if.bind="loading">-</span>
        <button click.delegate="load()" disabled.bind="loading">Load</button>
        <button class="btn-link" click.delegate="dialog.cancel()">Cancel</button>
    </ux-dialog-footer>
</ux-dialog>
    `;
    }
    init(app) {
        this.app = app;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.entities = yield this.server.getJson('/api/app/entities/' + this.app.namespace + '/' + this.app.name + '/' + this.app.hash);
            this.loading = false;
        });
    }
    load() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading = true;
            yield this.server.postJson('/api/sync', {
                options: {
                    overrideAll: true
                },
                app: {
                    namespace: this.app.namespace,
                    name: this.app.name
                }
            });
            this.dialog.close();
        });
    }
};
LoadEntitiesDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], LoadEntitiesDialog);



/***/ }),

/***/ "./node_modules/string-natural-compare/natural-compare.js":
/*!****************************************************************!*\
  !*** ./node_modules/string-natural-compare/natural-compare.js ***!
  \****************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var alphabet;
var alphabetIndexMap;
var alphabetIndexMapLength = 0;

function isNumberCode(code) {
  return code >= 48 && code <= 57;
}

function naturalCompare(a, b) {
  var lengthA = (a += '').length;
  var lengthB = (b += '').length;
  var aIndex = 0;
  var bIndex = 0;

  while (aIndex < lengthA && bIndex < lengthB) {
    var charCodeA = a.charCodeAt(aIndex);
    var charCodeB = b.charCodeAt(bIndex);

    if (isNumberCode(charCodeA)) {
      if (!isNumberCode(charCodeB)) {
        return charCodeA - charCodeB;
      }

      var numStartA = aIndex;
      var numStartB = bIndex;

      while (charCodeA === 48 && ++numStartA < lengthA) {
        charCodeA = a.charCodeAt(numStartA);
      }
      while (charCodeB === 48 && ++numStartB < lengthB) {
        charCodeB = b.charCodeAt(numStartB);
      }

      var numEndA = numStartA;
      var numEndB = numStartB;

      while (numEndA < lengthA && isNumberCode(a.charCodeAt(numEndA))) {
        ++numEndA;
      }
      while (numEndB < lengthB && isNumberCode(b.charCodeAt(numEndB))) {
        ++numEndB;
      }

      var difference = numEndA - numStartA - numEndB + numStartB; // numA length - numB length
      if (difference) {
        return difference;
      }

      while (numStartA < numEndA) {
        difference = a.charCodeAt(numStartA++) - b.charCodeAt(numStartB++);
        if (difference) {
          return difference;
        }
      }

      aIndex = numEndA;
      bIndex = numEndB;
      continue;
    }

    if (charCodeA !== charCodeB) {
      if (
        charCodeA < alphabetIndexMapLength &&
        charCodeB < alphabetIndexMapLength &&
        alphabetIndexMap[charCodeA] !== -1 &&
        alphabetIndexMap[charCodeB] !== -1
      ) {
        return alphabetIndexMap[charCodeA] - alphabetIndexMap[charCodeB];
      }

      return charCodeA - charCodeB;
    }

    ++aIndex;
    ++bIndex;
  }

  return lengthA - lengthB;
}

naturalCompare.caseInsensitive = naturalCompare.i = function(a, b) {
  return naturalCompare(('' + a).toLowerCase(), ('' + b).toLowerCase());
};

Object.defineProperties(naturalCompare, {
  alphabet: {
    get: function() {
      return alphabet;
    },
    set: function(value) {
      alphabet = value;
      alphabetIndexMap = [];
      var i = 0;
      if (alphabet) {
        for (; i < alphabet.length; i++) {
          alphabetIndexMap[alphabet.charCodeAt(i)] = i;
        }
      }
      alphabetIndexMapLength = alphabetIndexMap.length;
      for (i = 0; i < alphabetIndexMapLength; i++) {
        if (alphabetIndexMap[i] === undefined) {
          alphabetIndexMap[i] = -1;
        }
      }
    },
  },
});

module.exports = naturalCompare;


/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ })

}]);
//# sourceMappingURL=index.e28d4943052103ad78ee.js.map