(window["webpackJsonpcom_scifeon_scifeon_administration"] = window["webpackJsonpcom_scifeon_scifeon_administration"] || []).push([["routePage_src/pages/administration/data-sync/index"],{

/***/ "../apps/core/administration/src/pages/administration/data-sync/index.html":
/*!*********************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/data-sync/index.html ***!
  \*********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"grid\">\r\n        <div class=\"panel full-width\" if.bind=\"!config.configuration.isCloud\">\r\n            <div class=\"panel-heading\">Synchronize Templates</div>\r\n            <div class=\"panel-body\" style=\"display: grid;grid-template-columns: 50% 49%;grid-gap: 10px;\">\r\n                <div>\r\n                    <h2>Save to disk</h2>\r\n                    <form>\r\n                        <div class=\"form-group\">\r\n                            <label>Filename</label>\r\n                            <input type=\"text\" value.bind=\"filename\"/>\r\n                        </div>\r\n                        <button class=\"float-right\" type=\"submit\" click.delegate=\"saveToDisk()\" disabled.bind=\"savingToDisk\">Save<span if.bind=\"savingToDisk\" class=\"loading\"> </span></button>\r\n                        <div if.bind=\"savedEntities.length\">\r\n                            <h3>Entities</h3>\r\n                            <table class=\"full-width\">\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th>Name</th>\r\n                                        <th>Class</th>\r\n                                        <th>Type</th>\r\n                                        <th>ExternalID</th>\r\n                                        <th>ExternalSystem</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <tr repeat.for=\"e of savedEntities\">\r\n                                        <td>${e.name}</td>\r\n                                        <td>${e.eClass}</td>\r\n                                        <td>${e.type}</td>\r\n                                        <td>${e.externalID}</td>\r\n                                        <td>${e.externalSystem}</td>\r\n                                    </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </form>\r\n                </div>\r\n                <div>\r\n                    <h2>Load from file</h2>\r\n                    <label repeat.for=\"f of filenames\" style=\"display: block;\">\r\n                        <input type=\"radio\" value.bind=\"f\" name=\"file\" checked.bind=\"selectedFilename\" click.delegate=\"selectedFilenameChanged(f)\" /> ${f}\r\n                    </label>\r\n                    <button class=\"float-right\" type=\"submit\" click.delegate=\"loadFromDisk()\" disabled.bind=\"!selectedFilename || loadingFromDisk\">Load<span if.bind=\"loadingFromDisk\" class=\"loading\"> </span></button>\r\n\r\n                    <div if.bind=\"fileEntities.length\">\r\n                        <h3>Entities</h3>\r\n                        <table class=\"full-width\">\r\n                            <thead>\r\n                                <tr>\r\n                                    <th>ID</th>\r\n                                    <th>Name</th>\r\n                                    <th>Class</th>\r\n                                    <th>Type</th>\r\n                                    <th>ExternalID</th>\r\n                                    <th>ExternalSystem</th>\r\n                                </tr>\r\n                            </thead>\r\n                            <tbody>\r\n                                <tr repeat.for=\"e of fileEntities\">\r\n                                    <td>${e.id}</td>\r\n                                    <td>${e.name}</td>\r\n                                    <td>${e.type}</td>\r\n                                    <td>${e.eClass}</td>\r\n                                    <td>${e.externalID}</td>\r\n                                    <td>${e.externalSystem}</td>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>    \r\n        \r\n        <div class=\"panel\" if.bind=\"!config.configuration.isCloud\">\r\n            <div class=\"panel-heading\">Prepare Compare Script</div>\r\n            <div class=\"panel-body\">\r\n                <p>Useful for comparing restored backup against original database.</p>\r\n                <form submit.trigger=\"downloadCompareScript()\">\r\n                    <div class=\"form-group\">\r\n                        <label>Original database name (this)</label>\r\n                        <input type=\"text\" value.bind=\"originalDatabaseName\"/>\r\n                    </div>\r\n                    <div class=\"form-group\">\r\n                        <label>Restored database name</label>\r\n                        <input type=\"text\" value.bind=\"restoredDatabaseName\"/>\r\n                    </div>\r\n                    <button type=\"submit\" class=\"float-right\" disabled.bind=\"!originalDatabaseName || !restoredDatabaseName || originalDatabaseName.toLowerCase().trim() === restoredDatabaseName.toLowerCase().trim()\">Download Script</button>\r\n                </form>\r\n            </div>                \r\n        </div> \r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/data-sync/index.ts":
/*!*******************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/data-sync/index.ts ***!
  \*******************************************************************************/
/*! exports provided: DataSynchronization */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataSynchronization", function() { return DataSynchronization; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! file-saver */ "./node_modules/file-saver/FileSaver.js");
/* harmony import */ var file_saver__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(file_saver__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");




let DataSynchronization = class DataSynchronization {
    constructor(server, datamodel) {
        this.server = server;
        this.datamodel = datamodel;
        this.config = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].get();
        this.savingToDisk = false;
        this.savedEntities = [];
        this.loadingFromDisk = false;
        this.filenames = [];
        this.fileEntities = [];
        this.selectedFilename = null;
        this.originalDatabaseName = 'Scifeon_';
        this.restoredDatabaseName = 'Scifeon_';
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.filenames = yield this.server.getJson('/api/sync/files');
            this.setFilename();
        });
    }
    selectedFilenameChanged(filename) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loadingFromDisk = true;
            this.selectedFilename = filename;
            const entities = yield this.server.getJson('/api/sync/file/' + this.selectedFilename);
            this.loadingFromDisk = false;
            this.fileEntities = entities;
            return true;
        });
    }
    saveToDisk() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.savingToDisk = true;
            const response = yield this.server.postJson('/api/sync/save', {
                filename: this.filename,
                query: {
                    eClass: 'Template'
                }
            });
            this.savedEntities = yield response.json();
            this.filenames.push(this.filename);
            this.setFilename();
            this.savingToDisk = false;
        });
    }
    loadFromDisk() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loadingFromDisk = true;
            const response = yield this.server.postJson('/api/sync', {
                filename: this.selectedFilename,
                options: {
                    overrideAll: true
                }
            });
            const json = yield response.json();
            this.fileEntities = json.updated.concat(json.inserted);
            this.loadingFromDisk = false;
        });
    }
    setFilename() {
        this.filename = this.config.configuration.name + '-' + this.config.configuration.env + '-' + new Date().getTime() + '.json';
    }
    downloadCompareScript() {
        const sqlBase = `
WITH {EXCEPT_CLAUSES}
SELECT CASE WHEN (
    SELECT SUM(r.diff)
    FROM 
        (REPLACE_WITH_DATAMODEL) r
) = 0
THEN 'Everything is OK!'
ELSE 'Some rows deviate'
END AS Result;
        `;
        const withClauses = this.datamodel.tables.map(t => `
        r_${t.group}_${t.name} AS (SELECT ${t.columns.map(c => c.name).join(',')} FROM {db1}.dbo.${t.group}_${t.name} EXCEPT SELECT ${t.columns.map(c => c.name).join(',')} FROM {db2}.dbo.${t.group}_${t.name})
        `).join(', ');
        const rowDiffs = this.datamodel.tables.map(t => `
        SELECT COUNT(*) AS diff FROM r_${t.group}_${t.name}
        `).join(' UNION ALL ');
        Object(file_saver__WEBPACK_IMPORTED_MODULE_2__["saveAs"])(new Blob([
            sqlBase.replace('{EXCEPT_CLAUSES}', withClauses)
                .replace('REPLACE_WITH_DATAMODEL', rowDiffs)
                .replace(/\{db1\}/g, this.originalDatabaseName)
                .replace(/\{db2\}/g, this.restoredDatabaseName)
        ], { type: 'application/sql' }), `Compare_Script_${this.originalDatabaseName}_${this.restoredDatabaseName}.sql`);
    }
};
DataSynchronization = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__["route"])({
        route: 'admin/data-sync',
        title: 'Data Synchronization',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_3__["PAGE_TYPE"].ADMINISTRATION
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DataModel"]])
], DataSynchronization);



/***/ }),

/***/ "./node_modules/file-saver/FileSaver.js":
/*!******************************************************************************************!*\
  !*** delegated ./node_modules/file-saver/FileSaver.js from dll-reference scifeon_vendor ***!
  \******************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/file-saver/FileSaver.js");

/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ })

}]);
//# sourceMappingURL=index.e28d4943052103ad78ee.js.map