(window["webpackJsonpcom_scifeon_scifeon_administration"] = window["webpackJsonpcom_scifeon_scifeon_administration"] || []).push([["routePage_src/pages/administration/plugins"],{

/***/ "../apps/core/administration/src/pages/administration/plugins.html":
/*!*************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/plugins.html ***!
  \*************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel\">\r\n        <div class=\"panel-heading\">Plugins</div>\r\n        <div class=\"panel-body\">\r\n\r\n            <div if.bind=\"isLoading\" class=\"empty panel\">\r\n                <h4 class=\"empty-title\">Loading plugins...</h4>\r\n                <div class=\"loading loading-lg\"></div>\r\n            </div>\r\n\r\n            <template repeat.for=\"type of pluginTypes\">\r\n                <h3>${type}</h3>\r\n                <table>\r\n                    <thead>\r\n                        <tr><th>Name</th><th>Description</th></tr>\r\n                    </thead>\r\n                    <tbody>\r\n                        <tr repeat.for=\"plugin of plugins[type]\">\r\n                            <td>${plugin.name}</td>\r\n                        </tr>\r\n                    </tbody>\r\n                </table>\r\n            </template>\r\n\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/plugins.ts":
/*!***********************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/plugins.ts ***!
  \***********************************************************************/
/*! exports provided: AdminPlugins */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AdminPlugins", function() { return AdminPlugins; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");


let AdminPlugins = class AdminPlugins {
    constructor(pluginManager) {
        this.pluginManager = pluginManager;
        this.isLoading = true;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.plugins = yield this.pluginManager.getAllPlugins();
            this.pluginTypes = [];
            for (let type in this.plugins) {
                this.plugins[type].sort((a, b) => a.name > b.name ? 1 : -1);
                this.pluginTypes.push(type);
            }
            this.pluginTypes.sort();
            this.isLoading = false;
        });
    }
};
AdminPlugins = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["route"])({
        route: 'admin/settings',
        title: 'Settings',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PAGE_TYPE"].ADMINISTRATION
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PluginManager"]])
], AdminPlugins);



/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ })

}]);
//# sourceMappingURL=plugins.e28d4943052103ad78ee.js.map