(window["webpackJsonpcom_scifeon_scifeon_administration"] = window["webpackJsonpcom_scifeon_scifeon_administration"] || []).push([["routePage_src/pages/administration/users/index"],{

/***/ "../apps/core/administration/src/pages/administration/users/index.html":
/*!*****************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/users/index.html ***!
  \*****************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"panel\">\r\n        <div class=\"panel-body\">\r\n            <button click.delegate=\"newUser()\">New user</button>\r\n\r\n            <table class=\"full-width\">\r\n                <thead>\r\n                    <tr>\r\n                        <th>ID</th>\r\n                        <th>Name</th>\r\n                        <th>E-mail</th>\r\n                        <th>Department</th>\r\n                        <th>Active</th>\r\n                        <th>Administrator</th>\r\n                        <th></th>\r\n                    </tr>\r\n                </thead>\r\n                <tbody>\r\n                    <tr repeat.for=\"user of users\" id=\"user-${user.id}\">\r\n                        <td><a href=\"/#/entity/user/${ user.id }\">${ user.id }</a></td>\r\n                        <td>${ user.name }</td>\r\n                        <td>${ user.email }</td>\r\n                        <td>${ user.departmentID }</td>\r\n                        <td>${ user.isActive }</td>\r\n                        <td>${ user.isAdmin }</td>\r\n                        <td>\r\n                            <a click.delegate=\"editUser(user)\" class=\"fa fa-pencil\" title=\"Edit\"></a> \r\n                            <a click.delegate=\"showQRCode(user)\" class=\"fa fa-qrcode\" title=\"Show Authenticator Code\"></a>\r\n                        </td>\r\n                    </tr>\r\n                </tbody>\r\n                <tfoot>\r\n                    <tr class=\"loading\" if.bind=\"loading\">\r\n                        <td colspan=\"6\"></td>\r\n                    </tr>\r\n                </tfoot>\r\n            </table>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/users/index.ts":
/*!***************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/users/index.ts ***!
  \***************************************************************************/
/*! exports provided: UsersIndex */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "UsersIndex", function() { return UsersIndex; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _qrcode_dialog__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./qrcode-dialog */ "../apps/core/administration/src/pages/administration/users/qrcode-dialog.ts");
/* harmony import */ var _user_dialog__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./user-dialog */ "../apps/core/administration/src/pages/administration/users/user-dialog.ts");







let UsersIndex = class UsersIndex {
    constructor(dialog, router, server) {
        this.dialog = dialog;
        this.router = router;
        this.server = server;
        this.users = [];
        this.loading = true;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'User', collection: 'users' }
            ]);
            this.loading = false;
            this.users = dataset.users;
        });
    }
    newUser() {
        this.editUser(null);
    }
    editUser(user) {
        this.dialog
            .open({
            view: __webpack_require__(/*! ./user-dialog.html */ "../apps/core/administration/src/pages/administration/users/user-dialog.html"),
            viewModel: _user_dialog__WEBPACK_IMPORTED_MODULE_6__["UserDialog"],
            model: { user: user }
        })
            .whenClosed(result => {
            if (!result.wasCancelled) {
                if (!user) {
                    this.router.navigate(window.location.hash, { replace: true });
                }
                else {
                    Object.assign(user, result.output);
                }
            }
        });
    }
    showQRCode(user) {
        this.dialog
            .open({
            view: __webpack_require__(/*! ./qrcode-dialog.html */ "../apps/core/administration/src/pages/administration/users/qrcode-dialog.html"),
            viewModel: _qrcode_dialog__WEBPACK_IMPORTED_MODULE_5__["QRCodeDialog"],
            model: { user: user }
        })
            .whenClosed(result => { });
    }
    determineActivationStrategy() {
        return aurelia_router__WEBPACK_IMPORTED_MODULE_4__["activationStrategy"].replace;
    }
};
UsersIndex = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'admin/users',
        title: 'Users',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PAGE_TYPE"].ADMINISTRATION
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"], aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], UsersIndex);



/***/ }),

/***/ "../apps/core/administration/src/pages/administration/users/qrcode-dialog.html":
/*!*************************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/users/qrcode-dialog.html ***!
  \*************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog style=\"width: 600px;\">\r\n        <ux-dialog-header><h1>Authenticator Code for ${user.id}</h1></ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <p>You can use either an iPhone or an Android Phone (e.g. a Samsung)</p>\r\n            <p>To sign you first need to download “Google Authenticator” to your smartphone from the App store.\r\n                Then you need to open it and click the “+” sign in the menu line and use the Scan Barcode\r\n                function to scan the barcode from the link in Scifeon to get 6-digit pincodes listed. After\r\n                that you can enter the 6-digit code shown under ScifeonTest. It is only the first time you open\r\n                Google Authenticator that you need to scan the QR code. A code is valid for 30 seconds before a\r\n                new one is displayed.\r\n            </p>\r\n\r\n            <h3>Instructions for Using a Windows Application</h3>\r\n            <p>Not ready, yet</p>\r\n\r\n            <h3>Authenticator Signature Info</h3>\r\n            <p class=\"text-center\"><img src.bind=\"qr\"/></p>\r\n            <p>Key: <input type=\"text\" value.bind=\"key\"/></p>\r\n\r\n            <h3>Verify Signature</h3>\r\n            <p>Enter the current 6-digit code in the App and click verify:</p>\r\n            <form>\r\n                <div class=\"input-group has-icon-right\">\r\n                    <input type=\"text\" placeholder=\"6-digit code\" value.bind=\"pin\" />\r\n                    <i if.bind=\"loading\" class=\"form-icon loading\"></i>\r\n                    <button type=\"submit\" class=\"input-group-btn\" title=\"Verify\" click.delegate=\"verify()\" disabled.bind=\"!pin\">Verify</button>\r\n                </div>\r\n            </form>\r\n            <p if.bind=\"valid\">Result: ${valid}</p>\r\n            \r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <span if.bind=\"loading\" class=\"loading\">-</span>\r\n            <button click.delegate=\"dialog.ok()\">Close</button>\r\n        </ux-dialog-footer> \r\n    </ux-dialog>   \r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/users/qrcode-dialog.ts":
/*!***********************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/users/qrcode-dialog.ts ***!
  \***********************************************************************************/
/*! exports provided: QRCodeDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "QRCodeDialog", function() { return QRCodeDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);



let QRCodeDialog = class QRCodeDialog {
    constructor(server) {
        this.server = server;
        this.loading = false;
    }
    init(model) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.user = model.user;
            const response = yield this.server.get('/api/authenticator/signature/' + this.user.id);
            const auth = yield response.json();
            this.key = auth.key;
            this.qr = auth.qr;
        });
    }
    verify() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading = true;
            const response = yield this.server.get('api/authenticator/check/' + this.pin + '/' + this.user.id);
            const check = yield response.json();
            this.valid = !check.valid ? 'The code is NOT valid!' : 'The code is valid!';
            this.loading = false;
        });
    }
};
QRCodeDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], QRCodeDialog);



/***/ }),

/***/ "../apps/core/administration/src/pages/administration/users/user-dialog.html":
/*!***********************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/users/user-dialog.html ***!
  \***********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog style=\"width: 500px;\">\r\n        <ux-dialog-header><h1>${header}</h1></ux-dialog-header>\r\n        <ux-dialog-body>\r\n\r\n            <div class=\"form-horizontal\" if.bind=\"isNew\">\r\n                <div class=\"form-group\" style=\"margin:0;\">\r\n                    <label>Is Customer?</label>\r\n                    <label class=\"form-switch\" style=\"grid-column: 2\">\r\n                        <input type=\"checkbox\" checked.bind=\"isCustomer\"/>\r\n                        <i class=\"form-icon\"></i>\r\n                    </label>\r\n                </div>\r\n            </div>\r\n\r\n            <entity-form if.bind=\"!isCustomer\" e-class=\"user\" fields.bind=\"fields\" object.bind=\"entity\" valid.bind=\"userValid\"></entity-form>\r\n\r\n            <entity-form if.bind=\"isCustomer\" e-class=\"user\" fields.bind=\"customerFields\" object.bind=\"entity\" valid.bind=\"userValid\"></entity-form>\r\n\r\n            <div class=\"form-horizontal\" if.bind=\"isNew\">\r\n                <div class=\"form-group\" if.bind=\"!isCustomer && config.windowsAuthentication\">\r\n                    <label>Use Windows Authentication?</label>\r\n                    <label class=\"form-switch\" style=\"grid-column: 2\">\r\n                        <input type=\"checkbox\" checked.bind=\"useWindowsAuthentication\"/>\r\n                        <i class=\"form-icon\"></i>\r\n                    </label>\r\n                </div>\r\n                <div class=\"form-group\" if.bind=\"!isCustomer && !useWindowsAuthentication\">\r\n                    <label>Send 'Create Password' mail?</label>\r\n                    <label class=\"form-switch\" style=\"grid-column: 2\">\r\n                        <input type=\"checkbox\" checked.bind=\"entity.sendConfirmationEmail\"/>\r\n                        <i class=\"form-icon\"></i>\r\n                    </label>\r\n                </div>\r\n                <div class=\"form-group\" if.bind=\"!useWindowsAuthentication\">\r\n                    <label>Password <span if.bind=\"isCustomer || !entity.sendConfirmationEmail\" title=\"Required\" class=\"required-indicator\">*</span></label>\r\n                    <input type=\"password\" value.bind=\"entity.newPassword & validate:passwordController\" disabled.bind=\"!isCustomer && entity.sendConfirmationEmail\" />\r\n                </div>\r\n            </div>\r\n            <div class=\"form-horizontal\" if.bind=\"!isNew\">\r\n                <div class=\"form-group\">\r\n                    <label>New password</label>\r\n                    <input type=\"password\" value.bind=\"entity.newPassword & validate:passwordController\" />\r\n                </div>\r\n            </div>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <span if.bind=\"loading\" class=\"loading\">-</span>\r\n            <button click.delegate=\"save()\" disabled.bind=\"!userValid || !passwordValid\">OK</button>\r\n            <button class=\"btn-link\" click.delegate=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer> \r\n    </ux-dialog>   \r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/administration/users/user-dialog.ts":
/*!*********************************************************************************!*\
  !*** ../apps/core/administration/src/pages/administration/users/user-dialog.ts ***!
  \*********************************************************************************/
/*! exports provided: UserDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "UserDialog", function() { return UserDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-validation */ "./node_modules/aurelia-validation/dist/commonjs/aurelia-validation.js");
/* harmony import */ var aurelia_validation__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_validation__WEBPACK_IMPORTED_MODULE_4__);





let UserDialog = class UserDialog {
    constructor(server, dialog, validator, controllerFactory) {
        this.server = server;
        this.validator = validator;
        this.entity = {};
        this.header = 'New user';
        this.loading = false;
        this.isNew = false;
        this.isCustomer = false;
        this.useWindowsAuthentication = false;
        this.fields = 'name,email,phone,departmentID,isActive,isAdmin';
        this.customerFields = 'customerID,name,email,phone,isActive';
        this.passwordValid = true;
        this.userValid = false;
        this.dialog = dialog;
        this.config = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].get().configuration;
        this.useWindowsAuthentication = this.config.windowsAuthentication;
        this.passwordController = controllerFactory.createForCurrentScope(validator);
        this.passwordController.validateTrigger = aurelia_validation__WEBPACK_IMPORTED_MODULE_4__["validateTrigger"].changeOrBlur;
    }
    init(model) {
        if (this.config.windowsAuthentication) {
            this.fields = 'alias,' + this.fields;
        }
        if (model.user) {
            this.entity = JSON.parse(JSON.stringify(model.user));
            this.header = 'Edit user: ' + this.entity.id;
            this.isCustomer = !!this.entity.customerID;
            this.userValid = true;
        }
        else {
            this.fields = 'id,' + this.fields;
            this.customerFields = 'id,' + this.customerFields;
            this.isNew = true;
            this.entity.isActive = true;
            this.entity.sendConfirmationEmail = true;
        }
        this.entity.newPassword = '';
        this.passwordRules = aurelia_validation__WEBPACK_IMPORTED_MODULE_4__["ValidationRules"].ensure('newPassword').displayName('Password').minLength(8).rules;
        this.passwordController.addObject(this, this.passwordRules);
        this.passwordController.subscribe(event => this.validatePassword(event));
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading = true;
            if (this.useWindowsAuthentication || this.isCustomer) {
                this.entity.sendConfirmationEmail = false;
            }
            if (this.useWindowsAuthentication) {
                this.entity.newPassword = '';
            }
            const response = yield this.server.postJson('/api/user', this.entity);
            this.dialog.ok(yield response.json());
        });
    }
    validatePassword(event) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (event.type === 'validate') {
                const results = yield this.validator.validateObject(this.entity, this.passwordRules);
                this.passwordValid = results.every(result => result.valid);
            }
            if (!this.entity.newPassword.trim().length) {
                this.passwordValid = !this.isNew || this.entity.sendConfirmationEmail;
            }
        });
    }
};
UserDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], aurelia_validation__WEBPACK_IMPORTED_MODULE_4__["Validator"], aurelia_validation__WEBPACK_IMPORTED_MODULE_4__["ValidationControllerFactory"]])
], UserDialog);



/***/ }),

/***/ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js":
/*!*****************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-router/dist/commonjs/aurelia-router.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");

/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ })

}]);
//# sourceMappingURL=index.e28d4943052103ad78ee.js.map