(window["webpackJsonpcom_scifeon_scifeon_administration"] = window["webpackJsonpcom_scifeon_scifeon_administration"] || []).push([["routePage_src/pages/data-administration/departments"],{

/***/ "../apps/core/administration/src/pages/data-administration/departments.html":
/*!**********************************************************************************!*\
  !*** ../apps/core/administration/src/pages/data-administration/departments.html ***!
  \**********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-sidebar right\">\r\n        <div class=\"page-panels\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-body\">\r\n                    <table class=\"full-width row-clickable\">\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                                <th></th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"dept of departments\" click.delegate=\"selectDepartment(dept)\">\r\n                                <td>${dept.name}</td>\r\n                                <td></td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>                    \r\n                </div>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"sidebar\">\r\n            <section>\r\n                <button if.bind=\"!newDept\" click.delegate=\"newDept = {}\">Create Department</button>\r\n                \r\n                <div if.bind=\"newDept\" class=\"header\">\r\n                    Create Department\r\n                </div>\r\n                <div if.bind=\"newDept\">\r\n                    <entity-form columns.bind=\"newDeptColumns\" \r\n                                 object.bind=\"newDept\" \r\n                                 horizontal.bind=\"false\"\r\n                                 valid.bind=\"newDeptValid\"></entity-form>\r\n                    <div class=\"text-right\">\r\n                        <button class=\"sm\" disabled.bind=\"!newDeptValid\" click.delegate=\"createNewDept()\">Save</button>\r\n                        <button class=\"sm cancel\" click.delegate=\"newDept = null\">Cancel</button>\r\n                    </div>\r\n                </div>\r\n            </section>\r\n\r\n            <section>\r\n                <div class=\"header\">\r\n                    Department\r\n                    <a click.delegate=\"deleteDepartment()\" class=\"fa fa-trash float-right\" title=\"Delete department\"></a>\r\n                </div>\r\n                <span if.bind=\"!department\" class=\"no-content\">Select a department</span>\r\n                <div else>\r\n                    <div class=\"form\">\r\n                        <div class=\"form-group\">\r\n                            <label>ID</label>\r\n                            ${department.id}\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Name</label>\r\n                            <inplace-edit-text validate.bind=\"validateDept\" entity.bind=\"department\" editable.bind=\"department.accessType === 'Write'\" key=\"name\"></inplace-edit-text>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </section>\r\n\r\n            <section>\r\n                <div class=\"header\">\r\n                    Members\r\n                </div>\r\n                <span if.bind=\"!department\" class=\"no-content\">Select a department</span>\r\n                <div else>\r\n                    <div class=\"loading\" if.bind=\"!department.members\"></div>\r\n                    <table class=\"full-width\" else>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"user of department.members\">\r\n                                <td>${user.name}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n\r\n                    <div class=\"text-right\" if.bind=\"user.hasRole('admin') && !newMember\">\r\n                        <button class=\"sm\" click.delegate=\"newMember = {}\">Add member</button>\r\n                    </div>\r\n                    \r\n                    <p if.bind=\"newMember\">\r\n                        <input-foreign-key  \r\n                            style=\"width:100%\"\r\n                            value.bind=\"newMember.id\"\r\n                            entity.bind=\"newMember\"\r\n                            placeholder=\"Select a user\" \r\n                            filters.bind=\"addMemberFilters\"\r\n                            e-class=\"User\">\r\n                        </input-foreign-key>\r\n                    </p>\r\n                    <div class=\"text-right\" if.bind=\"newMember\">\r\n                        <button class=\"sm\" disabled.bind=\"!newMember\" click.delegate=\"addMember()\">Add member</button>\r\n                        <button class=\"sm cancel\" click.delegate=\"newMember = null\">Cancel</button>\r\n                    </div>\r\n                </div>\r\n            </section>\r\n\r\n            <section>\r\n                <div class=\"header\">\r\n                    Access Control\r\n                </div>\r\n                <span if.bind=\"!department\" class=\"no-content\">Select a department</span>\r\n                <div else>\r\n                    <div class=\"loading\" if.bind=\"!department.ACL\"></div>\r\n                    <table class=\"full-width\" else>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                                <th>Access</th>\r\n                                <th></th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"acl of department.ACL\">\r\n                                <td>${acl.user.name}</td>\r\n                                <td>\r\n                                    <select if.bind=\"acl.userID === currentACL.userID\" value.bind=\"currentACL.accessType\">\r\n                                        <option>Read</option>\r\n                                        <option>Write</option>\r\n                                    </select>\r\n                                    <span else>${acl.accessType}</span>\r\n                                </td>\r\n                                <td>\r\n                                    <div if.bind=\"!acl.isMember && department.accessType === 'Write'\">\r\n                                        <div if.bind=\"acl.userID === currentACL.userID\">\r\n                                            <button class=\"sm\" click.delegate=\"saveACL()\" disabled.bind=\"acl.accessType === currentACL.accessType\">Save</button>\r\n                                            <button class=\"sm cancel\" click.delegate=\"currentACL = null\">Cancel</button>\r\n                                        </div>       \r\n                                        <div else>\r\n                                            <a class=\"fa fa-pencil\" title=\"Edit\" click.delegate=\"editACL(acl)\"></a>\r\n                                            <a class=\"fa fa-remove\" title=\"Remove\" click.delegate=\"removeACL(acl)\"></a>\r\n                                        </div>                             \r\n                                    </div>\r\n                                </td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table> \r\n\r\n                    <div class=\"text-right\" if.bind=\"department.accessType === 'Write' && !newACL\">\r\n                        <button class=\"sm\" click.delegate=\"newACL = { accessType: 'Read' }\">Add user</button>\r\n                    </div>\r\n                    <p if.bind=\"newACL\">\r\n                        <input-foreign-key  \r\n                            style=\"width:100%\"\r\n                            value.bind=\"newACL.userID\"\r\n                            entity.bind=\"newACL.user\"\r\n                            placeholder=\"Select a user\" \r\n                            filters.bind=\"addACLFilters\"\r\n                            e-class=\"User\">\r\n                        </input-foreign-key>\r\n                    </p>\r\n                    <p if.bind=\"newACL\">\r\n                        <select value.bind=\"newACL.accessType\">\r\n                            <option>Read</option>\r\n                            <option>Write</option>\r\n                        </select>\r\n                    </p>\r\n                    <div class=\"text-right\" if.bind=\"newACL\">\r\n                        <button class=\"sm\" click.delegate=\"addACL()\" disabled.bind=\"!newACL.userID\">Add user</button>\r\n                        <button class=\"sm cancel\" click.delegate=\"newACL = null\">Cancel</button>\r\n                    </div>\r\n                </div>\r\n            </section>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/data-administration/departments.ts":
/*!********************************************************************************!*\
  !*** ../apps/core/administration/src/pages/data-administration/departments.ts ***!
  \********************************************************************************/
/*! exports provided: Departments */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Departments", function() { return Departments; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_5__);






let Departments = class Departments {
    constructor(server, router, user, dialog) {
        this.server = server;
        this.router = router;
        this.user = user;
        this.dialog = dialog;
        this.departments = [];
        this.newDept = null;
        this.newDeptColumns = [
            {
                name: 'id',
                description: 'Auto-generated if empty',
                form: {
                    label: 'ID',
                    placeholder: 'Optional',
                    rules: [{
                            unique: {
                                eClass: 'Department',
                                field: 'id'
                            },
                            message: 'Department with this ID already exists.'
                        }]
                }
            },
            {
                name: 'name',
                form: {
                    label: 'Name',
                    isRequired: true
                }
            }
        ];
        this.currentACL = {};
    }
    init(context) {
        this.loadID = context.params.dept;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const result = yield this.server.getEntities('Department', null, [{ field: 'name' }]);
            this.departments.push(...result.data);
            if (this.loadID) {
                yield this.selectDepartment(this.departments.find(d => d.id === this.loadID));
            }
        });
    }
    selectDepartment(dept) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!dept)
                return;
            this.router.navigateToRoute(this.router.currentInstruction.config.name, { 'dept': dept.id }, { trigger: false, replace: false });
            this.department = dept;
            const result = yield this.server.getEntities('User', [{ field: 'DepartmentID', value: dept.id }], [{ field: 'name' }]);
            dept.members = result.data;
            yield this.loadACL();
        });
    }
    createNewDept() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const entity = {
                eClass: 'Department',
                name: this.newDept.name,
                id: this.newDept.id
            };
            const result = yield this.server.saveEntities([entity]);
            entity.id = result.newEntities[0].id;
            entity.accessType = 'Write';
            this.departments.push(entity);
            this.selectDepartment(entity);
            this.newDept = null;
        });
    }
    deleteDepartment() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (yield this.dialog.confirm(`Are you sure you want to delete the department: '${this.department.name}'`)) {
                yield this.server.delete(`/api/department/${this.department.id}`);
                this.departments = this.departments.filter(d => d.id !== this.department.id);
                this.department = null;
            }
        });
    }
    validateDept(input) {
        const valid = input.value.trim().length > 0;
        return { valid: valid, msg: valid ? '' : 'Required' };
    }
    get addMemberFilters() {
        return [{
                field: 'departmentID',
                op: 'neq',
                value: this.department.id
            }];
    }
    addMember() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let fromDept = this.departments.find(d => d.id === this.newMember.departmentID);
            fromDept = fromDept ? fromDept.name : this.newMember.departmentID;
            if (yield this.dialog.confirm(`Are you sure you want to move the user '${this.newMember.name}' from the department '${fromDept}' the current department?`)) {
                yield this.server.updateEntity({
                    eClass: 'User',
                    version: this.newMember.version,
                    id: this.newMember.id,
                    departmentID: this.department.id
                });
                this.department.members.push(JSON.parse(JSON.stringify(this.newMember)));
                this.newMember = null;
                yield this.loadACL();
            }
        });
    }
    get addACLFilters() {
        return [{
                field: 'id',
                op: 'not_in',
                values: this.department.ACL.map(a => a.userID)
            }];
    }
    addACL() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.server.postJson(`/api/department/${this.department.id}/access`, this.newACL);
            this.department.ACL.push(this.newACL);
            this.newACL = null;
        });
    }
    editACL(acl) {
        this.currentACL = JSON.parse(JSON.stringify(acl));
    }
    removeACL(acl) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (yield this.dialog.confirm(`Are you sure you want to remove access for the user: '${acl.user.name}'?`)) {
                yield this.server.delete(`/api/department/${acl.departmentID}/access/${acl.userID}`);
                this.department.ACL = this.department.ACL.filter(da => da.userID !== acl.userID);
            }
        });
    }
    saveACL() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.server.postJson(`/api/department/${this.department.id}/access`, this.currentACL);
            const acl = this.department.ACL.find(acl => acl.userID === this.currentACL.userID);
            Object.assign(acl, this.currentACL);
            this.currentACL = null;
        });
    }
    loadACL() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const acl = yield this.server.getJson(`/api/department/${this.department.id}/access`);
            this.department.ACL = acl;
        });
    }
};
Departments = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'data-admin/departments',
        title: 'Departments',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PAGE_TYPE"].DATA_ADMINISTRATION
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_5__["Router"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"]])
], Departments);



/***/ }),

/***/ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js":
/*!*****************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-router/dist/commonjs/aurelia-router.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");

/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ })

}]);
//# sourceMappingURL=departments.e28d4943052103ad78ee.js.map