(window["webpackJsonpcom_scifeon_scifeon_administration"] = window["webpackJsonpcom_scifeon_scifeon_administration"] || []).push([["routePage_src/pages/data-administration/projects"],{

/***/ "../apps/core/administration/src/pages/data-administration/projects.html":
/*!*******************************************************************************!*\
  !*** ../apps/core/administration/src/pages/data-administration/projects.html ***!
  \*******************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-sidebar right\">\r\n        <div class=\"page-panels\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-body\">\r\n                    <table class=\"full-width row-clickable\">\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                                <th></th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"proj of projects\" click.delegate=\"selectProject(proj)\">\r\n                                <td>${proj.name}</td>\r\n                                <td></td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>                    \r\n                </div>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"sidebar\">\r\n            <section>\r\n                <button if.bind=\"!newProject\" click.delegate=\"newProject = {}\">Create Project</button>\r\n                \r\n                <div if.bind=\"newProject\" class=\"header\">\r\n                    Create Project\r\n                </div>\r\n                <div if.bind=\"newProject\">\r\n                    <entity-form columns.bind=\"newProjectColumns\" \r\n                                 object.bind=\"newProject\" \r\n                                 horizontal.bind=\"false\"\r\n                                 valid.bind=\"newProjectValid\"></entity-form>\r\n                    <div class=\"text-right\">\r\n                        <button class=\"sm\" disabled.bind=\"!newProjectValid\" click.delegate=\"createNewProject()\">Save</button>\r\n                        <button class=\"sm cancel\" click.delegate=\"newProject = null\">Cancel</button>\r\n                    </div>\r\n                </div>\r\n            </section>\r\n\r\n            <section>\r\n                <div class=\"header\">\r\n                    Project\r\n                </div>\r\n                <span if.bind=\"!project\" class=\"no-content\">Select a project</span>\r\n                <div else>\r\n                    <div class=\"form\">\r\n                        <div class=\"form-group\">\r\n                            <label>Name</label>\r\n                            <inplace-edit-text validate.bind=\"validateProject\" entity.bind=\"project\" editable.bind=\"project.accessType === 'Write'\" key=\"name\"></inplace-edit-text>\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Description</label>\r\n                            <inplace-edit-textarea entity.bind=\"project\" editable.bind=\"project.accessType === 'Write'\" key=\"description\"></inplace-edit-textarea>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </section>\r\n\r\n            <section>\r\n                <div class=\"header\">\r\n                    User Access\r\n                </div>\r\n                <span if.bind=\"!project\" class=\"no-content\">Select a project</span>\r\n                <div else>\r\n                    <div class=\"loading\" if.bind=\"!project.ACL.users\"></div>\r\n                    <table class=\"full-width\" else>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                                <th>Access</th>\r\n                                <th></th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"acl of project.ACL.users\">\r\n                                <td>${acl.user.name}</td>\r\n                                <td>\r\n                                    <select if.bind=\"acl.userID === currentACL.userID\" value.bind=\"currentACL.accessType\">\r\n                                        <option>Read</option>\r\n                                        <option>Write</option>\r\n                                    </select>\r\n                                    <span else>${acl.accessType}</span>\r\n                                </td>\r\n                                <td>\r\n                                    <div if.bind=\"project.accessType === 'Write'\">\r\n                                        <div if.bind=\"acl.userID === currentACL.userID\">\r\n                                            <button class=\"sm\" click.delegate=\"saveACL()\" disabled.bind=\"acl.accessType === currentACL.accessType\">Save</button>\r\n                                            <button class=\"sm cancel\" click.delegate=\"currentACL = {}\">Cancel</button>\r\n                                        </div>       \r\n                                        <div else>\r\n                                            <a class=\"fa fa-pencil\" title=\"Edit\" click.delegate=\"editACL(acl)\"></a>\r\n                                            <a class=\"fa fa-remove\" title=\"Remove\" click.delegate=\"removeACL(acl)\"></a>\r\n                                        </div>                             \r\n                                    </div>\r\n                                </td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table> \r\n\r\n                    <div class=\"text-right\" if.bind=\"project.accessType === 'Write' && !newACLUser\">\r\n                        <button class=\"sm\" click.delegate=\"newACLUser = { accessType: 'Read' }\">Add user</button>\r\n                    </div>\r\n                    <div if.bind=\"newACLUser\">\r\n                        <p>\r\n                            <input-foreign-key  \r\n                                style=\"width:100%\"\r\n                                value.bind=\"newACLUser.userID\"\r\n                                entity.bind=\"newACLUser.user\"\r\n                                placeholder=\"Select a user\" \r\n                                filters.bind=\"addACLUserFilters\"\r\n                                e-class=\"User\">\r\n                            </input-foreign-key>\r\n                        </p>\r\n                        <p>\r\n                            <select value.bind=\"newACLUser.accessType\">\r\n                                <option>Read</option>\r\n                                <option>Write</option>\r\n                            </select>\r\n                        </p>\r\n                        <div class=\"text-right\">\r\n                            <button class=\"sm\" click.delegate=\"addACL(newACLUser)\" disabled.bind=\"!newACLUser.userID\">Add user</button>\r\n                            <button class=\"sm cancel\" click.delegate=\"newACLUser = null\">Cancel</button>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </section>\r\n\r\n            <section>\r\n                <div class=\"header\">\r\n                    Department Access\r\n                </div>\r\n                <span if.bind=\"!project\" class=\"no-content\">Select a project</span>\r\n                <div else>\r\n                    <div class=\"loading\" if.bind=\"!project.ACL.departments\"></div>\r\n                    <table class=\"full-width\" else>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                                <th>Access</th>\r\n                                <th></th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"acl of project.ACL.departments\">\r\n                                <td>${acl.department.name}</td>\r\n                                <td>\r\n                                    <select if.bind=\"currentACL && acl.departmentID === currentACL.departmentID\" value.bind=\"currentACL.accessType\">\r\n                                        <option>Read</option>\r\n                                        <option>Write</option>\r\n                                    </select>\r\n                                    <span else>${acl.accessType}</span>\r\n                                </td>\r\n                                <td>\r\n                                    <div if.bind=\"project.accessType === 'Write'\">\r\n                                        <div if.bind=\"acl.departmentID === currentACL.departmentID\">\r\n                                            <button class=\"sm\" click.delegate=\"saveACL()\" disabled.bind=\"acl.accessType === currentACL.accessType\">Save</button>\r\n                                            <button class=\"sm cancel\" click.delegate=\"currentACL = {}\">Cancel</button>\r\n                                        </div>       \r\n                                        <div else>\r\n                                            <a class=\"fa fa-pencil\" title=\"Edit\" click.delegate=\"editACL(acl)\"></a>\r\n                                            <a class=\"fa fa-remove\" title=\"Remove\" click.delegate=\"removeACL(acl)\"></a>\r\n                                        </div>                             \r\n                                    </div>\r\n                                </td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table> \r\n\r\n                    <div class=\"text-right\" if.bind=\"project.accessType === 'Write' && !newACLDept\">\r\n                        <button class=\"sm\" click.delegate=\"newACLDept = { accessType: 'Read' }\">Add department</button>\r\n                    </div>\r\n                    <div if.bind=\"newACLDept\">\r\n                        <p>\r\n                            <input-foreign-key  \r\n                                style=\"width:100%\"\r\n                                value.bind=\"newACLDept.departmentID\"\r\n                                entity.bind=\"newACLDept.department\"\r\n                                placeholder=\"Select a department\" \r\n                                filters.bind=\"addACLDepartmentFilters\"\r\n                                e-class=\"Department\">\r\n                            </input-foreign-key>\r\n                        </p>\r\n                        <p>\r\n                            <select value.bind=\"newACLDept.accessType\">\r\n                                <option>Read</option>\r\n                                <option>Write</option>\r\n                            </select>\r\n                        </p>\r\n                        <div class=\"text-right\">\r\n                            <button class=\"sm\" click.delegate=\"addACL(newACLDept)\" disabled.bind=\"!newACLDept.departmentID\">Add department</button>\r\n                            <button class=\"sm cancel\" click.delegate=\"newACLDept = null\">Cancel</button>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </section>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/core/administration/src/pages/data-administration/projects.ts":
/*!*****************************************************************************!*\
  !*** ../apps/core/administration/src/pages/data-administration/projects.ts ***!
  \*****************************************************************************/
/*! exports provided: Projects */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Projects", function() { return Projects; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_5__);






let Projects = class Projects {
    constructor(server, router, user, dialog) {
        this.server = server;
        this.router = router;
        this.user = user;
        this.dialog = dialog;
        this.projects = [];
        this.newProject = null;
        this.newProjectColumns = [
            {
                name: 'id',
                description: 'Auto-generated if empty',
                form: {
                    label: 'ID',
                    placeholder: 'Optional',
                    rules: [{
                            unique: {
                                eClass: 'Project',
                                field: 'id'
                            },
                            message: 'Project with this ID already exists.'
                        }]
                }
            },
            {
                name: 'name',
                form: {
                    label: 'Name',
                    isRequired: true
                }
            }
        ];
        this.currentACL = {};
    }
    init(context) {
        this.loadID = context.params.project;
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const result = yield this.server.getEntities('Project', null, [{ field: 'name' }]);
            this.projects.push(...result.data);
            if (this.loadID) {
                yield this.selectProject(this.projects.find(d => d.id === this.loadID));
            }
        });
    }
    selectProject(project) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!project)
                return;
            this.router.navigateToRoute(this.router.currentInstruction.config.name, { 'project': project.id }, { trigger: false, replace: false });
            this.project = project;
            yield this.loadACL();
        });
    }
    createNewProject() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const entity = {
                eClass: 'Project',
                name: this.newProject.name,
                id: this.newProject.id
            };
            const result = yield this.server.saveEntities([entity]);
            entity.id = result.newEntities[0].id;
            entity.accessType = 'Write';
            this.projects.push(entity);
            this.selectProject(entity);
            this.newProject = null;
        });
    }
    validateProject(input) {
        const valid = input.value.trim().length > 0;
        return { valid: valid, msg: valid ? '' : 'Required' };
    }
    get addACLUserFilters() {
        return [{
                field: 'id',
                op: 'not_in',
                values: this.project.ACL.users.map(a => a.userID)
            }];
    }
    get addACLDepartmentFilters() {
        return [{
                field: 'id',
                op: 'not_in',
                values: this.project.ACL.departments.map(a => a.departmentID)
            }];
    }
    addACL(acl) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.server.postJson(`/api/project/${this.project.id}/access`, acl);
            if (acl.departmentID) {
                this.project.ACL.departments.push(acl);
                this.newACLDept = null;
            }
            else {
                this.project.ACL.users.push(acl);
                this.newACLUser = null;
            }
        });
    }
    editACL(acl) {
        this.currentACL = JSON.parse(JSON.stringify(acl));
    }
    removeACL(acl) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (acl.departmentID) {
                if (yield this.dialog.confirm(`Are you sure you want to remove access for the department: '${acl.department.name}'?`)) {
                    yield this.server.delete(`/api/project/${this.project.id}/access/${acl.departmentID}`);
                    this.project.ACL.departments = this.project.ACL.departments.filter(da => da.departmentID !== acl.departmentID);
                }
            }
            else {
                if (yield this.dialog.confirm(`Are you sure you want to remove access for the user: '${acl.user.name}'?`)) {
                    yield this.server.delete(`/api/project/${this.project.id}/access/${acl.userID}`);
                    this.project.ACL.users = this.project.ACL.users.filter(da => da.userID !== acl.userID);
                }
            }
        });
    }
    saveACL() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.server.postJson(`/api/project/${this.project.id}/access`, this.currentACL);
            let acl;
            if (this.currentACL.departmentID) {
                acl = this.project.ACL.departments.find(acl => acl.departmentID === this.currentACL.departmentID);
            }
            else {
                acl = this.project.ACL.users.find(acl => acl.userID === this.currentACL.userID);
            }
            Object.assign(acl, this.currentACL);
            this.currentACL = null;
        });
    }
    loadACL() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const acl = yield this.server.getJson(`/api/project/${this.project.id}/access`);
            this.project.ACL = {
                users: acl.filter(a => a.userID),
                departments: acl.filter(a => a.departmentID)
            };
        });
    }
};
Projects = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'data-admin/projects',
        title: 'Projects',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PAGE_TYPE"].DATA_ADMINISTRATION
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_5__["Router"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"]])
], Projects);



/***/ }),

/***/ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js":
/*!*****************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-router/dist/commonjs/aurelia-router.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");

/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ })

}]);
//# sourceMappingURL=projects.e28d4943052103ad78ee.js.map