(window["webpackJsonpcom_scifeon_scifeon_apps_demo"] = window["webpackJsonpcom_scifeon_scifeon_apps_demo"] || []).push([["routePage_src/pages/element/chart"],{

/***/ "../apps/demo/demo_app/src/pages/element/chart.html":
/*!**********************************************************!*\
  !*** ../apps/demo/demo_app/src/pages/element/chart.html ***!
  \**********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header prototype\">\r\n        <div class=\"page-header\">\r\n            <h1>Scifeon Demo Pages</h1>\r\n        </div>\r\n\r\n        <div class=\"page-panels grid full-width-panels\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Chart Demo</div>\r\n                <div class=\"panel-body\">\r\n                    <p>\r\n                        This page shows the chart element. The chart element can be used to visualize a data array and can have one or more curving\r\n                        functions applied to it. The datapoints are interactive and can be excluded/included with a click.\r\n                    </p>\r\n                </div>\r\n            </div>\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Chart</div>\r\n                <div class=\"panel-body\">\r\n                    <chart options.bind=\"options\" type=\"xy\" legends=\"none\" exclusion-update.delegate=\"exclusionUpdate($event)\" series-group.bind=\"seriesGroup\"></chart>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/demo_app/src/pages/element/chart.ts":
/*!********************************************************!*\
  !*** ../apps/demo/demo_app/src/pages/element/chart.ts ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
const plugins_1 = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
let DemoChart = class DemoChart {
    constructor() {
        this.seriesGroup = [
            {
                name: 'dose response',
                chartLabel: 'Series 1',
                category: 'series',
                content: {
                    points: this.XYtransform([-6.3, -6, -5.3, -5, -4.3, -4, -3.3, -3, -2.3, -2, -1.3, -1, -0.3], [123479, 110649, 127387, 130880, 136712, 171019, 208878, 207138, 216282, 224935, 233195, 238302, 223352])
                }
            }
        ];
        this.options = {
            exists: true,
            refLines: [{ name: 'This is a reference line', valueY: 200000 }]
        };
        this.results = [
            {
                name: 'Series 1',
                chartLabel: 'Series 1',
                newValue: 5,
                category: 'results',
                parent: {
                    entity: {
                        content: {
                            points: [{ valueX: 1, valueY: 1 }, { valueX: 2, valueY: 4.5 }, { valueX: 3, valueY: 3.5 }]
                        }
                    }
                }
            },
            {
                name: 'Series 2',
                chartLabel: 'Series 2',
                newValue: 2,
                category: 'results',
                parent: {
                    entity: {
                        content: {
                            points: [{ valueX: 1, valueY: 1 }, { valueX: 2, valueY: 0.3 }, { valueX: 3, valueY: 1.8 }]
                        }
                    }
                }
            },
            {
                name: 'Series 3',
                chartLabel: 'Series 3',
                newValue: 8,
                category: 'results',
                parent: {
                    entity: {
                        content: {
                            points: [{ valueX: 1, valueY: 4 }, { valueX: 2, valueY: 4 }, { valueX: 3, valueY: 4 }]
                        }
                    }
                }
            }
        ];
    }
    exclusionUpdate(e) {
        e.detail.chart.updateChart();
    }
    XYtransform(valuesX, valuesY) {
        if (!valuesY) {
            let xValues = [];
            let yValues = [];
            for (let point of valuesX) {
                xValues.push(point.valueX);
                yValues.push(point.valueY);
            }
            return [xValues, yValues];
        }
        else {
            if (valuesX.length !== valuesY.length) {
                return;
            }
            let points = [];
            for (let i = 0; i < valuesX.length; i++) {
                points.push({ valueX: valuesX[i], valueY: valuesY[i] });
            }
            return points;
        }
    }
};
DemoChart = tslib_1.__decorate([
    plugins_1.route({
        route: 'demo/element/chart',
        title: 'Demo - Chart'
    })
], DemoChart);
exports.DemoChart = DemoChart;


/***/ })

}]);
//# sourceMappingURL=chart.5d0bc4c08e328465e5be.js.map