(window["webpackJsonpcom_scifeon_scifeon_apps_demo"] = window["webpackJsonpcom_scifeon_scifeon_apps_demo"] || []).push([["routePage_src/pages/element/dataset-query"],{

/***/ "../apps/demo/demo_app/src/pages/element/dataset-query.html":
/*!******************************************************************!*\
  !*** ../apps/demo/demo_app/src/pages/element/dataset-query.html ***!
  \******************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header prototype\">\r\n        <div class=\"page-header\">\r\n            <h1>Scifeon Demo Pages</h1>\r\n        </div>\r\n        <div class=\"page-panels grid full-width-panels\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Dataset Query Demo</div>\r\n                <div class=\"panel-body\">\r\n                    <p>\r\n                        This page shows how to extract data from the database to JavaScript using a querying function.\r\n                    </p>\r\n                    <p>\r\n                        You can see the documentation on how to use this function in your own scripts\r\n                        <a href=\"https://docs.scifeon.com/developer/http-api/endpoints/query#dataset\" target=\"_blank\">here</a>.\r\n                    </p>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Query</div>\r\n                <div class=\"panel-body\">\r\n                    <p>\r\n                        <textarea value.bind=\"query\"></textarea>\r\n                    </p>\r\n                    <p>\r\n                        <button class=\"primary\" click.delegate=\"runQuery()\">Run Query</button>\r\n                    </p>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Result</div>\r\n                <div class=\"panel-body\" innerhtml.bind=\"queryResult\">\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/demo_app/src/pages/element/dataset-query.ts":
/*!****************************************************************!*\
  !*** ../apps/demo/demo_app/src/pages/element/dataset-query.ts ***!
  \****************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
const core_1 = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
const plugins_1 = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
const aurelia_framework_1 = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
let DatasetQuery = class DatasetQuery {
    constructor(server) {
        this.server = server;
        this.query = JSON.stringify([{ eClass: 'Experiment', collection: 'exp', filters: [{ field: 'Status', value: 'Initial' }] }]);
        this.runQuery();
    }
    runQuery() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery(JSON.parse(this.query));
            this.queryResult = this.formatObject(dataset);
        });
    }
    formatObject(o) {
        if (!o)
            return '(-)';
        let result = '';
        if (Array.isArray(o)) {
            result = '<ul>\n';
            for (let i = 0; i < o.length; i++) {
                result += `<li>${i}: ${this.formatObject(o[i])}</li>\n`;
            }
            result += '</ul>\n';
        }
        else if (typeof o === 'string' || typeof o === 'number' || typeof o === 'boolean')
            result = '' + o;
        else {
            result = '<ul>\n';
            for (let key in o) {
                if (!o.hasOwnProperty(key))
                    continue;
                result += `<li>${key}: ${this.formatObject(o[key])}</li>\n`;
            }
            result += '</ul>\n';
        }
        return result;
    }
};
DatasetQuery = tslib_1.__decorate([
    aurelia_framework_1.autoinject,
    plugins_1.route({
        route: 'demo/element/dataset-query',
        title: 'Demo - Dataset Query'
    }),
    tslib_1.__metadata("design:paramtypes", [core_1.ServerAPI])
], DatasetQuery);
exports.DatasetQuery = DatasetQuery;


/***/ }),

/***/ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js":
/*!*********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js from dll-reference scifeon_data ***!
  \*********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");

/***/ }),

/***/ "./packages/core/index.ts":
/*!**************************************************************************!*\
  !*** delegated ./packages/core/index.ts from dll-reference scifeon_data ***!
  \**************************************************************************/
/*! exports provided: Config, ScifeonConsoleLogger, ConsoleLogger, Status, Event, DataModel, ReadExcelCommon, XL, LoadingSpinner, ScifeonLoadingSpinner, ServerAPI, User, UserHelper, DSUtils, DateUtils, MathUtils, PLATE, PluginUtils, ScifeonUtils, Utils, SdkUtils, SpreadsheetUtils */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_data */ "dll-reference scifeon_data"))("./packages/core/index.ts");

/***/ })

}]);
//# sourceMappingURL=dataset-query.5d0bc4c08e328465e5be.js.map