(window["webpackJsonpcom_scifeon_scifeon_apps_facs"] = window["webpackJsonpcom_scifeon_scifeon_apps_facs"] || []).push([["analyzer"],{

/***/ "../apps/module/facs/src/pages/analyzer.html":
/*!***************************************************!*\
  !*** ../apps/module/facs/src/pages/analyzer.html ***!
  \***************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <style>\r\n        .failed {\r\n            background-color: #f00;\r\n            color: #fff;\r\n            font-weight: bold;\r\n        }\r\n        .accepted {\r\n            background-color: #6f6;\r\n            font-weight: bold;\r\n        }\r\n        p.failed {\r\n            padding-left: 5px;\r\n        }\r\n        table.facs {\r\n            table-layout: fixed;\r\n        }\r\n        table.facs td, table.facs th {\r\n            padding-left: 6px;\r\n            padding-right: 6px;\r\n        }\r\n        tr.detail td, tr.detail th {\r\n            padding-left: 0;\r\n            padding-right: 0;\r\n        }\r\n        tr.detail td:first-child, tr.detail th:first-child {\r\n            padding-left: 6px;\r\n            padding-right: 6px;\r\n        }\r\n        table.facs-detail {\r\n            font-size: 85%;\r\n        }\r\n        table.facs-detail th {\r\n            white-space: nowrap;\r\n        }\r\n        table.facs-detail td.block, table.facs-detail th.block {\r\n            border-left: none;\r\n        }\r\n        td.detail {\r\n            padding: 3px 5px;\r\n            background-color: #ddd;\r\n        }\r\n        table.facs span.fa:not(.fa-exclamation-circle) {\r\n            cursor: pointer;\r\n        }\r\n    </style>\r\n\r\n    <div if.bind=\"analyzerFailure\">\r\n        <div class=\"page-header\">\r\n            <h1>FACS Analyzer &ndash; <a target=\"_blank\" href=\"/#/eln/${experiment.id}\">${experiment.name}</a></h1>\r\n        </div>\r\n        <div class=\"page-panels grid\">\r\n            <div class=\"panel\">\r\n                <div class=\"panel-body\" id=\"failureMessage\">${failureMessage}</div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n    <div if.bind=\"hasResults\">\r\n        <div class=\"page-header\">\r\n            <h1>FACS Analyzer</h1>\r\n            <button id=\"button-save\" click.delegate=\"save()\">Save Results</button>\r\n        </div>\r\n\r\n        <div class=\"page-panels grid\">\r\n            <div class=\"panel\" style=\"grid-column: span 2\">\r\n                <div class=\"panel-heading\"><span>Experiment</span><collapsible /></div>\r\n                <div class=\"panel-body\">\r\n\r\n                    <div class=\"view-group\">\r\n                        <label>Name</label>\r\n                        <p><a _target=\"blank\" href=\"/#/eln/${experiment.id}\">${experiment.name}</a></p>\r\n                    </div>\r\n\r\n                    <div class=\"view-group\">\r\n                        <label>MTR</label>\r\n                        <p>${experiment.attributes.mtr}</p>\r\n                    </div>\r\n    \r\n                    <div class=\"view-group\">\r\n                        <label>SOP</label>\r\n                        <p>${experiment.setup.bnSOP} - ${experiment.setup.bnSOPVersion}</p>\r\n                    </div>\r\n\r\n                    <div class=\"view-group\">\r\n                        <label>Positive control</label>\r\n                        <p>${experiment.setup.posControl}</p>\r\n                    </div>\r\n            \r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\" style=\"grid-column: span 2\">\r\n                <div class=\"panel-heading\">\r\n                    <span>Experiment Acceptance Criteria</span>\r\n                    <span if.bind=\"!isRegulated\" style=\"font-weight:normal;\">\r\n                        Mode:\r\n                        <label><input type=\"radio\" model.bind=\"expSetup.bnAcceptanceCriteriaVariant\" checked.bind=\"'US'\" click.delegate=\"changeCellCountAnalysis()\"/>US</label>\r\n                        <label><input type=\"radio\" model.bind=\"expSetup.bnAcceptanceCriteriaVariant\" checked.bind=\"'DE'\" click.delegate=\"changeCellCountAnalysis()\"/>DE</label>\r\n                    </span> \r\n                    <collapsible />\r\n                </div>\r\n                <div class=\"panel-body\">\r\n                    <h3>Check Cell Quantification</h3>\r\n                    <div if.bind=\"expSetup.bnAcceptanceCriteriaVariant === 'US'\">\r\n                        <p>Cell Count Acceptance Criteria: <b>${result.acceptCellsPrWell ? 'Passed' : 'Failed'}</b></p>\r\n                        <p>Cells pr Well Used for Titer Calc: <b>${result.avgCellsPrWell | fixed:0}</b></p>\r\n                        <table>\r\n                            <thead>\r\n                                <tr>\r\n                                    <th>Tube selection</th>\r\n                                    <th class=\"number\">Avg</th>\r\n                                    <th class=\"number\">SD</th>\r\n                                    <th class=\"number\">RSD (%)</th>\r\n                                </tr>\r\n                            </thead>\r\n                            <tbody>\r\n                                <tr css=\"background-color: ${result.us.wellsAll.selected ? '#6f6' : '#fff'};\">\r\n                                    <td>All Wells</td>\r\n                                    <td class=\"number\">${result.us.wellsAll.avg | fixed:0}</td>\r\n                                    <td class=\"number\">${result.us.wellsAll.stdev | fixed:2}</td>\r\n                                    <td class=\"number\">${result.us.wellsAll.rsd | fixed:2}</td>\r\n                                </tr>\r\n                                <tr css=\"background-color: ${result.us.wellsInc.selected ? '#6f6' : '#fff'};\">\r\n                                    <td>< 30% infected></td>\r\n                                    <td class=\"number\">${result.us.wellsInc.avg | fixed:0}</td>\r\n                                    <td class=\"number\">${result.us.wellsInc.stdev | fixed:2}</td>\r\n                                    <td class=\"number\">${result.us.wellsInc.rsd | fixed:2}</td>\r\n                                </tr>\r\n                                <tr css=\"background-color: ${result.us.wellsTop50.selected ? '#6f6' : '#fff'};\">\r\n                                    <td>Top 50%</td>\r\n                                    <td class=\"number\">${result.us.wellsTop50.avg | fixed:0}</td>\r\n                                    <td class=\"number\">${result.us.wellsTop50.stdev | fixed:2}</td>\r\n                                    <td class=\"number\">${result.us.wellsTop50.rsd | fixed:2}</td>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n\r\n                        <div css=\"display: ${showUSCellCountDetails ? 'none' : 'block'}\">\r\n                            <button class=\"btn-link\" click.trigger=\"toggleUSCellCountDetails()\">Show Details</button>\r\n                        </div>\r\n                        <div css=\"display: ${showUSCellCountDetails ? 'block' : 'none'}\">\r\n                            <button class=\"btn-link\" click.trigger=\"toggleUSCellCountDetails()\">Hide Details</button>\r\n                            <table>\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th>Culture Sample</th>\r\n                                        <th class=\"number\">Volume</th>\r\n                                        <th class=\"number\">US Cell Count</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <tr repeat.for=\"csi of result.cultureSampleInfos\">\r\n                                        <td>${csi.id}</td>\r\n                                        <td class=\"number\">${csi.volumeAcquired_nl}</td>\r\n                                        <td class=\"number\">${csi.usCellCount | fixed:0}</td>\r\n                                    </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </div>\r\n                    <div else>\r\n                        <div class=\"view-group\">\r\n                            <label>Average Cells per Well</label>\r\n                            <p class=\"result-avg-cell-count\">${result.avgCellsPrWell | exponential}</p>\r\n                        </div>\r\n    \r\n                        <div class=\"view-group\">\r\n                            <label>%CV, Cells per Well</label>\r\n                            <p class=\"result-cv-cell-count ${ result.acceptCellsPrWellCV ? 'succeeded' : 'failed' }\">${result.pctCellsPrWellCV | significant}</p>\r\n                        </div>\r\n    \r\n                        <div class=\"view-group\">\r\n                            <label>Minimum Cells per Well</label>\r\n                            <p class=\"result-min-cell-count ${ result.acceptCellsPrWell ? 'succeeded' : 'failed' }\">${result.minCellsPrWell | exponential}</p>\r\n                        </div>\r\n    \r\n                        <div class=\"view-group\">\r\n                            <label>Maximum Cells per Well</label>\r\n                            <p class=\"result-max-cell-count\">${result.maxCellsPrWell | exponential}</p>\r\n                        </div>\r\n\r\n                    </div>\r\n                    <div style=\"margin-top: 15px; padding-top: 20px; border-top: 2px solid #aaa;\">\r\n                        <h3>Blank Controls</h3>\r\n                        <table class=\"blanks\">\r\n                            <thead>\r\n                                <tr>\r\n                                    <th>Marker</th>\r\n                                    <th>Avg Pos Cells (%)</th>\r\n                                    <th>Acceptance</th>\r\n                                </tr>\r\n                            </thead>\r\n                            <tbody>\r\n                                <tr repeat.for=\"sti of result.stainInfos\">\r\n                                    <td>${sti.label}</td>\r\n                                    <td>${result.blanksAvg[sti.id].avg | fixed}</td>\r\n                                    <td>${result.blanksAvg[sti.id].accept ? 'Passed' : 'Failed'}</td>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel accept-criteria\">\r\n                <div class=\"panel-heading\"><span>Acceptance Criteria</span> <collapsible default=\"collapsed\" /></div>\r\n                <div class=\"panel-body\">\r\n\r\n                    <template if.bind=\"isRegulated\">\r\n                        <div class=\"view-group\">\r\n                            <label>Min-n</label>\r\n                            <p class=\"ac-min-accepted-tubes\">${expSetup.bnMinAcceptedTubes}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Min positive cells (%)</label>\r\n                            <p class=\"ac-min-pct-pos-cells\">${expSetup.bnPctMinPositiveCells}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Max positive cells (%)</label>\r\n                            <p class=\"ac-max-pct-pos-cells\">${expSetup.bnPctMaxPositiveCells}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Max Cells pr Well CV (%)</label>\r\n                            <p class=\"ac-max-cell-count-cv\">${expSetup.bnPctMaxCellsPrWellCV}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Min Cells pr Well</label>\r\n                            <p class=\"ac-min-cell-count\">${expSetup.bnMinCellsPrWell | exponential}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Max Inf.U CV (%)</label>\r\n                            <p class=\"ac-max-inf-cv\">${expSetup.bnPctMaxInfUCV}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Ignore Titer CV for Txg</label>\r\n                            <p class=\"ac-max-inf-cv\">${expSetup.bnIgnoreTxgCV}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Min Inf.U, positive control</label>\r\n                            <p class=\"ac-min-pos-ctrl-inf\">${expSetup.bnMinPosControlInfU | exponential}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Max Inf.U, positive control</label>\r\n                            <p class=\"ac-max-pos-ctrl-inf\">${expSetup.bnMaxPosControlInfU | exponential}</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Min Txg Co-expression</label>\r\n                            <p class=\"ac-min-txg-cox\">${ expSetup.bnMinTxgCox }</p>\r\n                        </div>\r\n                        <div class=\"view-group\">\r\n                            <label>Min Txg.U / Inf.U ratio</label>\r\n                            <p class=\"ac-min-txg-inf-ratio\">${expSetup.bnMinTxgInfURatio}</p>\r\n                        </div>\r\n                        <div class=\"view-group\" repeat.for=\"key of expSetup.bnMinTxgInfURatios | objectKeys\">\r\n                            <label>Min Txg.U / Inf.U ratio: ${key}</label>\r\n                            <p class=\"ac-min-txg-inf-ratio-${key}\">${expSetup.bnMinTxgInfURatios[key]}</p>\r\n                        </div>\r\n                    </template>\r\n\r\n                    <template if.bind=\"!isRegulated\">\r\n                        <div class=\"form-group\">\r\n                            <label>Min-n</label>\r\n                            <input-number containerless class=\"ac-min-accepted-tubes\" value.bind=\"expSetup.bnMinAcceptedTubes\" keyup.delegate=\"update()\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Min positive cells (%)</label>\r\n                            <input-number containerless class=\"ac-min-pct-pos-cells\" value.bind=\"expSetup.bnPctMinPositiveCells\" keyup.delegate=\"update()\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Max positive cells (%)</label>\r\n                            <input-number containerless class=\"ac-max-pct-pos-cells\" value.bind=\"expSetup.bnPctMaxPositiveCells\" keyup.delegate=\"update()\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Max Cells pr Well CV (%)</label>\r\n                            <input-number containerless class=\"ac-max-cell-count-cv\" value.bind=\"expSetup.bnPctMaxCellsPrWellCV\" keyup.delegate=\"update()\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Min Cells pr Well</label>\r\n                            <input-number containerless class=\"ac-min-cell-count\" value.bind=\"expSetup.bnMinCellsPrWell\" keyup.delegate=\"update()\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Max Inf.U CV (%)</label>\r\n                            <input-number containerless class=\"ac-max-inf-cv\" value.bind=\"expSetup.bnPctMaxInfUCV\" keyup.delegate=\"update()\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Min Inf.U, positive control</label>\r\n                            <input-number containerless class=\"ac-min-pos-ctrl-inf\" value.bind=\"expSetup.bnMinPosControlInfU\" keyup.delegate=\"update()\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Max Inf.U, positive control</label>\r\n                            <input-number containerless class=\"ac-max-pos-ctrl-inf\" value.bind=\"expSetup.bnMaxPosControlInfU\" keyup.delegate=\"update()\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Min Txg Co-expression</label>\r\n                            <input-number containerless class=\"ac-min-txg-cox\" value.bind=\"expSetup.bnMinTxgCox\" keyup.delegate=\"update()\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Min Txg.U / Inf.U ratio</label>\r\n                            <input-number containerless class=\"ac-min-txg-inf-ratio\" value.bind=\"expSetup.bnMinTxgInfURatio\" keyup.delegate=\"update()\" />\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <label>Min Txg.U / Inf.U ratios</label>\r\n                            <dictionary-editor\r\n                                class=\"ac-min-txg-inf-ratios\"\r\n                                object.bind=\"expSetup.bnMinTxgInfURatios\"\r\n                                type=\"number\"\r\n                                placeholder=\"New Txg.U / Inf.U ratio\"\r\n                                change.delegate=\"update()\"></dictionary-editor>\r\n                        </div>\r\n                    </template>\r\n                </div>\r\n            </div>\r\n            <style>\r\n                .fixedcol {\r\n                    position: absolute;\r\n                    width: 160px;\r\n                    left: 0;\r\n                    padding-top:1px;\r\n                    margin-top: 1px;\r\n                }\r\n                div.fixed-col-container {\r\n                    overflow-x: auto;\r\n                    margin-left: 160px;\r\n                }\r\n                table.facs th {\r\n                    white-space: nowrap;\r\n                }\r\n                table.facs-detail th:not(.number) {\r\n                    padding-right: 5px;\r\n                }\r\n                table.facs td.number, table.facs th.number {\r\n                    padding-left: 5px !important;\r\n                }\r\n            </style>\r\n            <div class=\"panel full-width\">\r\n                <div class=\"panel-heading\">\r\n                    <span>Titer Results</span>\r\n                    <span><button class=\"small\" click.delegate=\"expandAll()\">Expand All</button></span>\r\n                    <span><button class=\"small\" click.delegate=\"collapseAll()\">Collapse All</button></span>\r\n                    <collapsible />\r\n                </div>\r\n                <div class=\"panel-body\">                    \r\n                    <div style=\"position: relative\">\r\n                    <div class=\"fixed-col-container\">\r\n                    <table class=\"facs\">\r\n                        <thead>\r\n                            <tr>\r\n                                <th class=\"fixedcol\">Sample</th>\r\n                                <th class=\"number\" style=\"width: 30px;\">n</th>\r\n                                <th class=\"number\" style=\"width: 75px;\">Inf.U.</th>\r\n                                <th class=\"number\" style=\"width: 55px;\">%CV</th>\r\n                                <th style=\"width: 40px; text-align: center\">Pos</th>\r\n                                <th></th>\r\n                                <template repeat.for=\"popI of result.txgInfos\">\r\n                                    <th class=\"block number\" style=\"width: 85px;\">${popI.label}</th>\r\n                                    <th class=\"number\" style=\"width: 55px;\">%CV</th>\r\n                                    <th class=\"number\" style=\"width: 55px;\">Ratio</th>\r\n                                </template>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <template repeat.for=\"tsi of result.testSampleInfos\">\r\n                                <tr data-tsi-name=\"${tsi.name}\" class=\"tsi\" style=\"border-top: 2px solid #d3e0ea;\">\r\n                                    <td class=\"fixedcol\" css=\"background-color: ${tsi.accepted ? '#fff' : '#ff0' };\">\r\n                                        <span click.delegate=\"toggleDetails(tsi)\" class=\"fa fa-toggle-off\" if.bind=\"!tsi.detailsVisible\" title=\"Show details\"></span>\r\n                                        <span click.delegate=\"toggleDetails(tsi)\" class=\"fa fa-toggle-on\" if.bind=\"tsi.detailsVisible\" title=\"Hide details\"></span>\r\n                                        ${tsi.name}\r\n                                    </td>\r\n                                    <td class=\"${tsi.acceptedNTubes ? 'accepted' : 'failed'} number\">${tsi.n}</td>\r\n                                    <td class=\"number ${tsi === tsi.tsiPosControl ? (tsi.acceptedPosControlInfU ? 'accepted' : 'failed') : ''}\">\r\n                                        ${tsi.averageTiterPrML[result.popInfU.id] | significant}</td>\r\n                                    <td class=\"${tsi.acceptedCVInfU ? 'accepted' : 'failed'} number\">\r\n                                        ${tsi.cvTiterPrML[result.popInfU.id] | significant}\r\n                                    </td>\r\n                                    <td class=\"${tsi.acceptedPosControlInfU ? 'accepted' : 'failed'}\"></td>\r\n                                    <td class=\"${tsi.acceptedPosControlInfU ? 'accepted' : 'failed'}\"></td>\r\n                                    <template repeat.for=\"popI of result.txgInfos\">\r\n                                        <td class=\"block number\">${tsi.averageTiterPrML[popI.id] | significant}</td>\r\n                                        <td class=\"${tsi.acceptedCVTxgU[popI.id] ? 'accepted' : 'failed'} number\">${tsi.cvTiterPrML[popI.id] | significant}</td>\r\n                                        <td class=\"${tsi.acceptedRatioTxgInfU[popI.id] ? 'accepted' : 'failed'} number\">${tsi.ratioTxgInfU[popI.id] | significant}</td>\r\n                                    </template>\r\n                                </tr>\r\n                                <tr class=\"detail\" css=\"display: ${tsi.detailsVisible ? 'table-row' : 'none'};\">\r\n                                    <td class=\"detail fixedcol\">\r\n                                        <table class=\"facs-detail\" style=\"table-layout: fixed;\">\r\n                                            <thead>\r\n                                                <tr>\r\n                                                    <th>Culture</th>\r\n                                                    <th></th>\r\n                                                    <th class=\"number\">Tube#</th>\r\n                                                </tr>\r\n                                            </thead>\r\n                                            <tbody>\r\n                                                <tr class=\"csi\" repeat.for='csi of tsi.cultureSampleInfos'>\r\n                                                    <td css.bind=\"csi.exclude ? 'background-color: #ff0' : ''\">\r\n                                                        ${csi.id}\r\n                                                    </td>\r\n                                                    <td style=\"padding-left: 2px;white-space: nowrap;\">\r\n                                                        <span if.bind=\"csi.exclude\" class=\"fa fa-check-circle\" click.delegate=\"toggleExclude(csi, tsi, csi.exclude, 'InfU')\" title=\"Include Inf.U.\"></span>\r\n                                                        <span else class=\"fa fa-times-circle\" click.delegate=\"toggleExclude(csi, tsi, csi.exclude, 'InfU')\" title=\"Exclude Inf.U.\"></span>\r\n                                                        <span if.bind=\"csi.manualExclude['InfU'] !== undefined\" class=\"fa fa-exclamation-circle\" title=\"Manually ${csi.manualExclude['InfU'] ? 'ex' : 'in'}cluded\"></span>\r\n                                                    </td>\r\n                                                    <td class=\"number\">${getTubeNo(csi)}</td>\r\n                                                </tr>\r\n                                            </tbody>\r\n                                        </table>    \r\n                                        <template if.bind=\"!tsi.accepted\">\r\n                                            <h3>&nbsp;</h3>\r\n                                            <ul style=\"margin: 0;list-style:none;\">\r\n                                                <li repeat.for=\"error of tsi.acceptErrors\">&nbsp;</li>\r\n                                            </ul>\r\n                                        </template>\r\n                                        <template if.bind=\"tsi.manualExIncludes.length\">\r\n                                            <h3>&nbsp;</h3>\r\n                                            <ul style=\"margin: 0;list-style:none;\">\r\n                                                <li repeat.for=\"csi of tsi.manualExIncludes\">&nbsp;</li>\r\n                                            </ul>\r\n                                        </template>                    \r\n                                    </td>\r\n                                    <td colspan=\"4\" class=\"detail\">\r\n                                        <table class=\"facs-detail\" style=\"table-layout: fixed;margin-right: 3px;\">\r\n                                            <thead>\r\n                                                <tr>\r\n                                                    <th class=\"number\" style=\"width: 50px;\" title=\"Pre-dilution\">Pre-D</th>\r\n                                                    <th class=\"number\" style=\"width: 55px;\">Dilution</th>\r\n                                                    <th class=\"number\" style=\"width: 65px;\">Viable</th>\r\n                                                    <th class=\"number\" style=\"width: 65px;\">Vol (nl)</th>\r\n                                                    <th class=\"number\" style=\"width: 65px;\">Cells/well</th>\r\n                                                    <th></th>\r\n                                                    <th class=\"number\" style=\"width: 65px;\">% pos</th>\r\n                                                    <th class=\"number\" style=\"width: 85px;\">w/o BG</th>\r\n                                                    <th class=\"number\" style=\"width: 85px;\">Titer / ml</th>\r\n                                                </tr>\r\n                                            </thead>\r\n                                            <tbody>\r\n                                                <tr class=\"csi\" repeat.for='csi of tsi.cultureSampleInfos'>\r\n                                                    <td class=\"number pre-d\">${csi.sample.attributes.preDilution}</td>\r\n                                                    <td class=\"number\">${csi.sample.attributes.foldDilution}</td>\r\n                                                    <td class=\"number\"\r\n                                                        css.bind=\"csi.invalidCellCount ? 'background-color: #f00; color: #fff;' : ''\">\r\n                                                        ${csi.usCellCount ? csi.usCellCount : csi.cellCount}\r\n                                                    </td>\r\n                                                    <td class=\"number\">${csi.volumeAcquired_nl}</td>\r\n                                                    <td class=\"number totalCellsPrWell\"\r\n                                                        css.bind=\"csi.excludeCount ? 'background-color: #ff0;' : ''\">\r\n                                                        ${csi.totalCellsPrWell | exponential}\r\n                                                    </td>                                                    \r\n                                                    <td style=\"padding-left: 2px;white-space: nowrap;\">  \r\n                                                        <div if.bind=\"csi.allowExcludeCount\">\r\n                                                            <span if.bind=\"csi.excludeCount\" class=\"fa fa-check-circle\" click.delegate=\"toggleExclude(csi, tsi, csi.excludeCount, 'Count')\" title=\"Include count\"></span>\r\n                                                            <span else class=\"fa fa-times-circle\" click.delegate=\"toggleExclude(csi, tsi, csi.excludeCount, 'Count')\" title=\"Exclude count\"></span>\r\n                                                            <span if.bind=\"csi.manualExclude['Count'] !== undefined\" class=\"fa fa-exclamation-circle\" title=\"Manually ${csi.manualExclude['Count'] ? 'ex' : 'in'}cluded\"></span>\r\n                                                        </div>                                                      \r\n                                                    </td>\r\n                                                    <td class=\"number\">${csi.results[result.popInfU.id].raw | fixed:2}</td>\r\n                                                    <td class=\"number woBG\"\r\n                                                        css.bind=\"csi.results[result.popInfU.id].failed ? 'background-color: #f00; color: #fff;' : ''\">\r\n                                                        ${csi.results[result.popInfU.id].woBackground | fixed:2}\r\n                                                    </td>\r\n                                                    <td class=\"number titer-infU\">${csi.results[result.popInfU.id].titerPrML | exponential}</td>                                                    \r\n                                                </tr>\r\n                                            </tbody>\r\n                                        </table>                                        \r\n                                        <template if.bind=\"!tsi.accepted\">\r\n                                            <h3>Acceptance failures:</h3>\r\n                                            <ul style=\"margin: 0;\">\r\n                                                <li repeat.for=\"error of tsi.acceptErrors\">${error}</li>\r\n                                            </ul>\r\n                                        </template>\r\n                                        <template if.bind=\"tsi.manualExIncludes.length\">\r\n                                            <h3>Manually excluded/included:</h3>\r\n                                            <ul style=\"margin: 0;\">\r\n                                                <li repeat.for=\"mei of tsi.manualExIncludes\">\r\n                                                    ${mei.csi}, ${mei.type}, manually ${mei.exclude ? 'ex' : 'in'}cluded: ${mei.reason}\r\n                                                </li>\r\n                                            </ul>\r\n                                        </template>\r\n                                    </td>\r\n                                    <td class=\"detail\"></td>\r\n                                    <td class=\"block detail\" colspan=\"3\" style=\"padding-right: 6px;\"\r\n                                        repeat.for=\"popI of result.txgInfos\">\r\n                                        <table class=\"facs-detail\">\r\n                                            <thead>\r\n                                                <tr>\r\n                                                    <th if.bind=\"$index === 0\"></th>\r\n                                                    <th class=\"number block\" style=\"width: 65px;\">% pos</th>\r\n                                                    <th class=\"number\" style=\"width: 65px;\">w/o BG</th>\r\n                                                    <th class=\"number\" style=\"width: 65px;\">Titer / ml</th>\r\n                                                    <!--<th></th>-->\r\n                                                </tr>\r\n                                            </thead>\r\n                                            <tbody>\r\n                                                <tr repeat.for=\"csi of tsi.cultureSampleInfos\" css.bind=\"csi.excludeTxg ? 'background-color: #ff0;' : ''\">\r\n                                                    <td style=\"padding-left: 2px;white-space: nowrap;\" if.bind=\"$parent.$index === 0\">\r\n                                                        <div if.bind=\"csi.allowExcludeTxg\">\r\n                                                            <span if.bind=\"csi.excludeTxg\" class=\"fa fa-check-circle\" click.delegate=\"toggleExclude(csi, tsi, csi.excludeTxg, 'Txg')\" title=\"Include Txg tube\"></span>\r\n                                                            <span else class=\"fa fa-times-circle\" click.delegate=\"toggleExclude(csi, tsi, csi.excludeTxg, 'Txg')\" title=\"Exclude Txg tube\"></span>\r\n                                                            <span if.bind=\"csi.manualExclude['Txg'] !== undefined\" class=\"fa fa-exclamation-circle\" title=\"Manually ${csi.manualExclude['Txg'] ? 'ex' : 'in'}cluded\"></span>\r\n                                                        </div>\r\n                                                    </td>\r\n                                                    <td class=\"number block\">\r\n                                                        ${csi.results[popI.id].raw | significant}\r\n                                                    </td>\r\n                                                    <td class=\"number\"\r\n                                                        css.bind=\"csi.results[popI.id].failed ? 'background-color: #f00; color: #fff;' : ''\">\r\n                                                        ${csi.results[popI.id].woBackground | significant}\r\n                                                    </td>\r\n                                                    <td class=\"number\">\r\n                                                        ${csi.results[popI.id].titerPrML | exponential}\r\n                                                    </td>\r\n                                                    <!--<td style=\"padding-left: 2px;white-space: nowrap;\">                                                        \r\n                                                        <span if.bind=\"csi.excludePop[popI.id]\" class=\"fa fa-check-circle\" click.delegate=\"toggleExclude(csi, tsi, csi.excludePop[popI.id], popI)\" title=\"Include\"></span>\r\n                                                        <span else class=\"fa fa-times-circle\" click.delegate=\"toggleExclude(csi, tsi, csi.excludePop[popI.id], popI)\" title=\"Exclude\"></span>\r\n                                                        <span if.bind=\"csi.manualExclude['pop-'+popI.id] !== undefined\" class=\"fa fa-exclamation-circle\" title=\"Manually ${csi.manualExclude['pop-'+popI.id] ? 'ex' : 'in'}cluded\"></span>\r\n                                                    </td>-->\r\n                                                </tr>\r\n                                            </tbody>\r\n                                        </table>\r\n                                    </td>\r\n                                </tr>\r\n                            </template>\r\n                        </tbody>\r\n                    </table>\r\n                    </div></div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel full-width cox-results\" if.bind=\"result.coXInfos.length\">\r\n                <div class=\"panel-heading\">\r\n                    <span>Co-expression Results</span>\r\n                    <span><button class=\"small\" click.delegate=\"expandAll()\">Expand All</button></span>\r\n                    <span><button class=\"small\" click.delegate=\"collapseAll()\">Collapse All</button></span>\r\n                    <collapsible />\r\n                </div>\r\n                <div class=\"panel-body\">\r\n                    <table class=\"facs\">\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Sample</th>\r\n                                <th class=\"block\" if.bind=\"result.coXInfos.length\">Txg CoX</th>\r\n                                <template repeat.for=\"popI of result.coXInfos\">\r\n                                    <th class=\"block number\" css=\"width: 85px;\">${popI.label}</th>\r\n                                    <th class=\"number\" style=\"width: 55px;\">SD</th>\r\n                                </template>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <template repeat.for=\"tsi of result.testSampleInfos\">\r\n                                <tr data-tsi-name=\"${tsi.name}\" class=\"tsi\" style=\"border-top: 2px solid #d3e0ea;\">\r\n                                    <td css=\"background-color: ${tsi.accepted ? '#fff' : '#ff0' };\">\r\n                                        <span click.delegate=\"toggleDetails(tsi)\" class=\"fa fa-toggle-off\" css=\"display: ${tsi.detailsVisible ? 'none' : 'initial'};\" title=\"Show details\"></span>\r\n                                        <span click.delegate=\"toggleDetails(tsi)\" class=\"fa fa-toggle-on\" css=\"display: ${tsi.detailsVisible ? 'initial' : 'none'};\" title=\"Hide details\"></span>\r\n                                        ${tsi.name}\r\n                                    </td>\r\n                                    <td class=\"block ${tsi.acceptedTxgCox ? '' : 'failed'}\" if.bind=\"result.coXInfos.length\">${tsi.pctTxgCoX | significant:4}</td>\r\n                                    <template repeat.for=\"popI of result.coXInfos\">\r\n                                        <td class=\"block number\">\r\n                                            ${tsi.averageCoX[popI.id] | significant:4}\r\n                                        </td>\r\n                                        <td class=\"number\">\r\n                                            ${tsi.stdevCoX[popI.id] | fixed:2}\r\n                                        </td>\r\n                                    </template>\r\n                                </tr>\r\n                                <tr class=\"detail\" css=\"display: ${tsi.detailsVisible ? 'table-row' : 'none'};\">\r\n                                    <td class=\"detail\">\r\n                                        <table class=\"facs-detail\" style=\"table-layout: fixed;\">\r\n                                            <thead>\r\n                                                <tr>\r\n                                                    <th>Culture</th>\r\n                                                    <th class=\"number\">Tube#</th>\r\n                                                </tr>\r\n                                            </thead>\r\n                                            <tbody>\r\n                                                <tr class=\"csi\" repeat.for='csi of tsi.cultureSampleInfos'>\r\n                                                    <td css.bind=\"csi.excludeTxg ? 'background-color: #ff0' : ''\">\r\n                                                        ${csi.id}\r\n                                                    </td>\r\n                                                    <td class=\"number\">${getTubeNo(csi)}</td>\r\n                                                </tr>\r\n                                            </tbody>\r\n                                        </table>                       \r\n                                    </td>\r\n                                    <td class=\"block detail\" if.bind=\"result.coXInfos.length\">&nbsp;</td>\r\n                                    <td class=\"block detail\" colspan=\"2\" style=\"padding-right: 6px;\"\r\n                                        repeat.for=\"popI of result.coXInfos\">\r\n                                        <table class=\"facs-detail\">\r\n                                            <thead>\r\n                                                <tr>\r\n                                                    <th class=\"number block\" style=\"width: 65px;\">% Parent</th>\r\n                                                </tr>\r\n                                            </thead>\r\n                                            <tbody>\r\n                                                <tr repeat.for=\"csi of tsi.cultureSampleInfos\">\r\n                                                    <td class=\"number block\">\r\n                                                        ${csi.results[popI.id].entity.pctParent | significant}\r\n                                                    </td>\r\n                                                </tr>\r\n                                            </tbody>\r\n                                        </table>\r\n                                    </td>\r\n                                </tr>\r\n                            </template>\r\n                        </tbody>\r\n                    </table>\r\n                    <div class=\"view-group\">\r\n                        <label>Total CoX, positive controls (%)</label>\r\n                        <p>${result.pctPosControlTotalCoX | fixed:2}</p>\r\n                    </div> \r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel full-width\">\r\n                <div class=\"panel-heading\">Notes</div>\r\n                <div class=\"panel-body\">\r\n                    <rich-text-editor value.bind=\"note\" placeholder=\"Enter note here...\"></rich-text-editor>\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n</template>\r\n";

/***/ }),

/***/ "../apps/module/facs/src/pages/analyzer.ts":
/*!*************************************************!*\
  !*** ../apps/module/facs/src/pages/analyzer.ts ***!
  \*************************************************/
/*! exports provided: AppFlowCytDataAnalyzer */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AppFlowCytDataAnalyzer", function() { return AppFlowCytDataAnalyzer; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _facs__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../facs */ "../apps/module/facs/src/facs.ts");
/* harmony import */ var _popups_include_exclude_tube__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../popups/include-exclude-tube */ "../apps/module/facs/src/popups/include-exclude-tube.ts");
/* harmony import */ var _processing_analyzer_calc__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ../processing/analyzer-calc */ "../apps/module/facs/src/processing/analyzer-calc.ts");
/* harmony import */ var _processing_analyzer_result__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ../processing/analyzer-result */ "../apps/module/facs/src/processing/analyzer-result.ts");










let AppFlowCytDataAnalyzer = class AppFlowCytDataAnalyzer {
    constructor(server, router, dialog) {
        this.server = server;
        this.router = router;
        this.dialog = dialog;
        this.note = '';
        this.hasResults = false;
        this.analyzerFailure = false;
        this.failureMessage = '';
        this.showUSCellCountDetails = false;
        this.isRegulated = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].get().configuration.isRegulated;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadResults(context.params.id, context.params.existingID);
        });
    }
    loadResults(resultSetID, existingResultSetID) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            const datasetQuery = [
                { eClass: 'ResultSet', alias: 'rs', filters: [{ field: 'ID', value: resultSetID }] },
                { eClass: 'Step', alias: 'step', filters: [{ field: 'ID', value: '$rs.OriginID' }] },
                { eClass: 'Step', collection: 'allSteps', filters: [{ field: 'ExperimentID', value: '$step.ExperimentID' }] },
                { eClass: 'ResultSet', collection: 'allRS', filters: [{ field: 'OriginID', in: 'allSteps.ID' }] },
                { eClass: 'Experiment', alias: 'exp', filters: [{ field: 'ID', value: '$step.ExperimentID' }] },
                { eClass: 'ResultFACSPopulation', collection: 'populations', filters: [{ field: 'ResultSetID', value: resultSetID }] },
                { eClass: 'ResultFACSTube', collection: 'tubes', filters: [{ field: 'ResultSetID', value: resultSetID }] },
                { eClass: 'ResultFACSCount', collection: 'counts', filters: [{ field: 'ResultSetID', value: resultSetID }] },
                { eClass: 'ResultFACSGatingSet', collection: 'gatingSets', filters: [{ field: 'ResultSetID', value: resultSetID }] },
                { eClass: 'Sample', collection: 'samples', filters: [{ field: 'OriginID', value: '$step.ParentID' }], sortings: [{ field: 'id' }] },
                { eClass: 'Plate', collection: 'stainingPlates', filters: [{ field: 'OriginID', value: '$step.ParentID' }], sortings: [{ field: 'id' }] },
                {
                    view: 'StepSampleInput', collection: 'testSamples', filters: [
                        { field: 'Type', value: 'FACS-Input' },
                        { field: 'StepID', in: 'allSteps.ID' }
                    ]
                },
                { view: 'FACSResults', collection: 'results', filters: [{ field: 'ResultSetID', value: resultSetID }] },
                { eClass: 'Template', collection: 'templates', filters: [{ field: 'Type', values: _facs__WEBPACK_IMPORTED_MODULE_6__["FACS"].AllTemplateTypes }] }
            ];
            if (existingResultSetID) {
                datasetQuery.push({ eClass: 'ResultSet', entity: 'existingRS', filters: [{ field: 'ID', value: existingResultSetID }] });
                datasetQuery.push({ eClass: 'ResultIntermediate', entity: 'manualExIncludes', filters: [{ field: 'ResultSetID', value: existingResultSetID }, { field: 'Type', value: _facs__WEBPACK_IMPORTED_MODULE_6__["FACS"].ResultTypeManualExIncludes }] });
            }
            const dataset = yield this.server.datasetQuery(datasetQuery);
            this.experiment = dataset.exp;
            this.stepAcquisition = dataset.step;
            this.rsPopulations = dataset.rs;
            this.expSetup = dataset.exp.setup;
            if (dataset.existingRS) {
                this.expSetup = dataset.existingRS.setup;
            }
            this.result = new _processing_analyzer_result__WEBPACK_IMPORTED_MODULE_9__["AnalyzerResult"](dataset);
            if (this.result.failed) {
                this.analyzerFailure = true;
                this.failureMessage = this.result.failureMessage;
                _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
                return;
            }
            this.calc = new _processing_analyzer_calc__WEBPACK_IMPORTED_MODULE_8__["AnalyzerCalc"](this.expSetup, this.result);
            this.rsTiter = {
                eClass: 'ResultSet',
                id: '#idRS',
                status: _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].IN_PROGRESS,
                name: this.generateRSName(dataset.allRS),
                type: _facs__WEBPACK_IMPORTED_MODULE_6__["FACS"].RSTypeTiter,
                originID: this.stepAcquisition.id,
                setup: this.expSetup,
                parents: [this.rsPopulations.id],
                attributes: {
                    failureCauses: ''
                }
            };
            this.update();
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
            this.hasResults = true;
        });
    }
    generateRSName(allRS) {
        const baseName = `RS-${this.experiment.name}-Titer`;
        if (!allRS.find(rs => rs.name === baseName)) {
            return baseName;
        }
        for (let suffix = 2; suffix < 100; suffix++) {
            let name = baseName + '-' + suffix;
            if (!allRS.find(rs => rs.name === name)) {
                return name;
            }
        }
        return baseName + '-100';
    }
    update() {
        this.calc.update();
    }
    changeCellCountAnalysis() {
        this.expSetup.bnAcceptanceCriteriaVariant = this.expSetup.bnAcceptanceCriteriaVariant === 'DE' ? 'US' : 'DE';
        this.update();
        return true;
    }
    toggleExclude(csi, tsi, exclude, mod) {
        const type = typeof mod === 'string' ? mod : 'pop-' + mod.id;
        const manualExInclude = tsi.manualExIncludes.find(e => e.csi === csi.id && e.type === type);
        if (manualExInclude) {
            csi.manualExclude[type] = undefined;
            tsi.manualExIncludes = tsi.manualExIncludes.filter(i => i !== manualExInclude);
            this.update();
        }
        else {
            this.dialog.open({
                viewModel: _popups_include_exclude_tube__WEBPACK_IMPORTED_MODULE_7__["ManualIncludeExclude"],
                model: {
                    header: `Manually ${csi.exclude ? 'in' : 'ex'}clude: ${csi.id}`
                }
            }).whenClosed(result => {
                if (!result.wasCancelled) {
                    csi.manualExclude[type] = !exclude;
                    tsi.manualExIncludes.push({
                        csi: csi.id,
                        exclude: csi.manualExclude[type],
                        reason: result.output,
                        type: type,
                        tsi: tsi.sample.id
                    });
                    this.update();
                }
            });
        }
    }
    toggleUSCellCountDetails() {
        this.showUSCellCountDetails = !this.showUSCellCountDetails;
    }
    toggleDetails(sampleInfo) {
        sampleInfo.detailsVisible = !sampleInfo.detailsVisible;
    }
    expandAll() {
        this.result.testSampleInfos.forEach(tsi => tsi.detailsVisible = true);
    }
    collapseAll() {
        this.result.testSampleInfos.forEach(tsi => tsi.detailsVisible = false);
    }
    getTubeNo(csi) {
        let tubeNo = NaN;
        if (csi.tubeInfos instanceof Array && csi.tubeInfos.length) {
            tubeNo = parseInt(csi.tubeInfos[0].name.replace('Tube_', ''));
        }
        return Number.isNaN(tubeNo) ? '-' : tubeNo;
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            if (!this.result.acceptCellsPrWell) {
                this.rsTiter.status = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].FAILED;
                this.rsTiter.attributes.failureCauses += 'Failed Cell Count\n';
            }
            if (!this.result.acceptCellsPrWellCV) {
                this.rsTiter.status = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].FAILED;
                this.rsTiter.attributes.failureCauses += 'Failed Cell Count CV\n';
            }
            if (!this.result.acceptBlanks) {
                this.rsTiter.status = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].FAILED;
                this.rsTiter.attributes.failureCauses += 'Failed Blank < 2%\n';
            }
            let entities = [this.rsTiter];
            if (this.note) {
                this.rsTiter.notes = [{
                        content: this.note,
                        type: 'Note'
                    }];
            }
            for (let tsi of this.result.testSampleInfos) {
                let sample = tsi.sample;
                if (!sample)
                    sample = tsi.tubeInfos[0].sample;
                let resultStatus = tsi.accepted ? _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].OK : _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].FAILED;
                if (this.rsTiter.status === _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].FAILED)
                    resultStatus = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].FAILED;
                for (let popInfo of this.result.stainInfos) {
                    entities.push({
                        eClass: 'ResultValue',
                        resultSetID: '#idRS',
                        status: resultStatus,
                        type: 'FACS-Titer-' + popInfo.label,
                        subjectID: sample.id,
                        subjectClass: 'Sample',
                        valueText: tsi.averageTiterPrML[popInfo.id] || '-',
                        valueFloat: tsi.averageTiterPrML[popInfo.id],
                        pctCV: tsi.cvTiterPrML[popInfo.id],
                        stdev: tsi.stdevTiterPrML[popInfo.id],
                        n: tsi.n,
                        attributes: {
                            failureCauses: tsi.acceptErrors.join('\n'),
                            manualExIncludes: tsi.manualExIncludes.map(mei => `${mei.csi}, ${mei.type}, manually ${mei.exclude ? 'ex' : 'in'}cluded: ${mei.reason}`).join('\n')
                        }
                    });
                }
                if (this.result.coXInfos.length > 0) {
                    entities.push({
                        eClass: 'ResultValue',
                        resultSetID: '#idRS',
                        status: resultStatus,
                        type: _facs__WEBPACK_IMPORTED_MODULE_6__["FACS"].ResultTypeTotalCoX,
                        subjectID: sample.id,
                        subjectClass: 'Sample',
                        valueText: tsi.pctTxgCoX,
                        valueFloat: tsi.pctTxgCoX,
                        n: tsi.n,
                        attributes: {
                            failureCauses: tsi.acceptErrors.join('\n')
                        }
                    });
                    for (let popInfo of this.result.coXInfos) {
                        entities.push({
                            eClass: 'ResultValue',
                            resultSetID: '#idRS',
                            status: resultStatus,
                            type: 'FACS-CoX-' + popInfo.label,
                            subjectID: sample.id,
                            subjectClass: 'Sample',
                            valueText: tsi.averageCoX[popInfo.id],
                            valueFloat: tsi.averageCoX[popInfo.id],
                            stdev: tsi.stdevCoX[popInfo.id],
                            n: tsi.n,
                            attributes: {
                                failureCauses: tsi.acceptErrors.join('\n')
                            }
                        });
                    }
                }
            }
            if (this.result.coXInfos.length > 0) {
                entities.push({
                    eClass: 'ResultValue',
                    resultSetID: '#idRS',
                    status: this.rsTiter.status,
                    type: _facs__WEBPACK_IMPORTED_MODULE_6__["FACS"].ResultTypePosControlsTotalCoX,
                    subjectID: '#idRS',
                    subjectClass: 'ResultSet',
                    valueText: this.result.pctPosControlTotalCoX,
                    valueFloat: this.result.pctPosControlTotalCoX,
                });
            }
            entities.push({
                eClass: 'ResultIntermediate',
                resultSetID: '#idRS',
                status: this.rsTiter.status,
                type: _facs__WEBPACK_IMPORTED_MODULE_6__["FACS"].ResultTypeManualExIncludes,
                content: [].concat.apply([], this.result.testSampleInfos.map(tsi => tsi.manualExIncludes))
            });
            yield this.server.saveEntities(entities);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
            this.router.navigate(`eln/${this.experiment.id}`);
        });
    }
    cleanSetupObject() {
        if (typeof this.expSetup.bnMinAcceptedTubes === 'string')
            this.expSetup.bnMinAcceptedTubes = parseInt(this.expSetup.bnMinAcceptedTubes);
        if (typeof this.expSetup.bnPctMinPositiveCells === 'string')
            this.expSetup.bnPctMinPositiveCells = parseFloat(this.expSetup.bnPctMinPositiveCells);
        if (typeof this.expSetup.bnPctMaxPositiveCells === 'string')
            this.expSetup.bnPctMaxPositiveCells = parseFloat(this.expSetup.bnPctMaxPositiveCells);
        if (typeof this.expSetup.bnMinTxgInfURatio === 'string')
            this.expSetup.bnMinTxgInfURatio = parseFloat(this.expSetup.bnMinTxgInfURatio);
        if (typeof this.expSetup.bnPctMaxInfUCV === 'string')
            this.expSetup.bnPctMaxInfUCV = parseFloat(this.expSetup.bnPctMaxInfUCV);
        if (typeof this.expSetup.bnMinPosControlInfU === 'string')
            this.expSetup.bnMinPosControlInfU = parseFloat(this.expSetup.bnMinPosControlInfU);
        if (typeof this.expSetup.bnMaxPosControlInfU === 'string')
            this.expSetup.bnMaxPosControlInfU = parseFloat(this.expSetup.bnMaxPosControlInfU);
    }
};
AppFlowCytDataAnalyzer = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'facs/analyzer/:id/:existingID?',
        title: 'FACS Analyzer',
        chunk: 'analyzer'
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], aurelia_router__WEBPACK_IMPORTED_MODULE_5__["Router"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"]])
], AppFlowCytDataAnalyzer);



/***/ }),

/***/ "../apps/module/facs/src/popups/include-exclude-tube.ts":
/*!**************************************************************!*\
  !*** ../apps/module/facs/src/popups/include-exclude-tube.ts ***!
  \**************************************************************/
/*! exports provided: ManualIncludeExclude */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ManualIncludeExclude", function() { return ManualIncludeExclude; });
class ManualIncludeExclude {
    constructor() {
        this.reason = '';
        this.view = () => `
<ux-dialog>
    <ux-dialog-header>
        <h2>#{header}</h2>
    </ux-dialog-header>
    <ux-dialog-body>
        <div class="form-group">
            <label>Please, state a reason:</label>
            <textarea attach-focus="true" value.bind="reason" style="width: 400px;height: 140px;"></textarea>
        </div>
    </ux-dialog-body>
    <ux-dialog-footer>
        <button disabled.bind="!reason" click.delegate="dialog.ok(reason)">OK</button>
        <button class="btn-link" click.delegate="dialog.cancel()">Cancel</button>
    </ux-dialog-footer>
</ux-dialog>`;
    }
    init(model) {
        this.header = model.header;
    }
}


/***/ }),

/***/ "../apps/module/facs/src/processing/analyzer-calc.ts":
/*!***********************************************************!*\
  !*** ../apps/module/facs/src/processing/analyzer-calc.ts ***!
  \***********************************************************/
/*! exports provided: AnalyzerCalc */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AnalyzerCalc", function() { return AnalyzerCalc; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _facs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../facs */ "../apps/module/facs/src/facs.ts");


class AnalyzerCalc {
    constructor(expSetup, result) {
        this.expSetup = expSetup;
        this.result = result;
    }
    update() {
        let acVariant = this.expSetup.bnAcceptanceCriteriaVariant;
        let acceptBlanks = true;
        for (let sti of this.result.stainInfos) {
            const blanks = this.result.cultureSampleInfos.filter(csi => csi.sample.controlType === 'Blank');
            const results = blanks.filter(b => b.results[sti.id]);
            if (results.length) {
                const avg = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].average(results.map(r => r.results[sti.id].raw));
                this.result.blanksAvg[sti.id] = {
                    avg: avg,
                    accept: avg <= 2
                };
                acceptBlanks = acceptBlanks && this.result.blanksAvg[sti.id].accept;
            }
        }
        this.result.acceptBlanks = acceptBlanks;
        for (let csi of this.result.cultureSampleInfos) {
            csi.exclude = false;
            csi.excludeTxg = false;
            csi.excludeCount = false;
            if (!csi.manualExclude)
                csi.manualExclude = {};
            csi.totalCellsPrWell = csi.cellCount *
                this.expSetup.bnVolumePrWellCC_ul / (csi.volumeAcquired_nl / 1000) *
                this.expSetup.bnVolumeHarvest_ul / this.expSetup.bnVolumeCellCount_ul;
            if (acVariant === _facs__WEBPACK_IMPORTED_MODULE_1__["FACS"].DE && csi.cellCount < 10000) {
                csi.exclude = true;
                csi.excludeCount = true;
                csi.excludeTxg = true;
                csi.invalidCellCount = true;
                csi.excludeCauses.push('Cell count');
            }
            if (csi.sample.controlType === 'Blank') {
                csi.excludeCount = true;
                continue;
            }
            for (let m of this.result.stainInfos) {
                let result = csi.results[m.id];
                let blank = csi.tsi.csiBlank.results[m.id];
                if (!result && m.isTransgene)
                    continue;
                if (!result || !blank) {
                    csi.exclude = true;
                    csi.excludeCount = true;
                    csi.excludeTxg = true;
                    csi.excludeCauses.push('Missing result');
                    continue;
                }
                result.failed = false;
                if (acVariant === _facs__WEBPACK_IMPORTED_MODULE_1__["FACS"].US) {
                    result.woBackground = result.raw - this.result.blanksAvg[m.id].avg;
                }
                else {
                    result.woBackground = result.raw - blank.raw;
                }
                if (!this.expSetup.bnPosCheckOnlyInfU || m.pop.id === this.result.popInfU.id) {
                    const posCellsCheck = acVariant === _facs__WEBPACK_IMPORTED_MODULE_1__["FACS"].US ? result.raw : result.woBackground;
                    if (posCellsCheck < this.expSetup.bnPctMinPositiveCells
                        || posCellsCheck > this.expSetup.bnPctMaxPositiveCells) {
                        result.failed = true;
                        csi.exclude = true;
                        csi.excludeCount = true;
                        csi.excludeTxg = true;
                        csi.excludeCauses.push('Outside pos level range');
                    }
                }
                csi.allowExcludeCount = true;
                csi.allowExcludeTxg = !_scifeon_core__WEBPACK_IMPORTED_MODULE_0__["Config"].get().configuration.isRegulated || this.expSetup.bnAllowExcludeTxgRegulated;
                if (csi.manualExclude['InfU'] !== undefined) {
                    csi.exclude = csi.manualExclude['InfU'];
                }
                if (csi.manualExclude['InfU'] !== true) {
                    if (csi.manualExclude['Count'] !== undefined) {
                        csi.excludeCount = csi.manualExclude['Count'];
                    }
                    if (csi.manualExclude['Txg'] !== undefined) {
                        csi.excludeTxg = csi.manualExclude['Txg'];
                    }
                }
                else {
                    csi.excludeCount = csi.excludeTxg = true;
                    csi.allowExcludeCount = false;
                    csi.allowExcludeTxg = false;
                }
            }
            for (let pop of this.result.coXInfos) {
                let result = csi.results[pop.id];
                if (!result) {
                    csi.excludeCoX = true;
                    csi.excludeCauses.push('Missing CoX population result');
                }
            }
        }
        if (acVariant === _facs__WEBPACK_IMPORTED_MODULE_1__["FACS"].US) {
            for (let csi of this.result.cultureSampleInfos) {
                csi.usCellCount = csi.totalCellsPrWell / 100;
                csi.usCellCount = Math.round(csi.usCellCount / 10) * 10;
                if (csi.usCellCount > 10000) {
                    csi.usCellCount = Math.round(csi.usCellCount / 100) * 100;
                }
                if (csi.usCellCount < 6000) {
                    csi.usExcludeCount = true;
                    csi.invalidCellCount = true;
                }
                for (const m of this.result.stainInfos) {
                    if (csi.results[m.id] && csi.results[m.id].raw > 30) {
                        csi.usExcludeCount = true;
                        csi.invalidCellCount = true;
                    }
                }
            }
            this.result.us.median = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].median(this.result.cultureSampleInfos.map(csi => csi.usCellCount));
            this.result.us.wellsAll = this.calcCellCountUS(this.result.cultureSampleInfos);
            this.result.us.wellsInc = this.calcCellCountUS(this.result.cultureSampleInfos.filter(csi => !csi.usExcludeCount));
            this.result.us.wellsTop50 = this.calcCellCountUS(this.result.cultureSampleInfos.filter(csi => csi.usCellCount >= this.result.us.median));
            if (this.result.us.wellsAll.rsd < 15) {
                this.result.us.wellsAll.selected = true;
                this.result.us.wellsSelected = this.result.us.wellsAll;
            }
            else if (this.result.us.wellsInc.rsd < 15) {
                this.result.us.wellsInc.selected = true;
                this.result.us.wellsSelected = this.result.us.wellsInc;
            }
            else if (this.result.us.wellsTop50.rsd < 15) {
                this.result.us.wellsTop50.selected = true;
                this.result.us.wellsSelected = this.result.us.wellsTop50;
            }
            this.result.acceptCellsPrWell = this.result.us.wellsSelected !== undefined;
            if (this.result.acceptCellsPrWell) {
                this.result.avgCellsPrWell = this.result.us.wellsSelected.avg * 100;
            }
        }
        if (acVariant === _facs__WEBPACK_IMPORTED_MODULE_1__["FACS"].DE) {
            let csiIncludedForCellsPrWell = this.result.cultureSampleInfos.filter(csi => !csi.excludeCount);
            this.result.sumCellsPrWell = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].sum(csiIncludedForCellsPrWell.map(csi => csi.totalCellsPrWell));
            this.result.nCellsPrWellValues = csiIncludedForCellsPrWell.length;
            this.result.avgCellsPrWell = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].average(csiIncludedForCellsPrWell.map(csi => csi.totalCellsPrWell));
            this.result.stdevCellsPrWell = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].stdev(csiIncludedForCellsPrWell.map(csi => csi.totalCellsPrWell));
            this.result.pctCellsPrWellCV = this.result.stdevCellsPrWell / this.result.avgCellsPrWell * 100;
            this.result.acceptCellsPrWellCV = this.result.pctCellsPrWellCV <= this.expSetup.bnPctMaxCellsPrWellCV;
            this.result.maxCellsPrWell = csiIncludedForCellsPrWell.reduce((max, csi) => max > csi.totalCellsPrWell ? max : csi.totalCellsPrWell, 0);
            this.result.minCellsPrWell = csiIncludedForCellsPrWell.reduce((min, csi) => min < csi.totalCellsPrWell ? min : csi.totalCellsPrWell, this.result.maxCellsPrWell);
            this.result.acceptCellsPrWell = this.result.minCellsPrWell >= this.expSetup.bnMinCellsPrWell;
        }
        for (let csi of this.result.cultureSampleInfos.filter(si => !si.name.startsWith('Blank'))) {
            for (let m of this.result.stainInfos.filter(mi => mi.isTransgene || mi.pop === this.result.popInfU)) {
                let result = csi.results[m.id];
                if (!result || result.woBackground == null) {
                    continue;
                }
                const preDilution = csi.sample.attributes.preDilution || 1;
                result.titerPrML = this.result.avgCellsPrWell *
                    (-Math.log(1 - result.woBackground / 100)) *
                    (csi.sample.attributes.foldDilution * preDilution) / this.expSetup.bnVolumePrWell_ul * 1000;
            }
        }
        for (let tsi of this.result.testSampleInfos) {
            for (let popI of this.result.stainInfos) {
                const csis = tsi.cultureSampleInfos.filter(csi => csi.results[popI.id] && (!popI.isTransgene ? !csi.exclude : !csi.excludeTxg));
                if (!csis)
                    continue;
                tsi.ratioTxgInfU[popI.id] = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].average(csis.map(csi => csi.results[popI.id].titerPrML / csi.results[this.result.popInfU.id].titerPrML));
                tsi.averageTiterPrML[popI.id] = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].average(csis.map(csi => csi.results[popI.id].titerPrML));
                tsi.logTiterPrML[popI.id] = Math.log10(tsi.averageTiterPrML[popI.id]);
                tsi.stdevTiterPrML[popI.id] = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].stdev(csis.map(csi => csi.results[popI.id].titerPrML));
                tsi.cvTiterPrML[popI.id] = tsi.stdevTiterPrML[popI.id] / tsi.averageTiterPrML[popI.id] * 100;
            }
            let includedCSIs = tsi.cultureSampleInfos.filter(csi => !csi.exclude);
            if (!includedCSIs)
                continue;
            const includedTxgs = includedCSIs.filter(csi => !csi.excludeTxg && !csi.excludeCoX);
            if (!includedTxgs)
                continue;
            for (let popI of this.result.coXInfos) {
                tsi.averageCoX[popI.id] = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].average(includedTxgs.map(csi => csi.results[popI.id].entity.pctParent));
                tsi.stdevCoX[popI.id] = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].stdev(includedTxgs.map(csi => csi.results[popI.id].entity.pctParent)) / tsi.averageCoX[popI.id] * 100;
            }
            const sumOfPctParentProducts = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].sum(includedTxgs.map(csi => _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["MathUtils"].product(this.result.coXInfos.map(popI => csi.results[popI.id] && csi.results[popI.id].entity.pctParent / 100)) * 100));
            tsi.pctTxgCoX = sumOfPctParentProducts / includedTxgs.length;
        }
        this.result.pctPosControlTotalCoX = 100;
        for (let tsi of this.result.testSampleInfosPosControls) {
            this.result.pctPosControlTotalCoX *= tsi.pctTxgCoX / 100;
        }
        for (let tsi of this.result.testSampleInfos) {
            tsi.n = tsi.cultureSampleInfos.filter(csi => !csi.exclude).length;
            tsi.acceptErrors = [];
            tsi.accepted = true;
            tsi.acceptedNTubes = true;
            if (tsi.n < this.expSetup.bnMinAcceptedTubes) {
                tsi.accepted = false;
                tsi.acceptErrors.push(`Failed criterion: n >= ${this.expSetup.bnMinAcceptedTubes}`);
                tsi.acceptedNTubes = false;
            }
            tsi.acceptedCVInfU = true;
            if (acVariant === _facs__WEBPACK_IMPORTED_MODULE_1__["FACS"].US) {
                if (tsi.cvTiterPrML[this.result.popInfU.id] > this.expSetup.bnPctMaxInfUCV) {
                    tsi.accepted = false;
                    tsi.acceptErrors.push(`Failed criterion: Inf.U CV <= ${this.expSetup.bnPctMaxInfUCV}`);
                    tsi.acceptedCVInfU = false;
                }
            }
            else {
                if (tsi.cvTiterPrML[this.result.popInfU.id] >= this.expSetup.bnPctMaxInfUCV) {
                    tsi.accepted = false;
                    tsi.acceptErrors.push(`Failed criterion: Inf.U CV < ${this.expSetup.bnPctMaxInfUCV}`);
                    tsi.acceptedCVInfU = false;
                }
            }
            tsi.acceptedPosControlInfU = true;
            if (tsi.tsiPosControl.averageTiterPrML[this.result.popInfU.id] < this.expSetup.bnMinPosControlInfU ||
                tsi.tsiPosControl.averageTiterPrML[this.result.popInfU.id] > this.expSetup.bnMaxPosControlInfU) {
                tsi.accepted = false;
                tsi.acceptErrors.push(`Failed Pos Control Inf.U range check`);
                tsi.acceptedPosControlInfU = false;
            }
            tsi.acceptedTxgCox = true;
            if (tsi.pctTxgCoX < this.expSetup.bnMinTxgCox) {
                tsi.accepted = false;
                tsi.acceptErrors.push(`Failed criterion: Txg CoX >= ${this.expSetup.bnMinTxgCox}`);
                tsi.acceptedTxgCox = false;
            }
            tsi.acceptedRatioTxgInfU = {};
            tsi.acceptedCVTxgU = {};
            for (const popInfo of this.result.txgInfos) {
                tsi.acceptedCVTxgU[popInfo.id] = true;
                if (acVariant === _facs__WEBPACK_IMPORTED_MODULE_1__["FACS"].US) {
                    if (tsi.cvTiterPrML[popInfo.id] > this.expSetup.bnPctMaxInfUCV && !this.expSetup.bnIgnoreTxgCV) {
                        tsi.accepted = false;
                        tsi.acceptErrors.push(`Failed criterion: Txg.U CV <= ${this.expSetup.bnPctMaxInfUCV} for ${popInfo.label}`);
                        tsi.acceptedCVTxgU[popInfo.id] = false;
                    }
                }
                else {
                    if (tsi.cvTiterPrML[popInfo.id] >= this.expSetup.bnPctMaxInfUCV && !this.expSetup.bnIgnoreTxgCV) {
                        tsi.accepted = false;
                        tsi.acceptErrors.push(`Failed criterion: Txg.U CV < ${this.expSetup.bnPctMaxInfUCV} for ${popInfo.label}`);
                        tsi.acceptedCVTxgU[popInfo.id] = false;
                    }
                }
                tsi.acceptedRatioTxgInfU[popInfo.id] = true;
                const ratioKey = this.expSetup.bnMinTxgInfURatios && Object.keys(this.expSetup.bnMinTxgInfURatios).find(k => k.toLowerCase().trim() === popInfo.label.toLowerCase().trim());
                const ratio = (ratioKey && this.expSetup.bnMinTxgInfURatios[ratioKey]) || this.expSetup.bnMinTxgInfURatio;
                if (tsi.ratioTxgInfU[popInfo.id] < ratio) {
                    tsi.accepted = false;
                    tsi.acceptErrors.push(`Failed criterion: Txg.U/Inf.U ratio >= ${ratio} for ${popInfo.label}`);
                    tsi.acceptedRatioTxgInfU[popInfo.id] = false;
                }
            }
        }
    }
    calcCellCountUS(csis) {
        let result = {};
        result.sum = csis.reduce((sum, csi) => sum += csi.usCellCount, 0);
        result.avg = result.sum / csis.length;
        result.stdev = Math.sqrt(csis.reduce((sum, ti) => sum += Math.pow(ti.usCellCount - result.avg, 2), 0)
            / (csis.length - 1));
        result.rsd = result.stdev / result.avg * 100;
        return result;
    }
}


/***/ }),

/***/ "../apps/module/facs/src/processing/analyzer-result.ts":
/*!*************************************************************!*\
  !*** ../apps/module/facs/src/processing/analyzer-result.ts ***!
  \*************************************************************/
/*! exports provided: AnalyzerResult */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AnalyzerResult", function() { return AnalyzerResult; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _facs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../facs */ "../apps/module/facs/src/facs.ts");


class AnalyzerResult {
    constructor(dataset) {
        this.acceptCellsPrWellCV = true;
        this.acceptBlanks = true;
        this.blanksAvg = {};
        this.us = {};
        this.failed = false;
        this.failureMessage = '';
        this.createStructure(dataset);
    }
    createStructure(dataset) {
        if (dataset.rs.status !== _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["Status"].COMPLETED) {
            this.failed = true;
            this.failureMessage = 'Please, sign the population dataset before opening the Analyzer.';
        }
        const plateCount = dataset.stainingPlates.find(p => p.name === 'Count');
        this.popViableCells = dataset.populations.find(p => p.name === _facs__WEBPACK_IMPORTED_MODULE_1__["FACS"].PopulationViableCells && p.plateID === plateCount.id);
        if (!this.popViableCells) {
            this.failed = true;
            this.failureMessage = 'Please, load a Count file before opening the Analyzer.';
        }
        this.popInfU = dataset.populations.find(p => p.name === _facs__WEBPACK_IMPORTED_MODULE_1__["FACS"].PopulationInfU);
        if (!this.popInfU) {
            this.failed = true;
            this.failureMessage = 'Please, load an InfU file before opening the Analyzer.';
        }
        this.stainInfos = [];
        this.coXInfos = [];
        for (let pop of dataset.populations) {
            let tpt = dataset.templates.find(t => t.name === pop.name);
            if (!tpt || tpt.name === 'FACS-Pop-AllEvents' || tpt.name === 'FACS-Pop-ViableCells')
                continue;
            const popInfo = {
                id: pop.id,
                pop: pop,
                label: tpt.content.label,
                isTransgene: tpt.content.isTransgene
            };
            if (tpt.content.isCoExpression)
                this.coXInfos.push(popInfo);
            else
                this.stainInfos.push(popInfo);
        }
        this.stainInfos.sort((a, b) => (a.label > b.label ? 1 : -1));
        this.coXInfos.sort((a, b) => (a.label > b.label ? 1 : -1));
        this.txgInfos = this.stainInfos.filter(info => info.isTransgene);
        this.tubeInfos = dataset.tubes.map(t => {
            return {
                name: t.name,
                tube: t,
                sample: dataset.samples.find(s => s.id === t.sampleID)
            };
        });
        this.cultureSampleInfos = this.tubeInfos
            .filter((ti, i, array) => array.findIndex(ti2 => ti2.name === ti.name) === i)
            .map(ti => {
            return {
                name: ti.name,
                tubeInfos: this.tubeInfos.filter(ti2 => ti2.name === ti.name),
                results: {},
                excludeCauses: []
            };
        });
        this.cultureSampleInfos.forEach(csi => {
            csi.sample = csi.tubeInfos[0].sample;
            csi.id = csi.tubeInfos[0].sample.parentID;
            csi.name = csi.tubeInfos[0].sample.name;
            csi.tubeInfos.forEach(tsi => {
                tsi.csi = csi;
                if (tsi.tube.volumeAcquired_nl)
                    csi.volumeAcquired_nl = tsi.tube.volumeAcquired_nl;
            });
            csi.manualExclude = {};
            if (dataset.manualExIncludes) {
                for (const mei of dataset.manualExIncludes.content.filter(mei => mei.csi === csi.id)) {
                    csi.manualExclude[mei.type] = mei.exclude;
                }
            }
        });
        this.cultureSampleInfos.sort((a, b) => (a.id > b.id ? 1 : -1));
        this.testSampleInfos = dataset.samples
            .filter((s, i, array) => array.findIndex(s2 => s2.name === s.name) === i)
            .filter(s => s.controlType !== 'Blank')
            .map(s => {
            return {
                name: s.name,
                isControl: s.isControl,
                controlType: s.controlType,
                cultureSampleInfos: this.cultureSampleInfos.filter(csi => csi.name === s.name).sort((a, b) => (a.id > b.id ? 1 : -1)),
                averageTiterPrML: {},
                logTiterPrML: {},
                stdevTiterPrML: {},
                cvTiterPrML: {},
                ratioTxgInfU: {},
                averageCoX: {},
                stdevCoX: {},
                detailsVisible: false,
                acceptErrors: [],
                accepted: true,
                manualExIncludes: []
            };
        });
        this.testSampleInfos.forEach(tsi => {
            tsi.sample = dataset.testSamples.find(s => s.name === tsi.name);
            if (dataset.manualExIncludes) {
                tsi.manualExIncludes = dataset.manualExIncludes.content.filter(mei => mei.tsi === tsi.sample.id);
            }
            tsi.cultureSampleInfos.forEach(csi => (csi.tsi = tsi));
        });
        this.testSampleInfosPosControls = this.testSampleInfos.filter(tsi => tsi.controlType === 'Positive');
        dataset.samples.forEach(s => {
            let tsi = this.testSampleInfos.find(si => si.name === s.name);
            if (tsi) {
                let ti = this.tubeInfos.find(ti => ti.sample.id === s.id);
                if (ti) {
                    ti.tsi = tsi;
                }
                else {
                }
            }
        });
        this.testSampleInfos.sort((a, b) => (a.sample.id > b.sample.id ? 1 : -1));
        this.testSampleInfos.filter(tsi => !tsi.isControl);
        let smpLatestBlank = null;
        let tsiLatestPosControl = null;
        for (let smp of dataset.samples.sort((a, b) => (a.id > b.id ? 1 : -1))) {
            if (smp.controlType === 'Blank') {
                smpLatestBlank = smp;
                continue;
            }
            if (!smpLatestBlank)
                throw Error('Must have a blank samples as the first sample');
            let tsi = this.testSampleInfos.find(si => si.name === smp.name);
            if (!tsi)
                throw Error(`Missing sample info for sample: ${smp.name}`);
            if (smp.controlType === 'Positive')
                tsiLatestPosControl = tsi;
            let csiBlank = this.cultureSampleInfos.find(csi => csi.sample.id === smpLatestBlank.id);
            if (csiBlank)
                tsi.csiBlank = csiBlank;
            tsi.tsiPosControl = tsiLatestPosControl;
        }
        this.testSampleInfos.forEach(tsi => {
            if (!tsi.csiBlank)
                throw Error(`Missing blank culture sample for ${tsi.name}`);
        });
        dataset.results.forEach(r => {
            let ti = this.tubeInfos.find(ti => ti.sample.id === r.sampleID);
            ti.csi.results[r.populationID] = {
                entity: r,
                raw: r.pctParent
            };
        });
        this.cultureSampleInfos.forEach(csi => {
            if (!csi.results[this.popViableCells.id])
                throw Error(`Missing result viable cells result for sample ${csi.id}`);
            csi.cellCount = csi.results[this.popViableCells.id].entity.count;
        });
    }
}


/***/ })

}]);
//# sourceMappingURL=analyzer.01ac3593419a3ad6c940.js.map