(window["webpackJsonpcom_scifeon_scifeon_apps_validation"] = window["webpackJsonpcom_scifeon_scifeon_apps_validation"] || []).push([["routePage_sciquClaimDetail"],{

/***/ "../apps/demo/validation_app/src/pages/claim-detail.html":
/*!***************************************************************!*\
  !*** ../apps/demo/validation_app/src/pages/claim-detail.html ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\">\r\n            <h1>Claim ${claim.name}: ${claim.description}</h1>\r\n        </div>\r\n        <div class=\"page-panels grid\" style=\"grid-template-columns: 1fr 1fr\">\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Claim Info</div>\r\n                <div class=\"panel-body\">\r\n                    <div class=\"view-group\">\r\n                        <label>Project</label>\r\n                        <p><a href='/#/val/project/${project.id}'>${project.name}</a></p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Name</label>\r\n                        <p>${claim.name}</p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Type</label>\r\n                        <p>${claim.type}</p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Document</label>\r\n                        <p><a href='/#/val/document/${doc.id}'>${doc.name}</a></p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Section</label>\r\n                        <p>${section.name}</p>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Review &amp; Approval</div>\r\n                <div class=\"panel-body\">\r\n\r\n                    <div class=\"form-group\">\r\n                        <label>Current Status</label>\r\n                        <p>${claim.status}</p>\r\n                    </div>\r\n\r\n                </div>\r\n            </div>\r\n    \r\n    \r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Claim Text</div>\r\n                <div class=\"panel-body\">\r\n                    <div class=\"form-group\">\r\n                        <label>Title</label>\r\n                        <inplace-edit-text value.bind=\"claim.description\" entity-saved.delegate=\"claimUpdated($event)\"></inplace-edit-text>\r\n                    </div>\r\n                    <div class=\"form-group\">\r\n                        <label>Claim Text</label>\r\n                        <inplace-edit-textarea entity.bind=\"claim\" key=\"content\" entity-saved.delegate=\"claimUpdated($event)\"></inplace-edit-textarea>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Implementations and Tests</div>\r\n                <div class=\"panel-body\">\r\n                    <div if.bind=\"parentClaims.length > 0\">\r\n                        <h3>Parent Claims</h3>\r\n                        <table>\r\n                            <thead>\r\n                                <tr>\r\n                                    <th>Name</th>\r\n                                    <th>Type</th>\r\n                                    <th>Title</th>\r\n                                </tr>\r\n                            </thead>\r\n                            <tbody>\r\n                                <tr repeat.for=\"claim of parentClaims\">\r\n                                    <td><a href=\"/#/val/claim/${claim.id}\">${claim.name}</a></td>\r\n                                    <td>${claim.type}</td>\r\n                                    <td>${claim.description}</td>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n                    </div>\r\n\r\n                    <h3>Descendant Claims</h3>\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                                <th>Type</th>\r\n                                <th>Title</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"claim of childClaims\">\r\n                                <td><a href=\"/#/val/claim/${claim.id}\">${claim.name}</a></td>\r\n                                <td>${claim.type}</td>\r\n                                <td>${claim.description}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n\r\n                    <div class=\"form-group\">\r\n                        <button click.delegate=\"createChildClaim()\">Create Child Claim</button>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Communication</div>\r\n                <div class=\"panel-body\">\r\n                    <h3>Messages Threads</h3>\r\n\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th></th>\r\n                                <th>Date</th>\r\n                                <th>User</th>\r\n                                <th>Status</th>\r\n                                <th>Topic</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <template repeat.for=\"ti of threadInfos\" containerless>\r\n                                <tr>\r\n                                    <td>\r\n                                        <span click.delegate=\"toggleDetails(ti)\" class=\"fa fa-toggle-off\" if.bind=\"!ti.detailsVisible\" title=\"Show details\"></span>\r\n                                        <span click.delegate=\"toggleDetails(ti)\" class=\"fa fa-toggle-on\" if.bind=\"ti.detailsVisible\" title=\"Hide details\"></span>    \r\n                                    </td>\r\n                                    <td>${ti.messages[0].createdUtc | dateTimeFormat}</td>\r\n                                    <td>${ti.messages[0].userID}</td>\r\n                                    <td>${ti.thread.status}</td>\r\n                                    <td>${ti.thread.description}</td>\r\n                                    <td>\r\n                                        <button if.bind=\"ti.showReply\" class=\"small\" click.delegate=\"reply(ti)\">Reply</button>\r\n                                        <button if.bind=\"ti.showResolve\" class=\"small\" click.delegate=\"resolve(ti)\">Resolved</button>\r\n                                        <button if.bind=\"ti.showReopen\" class=\"small\" click.delegate=\"reopen(ti)\">Re-open</button>\r\n                                    </td>\r\n                                </tr>\r\n                                <tr if.bind=\"ti.detailsVisible\">\r\n                                    <td colspan=\"6\">\r\n                                        <label>Messages</label>\r\n                                        <div repeat.for=\"m of ti.messages\">\r\n                                            <hr/>\r\n                                            <h3>Topic: ${m.description}</h3>\r\n                                            <p>${m.createdUtc | dateTimeFormat}: ${m.userID}</p>\r\n                                            <p><button click.delegate=\"markDecision(m)\" class=\"small\">Decision</button></p>\r\n                                            <div innerHtml.bind=\"m.content\"></div>\r\n                                        </div>\r\n                                    </td>\r\n                                </tr>\r\n                            </template>\r\n                        </tbody>\r\n                    </table>\r\n\r\n                    <hr/>\r\n                    <button click.delegate=\"startMessageThread()\">Start New Thread</button>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Decisions</div>\r\n                <div class=\"panel-body\">\r\n                    <table>\r\n                        <tbody>\r\n                            <template repeat.for=\"di of decisions\" containerless>\r\n                                <tr>\r\n                                    <td>\r\n                                        <span click.delegate=\"toggleDetails(di)\" class=\"fa fa-toggle-off\" if.bind=\"!di.detailsVisible\" title=\"Show details\"></span>\r\n                                        <span click.delegate=\"toggleDetails(di)\" class=\"fa fa-toggle-on\" if.bind=\"di.detailsVisible\" title=\"Hide details\"></span>    \r\n                                    </td>\r\n                                    <td>${di.message.createdDate | dateFormat}</td>\r\n                                    <td>${di.message.userID}</td>\r\n                                    <td>${di.message.description}</td>\r\n                                </tr>\r\n            \r\n                            </template>\r\n                        </tbody>\r\n                    </table>\r\n                </div>\r\n            </div>\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-heading\">Audit Trail</div>\r\n                <div class=\"panel-body\">\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>V</th>\r\n                                <th>Date</th>\r\n                                <th>User</th>\r\n                                <th>Notes</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"a of audit\">\r\n                                <td>${a.auditOp}</td>\r\n                                <td>${a.modifiedDate | dateFormat}</td>\r\n                                <td>${a.modifiedBy}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/validation_app/src/pages/claim-detail.ts":
/*!*************************************************************!*\
  !*** ../apps/demo/validation_app/src/pages/claim-detail.ts ***!
  \*************************************************************/
/*! exports provided: ClaimDetail */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ClaimDetail", function() { return ClaimDetail; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _popups_writeMessage__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../popups/writeMessage */ "../apps/demo/validation_app/src/popups/writeMessage.ts");






let ClaimDetail = class ClaimDetail {
    constructor(server, router, dialog) {
        this.server = server;
        this.router = router;
        this.dialog = dialog;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let claimID = context.params.id;
            const ds = yield this.server.datasetQuery([
                { eClass: 'ValEntry', alias: 'claim', filters: [{ field: 'ID', value: claimID }] },
                { eClass: 'Project', alias: 'project', filters: [{ field: 'ID', value: '$claim.ProjectID' }] },
                { eClass: 'ValSection', alias: 'section', filters: [{ field: 'ID', value: '$claim.SectionID' }] },
                { eClass: 'ValDocument', alias: 'doc', filters: [{ field: 'ID', value: '$section.DocumentID' }] },
                { eClass: 'Message', collection: 'messages', filters: [{ field: 'SubjectID', value: claimID }] },
                { eClass: 'MessageThread', collection: 'threads', filters: [{ field: 'SubjectID', value: claimID }] },
                { view: 'ValParentClaims', collection: 'parentClaims', filters: [{ field: 'EntryID', value: claimID }] },
                { view: 'ValClaimsHierarchy', collection: 'childClaims', filters: [{ field: 'RootID', value: claimID }] },
                { view: 'ValEntryAudit', collection: 'audit', filters: [{ field: 'ID', value: claimID }] }
            ]);
            this.audit = ds.audit;
            this.project = ds.project;
            this.claim = ds.claim;
            this.section = ds.section;
            this.updateThreadInfos(ds);
            this.doc = ds.doc;
            this.parentClaims = ds.parentClaims;
            this.childClaims = ds.childClaims.filter(c => c.id !== this.claim.id);
        });
    }
    createChildClaim() {
        this.router.navigate('val/claim-create?parentID=' + this.claim.id);
    }
    claimUpdated(e) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const ds = yield this.server.datasetQuery([
                { view: 'ValEntryAudit', collection: 'audit', filters: [{ field: 'ID', value: this.claim.id }] }
            ]);
            this.audit = ds.audit;
        });
    }
    toggleDetails(o) {
        o.detailsVisible = !o.detailsVisible;
    }
    updateThreadInfos(ds) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.threadInfos = ds.threads.map(t => {
                return {
                    thread: t,
                    messages: ds.messages.filter(m => m.threadID === t.id).sort((a, b) => a.createdUtc > b.createdUtc ? -1 : 1),
                    detailsVisible: false,
                    showReopen: t.status === 'Resolved',
                    showReply: t.status !== 'Resolved',
                    showResolve: t.status !== 'Resolved'
                };
            });
            this.decisions = ds.messages.filter(m => m.status === 'Decision').map(m => {
                return {
                    message: m,
                    detailsVisible: false
                };
            });
        });
    }
    updateMessageList() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const ds = yield this.server.datasetQuery([
                { eClass: 'Message', collection: 'messages', filters: [{ field: 'EntryID', value: this.claim.id }] },
                { eClass: 'MessageThread', collection: 'threads', filters: [{ field: 'EntryID', value: this.claim.id }] }
            ]);
            this.updateThreadInfos(ds);
        });
    }
    markDecision(message) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.server.postJson('/SciQu/MarkDecision', { messageID: message.id });
            this.updateMessageList();
        });
    }
    resolve(threadInfo) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.server.postJson('/SciQu/ResolveThread', { threadID: threadInfo.thread.id });
            this.updateMessageList();
        });
    }
    reopen(threadInfo) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.server.postJson('/SciQu/ReopenThread', { threadID: threadInfo.thread.id });
            this.updateMessageList();
        });
    }
    reply(threadInfo) {
        let message = {
            eClass: 'Message',
            type: 'Reply',
            projectID: this.claim.projectID,
            entryID: this.claim.id,
            threadID: threadInfo.thread.id,
            status: 'Sent'
        };
        this.dialog
            .open({
            viewModel: _popups_writeMessage__WEBPACK_IMPORTED_MODULE_5__["PopupWriteMessage"],
            model: { message: message }
        })
            .whenClosed(result => {
            if (!result.wasCancelled)
                this.createMessage(message);
        });
    }
    createMessage(message) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            yield this.server.saveEntities([message]);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
            this.updateMessageList();
        });
    }
    startMessageThread() {
        let message = {
            eClass: 'Message',
            type: 'Message',
            projectID: this.claim.projectID,
            entryID: this.claim.id,
            threadID: '#idThread',
            status: 'Sent'
        };
        this.dialog
            .open({
            viewModel: _popups_writeMessage__WEBPACK_IMPORTED_MODULE_5__["PopupWriteMessage"],
            model: { message: message }
        })
            .whenClosed(result => {
            this.createThread(message);
        });
    }
    createThread(message) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            let thread = {
                eClass: 'MessageThread',
                id: '#idThread',
                projectID: this.claim.projectID,
                entryID: this.claim.id,
                status: 'Open',
                description: message.description
            };
            yield this.server.saveEntities([thread, message]);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
            this.updateMessageList();
        });
    }
};
ClaimDetail = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], ClaimDetail);



/***/ }),

/***/ "../apps/demo/validation_app/src/popups/writeMessage.ts":
/*!**************************************************************!*\
  !*** ../apps/demo/validation_app/src/popups/writeMessage.ts ***!
  \**************************************************************/
/*! exports provided: PopupWriteMessage */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PopupWriteMessage", function() { return PopupWriteMessage; });
class PopupWriteMessage {
    constructor() {
        this.view = () => `
<ux-dialog>
    <ux-dialog-header>
        <h2>Write Message</h2>
    </ux-dialog-header>
    <ux-dialog-body>
        <div class="form-group">
            <label>Topic</label>
            <input value.bind="message.description"></input>
        </div>
        <div class="form-group">
            <label>Message Text</label>
            <rich-text-editor rows="7" cols="60" value.bind="message.content"></textarea>
        </div>
    </ux-dialog-body>
    <ux-dialog-footer>
        <button click.delegate="dialog.ok(model)">Send</button>
        <button class="btn-link" click.delegate="dialog.cancel()">Cancel</button>
    </ux-dialog-footer>
</ux-dialog>`;
    }
    init(model) {
        this.message = model.message;
    }
}


/***/ })

}]);
//# sourceMappingURL=routePage_sciquClaimDetail.5886312936a19e110910.js.map