(window["webpackJsonpcom_scifeon_scifeon_apps_validation"] = window["webpackJsonpcom_scifeon_scifeon_apps_validation"] || []).push([["routePage_sciquDocumentDetail"],{

/***/ "../apps/demo/validation_app/src/pages/document-detail.html":
/*!******************************************************************!*\
  !*** ../apps/demo/validation_app/src/pages/document-detail.html ***!
  \******************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header\">\r\n        <div class=\"page-header\"><h1>Document: ${doc.name}: ${doc.description}</h1></div>\r\n\r\n        <div class=\"page-panels grid\">\r\n\r\n            <div class=\"panel\">\r\n                <div class=\"panel-body\">\r\n                    <div class=\"view-group\">\r\n                        <label>Project</label>\r\n                        <p><a href='/#/val/project/${project.id}'>${project.name}</a></p>\r\n                    </div>\r\n                    <div class=\"view-group\">\r\n                        <label>Document Type</label>\r\n                        <p>${doc.type}</p>\r\n                    </div>\r\n\r\n                    <h3>Sections</h3>\r\n                    <table>\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Name</th>\r\n                                <th>Title</th>\r\n                                <th>Entries</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"si of sectionInfos\">\r\n                                <td>${si.section.name}</td>\r\n                                <td>${si.section.description}</td>\r\n                                <td>\r\n                                    <ul>\r\n                                        <li repeat.for=\"entry of si.entries\">\r\n                                            <a href='/#/val/claim/${entry.id}'>${entry.name}</a>: ${entry.description}\r\n                                        </li>\r\n                                    </ul>\r\n                                    <button class=\"small\" click.delegate=\"addEntry(si.section)\">Add Entry</button>\r\n                                </td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n\r\n                    <p><button click.delegate=\"addSection()\">Add Section</button></p>\r\n                </div>\r\n            </div>\r\n\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "../apps/demo/validation_app/src/pages/document-detail.ts":
/*!****************************************************************!*\
  !*** ../apps/demo/validation_app/src/pages/document-detail.ts ***!
  \****************************************************************/
/*! exports provided: DocumentDetail */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DocumentDetail", function() { return DocumentDetail; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _popups_popupAddSection__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../popups/popupAddSection */ "../apps/demo/validation_app/src/popups/popupAddSection.ts");






let DocumentDetail = class DocumentDetail {
    constructor(server, router, dialog) {
        this.server = server;
        this.router = router;
        this.dialog = dialog;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let documentID = context.params.id;
            const ds = yield this.server.datasetQuery([
                { eClass: 'ValDocument', alias: 'doc', filters: [{ field: 'ID', value: documentID }] },
                { eClass: 'ValSection', collection: 'sections',
                    filters: [{ field: 'DocumentID', value: documentID }],
                    sortings: [{ field: 'Name' }]
                },
                { eClass: 'ValEntry', collection: 'entries', filters: [{ field: 'DocumentID', value: documentID }] },
                { eClass: 'Project', alias: 'project', filters: [{ field: 'ID', value: '$doc.ProjectID' }] }
            ]);
            this.doc = ds.doc;
            this.project = ds.project;
            this.sectionInfos = ds.sections.map(s => {
                return {
                    section: s,
                    entries: ds.entries.filter(e => e.sectionID === s.id)
                };
            });
        });
    }
    refreshSectionList() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const ds = yield this.server.datasetQuery([
                { eClass: 'ValSection', collection: 'sections', filters: [{ field: 'DocumentID', value: this.doc.id }] },
                { eClass: 'ValEntry', collection: 'entries', filters: [{ field: 'DocumentID', value: this.doc.id }] },
            ]);
            this.sectionInfos = ds.sections.map(s => {
                return {
                    section: s,
                    entries: ds.entries.filter(e => e.sectionID === s.id)
                };
            });
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
        });
    }
    addEntry(section) {
        this.router.navigate(`val/claim-create?documentID=${this.doc.id}&sectionID=${section.id}&projectID=${this.doc.projectID}`);
    }
    addSection() {
        let section = {
            eClass: 'ValSection',
            projectID: this.project.id,
            documentID: this.doc.id,
            type: this.doc.type,
            status: 'Draft'
        };
        this.dialog
            .open({
            viewModel: _popups_popupAddSection__WEBPACK_IMPORTED_MODULE_5__["PopupAddSection"],
            model: { section: section }
        })
            .whenClosed(result => {
            if (!result.wasCancelled)
                this.createSection(section);
        });
    }
    createSection(section) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            let response = yield this.server.saveEntities([section]);
            this.refreshSectionList();
        });
    }
};
DocumentDetail = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], DocumentDetail);



/***/ }),

/***/ "../apps/demo/validation_app/src/popups/popupAddSection.ts":
/*!*****************************************************************!*\
  !*** ../apps/demo/validation_app/src/popups/popupAddSection.ts ***!
  \*****************************************************************/
/*! exports provided: PopupAddSection */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "PopupAddSection", function() { return PopupAddSection; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");


class PopupAddSection {
    constructor(dialog) {
        this.dialog = dialog;
        this.view = () => `
<ux-dialog>
    <ux-dialog-header>
        <h2>Add Section</h2>
    </ux-dialog-header>
    <ux-dialog-body>
        <div class="form-group">
            <label>Name</label>
            <input value.bind="section.name" focus="true"></input>
        </div>
        <div class="form-group">
            <label>Title</label>
            <input value.bind="section.description"></input>
        </div>
        <div class="form-group">
            <label>Type</label>
            <input value.bind="section.type"></input>
        </div>
    </ux-dialog-body>
    <ux-dialog-footer>
        <button click.delegate="dialog.ok()">Create</button>
        <button class="btn-link" click.delegate="dialog.cancel()">Cancel</button>
    </ux-dialog-footer>
</ux-dialog>`;
    }
    init(model) {
        this.section = model.section;
    }
    enter() { this.dialog.ok(); }
}
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    _scifeon_ui__WEBPACK_IMPORTED_MODULE_1__["Dialog"].enterKeyPressedAction,
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Function),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", []),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:returntype", void 0)
], PopupAddSection.prototype, "enter", null);


/***/ })

}]);
//# sourceMappingURL=routePage_sciquDocumentDetail.5886312936a19e110910.js.map