(window["webpackJsonpcom_scifeon_scifeon_logistics"] = window["webpackJsonpcom_scifeon_scifeon_logistics"] || []).push([["routePage_logisticsRequest"],{

/***/ "../apps/demo/logistics_app/src/pages/request.html":
/*!*********************************************************!*\
  !*** ../apps/demo/logistics_app/src/pages/request.html ***!
  \*********************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"page-with-header prototype\">\r\n        <div class=\"page-header\"><h1>Storage Customization Demo</h1></div>\r\n        <div class=\"panel-group\">       \r\n            <div class=\"page-panels grid full-width-panels\">\r\n    \r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Request Info</div>\r\n                    <div class=\"panel-body\">\r\n                        <div class=\"form-group\">\r\n                            <label>Inbox</label>\r\n                            <select value.bind=\"selectedInbox\">\r\n                                <option repeat.for=\"inbox of inboxes\" model.bind=\"inbox\">${inbox.name}</option>\r\n                            </select>\r\n                        </div>\r\n    \r\n                        <div class=\"form-group\">\r\n                            <label>Notes</label>\r\n                            <rich-text-editor value.bind=\"note.content\"></rich-text-editor>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Select Analyses</div>\r\n                    <div class=\"panel-body\">\r\n                        <div class=\"form-group\">\r\n                            <label repeat.for=\"method of methods\">\r\n                                <input type=\"checkbox\" model.bind=\"method\" checked.bind=\"$parent.selectedMethods\" />\r\n                                ${method.name}\r\n                            </label>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-heading\">Samples</div>\r\n                    <div class=\"panel-body\">\r\n                        <div class=\"form-group\">\r\n                            <button click.delegate=\"showAddSamplesPopup()\">Edit Samples</button>\r\n                        </div>\r\n                        <div class=\"form-group\">\r\n                            <table>\r\n                                <thead>\r\n                                    <tr>\r\n                                        <th>External ID</th>\r\n                                        <th>Type</th>\r\n                                        <th>Content</th>\r\n                                        <th>Tags</th>\r\n                                        <th>Description</th>\r\n                                    </tr>\r\n                                </thead>\r\n                                <tbody>\r\n                                    <tr repeat.for=\"sample of samples\">\r\n                                        <td>${sample.externalID}</td>\r\n                                        <td>${sample.type}</td>\r\n                                        <td>${sample.content}</td>\r\n                                        <td>${sample.tags}</td>\r\n                                        <td>${sample.description}</td>\r\n                                        <td><button class=\"small\" click.delegate=\"removeItem(sample.externalID)\">Remove</button></td>\r\n                                    </tr>\r\n                                </tbody>\r\n                            </table>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n            <div class=\"page-panels full-width-panels\">\r\n                <div class=\"panel\">\r\n                    <div class=\"panel-body\">\r\n                        <p  class=\"text-center\">\r\n                            <button click.delegate=\"createRequest()\">Submit Request</button>\r\n                        </p>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </template>";

/***/ }),

/***/ "../apps/demo/logistics_app/src/pages/request.ts":
/*!*******************************************************!*\
  !*** ../apps/demo/logistics_app/src/pages/request.ts ***!
  \*******************************************************/
/*! exports provided: RequestCreate */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RequestCreate", function() { return RequestCreate; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);





let RequestCreate = class RequestCreate {
    constructor(api, router, sis, user) {
        this.api = api;
        this.router = router;
        this.sis = sis;
        this.user = user;
        this.selectedMethods = [];
        this.note = {
            eClass: 'Note',
            content: '',
            subjectClass: 'Request',
            subjectID: '#idRequest',
            type: 'EntryNotes'
        };
        this.samples = [];
        this.nextInputSampleAlias = 1;
    }
    init() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.api.datasetQuery([
                { eClass: 'Method', collection: 'methods', filters: [{ field: 'Type', value: 'Service' }] },
                { eClass: 'RequestInbox', collection: 'inboxes', filters: [{ field: 'Status', value: 'Completed' }] }
            ]);
            this.methods = dataset.methods;
            this.inboxes = [{ name: 'none' }].concat(dataset.inboxes.sort((a, b) => a.name > b.name ? 1 : -1));
        });
    }
    showAddSamplesPopup() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const newSamples = yield this.sis.editSamples('externalID, type, content, tags, description', this.samples.slice(0));
            this.samples = newSamples.filter(s => s.type || s.externalID || s.content);
        });
    }
    createRequest() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!this.selectedInbox || this.selectedInbox.name === "none") {
                throw new Error("No inbox selected.");
            }
            let entities = this.samples.map(sample => {
                sample.id = `#idSmp${this.nextInputSampleAlias++}`;
                sample.barcode = '!Barcode';
                sample.format = 'Vial';
                return sample;
            });
            entities.push({
                eClass: 'Collection',
                id: '#idPayloadCollection',
                type: 'Payload',
                collItems: entities.filter(e => e.eClass === 'Sample').map(s => {
                    return { entityClass: 'Sample', entityID: s.id };
                })
            });
            let payload = {
                methods: this.selectedMethods.map(m => m.id),
                sampleMethodMap: []
            };
            this.selectedMethods.map(m => this.samples.map(s => {
                payload.sampleMethodMap.push({
                    sampleID: s.id, methodID: m.id
                });
            }));
            entities.push({
                eClass: 'Request',
                id: '#idRequest',
                inboxID: this.selectedInbox.id,
                status: 'Sent',
                sentByID: this.user.id,
                payload: payload,
                dateSent: new Date(),
                xrefs: [{ type: 'Payload', toID: '#idPayloadCollection', toClass: 'Collection' }]
            });
            if (this.note.content.length > 0)
                entities.push(this.note);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            const response = yield this.api.saveEntities(entities, [{ eClass: 'RequestInbox', name: 'MSService', alias: '#idInbox' }]);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide();
            let requestID = response.newEntities.find(e => e.eClass === 'Request').id;
            this.router.navigate('/entity/request/' + requestID);
        });
    }
    removeItem(id) {
        this.samples = this.samples.filter(i => i.externalID !== id);
    }
};
RequestCreate = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["SampleInputSelectorDialogService"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], RequestCreate);



/***/ }),

/***/ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js":
/*!*****************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-router/dist/commonjs/aurelia-router.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ })

}]);
//# sourceMappingURL=routePage_logisticsRequest.1689f8bda2b220050734.js.map