(window["webpackJsonpcom_scifeon_scifeon_logistics"] = window["webpackJsonpcom_scifeon_scifeon_logistics"] || []).push([["routePage_src/pages/visualization"],{

/***/ "../apps/demo/logistics_app/src/pages/visualization.html":
/*!***************************************************************!*\
  !*** ../apps/demo/logistics_app/src/pages/visualization.html ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <style>\r\n        .freezer {\r\n            width: 300px;\r\n            background-color: #ccc;\r\n            padding: 15px;\r\n        }\r\n        .drawer {\r\n            background-color: #555;\r\n            padding: 5px;\r\n            margin-bottom: 10px;\r\n            min-height: 80px;\r\n        }\r\n        .drawer .rack {\r\n            background-color: #eee;\r\n            padding: 3px;\r\n            margin-bottom: 3px;\r\n            display: flex;\r\n        }\r\n        .drawer .rack span {\r\n            margin: 2px 10px;\r\n        }\r\n\r\n        .rack {\r\n            background-color: #ccc;\r\n            padding: 15px;\r\n            display: inline-block;\r\n        }\r\n        .row {\r\n            display: flex;\r\n        }\r\n        .slot {\r\n            background-color: #555;\r\n            width: 80px;\r\n            height: 20px;\r\n            margin: 0 5px 5px 0;\r\n        }\r\n        .slot.filled {\r\n            background-color: #f00;\r\n        }\r\n    </style>\r\n\r\n    <div class=\"page-with-header prototype\">\r\n        <div class=\"page-header\">Visualization</div>\r\n        <div class=\"panel-group\">\r\n\r\n            <div class=\"page-panels grid\">\r\n                <div class=\"panel\" style=\"grid-column: 1 / -1\">\r\n                    <div class=\"panel-heading\">Choose Freezer</div>\r\n                    <div class=\"panel-body\">\r\n                        <div class=\"form-group\">\r\n                            <label>Freezers</label>\r\n                            <select value.bind=\"selectedFreezer\" change.delegate=\"getFreezerLayout()\">\r\n                                <option repeat.for=\"freezer of freezers\" model.bind=\"freezer\">${freezer.name}</option>\r\n                            </select>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Racks</label>\r\n                            <select value.bind=\"selectedRack\" change.delegate=\"getRackLayout()\">\r\n                                <option repeat.for=\"rack of racks\" model.bind=\"rack\">${rack.name}</option>\r\n                            </select>\r\n                        </div>\r\n\r\n                        <div class=\"form-group\">\r\n                            <label>Columns</label>\r\n                            <select value.bind=\"selectedCol\" change.delegate=\"getRackLayout()\">\r\n                                <option repeat.for=\"col of columns\" model.bind=\"col\">${col}</option>\r\n                            </select>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n        <div class=\"freezerview\" if.bind=\"selectedFreezer.name\">\r\n            <h1>Freezer</h1>\r\n            <div class=\"freezer\">\r\n                <div class=\"drawer\" repeat.for=\"drawer of drawers\" >\r\n                    <span class=\"name\"><a href=\"#/entity/StorageLocation/${drawer.id}\" style=\"color:#ccc\">${drawer.name}</a></span>\r\n                    <div class=\"rack\" repeat.for=\"rack of drawer.racks\" >\r\n                        <span class=\"name\"><a href=\"#/entity/StorageLocation/${rack.id}\">${rack.name}</a></span>\r\n                        <span class=\"fill-level full\">${rack.boxes.length} / ${rack.capacity? rack.capacity : 100 }</span>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n\r\n        <div class=\"rackview\" if.bind=\"selectedRack.name\">\r\n            <h1>Rack</h1>\r\n            <div class=\"rack\">\r\n                <div class=\"row\" repeat.for=\"row of boxesInTable\">\r\n                    <div repeat.for=\"box of row\" class.bind=\"box ? 'slot filled' : 'slot'\" style=\"overflow: hidden; \">\r\n                        <span class=\"name\"><a href=\"#/entity/StorageLocation/${box.id}\">${box.name}</a></span>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </div>\r\n    </div>\r\n\r\n</template>";

/***/ }),

/***/ "../apps/demo/logistics_app/src/pages/visualization.ts":
/*!*************************************************************!*\
  !*** ../apps/demo/logistics_app/src/pages/visualization.ts ***!
  \*************************************************************/
/*! exports provided: Visualization */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Visualization", function() { return Visualization; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.js");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");



let Visualization = class Visualization {
    constructor(server) {
        this.server = server;
        this.columns = [1, 2, 3, 4, 5];
        this.letters = ["A", "B", "C", "D", "E"];
    }
    attached() {
        this.getContainers();
    }
    getContainers() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataset = yield this.server.datasetQuery([
                { eClass: 'StorageLocation', collection: 'freezers', filters: [{ field: 'Type', value: 'Freezer' }] },
                { eClass: 'StorageLocation', collection: 'drawers', filters: [{ field: 'Type', value: 'Drawer' }] },
                { eClass: 'StorageLocation', collection: 'racks', filters: [{ field: 'Type', value: 'Rack' }] },
                { eClass: 'StorageLocation', collection: 'boxes', filters: [{ field: 'Type', value: 'Box' }] }
            ]);
            this.freezers = dataset.freezers;
            this.drawers = dataset.drawers;
            this.racks = dataset.racks;
            this.boxes = dataset.boxes;
        });
    }
    getFreezerLayout() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.drawers = this.drawers.filter(d => d.locationID === this.selectedFreezer.id);
            this.drawers.forEach(d => d.racks = this.racks.filter(r => r.locationID === d.id));
            this.racks.forEach(r => r.boxes = this.boxes.filter(b => b.locationID === r.id));
        });
    }
    getRowNum() {
        this.selectedRow = Math.ceil((this.selectedRack.capacity || 10) / this.selectedCol);
    }
    getRackLayout() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.getRowNum();
            if (!this.selectedRack) {
                return;
            }
            let boxesInList = Array(this.selectedRow * this.selectedCol);
            let boxesInRack = this.boxes.filter(b => b.locationID === this.selectedRack.id);
            for (let box of boxesInRack) {
                if (box.position) {
                    boxesInList[(box.position.slice(1) - 1) * this.selectedCol + this.letters.indexOf(box.position.slice(0, 1))] = box;
                }
                else {
                    boxesInList[boxesInList.findIndex(t => !t)] = box;
                }
            }
            this.boxesInTable = [];
            while (boxesInList.length > 0) {
                this.boxesInTable.push(boxesInList.splice(0, this.selectedCol));
            }
        });
    }
};
Visualization = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["route"])({
        route: 'logistics/visualization',
        title: 'Logistics - Visualization'
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], Visualization);



/***/ })

}]);
//# sourceMappingURL=visualization.1689f8bda2b220050734.js.map