import { Entity, EntityInfo, User, WFTemplates } from '@scifeon/core';
export declare class WorkflowEngine {
    private templates;
    private options;
    private user;
    private builders;
    newEntities: Entity[];
    private entityInfos;
    private idCounter;
    constructor(templates: WFTemplates, options: any, user: User);
    buildStep(template: any, dsInput: any): any;
    private createStep;
    buildExperiment(template: any, dsInput: any): any;
    addNewEntityInfo(entityInfo: EntityInfo): void;
    addNewEntity(entity: Entity): void;
    getEntityInfo(key: string): EntityInfo;
    getID(prefix: string): string;
    private getTemplate;
    transferInheritedProperties(smpParent: any, smpChild: any, tptWell?: any): void;
    /**
     * Sets the @param property on @param object if it not set.
     * Values of @param values are prioritized from left to right.
     */
    private setEntityProperty;
    /**
 * Replaces ${} in @param value with matching properties from this.datasetIn.
 */
    private replaceTemplateLiterals;
}
