import { BindingEngine } from 'aurelia-binding';
import { Container } from 'aurelia-dependency-injection';
import { DialogService } from 'aurelia-dialog';
export declare class Dialog {
    private dialogService;
    private bindingEngine;
    private container;
    static enterKeyPressedAction(target: any, name: any, descriptor: any): void;
    private logger;
    constructor(dialogService: DialogService, bindingEngine: BindingEngine, container: Container);
    print(options: {
        viewModel?: Function;
        view?: string;
        model?: any;
    }): import("aurelia-dialog/dist/commonjs/dialog-service").DialogOpenPromise<import("aurelia-dialog/dist/commonjs/dialog-service").DialogCancellableOpenResult>;
    callWindowPrint(): void;
    open(options: {
        viewModel?: Function;
        view?: string;
        model?: any;
        header?: string;
        message?: string;
        confirm?: string;
        lock?: boolean;
        showCancel?: boolean;
        style?: string;
    }): import("aurelia-dialog/dist/commonjs/dialog-service").DialogOpenPromise<import("aurelia-dialog/dist/commonjs/dialog-service").DialogCancellableOpenResult>;
    confirm(question: any, showCancel?: boolean): Promise<boolean>;
    message(message: any): Promise<boolean>;
    private getBaseDialog;
    private getConfirmDialog;
    private getMessageDialog;
    private getHtmlDialog;
    close(ok?: boolean, object?: any): void;
    cancel(object?: any): void;
    ok(object?: any): void;
    error(message: string): void;
    private callDialogMethod;
}
