/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 	};
/******/
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		"app": 0
/******/ 	};
/******/
/******/
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "" + chunkId + "." + "7d2e17d8ae74be98b4b6" + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var head = document.getElementsByTagName('head')[0];
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							var error = new Error('Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')');
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/dist/";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["webpackJsonp"] = window["webpackJsonp"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "./SPA/module/data-upload/data-loaders/data-loader-attach-file.ts":
/*!************************************************************************!*\
  !*** ./SPA/module/data-upload/data-loaders/data-loader-attach-file.ts ***!
  \************************************************************************/
/*! exports provided: DataLoaderAttachFile */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataLoaderAttachFile", function() { return DataLoaderAttachFile; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");


let DataLoaderAttachFile = class DataLoaderAttachFile {
    constructor(context) {
        this.init(context);
    }
    init(context) {
        this.context = context;
        this.entity = context.entity;
        this.selectedEntity = this.entity;
    }
    optionsView() {
        return `
<label>
    <input type="radio" name="selectedEntity" model.bind="entity" checked.bind="selectedEntity" />
    \${entity.eClass}
</label>
<label if.bind="entity.steps" repeat.for="step of entity.steps">
    <input type="radio" name="selectedEntity" model.bind="step" checked.bind="selectedEntity" />
    Step: \${step.name}
</label>
<label if.bind="entity.resultSets" repeat.for="resultSet of entity.resultSets">
    <input type="radio" name="selectedEntity" model.bind="resultSet" checked.bind="selectedEntity" />
    ResultSet: \${resultSet.id}
</label>`;
    }
    getResult() {
        return {
            entities: this.context.fileInfos.map(fileInfo => {
                return {
                    eClass: 'File',
                    subjectClass: this.selectedEntity.eClass,
                    subjectID: this.selectedEntity.id,
                    name: fileInfo.filename,
                    content: window.btoa(fileInfo.content),
                    size: fileInfo.file.size,
                    mediaType: fileInfo.type,
                    type: 'AttachedFile'
                };
            })
        };
    }
    entitiesView() {
        return null;
    }
};
DataLoaderAttachFile = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["scifeonPlugin"])({
        name: 'Attach file(s) to entity',
        description: 'Simply attach the file(s) to the selected entity',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].DATA_LOADER
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Object])
], DataLoaderAttachFile);



/***/ }),

/***/ "./SPA/module/data-upload/data-upload-info.ts":
/*!****************************************************!*\
  !*** ./SPA/module/data-upload/data-upload-info.ts ***!
  \****************************************************/
/*! exports provided: DataUploadInfo */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataUploadInfo", function() { return DataUploadInfo; });
class DataUploadInfo {
    constructor(context) {
        this.state = DataUploadInfo.STATES.WAITING;
        this.fileInfos = [];
        this.hasPluginExecuted = false;
        this.plugins = [];
        this.context = Object.assign({ fileInfos: this.fileInfos }, context);
    }
    hasPlugins() {
        return this.plugins.length > 0;
    }
}
DataUploadInfo.CATEGORIES = {
    EXCEL: 'ExcelImport',
    JSON: 'JsonImport',
    CSV: 'CsvImport'
};
DataUploadInfo.STATES = {
    WAITING: 'Waiting',
    IN_PROGRESS: 'InProgress',
    COMPLETED: 'Completed'
};


/***/ }),

/***/ "./SPA/module/data-upload/file-processor.ts":
/*!**************************************************!*\
  !*** ./SPA/module/data-upload/file-processor.ts ***!
  \**************************************************/
/*! exports provided: FileProcessor */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(Promise) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "FileProcessor", function() { return FileProcessor; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var module_data_upload_data_loaders_data_loader_attach_file__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! module/data-upload/data-loaders/data-loader-attach-file */ "./SPA/module/data-upload/data-loaders/data-loader-attach-file.ts");
/* harmony import */ var module_data_upload_data_upload_info__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! module/data-upload/data-upload-info */ "./SPA/module/data-upload/data-upload-info.ts");
/* harmony import */ var papaparse__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! papaparse */ "./node_modules/papaparse/papaparse.js");
/* harmony import */ var papaparse__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(papaparse__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! string-natural-compare */ "./node_modules/string-natural-compare/natural-compare.js");
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(string_natural_compare__WEBPACK_IMPORTED_MODULE_7__);








let FileProcessor = class FileProcessor {
    constructor(pluginManager, pluginLoader) {
        this.pluginManager = pluginManager;
        this.pluginLoader = pluginLoader;
        this.nextFileIndex = 0;
    }
    preprocessFiles(files, context = null) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const dataUploadInfo = new module_data_upload_data_upload_info__WEBPACK_IMPORTED_MODULE_5__["DataUploadInfo"](context);
            for (let i = 0; i < files.length; i++) {
                const file = files[i];
                yield this.loadFile(dataUploadInfo, file);
            }
            dataUploadInfo.fileInfos = dataUploadInfo.fileInfos.sort((a, b) => string_natural_compare__WEBPACK_IMPORTED_MODULE_7__(a.filename, b.filename));
            yield this.loadPlugins(dataUploadInfo);
            if (context) {
                const attachFileDataloader = new module_data_upload_data_loaders_data_loader_attach_file__WEBPACK_IMPORTED_MODULE_4__["DataLoaderAttachFile"](dataUploadInfo.context);
                attachFileDataloader.$METADATA = module_data_upload_data_loaders_data_loader_attach_file__WEBPACK_IMPORTED_MODULE_4__["DataLoaderAttachFile"].$METADATA;
                dataUploadInfo.plugins.push(attachFileDataloader);
            }
            if (dataUploadInfo.hasPlugins()) {
                dataUploadInfo.selectedPlugin = dataUploadInfo.plugins[0];
            }
            return dataUploadInfo;
        });
    }
    loadPlugins(dataUploadInfo) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].setMessage(`Loading plugins for files...`);
            const plugins = yield this.pluginManager.getPlugins(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].DATA_LOADER, dataUploadInfo.context);
            for (const plugin of plugins) {
                const instance = yield this.pluginLoader.getInstance(plugin, dataUploadInfo.context);
                instance.$METADATA = plugin.func.$METADATA;
                dataUploadInfo.plugins.push(instance);
            }
        });
    }
    loadFile(dataUploadInfo, file) {
        return new Promise(resolve => {
            let reader = new FileReader();
            reader.onload = event => {
                _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].setMessage(`Reading file: ${file.name}`);
                let fileInfo = {
                    file: file,
                    content: event.target.result,
                    contentAsBase64: window.btoa(event.target.result),
                    filename: file.name,
                    type: file.type,
                    index: this.nextFileIndex++
                };
                const lcFilename = fileInfo.filename.toLowerCase();
                if (lcFilename.endsWith('.xlsx')) {
                    fileInfo.category = module_data_upload_data_upload_info__WEBPACK_IMPORTED_MODULE_5__["DataUploadInfo"].CATEGORIES.EXCEL;
                }
                if (lcFilename.endsWith('.csv')) {
                    fileInfo.category = module_data_upload_data_upload_info__WEBPACK_IMPORTED_MODULE_5__["DataUploadInfo"].CATEGORIES.CSV;
                }
                if (lcFilename.endsWith('.json')) {
                    fileInfo.category = module_data_upload_data_upload_info__WEBPACK_IMPORTED_MODULE_5__["DataUploadInfo"].CATEGORIES.JSON;
                }
                dataUploadInfo.fileInfos.push(fileInfo);
                switch (fileInfo.category) {
                    case module_data_upload_data_upload_info__WEBPACK_IMPORTED_MODULE_5__["DataUploadInfo"].CATEGORIES.EXCEL:
                        fileInfo.wb = XLSX.read(fileInfo.content, { type: 'binary', cellDates: true });
                        break;
                    case module_data_upload_data_upload_info__WEBPACK_IMPORTED_MODULE_5__["DataUploadInfo"].CATEGORIES.CSV:
                        fileInfo.csv = papaparse__WEBPACK_IMPORTED_MODULE_6__["parse"](fileInfo.content);
                        fileInfo.type = 'text/csv';
                        break;
                    case module_data_upload_data_upload_info__WEBPACK_IMPORTED_MODULE_5__["DataUploadInfo"].CATEGORIES.JSON:
                        fileInfo.json = JSON.parse(fileInfo.content);
                        break;
                }
                resolve(fileInfo);
            };
            const lcFilename = file.name.toLowerCase();
            const match = /(\.\w+)$/.exec(lcFilename);
            const fileSuffix = match[1];
            if (['.txt', '.csv', '.json'].includes(fileSuffix)) {
                reader.readAsText(file);
            }
            else {
                reader.readAsBinaryString(file);
            }
        });
    }
};
FileProcessor = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginManager"], _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginLoader"]])
], FileProcessor);


/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! bluebird */ "./node_modules/bluebird/js/browser/bluebird.js")))

/***/ }),

/***/ "./SPA/module/error/bug-report-service.ts":
/*!************************************************!*\
  !*** ./SPA/module/error/bug-report-service.ts ***!
  \************************************************/
/*! exports provided: BugReportService */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "BugReportService", function() { return BugReportService; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-fetch-client */ "./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var module_error_report_dialog__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! module/error/report-dialog */ "module/error/report-dialog");






let BugReportService = class BugReportService {
    constructor(dialog, http, user) {
        this.dialog = dialog;
        this.http = http;
        this.user = user;
    }
    report(error = null) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            try {
                _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show('Capturing screenshot...');
                const screenShots = [];
                const scifeonMainScreenshot = yield html2canvas(document.getElementById('scifeon-boot'));
                screenShots.push(scifeonMainScreenshot.toDataURL('image/png', 1.0));
                if (document.getElementsByTagName('ux-dialog').length) {
                    const modalElement = document.getElementsByTagName('ux-dialog').item(0);
                    const modalScreenshot = yield html2canvas(modalElement);
                    screenShots.push(modalScreenshot.toDataURL('image/png', 1.0));
                }
                const model = {
                    error: error,
                    screenshots: screenShots,
                    reportService: this
                };
                if (this.user === null) {
                    yield this.save({
                        type: 'Public',
                        severity: 'High',
                        expected: '-',
                        observed: '-',
                        steps: '-'
                    }, model.error, model.screenshots);
                    _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
                    this.dialog.message('The error has been successfully reported. Thanks!');
                }
                else {
                    this.dialog.open({
                        view: __webpack_require__(/*! ./report-dialog.html */ "module/error/report-dialog.html"),
                        viewModel: module_error_report_dialog__WEBPACK_IMPORTED_MODULE_5__["ReportDialog"],
                        model: model
                    }).whenClosed(result => {
                        if (!result.wasCancelled) {
                            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
                            this.dialog.message('The error has been successfully reported. Thanks!');
                        }
                    });
                }
            }
            catch (_a) {
                _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
                this.dialog.message('An error occurred while reporting the bug. Please contact <a href="mailto:support@scifeon.com">support@scifeon.com</a>');
            }
        });
    }
    save(bug, error, screenshots, files = null) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const errorReport = error ? {
                message: error.message,
                stacktrace: error.stacktrace
            } : {};
            let filesToUpload = [];
            for (let screenshot of screenshots) {
                filesToUpload.push({
                    name: `screenshot_${filesToUpload.length}.png`,
                    mediaType: 'image/png',
                    type: 'Screenshot',
                    base64: screenshot.replace('data:image/png;base64,', '')
                });
            }
            if (files) {
                for (let f = 0; f < files.fileInfos.length; f++) {
                    const file = files.fileInfos[f];
                    filesToUpload.push({
                        name: file.filename,
                        mediaType: file.type,
                        type: 'AttachFile',
                        base64: window.btoa(file.content)
                    });
                }
            }
            yield this.http.fetch('/api/log/error/report', {
                method: 'POST',
                body: Object(aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__["json"])({
                    error: errorReport,
                    severity: bug.severity,
                    type: bug.type,
                    component: 'SPA',
                    expected: bug.expected,
                    observed: bug.observed,
                    steps: bug.steps,
                    description: bug.description,
                    url: window.location.href,
                    files: filesToUpload
                })
            });
        });
    }
};
BugReportService = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_3__["HttpClient"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], BugReportService);



/***/ }),

/***/ "./SPA/module/error/error-manager.ts":
/*!*******************************************!*\
  !*** ./SPA/module/error/error-manager.ts ***!
  \*******************************************/
/*! exports provided: ErrorManager */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ErrorManager", function() { return ErrorManager; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _app_dev_bar__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../app/dev-bar */ "module/app/dev-bar");



let ErrorManager = class ErrorManager {
    constructor() {
        this.callbacks = [];
    }
    subscribe(callback) {
        this.callbacks.push(callback);
    }
    showApiError(error) {
        for (let callback of this.callbacks) {
            callback.showApiError(error);
        }
    }
    showError(error) {
        _app_dev_bar__WEBPACK_IMPORTED_MODULE_2__["DevBar"].instance.addError(error);
        for (let callback of this.callbacks) {
            callback.showError(error);
        }
    }
    showMessage(message, error = null) {
        for (let callback of this.callbacks) {
            callback.showMessage(message, error);
        }
    }
};
ErrorManager = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["singleton"])()
], ErrorManager);



/***/ }),

/***/ "./SPA/module/error/scifeon-log-appender.ts":
/*!**************************************************!*\
  !*** ./SPA/module/error/scifeon-log-appender.ts ***!
  \**************************************************/
/*! exports provided: ScifeonLogAppender */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ScifeonLogAppender", function() { return ScifeonLogAppender; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");

class ScifeonLogAppender {
    constructor(errorManager, http) {
        this.errorManager = errorManager;
        this.http = http;
        window.onerror = null;
        window.unhandledrejection = null;
        window.addEventListener("unhandledrejection", (e) => {
            const reason = e.detail && e.detail.reason ? e.detail.reason : e.reason;
            if (reason && !reason.headers) {
                if (!reason.message)
                    reason.message = 'unhandledrejection';
                this.errorManager.showError(reason);
                this.postError('unhandledrejection', reason, reason.message);
            }
        });
        window.addEventListener('error', (ev) => {
            const error = ev.error || {};
            if (!error.message)
                error.message = ev.message;
            this.errorManager.showError(error);
            this.postError('unhandledJSexception', error, ev.message, ev.colno, ev.lineno, ev.filename);
        });
    }
    debug(logger, ...rest) { }
    info(logger, ...rest) { }
    warn(logger, ...rest) { }
    error(logger, ...rest) {
        const error = rest[0];
        const message = error.innerError ? error.innerError.message : error.message ? error.message.split('\n')[0] : error;
        this.errorManager.showError({ name: 'error', message: message, stack: error.message });
        this.postError(logger.id || 'ScifeonLogAppender', error, message, error.column, error.lineNumber, error.fileName);
    }
    postError(loggerName, error, message, column = null, lineNumber = null, filename = null) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const writeError = (stringifiedStack = null) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
                const errorObj = {
                    msg: 'Uncaught JS Exception',
                    errorMsg: message,
                    url: document.location.href,
                    lineNumber: lineNumber,
                    column: column,
                    filename: filename,
                    stringifiedStack: stringifiedStack
                };
                JL(loggerName).fatalException(errorObj, error);
                yield this.http.fetch('/api/log/error/app-insights', {
                    method: 'POST',
                    body: JSON.stringify(errorObj),
                    headers: { 'Content-Type': 'application/json' }
                });
            });
            if (error.stack) {
                StackTrace.fromError(error).then((stackframes) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
                    const stringifiedStack = stackframes.map(sf => sf.toString()).join('\n');
                    yield writeError(stringifiedStack);
                })).catch(err => console.log(err));
            }
            else {
                yield writeError();
            }
        });
    }
}


/***/ }),

/***/ "./SPA/resources/styles/scifeon.scss":
/*!*******************************************!*\
  !*** ./SPA/resources/styles/scifeon.scss ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

// extracted by mini-css-extract-plugin

/***/ }),

/***/ "./SPA/services/auth.ts":
/*!******************************!*\
  !*** ./SPA/services/auth.ts ***!
  \******************************/
/*! exports provided: AuthService */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AuthService", function() { return AuthService; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-fetch-client */ "./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let AuthService = class AuthService {
    constructor(http, config, container) {
        this.http = http;
        this.config = config;
        this.container = container;
        this.storeRememberMe = 'scifeon-remember-me';
        this.logger = aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["LogManager"].getLogger('AuthService');
    }
    refreshUser() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const loadingText = document.getElementById('scifeon-loading-text');
            if (loadingText) {
                loadingText.innerHTML = 'Checking login...';
            }
            const response = yield this.http.fetch('/config?v=' + new Date().getTime());
            if (!response.ok) {
                _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].set({
                    configuration: {}
                });
                localStorage.removeItem(this.storeRememberMe);
                return null;
            }
            const config = yield response.json();
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].set(config);
            this.logger.debug('Config loaded:', _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].get());
            const user = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].get().user;
            if (user) {
                if (loadingText) {
                    loadingText.innerHTML = 'Initializing...';
                }
                this.logger.debug('Setting user: ', user);
                this.container.registerInstance(_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"], new _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"](user));
                return user;
            }
            else {
                localStorage.removeItem(this.storeRememberMe);
                return null;
            }
        });
    }
    login(username, password, rememberMe) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.logger.debug('Logging in...');
            localStorage.setItem(this.storeRememberMe, rememberMe);
            const response = yield this.http.fetch('/api/auth/login/cookie', {
                method: 'post',
                body: JSON.stringify({
                    username: username,
                    password: password,
                    rememberMe: rememberMe
                }),
                headers: { 'Content-Type': 'application/json' },
                credentials: 'same-origin',
            });
            if (response.status >= 200 && response.status <= 300) {
                return response;
            }
            else {
                const errors = yield response.json();
                throw new Error(errors[0].message);
            }
        });
    }
    logout(reload = true) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            reload = reload === undefined ? true : reload;
            this.logger.debug('Logging out...');
            localStorage.removeItem(this.storeRememberMe);
            const response = yield this.http.fetch('/api/auth/logout', {
                method: 'post',
                credentials: 'same-origin',
                headers: { 'Content-Type': 'application/json' }
            });
            if (reload) {
                window.location.reload();
            }
        });
    }
};
AuthService = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2__["HttpClient"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"], aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["Container"]])
], AuthService);



/***/ }),

/***/ "./SPA/services/help.js":
/*!******************************!*\
  !*** ./SPA/services/help.js ***!
  \******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Help = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _aureliaDependencyInjection = __webpack_require__(/*! aurelia-dependency-injection */ "./node_modules/aurelia-dependency-injection/dist/commonjs/aurelia-dependency-injection.js");

var _helpDialog = __webpack_require__(/*! module/app/help-dialog */ "module/app/help-dialog");

var _ui = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Help = exports.Help = (_temp = _class = function () {
    function Help() {
        _classCallCheck(this, Help);
    }

    _createClass(Help, null, [{
        key: 'openContextUrl',
        value: function openContextUrl() {
            var scifeonDocsUrl = 'https://docs.scifeon.com/' + Help.ContextUrl;
            _aureliaDependencyInjection.Container.instance.get(_ui.Dialog).open({ viewModel: _helpDialog.HelpDialog, model: scifeonDocsUrl, lock: false, view: __webpack_require__(/*! module/app/help-dialog.html */ "module/app/help-dialog.html") });
        }
    }, {
        key: 'open',
        value: function open(src, replace) {
            var scifeonDocsUrl = 'https://docs.scifeon.com/';
            if (src) {
                scifeonDocsUrl = replace ? src : scifeonDocsUrl + src;
            }
            _aureliaDependencyInjection.Container.instance.get(_ui.Dialog).open({ viewModel: _helpDialog.HelpDialog, model: scifeonDocsUrl, lock: false, view: __webpack_require__(/*! module/app/help-dialog.html */ "module/app/help-dialog.html") });
        }
    }]);

    return Help;
}(), _class.ContextUrl = '', _temp);

/***/ }),

/***/ "./node_modules/aurelia-bootstrapper/dist/commonjs/aurelia-bootstrapper.js":
/*!*********************************************************************************!*\
  !*** ./node_modules/aurelia-bootstrapper/dist/commonjs/aurelia-bootstrapper.js ***!
  \*********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Promise, process) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.starting = undefined;
exports.bootstrap = bootstrap;

__webpack_require__(/*! aurelia-polyfills */ "./node_modules/aurelia-polyfills/dist/commonjs/aurelia-polyfills.js");

var _aureliaPal = __webpack_require__(/*! aurelia-pal */ "./node_modules/aurelia-pal/dist/commonjs/aurelia-pal.js");

var bootstrapPromises = [];
var startResolve = void 0;

var startPromise = new Promise(function (resolve) {
  return startResolve = resolve;
});
var host = _aureliaPal.PLATFORM.global;
var isNodeLike = typeof process !== 'undefined' && !process.browser;

function ready() {
  if (!host.document || host.document.readyState === 'complete') {
    return Promise.resolve();
  }

  return new Promise(function (resolve) {
    host.document.addEventListener('DOMContentLoaded', completed);
    host.addEventListener('load', completed);

    function completed() {
      host.document.removeEventListener('DOMContentLoaded', completed);
      host.removeEventListener('load', completed);
      resolve();
    }
  });
}

function createLoader() {
  if (_aureliaPal.PLATFORM.Loader) {
    return Promise.resolve(new _aureliaPal.PLATFORM.Loader());
  }

  if (false) { var _m, m; }

  return Promise.reject('No PLATFORM.Loader is defined and there is neither a System API (ES6) or a Require API (AMD) globally available to load your app.');
}

function initializePal(loader) {
  var type = void 0;

  var isRenderer = isNodeLike && (process.type === 'renderer' || process.versions['node-webkit']);

  if (isNodeLike && !isRenderer) {
    type = 'nodejs';
  } else if (typeof window !== 'undefined') {
    type = 'browser';
  } else if (typeof self !== 'undefined') {
    type = 'worker';
  } else {
    throw new Error('Could not determine platform implementation to load.');
  }

  return loader.loadModule('aurelia-pal-' + type).then(function (palModule) {
    return type === 'nodejs' && !_aureliaPal.isInitialized && palModule.globalize() || palModule.initialize();
  });
}

function preparePlatform(loader) {
  var map = function map(moduleId, relativeTo) {
    return loader.normalize(moduleId, relativeTo).then(function (normalized) {
      loader.map(moduleId, normalized);
      return normalized;
    });
  };

  return initializePal(loader).then(function () {
    return loader.normalize('aurelia-bootstrapper');
  }).then(function (bootstrapperName) {
    var frameworkPromise = map('aurelia-framework', bootstrapperName);

    return Promise.all([frameworkPromise, frameworkPromise.then(function (frameworkName) {
      return map('aurelia-dependency-injection', frameworkName);
    }), map('aurelia-router', bootstrapperName), map('aurelia-logging-console', bootstrapperName)]);
  }).then(function (_ref) {
    var frameworkName = _ref[0];
    return loader.loadModule(frameworkName);
  }).then(function (fx) {
    return startResolve(function () {
      return new fx.Aurelia(loader);
    });
  });
}

function config(appHost, configModuleId, aurelia) {
  aurelia.host = appHost;
  aurelia.configModuleId = configModuleId || null;

  if (configModuleId) {
    return aurelia.loader.loadModule(configModuleId).then(function (customConfig) {
      if (!customConfig.configure) {
        throw new Error('Cannot initialize module \'' + configModuleId + '\' without a configure function.');
      }

      return customConfig.configure(aurelia);
    });
  }

  aurelia.use.standardConfiguration().developmentLogging();

  return aurelia.start().then(function () {
    return aurelia.setRoot();
  });
}

function run() {
  return ready().then(createLoader).then(preparePlatform).then(function () {
    var appHosts = host.document.querySelectorAll('[aurelia-app],[data-aurelia-app]');
    for (var i = 0, ii = appHosts.length; i < ii; ++i) {
      var appHost = appHosts[i];
      var moduleId = appHost.getAttribute('aurelia-app') || appHost.getAttribute('data-aurelia-app');
      bootstrap(config.bind(null, appHost, moduleId));
    }

    var toConsole = console.error.bind(console);
    var bootstraps = bootstrapPromises.map(function (p) {
      return p.catch(toConsole);
    });
    bootstrapPromises = null;
    return Promise.all(bootstraps);
  });
}

function bootstrap(configure) {
  var p = startPromise.then(function (factory) {
    return configure(factory());
  });
  if (bootstrapPromises) bootstrapPromises.push(p);
  return p;
}

var starting = exports.starting = run();
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! bluebird */ "./node_modules/bluebird/js/browser/bluebird.js"), __webpack_require__(/*! ./../../../process/browser.js */ "./node_modules/process/browser.js")))

/***/ }),

/***/ "./node_modules/aurelia-dependency-injection/dist/commonjs/aurelia-dependency-injection.js":
/*!*********************************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-dependency-injection/dist/commonjs/aurelia-dependency-injection.js from dll-reference scifeon_vendor ***!
  \*********************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-dependency-injection/dist/commonjs/aurelia-dependency-injection.js");

/***/ }),

/***/ "./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js":
/*!*****************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js");

/***/ }),

/***/ "./node_modules/aurelia-loader-webpack/dist/commonjs/aurelia-loader-webpack.js":
/*!*************************************************************************************!*\
  !*** ./node_modules/aurelia-loader-webpack/dist/commonjs/aurelia-loader-webpack.js ***!
  \*************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Promise, module) {
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var aurelia_metadata_1 = __webpack_require__(/*! aurelia-metadata */ "./node_modules/aurelia-metadata/dist/commonjs/aurelia-metadata.js");
var aurelia_loader_1 = __webpack_require__(/*! aurelia-loader */ "./node_modules/aurelia-loader/dist/commonjs/aurelia-loader.js");
var aurelia_pal_1 = __webpack_require__(/*! aurelia-pal */ "./node_modules/aurelia-pal/dist/commonjs/aurelia-pal.js");
/**
* An implementation of the TemplateLoader interface implemented with text-based loading.
*/
var TextTemplateLoader = /** @class */ (function () {
    function TextTemplateLoader() {
    }
    /**
    * Loads a template.
    * @param loader The loader that is requesting the template load.
    * @param entry The TemplateRegistryEntry to load and populate with a template.
    * @return A promise which resolves when the TemplateRegistryEntry is loaded with a template.
    */
    TextTemplateLoader.prototype.loadTemplate = function (loader, entry) {
        return __awaiter(this, void 0, void 0, function () {
            var text;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, loader.loadText(entry.address)];
                    case 1:
                        text = _a.sent();
                        entry.template = aurelia_pal_1.DOM.createTemplateFromMarkup(text);
                        return [2 /*return*/];
                }
            });
        });
    };
    return TextTemplateLoader;
}());
exports.TextTemplateLoader = TextTemplateLoader;
function ensureOriginOnExports(moduleExports, moduleId) {
    var target = moduleExports;
    var key;
    var exportedValue;
    if (target.__useDefault) {
        target = target.default;
    }
    aurelia_metadata_1.Origin.set(target, new aurelia_metadata_1.Origin(moduleId, 'default'));
    if (typeof target === 'object') {
        for (key in target) {
            exportedValue = target[key];
            if (typeof exportedValue === 'function') {
                aurelia_metadata_1.Origin.set(exportedValue, new aurelia_metadata_1.Origin(moduleId, key));
            }
        }
    }
    return moduleExports;
}
exports.ensureOriginOnExports = ensureOriginOnExports;
/**
* A default implementation of the Loader abstraction which works with webpack (extended common-js style).
*/
var WebpackLoader = /** @class */ (function (_super) {
    __extends(WebpackLoader, _super);
    function WebpackLoader() {
        var _this = _super.call(this) || this;
        _this.moduleRegistry = Object.create(null);
        _this.loaderPlugins = Object.create(null);
        _this.modulesBeingLoaded = new Map();
        _this.useTemplateLoader(new TextTemplateLoader());
        _this.addPlugin('template-registry-entry', {
            fetch: function (moduleId) { return __awaiter(_this, void 0, void 0, function () {
                var HmrContext, entry;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            // HMR:
                            if (false) {}
                            entry = this.getOrCreateTemplateRegistryEntry(moduleId);
                            if (!!entry.templateIsLoaded) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.templateLoader.loadTemplate(this, entry)];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/, entry];
                    }
                });
            }); }
        });
        aurelia_pal_1.PLATFORM.eachModule = function (callback) {
            var registry = __webpack_require__.c;
            var cachedModuleIds = Object.getOwnPropertyNames(registry);
            cachedModuleIds
                // Note: we use .some here like a .forEach that can be "break"ed out of.
                // It will stop iterating only when a truthy value is returned.
                // Even though the docs say "true" explicitly, loader-default also goes by truthy
                // and this is to keep it consistent with that.
                .some(function (moduleId) {
                var moduleExports = registry[moduleId].exports;
                if (typeof moduleExports === 'object') {
                    return callback(moduleId, moduleExports);
                }
                return false;
            });
        };
        return _this;
    }
    WebpackLoader.prototype._import = function (address, defaultHMR) {
        if (defaultHMR === void 0) { defaultHMR = true; }
        return __awaiter(this, void 0, void 0, function () {
            var addressParts, moduleId, loaderPlugin, plugin_1, asyncModuleId, callback;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        addressParts = address.split('!');
                        moduleId = addressParts.splice(addressParts.length - 1, 1)[0];
                        loaderPlugin = addressParts.length === 1 ? addressParts[0] : null;
                        if (!loaderPlugin) return [3 /*break*/, 2];
                        plugin_1 = this.loaderPlugins[loaderPlugin];
                        if (!plugin_1) {
                            throw new Error("Plugin " + loaderPlugin + " is not registered in the loader.");
                        }
                        if (false) {}
                        return [4 /*yield*/, plugin_1.fetch(moduleId)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        if (__webpack_require__.m[moduleId]) {
                            if (defaultHMR && module.hot && this.hmrContext) {
                                module.hot.accept(moduleId, function () { return _this.hmrContext.handleModuleChange(moduleId, module.hot); });
                            }
                            return [2 /*return*/, __webpack_require__(moduleId)];
                        }
                        asyncModuleId = "async!" + moduleId;
                        if (!__webpack_require__.m[asyncModuleId]) return [3 /*break*/, 4];
                        if (defaultHMR && module.hot && this.hmrContext) {
                            module.hot.accept(moduleId, function () { return _this.hmrContext.handleModuleChange(moduleId, module.hot); });
                            module.hot.accept(asyncModuleId, function () { return _this.hmrContext.handleModuleChange(moduleId, module.hot); });
                        }
                        callback = __webpack_require__(asyncModuleId);
                        return [4 /*yield*/, new Promise(callback)];
                    case 3: return [2 /*return*/, _a.sent()];
                    case 4: throw new Error("Unable to find module with ID: " + moduleId);
                }
            });
        });
    };
    /**
    * Maps a module id to a source.
    * @param id The module id.
    * @param source The source to map the module to.
    */
    WebpackLoader.prototype.map = function (id, source) { };
    /**
    * Normalizes a module id.
    * @param moduleId The module id to normalize.
    * @param relativeTo What the module id should be normalized relative to.
    * @return The normalized module id.
    */
    WebpackLoader.prototype.normalizeSync = function (moduleId, relativeTo) {
        return moduleId;
    };
    /**
    * Normalizes a module id.
    * @param moduleId The module id to normalize.
    * @param relativeTo What the module id should be normalized relative to.
    * @return The normalized module id.
    */
    WebpackLoader.prototype.normalize = function (moduleId, relativeTo) {
        return Promise.resolve(moduleId);
    };
    /**
    * Instructs the loader to use a specific TemplateLoader instance for loading templates
    * @param templateLoader The instance of TemplateLoader to use for loading templates.
    */
    WebpackLoader.prototype.useTemplateLoader = function (templateLoader) {
        this.templateLoader = templateLoader;
    };
    /**
    * Loads a collection of modules.
    * @param ids The set of module ids to load.
    * @return A Promise for an array of loaded modules.
    */
    WebpackLoader.prototype.loadAllModules = function (ids) {
        var _this = this;
        return Promise.all(ids.map(function (id) { return _this.loadModule(id); }));
    };
    /**
    * Loads a module.
    * @param moduleId The module ID to load.
    * @return A Promise for the loaded module.
    */
    WebpackLoader.prototype.loadModule = function (moduleId, defaultHMR) {
        if (defaultHMR === void 0) { defaultHMR = true; }
        return __awaiter(this, void 0, void 0, function () {
            var existing, beingLoaded, moduleExports;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        existing = this.moduleRegistry[moduleId];
                        if (existing) {
                            return [2 /*return*/, existing];
                        }
                        beingLoaded = this.modulesBeingLoaded.get(moduleId);
                        if (beingLoaded) {
                            return [2 /*return*/, beingLoaded];
                        }
                        beingLoaded = this._import(moduleId, defaultHMR);
                        this.modulesBeingLoaded.set(moduleId, beingLoaded);
                        return [4 /*yield*/, beingLoaded];
                    case 1:
                        moduleExports = _a.sent();
                        this.moduleRegistry[moduleId] = ensureOriginOnExports(moduleExports, moduleId);
                        this.modulesBeingLoaded.delete(moduleId);
                        return [2 /*return*/, moduleExports];
                }
            });
        });
    };
    /**
    * Loads a template.
    * @param url The url of the template to load.
    * @return A Promise for a TemplateRegistryEntry containing the template.
    */
    WebpackLoader.prototype.loadTemplate = function (url) {
        return this.loadModule(this.applyPluginToUrl(url, 'template-registry-entry'), false);
    };
    /**
    * Loads a text-based resource.
    * @param url The url of the text file to load.
    * @return A Promise for text content.
    */
    WebpackLoader.prototype.loadText = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loadModule(url, false)];
                    case 1:
                        result = _a.sent();
                        if (result instanceof Array && result[0] instanceof Array && result.hasOwnProperty('toString')) {
                            // we're dealing with a file loaded using the css-loader:
                            return [2 /*return*/, result.toString()];
                        }
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
    * Alters a module id so that it includes a plugin loader.
    * @param url The url of the module to load.
    * @param pluginName The plugin to apply to the module id.
    * @return The plugin-based module id.
    */
    WebpackLoader.prototype.applyPluginToUrl = function (url, pluginName) {
        return pluginName + "!" + url;
    };
    /**
    * Registers a plugin with the loader.
    * @param pluginName The name of the plugin.
    * @param implementation The plugin implementation.
    */
    WebpackLoader.prototype.addPlugin = function (pluginName, implementation) {
        this.loaderPlugins[pluginName] = implementation;
    };
    return WebpackLoader;
}(aurelia_loader_1.Loader));
exports.WebpackLoader = WebpackLoader;
aurelia_pal_1.PLATFORM.Loader = WebpackLoader;

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! bluebird */ "./node_modules/bluebird/js/browser/bluebird.js"), __webpack_require__(/*! ./../../../webpack/buildin/module.js */ "./node_modules/webpack/buildin/module.js")(module)))

/***/ }),

/***/ "./node_modules/aurelia-loader/dist/commonjs/aurelia-loader.js":
/*!*****************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-loader/dist/commonjs/aurelia-loader.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-loader/dist/commonjs/aurelia-loader.js");

/***/ }),

/***/ "./node_modules/aurelia-metadata/dist/commonjs/aurelia-metadata.js":
/*!*********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-metadata/dist/commonjs/aurelia-metadata.js from dll-reference scifeon_vendor ***!
  \*********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-metadata/dist/commonjs/aurelia-metadata.js");

/***/ }),

/***/ "./node_modules/aurelia-pal/dist/commonjs/aurelia-pal.js":
/*!***********************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-pal/dist/commonjs/aurelia-pal.js from dll-reference scifeon_vendor ***!
  \***********************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-pal/dist/commonjs/aurelia-pal.js");

/***/ }),

/***/ "./node_modules/aurelia-polyfills/dist/commonjs/aurelia-polyfills.js":
/*!***********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-polyfills/dist/commonjs/aurelia-polyfills.js from dll-reference scifeon_vendor ***!
  \***********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-polyfills/dist/commonjs/aurelia-polyfills.js");

/***/ }),

/***/ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js":
/*!*****************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-router/dist/commonjs/aurelia-router.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");

/***/ }),

/***/ "./node_modules/aurelia-webpack-plugin/runtime/empty-entry.js":
/*!********************************************************************!*\
  !*** ./node_modules/aurelia-webpack-plugin/runtime/empty-entry.js ***!
  \********************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

// This file contains an empty module that does nothing.
// It's meant to be added as an entry point to the main bundle
// and helps reliably adding some Aurelia dependencies that are attached 
// to no module in particular, such as `includeAll` results or `aureliaApp`.
//
// Trying to attach those dependencies to, for example, 'aurelia-bootstrapper' 
// is unreliable if 'aurelia-bootstrapper' is in a DLL outside the bundle.
//
// Trying to attach to 'aurelia-loader-webpack' works well, unless a user
// configures a customized loader instead (unlikely, but in theory supported).


/***/ }),

/***/ "./node_modules/aurelia-webpack-plugin/runtime/pal-loader-entry.js":
/*!*************************************************************************!*\
  !*** ./node_modules/aurelia-webpack-plugin/runtime/pal-loader-entry.js ***!
  \*************************************************************************/
/*! no exports provided */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var aurelia_pal__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! aurelia-pal */ "./node_modules/aurelia-pal/dist/commonjs/aurelia-pal.js");
/* harmony import */ var aurelia_pal__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(aurelia_pal__WEBPACK_IMPORTED_MODULE_0__);
// With default aurelia-loader-webpack config, this module is added as an extra entry
// before any other code executes so that PAL.Loader is properly configured.
// There are several tricky points worth noticing.
// 
// We don't add aurelia-loader-webpack itself as an entry point (used to until 2.0 RC2)
// because it (transitively) brings too much bagage with itself, most notably polyfills.
// This made it super-hard to add other polyfills before Aurelia's and led to various bugs.
//
// We don't add custom code in aurelia-pal or aurelia-loader or aurelia-bootstrapper to detect
// the Webpack environment and configure the loader because they might live in a DLL.
// If they do, they would bring aurelia-loader-webpack along in the DLL and this is a special 
// library that *has to be in the main chunk.*
//
// The over-complicated design I've settled upon in the end is to use this special module
// as an entry point that configures aurelia-loader-webpack. It has minimal static imports:
// just aurelia-pal, which itself has no other dependencies and doesn't run much code.
// It hacks the loader field into a getter so that it can synchronously load aurelia-loader-webpack
// just in time when it is demanded by aurelia-bootstrapper.
// This enables users to load polyfills before aurelia-loader-webpack is actually loaded.



var Loader;

Object.defineProperty(aurelia_pal__WEBPACK_IMPORTED_MODULE_0__["PLATFORM"], "Loader", {
  get: function() {
    return Loader || (Loader = __webpack_require__(/*! aurelia-loader-webpack */ "./node_modules/aurelia-loader-webpack/dist/commonjs/aurelia-loader-webpack.js").WebpackLoader);
  },
  set: function(value) {
    Loader = value;
  }
});


/***/ }),

/***/ "./node_modules/bluebird/js/browser/bluebird.js":
/*!**************************************************************************************************!*\
  !*** delegated ./node_modules/bluebird/js/browser/bluebird.js from dll-reference scifeon_vendor ***!
  \**************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/bluebird/js/browser/bluebird.js");

/***/ }),

/***/ "./node_modules/isomorphic-fetch/fetch-npm-browserify.js":
/*!***************************************************************!*\
  !*** ./node_modules/isomorphic-fetch/fetch-npm-browserify.js ***!
  \***************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

// the whatwg-fetch polyfill installs the fetch() function
// on the global object (window or self)
//
// Return that as the export for use in Webpack, Browserify etc.
__webpack_require__(/*! whatwg-fetch */ "./node_modules/whatwg-fetch/fetch.js");
module.exports = self.fetch.bind(self);


/***/ }),

/***/ "./node_modules/papaparse/papaparse.js":
/*!*****************************************************************************************!*\
  !*** delegated ./node_modules/papaparse/papaparse.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/papaparse/papaparse.js");

/***/ }),

/***/ "./node_modules/process/browser.js":
/*!*************************************************************************************!*\
  !*** delegated ./node_modules/process/browser.js from dll-reference scifeon_vendor ***!
  \*************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/process/browser.js");

/***/ }),

/***/ "./node_modules/string-natural-compare/natural-compare.js":
/*!****************************************************************!*\
  !*** ./node_modules/string-natural-compare/natural-compare.js ***!
  \****************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var alphabet;
var alphabetIndexMap;
var alphabetIndexMapLength = 0;

function isNumberCode(code) {
  return code >= 48 && code <= 57;
}

function naturalCompare(a, b) {
  var lengthA = (a += '').length;
  var lengthB = (b += '').length;
  var aIndex = 0;
  var bIndex = 0;

  while (aIndex < lengthA && bIndex < lengthB) {
    var charCodeA = a.charCodeAt(aIndex);
    var charCodeB = b.charCodeAt(bIndex);

    if (isNumberCode(charCodeA)) {
      if (!isNumberCode(charCodeB)) {
        return charCodeA - charCodeB;
      }

      var numStartA = aIndex;
      var numStartB = bIndex;

      while (charCodeA === 48 && ++numStartA < lengthA) {
        charCodeA = a.charCodeAt(numStartA);
      }
      while (charCodeB === 48 && ++numStartB < lengthB) {
        charCodeB = b.charCodeAt(numStartB);
      }

      var numEndA = numStartA;
      var numEndB = numStartB;

      while (numEndA < lengthA && isNumberCode(a.charCodeAt(numEndA))) {
        ++numEndA;
      }
      while (numEndB < lengthB && isNumberCode(b.charCodeAt(numEndB))) {
        ++numEndB;
      }

      var difference = numEndA - numStartA - numEndB + numStartB; // numA length - numB length
      if (difference) {
        return difference;
      }

      while (numStartA < numEndA) {
        difference = a.charCodeAt(numStartA++) - b.charCodeAt(numStartB++);
        if (difference) {
          return difference;
        }
      }

      aIndex = numEndA;
      bIndex = numEndB;
      continue;
    }

    if (charCodeA !== charCodeB) {
      if (
        charCodeA < alphabetIndexMapLength &&
        charCodeB < alphabetIndexMapLength &&
        alphabetIndexMap[charCodeA] !== -1 &&
        alphabetIndexMap[charCodeB] !== -1
      ) {
        return alphabetIndexMap[charCodeA] - alphabetIndexMap[charCodeB];
      }

      return charCodeA - charCodeB;
    }

    ++aIndex;
    ++bIndex;
  }

  return lengthA - lengthB;
}

naturalCompare.caseInsensitive = naturalCompare.i = function(a, b) {
  return naturalCompare(('' + a).toLowerCase(), ('' + b).toLowerCase());
};

Object.defineProperties(naturalCompare, {
  alphabet: {
    get: function() {
      return alphabet;
    },
    set: function(value) {
      alphabet = value;
      alphabetIndexMap = [];
      var i = 0;
      if (alphabet) {
        for (; i < alphabet.length; i++) {
          alphabetIndexMap[alphabet.charCodeAt(i)] = i;
        }
      }
      alphabetIndexMapLength = alphabetIndexMap.length;
      for (i = 0; i < alphabetIndexMapLength; i++) {
        if (alphabetIndexMap[i] === undefined) {
          alphabetIndexMap[i] = -1;
        }
      }
    },
  },
});

module.exports = naturalCompare;


/***/ }),

/***/ "./node_modules/tslib/tslib.es6.js":
/*!*************************************************************************************!*\
  !*** delegated ./node_modules/tslib/tslib.es6.js from dll-reference scifeon_vendor ***!
  \*************************************************************************************/
/*! exports provided: __extends, __assign, __rest, __decorate, __param, __metadata, __awaiter, __generator, __exportStar, __values, __read, __spread, __await, __asyncGenerator, __asyncDelegator, __asyncValues, __makeTemplateObject, __importStar, __importDefault */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/tslib/tslib.es6.js");

/***/ }),

/***/ "./node_modules/webpack/buildin/module.js":
/*!********************************************************************************************!*\
  !*** delegated ./node_modules/webpack/buildin/module.js from dll-reference scifeon_vendor ***!
  \********************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/webpack/buildin/module.js");

/***/ }),

/***/ "./node_modules/whatwg-fetch/fetch.js":
/*!****************************************************************************************!*\
  !*** delegated ./node_modules/whatwg-fetch/fetch.js from dll-reference scifeon_vendor ***!
  \****************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/whatwg-fetch/fetch.js");

/***/ }),

/***/ "./packages/core/index.ts":
/*!**************************************************************************!*\
  !*** delegated ./packages/core/index.ts from dll-reference scifeon_core ***!
  \**************************************************************************/
/*! exports provided: Config, ScifeonConsoleLogger, ConsoleLogger, Status, Event, DataModel, ReadExcelCommon, XL, LoadingSpinner, ScifeonLoadingSpinner, ServerAPI, User, UserHelper, DSUtils, DateUtils, MathUtils, PLATE, PluginUtils, ScifeonUtils, Utils, SdkUtils, SpreadsheetUtils */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_core */ "dll-reference scifeon_core"))("./packages/core/index.ts");

/***/ }),

/***/ "./packages/plugins/index.ts":
/*!********************************************************************************!*\
  !*** delegated ./packages/plugins/index.ts from dll-reference scifeon_plugins ***!
  \********************************************************************************/
/*! exports provided: AppLoader, POSITIONS, route, scifeonPlugin, KVPJsonFieldPanel, ListColumnOptionsPlugin, PluginLoader, PluginManager, PAGE_TYPE, PLUGIN_TYPE */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_plugins */ "dll-reference scifeon_plugins"))("./packages/plugins/index.ts");

/***/ }),

/***/ "./packages/ui/index.ts":
/*!**********************************************************************!*\
  !*** delegated ./packages/ui/index.ts from dll-reference scifeon_ui ***!
  \**********************************************************************/
/*! exports provided: Dialog, SampleInputSelectorDialogService */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_ui */ "dll-reference scifeon_ui"))("./packages/ui/index.ts");

/***/ }),

/***/ 0:
/*!*****************************************************************************************************************************!*\
  !*** multi aurelia-webpack-plugin/runtime/empty-entry aurelia-webpack-plugin/runtime/pal-loader-entry aurelia-bootstrapper ***!
  \*****************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(/*! aurelia-webpack-plugin/runtime/empty-entry */"./node_modules/aurelia-webpack-plugin/runtime/empty-entry.js");
__webpack_require__(/*! aurelia-webpack-plugin/runtime/pal-loader-entry */"./node_modules/aurelia-webpack-plugin/runtime/pal-loader-entry.js");
module.exports = __webpack_require__(/*! aurelia-bootstrapper */"./node_modules/aurelia-bootstrapper/dist/commonjs/aurelia-bootstrapper.js");


/***/ }),

/***/ "async!app":
/*!*********************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=protected!./SPA/app.ts ***!
  \*********************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | protected */[__webpack_require__.e("elements~protected"), __webpack_require__.e("protected")]).then((function(require) {
		cb(__webpack_require__(/*! !../node_modules/ts-loader?silent=true!./app.ts */ "app"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!customer":
/*!*************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=customer!./SPA/customer.ts ***!
  \*************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	__webpack_require__.e(/*! require.ensure | customer */ "customer").then((function(require) {
		cb(__webpack_require__(/*! !../node_modules/ts-loader?silent=true!./customer.ts */ "customer"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!element/index":
/*!******************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=elements!./SPA/element/index.ts ***!
  \******************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	Promise.all(/*! require.ensure | elements */[__webpack_require__.e("vendors~elements~entity~module/assayadm"), __webpack_require__.e("elements~entity~module/assayadm"), __webpack_require__.e("elements~protected"), __webpack_require__.e("elements")]).then((function(require) {
		cb(__webpack_require__(/*! !../../node_modules/ts-loader?silent=true!./index.ts */ "./node_modules/ts-loader/index.js?silent=true!./SPA/element/index.ts"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!public":
/*!*********************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=public!./SPA/public.ts ***!
  \*********************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	__webpack_require__.e(/*! require.ensure | public */ "public").then((function(require) {
		cb(__webpack_require__(/*! !../node_modules/ts-loader?silent=true!./public.ts */ "public"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "async!resources/index":
/*!*********************************************************************************!*\
  !*** ./node_modules/bundle-loader?lazy&name=resources!./SPA/resources/index.ts ***!
  \*********************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function(cb) {
	__webpack_require__.e(/*! require.ensure | resources */ "resources").then((function(require) {
		cb(__webpack_require__(/*! !../../node_modules/ts-loader?silent=true!./index.ts */ "./node_modules/ts-loader/index.js?silent=true!./SPA/resources/index.ts"));
	}).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
}

/***/ }),

/***/ "aurelia-dialog":
/*!*****************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-dialog/dist/commonjs/aurelia-dialog.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-dialog/dist/commonjs/aurelia-dialog.js");

/***/ }),

/***/ "aurelia-event-aggregator":
/*!*************************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-event-aggregator/dist/commonjs/aurelia-event-aggregator.js from dll-reference scifeon_vendor ***!
  \*************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-event-aggregator/dist/commonjs/aurelia-event-aggregator.js");

/***/ }),

/***/ "aurelia-framework":
/*!***********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js from dll-reference scifeon_vendor ***!
  \***********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-framework/dist/commonjs/aurelia-framework.js");

/***/ }),

/***/ "aurelia-gridster":
/*!*********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-gridster/dist/commonjs/aurelia-gridster.js from dll-reference scifeon_vendor ***!
  \*********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-gridster/dist/commonjs/aurelia-gridster.js");

/***/ }),

/***/ "aurelia-gridster/au-gridster":
/*!****************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-gridster/dist/commonjs/au-gridster.js from dll-reference scifeon_vendor ***!
  \****************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-gridster/dist/commonjs/au-gridster.js");

/***/ }),

/***/ "aurelia-gridster/au-gridster-item":
/*!*********************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-gridster/dist/commonjs/au-gridster-item.js from dll-reference scifeon_vendor ***!
  \*********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-gridster/dist/commonjs/au-gridster-item.js");

/***/ }),

/***/ "aurelia-gridster/au-gridster-placeholder":
/*!****************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-gridster/dist/commonjs/au-gridster-placeholder.js from dll-reference scifeon_vendor ***!
  \****************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-gridster/dist/commonjs/au-gridster-placeholder.js");

/***/ }),

/***/ "aurelia-history-browser":
/*!***********************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-history-browser/dist/commonjs/aurelia-history-browser.js from dll-reference scifeon_vendor ***!
  \***********************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-history-browser/dist/commonjs/aurelia-history-browser.js");

/***/ }),

/***/ "aurelia-logging-console":
/*!***********************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-logging-console/dist/commonjs/aurelia-logging-console.js from dll-reference scifeon_vendor ***!
  \***********************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-logging-console/dist/commonjs/aurelia-logging-console.js");

/***/ }),

/***/ "aurelia-pal-browser":
/*!***************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-pal-browser/dist/commonjs/aurelia-pal-browser.js from dll-reference scifeon_vendor ***!
  \***************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-pal-browser/dist/commonjs/aurelia-pal-browser.js");

/***/ }),

/***/ "aurelia-resize":
/*!********************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-resize/dist/commonjs/index.js from dll-reference scifeon_vendor ***!
  \********************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-resize/dist/commonjs/index.js");

/***/ }),

/***/ "aurelia-resize/resizeable":
/*!*************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-resize/dist/commonjs/resizeable.js from dll-reference scifeon_vendor ***!
  \*************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-resize/dist/commonjs/resizeable.js");

/***/ }),

/***/ "aurelia-templating-binding":
/*!*****************************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-templating-binding/dist/commonjs/aurelia-templating-binding.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-templating-binding/dist/commonjs/aurelia-templating-binding.js");

/***/ }),

/***/ "aurelia-templating-resources":
/*!*********************************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-templating-resources/dist/commonjs/aurelia-templating-resources.js from dll-reference scifeon_vendor ***!
  \*********************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-templating-resources/dist/commonjs/aurelia-templating-resources.js");

/***/ }),

/***/ "aurelia-templating-router":
/*!***************************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-templating-router/dist/commonjs/aurelia-templating-router.js from dll-reference scifeon_vendor ***!
  \***************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-templating-router/dist/commonjs/aurelia-templating-router.js");

/***/ }),

/***/ "aurelia-ui-virtualization":
/*!***************************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-ui-virtualization/dist/commonjs/aurelia-ui-virtualization.js from dll-reference scifeon_vendor ***!
  \***************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-ui-virtualization/dist/commonjs/aurelia-ui-virtualization.js");

/***/ }),

/***/ "aurelia-ui-virtualization/infinite-scroll-next":
/*!**********************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-ui-virtualization/dist/commonjs/infinite-scroll-next.js from dll-reference scifeon_vendor ***!
  \**********************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-ui-virtualization/dist/commonjs/infinite-scroll-next.js");

/***/ }),

/***/ "aurelia-ui-virtualization/virtual-repeat":
/*!****************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-ui-virtualization/dist/commonjs/virtual-repeat.js from dll-reference scifeon_vendor ***!
  \****************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-ui-virtualization/dist/commonjs/virtual-repeat.js");

/***/ }),

/***/ "aurelia-validation":
/*!*************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-validation/dist/commonjs/aurelia-validation.js from dll-reference scifeon_vendor ***!
  \*************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-validation/dist/commonjs/aurelia-validation.js");

/***/ }),

/***/ "aurelia-validation/validate-binding-behavior":
/*!********************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-validation/dist/commonjs/validate-binding-behavior.js from dll-reference scifeon_vendor ***!
  \********************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-validation/dist/commonjs/validate-binding-behavior.js");

/***/ }),

/***/ "aurelia-validation/validation-errors-custom-attribute":
/*!*****************************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-validation/dist/commonjs/validation-errors-custom-attribute.js from dll-reference scifeon_vendor ***!
  \*****************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-validation/dist/commonjs/validation-errors-custom-attribute.js");

/***/ }),

/***/ "aurelia-validation/validation-renderer-custom-attribute":
/*!*******************************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-validation/dist/commonjs/validation-renderer-custom-attribute.js from dll-reference scifeon_vendor ***!
  \*******************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-validation/dist/commonjs/validation-renderer-custom-attribute.js");

/***/ }),

/***/ "boot":
/*!*********************!*\
  !*** ./SPA/boot.ts ***!
  \*********************/
/*! exports provided: configure */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "configure", function() { return configure; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-fetch-client */ "./node_modules/aurelia-fetch-client/dist/commonjs/aurelia-fetch-client.js");
/* harmony import */ var aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_logging_console__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-logging-console */ "aurelia-logging-console");
/* harmony import */ var aurelia_logging_console__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_logging_console__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var bluebird__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! bluebird */ "./node_modules/bluebird/js/browser/bluebird.js");
/* harmony import */ var bluebird__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(bluebird__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var isomorphic_fetch__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! isomorphic-fetch */ "./node_modules/isomorphic-fetch/fetch-npm-browserify.js");
/* harmony import */ var isomorphic_fetch__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(isomorphic_fetch__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var module_app_dev_bar__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! module/app/dev-bar */ "module/app/dev-bar");
/* harmony import */ var module_app_main_menu__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! module/app/main-menu */ "module/app/main-menu");
/* harmony import */ var module_error_error_manager__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! module/error/error-manager */ "./SPA/module/error/error-manager.ts");
/* harmony import */ var module_error_scifeon_log_appender__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! module/error/scifeon-log-appender */ "./SPA/module/error/scifeon-log-appender.ts");
/* harmony import */ var resources_styles_scifeon_scss__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! resources/styles/scifeon.scss */ "./SPA/resources/styles/scifeon.scss");
/* harmony import */ var resources_styles_scifeon_scss__WEBPACK_IMPORTED_MODULE_11___default = /*#__PURE__*/__webpack_require__.n(resources_styles_scifeon_scss__WEBPACK_IMPORTED_MODULE_11__);
/* harmony import */ var services_auth__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! services/auth */ "./SPA/services/auth.ts");













String.prototype.toLowerFirst = function () {
    return this[0].toLowerCase() + this.substring(1);
};
String.prototype.toUpperFirst = function () {
    return this[0].toUpperCase() + this.substring(1);
};
bluebird__WEBPACK_IMPORTED_MODULE_5__["config"]({
    warnings: {
        wForgottenReturn: false
    }
});
window.DEBUG = function () {
    if (location.hostname !== 'localhost'
        && location.hostname.endsWith('.scifeon.cloud')
        && !location.hostname.endsWith('-test.scifeon.cloud'))
        return;
    const getLogger = aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["LogManager"].getLogger;
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["LogManager"].getLogger = id => {
        const logger = getLogger(id);
        const addLogger = l => {
            if (!module_app_dev_bar__WEBPACK_IMPORTED_MODULE_7__["DevBar"].instance) {
                setTimeout(() => addLogger(l), 10);
            }
            else {
                module_app_dev_bar__WEBPACK_IMPORTED_MODULE_7__["DevBar"].instance.addLogger(l);
            }
        };
        addLogger(logger);
        return logger;
    };
    module_app_main_menu__WEBPACK_IMPORTED_MODULE_8__["MainMenu"].allowDevTools = true;
    return true;
};
function configure(aurelia) {
    return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
        document.getElementById('scifeon-loading-text').innerHTML = 'Initializing...';
        const http = aurelia.container.get(aurelia_fetch_client__WEBPACK_IMPORTED_MODULE_2__["HttpClient"]);
        http.configure(config => {
            config
                .withDefaults({
                credentials: 'same-origin',
                headers: {
                    'Accept': 'application/json',
                    'X-Requested-With': 'ScifeonSPA'
                }
            });
        });
        aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["LogManager"].addAppender(new aurelia_logging_console__WEBPACK_IMPORTED_MODULE_4__["ConsoleAppender"]());
        aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["LogManager"].addAppender(new module_error_scifeon_log_appender__WEBPACK_IMPORTED_MODULE_10__["ScifeonLogAppender"](aurelia.container.get(module_error_error_manager__WEBPACK_IMPORTED_MODULE_9__["ErrorManager"]), http));
        aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["LogManager"].setLevel(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["LogManager"].logLevel.error);
        if (location.hostname === 'localhost') {
            window.DEBUG();
        }
        const aureliaConfig = aurelia.use.standardConfiguration();
        const auth = aurelia.container.get(services_auth__WEBPACK_IMPORTED_MODULE_12__["AuthService"]);
        const user = yield auth.refreshUser();
        if (user) {
            document.getElementById('scifeon-loading-text').innerHTML = 'Loading plugins...';
            aureliaConfig
                .plugin('aurelia-dialog', config => config.useDefaults().useCSS(''))
                .plugin('aurelia-gridster')
                .plugin('aurelia-validation')
                .plugin('aurelia-ui-virtualization')
                .plugin('oribella-aurelia-sortable');
            document.getElementById('scifeon-loading-text').innerHTML = 'Loading elements...';
            aureliaConfig
                .feature('resources/index')
                .feature('element/index');
        }
        yield aurelia.start();
        if (user) {
            document.getElementById('scifeon-loading-text').innerHTML = 'Loading apps...';
            const pluginLoader = aurelia.container.get(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PluginLoader"]);
            yield pluginLoader.boostrapPlugins(aurelia);
        }
        document.getElementById('scifeon-loading-text').innerHTML = 'Loading platform...';
        if (user && user.type === 'Customer') {
            aurelia.setRoot('customer');
        }
        else if (user) {
            aurelia.setRoot('app');
        }
        else {
            aurelia.setRoot('public');
        }
    });
}


/***/ }),

/***/ "dll-reference scifeon_core":
/*!*******************************!*\
  !*** external "scifeon_core" ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_core;

/***/ }),

/***/ "dll-reference scifeon_data":
/*!*******************************!*\
  !*** external "scifeon_data" ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_data;

/***/ }),

/***/ "dll-reference scifeon_plugins":
/*!**********************************!*\
  !*** external "scifeon_plugins" ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_plugins;

/***/ }),

/***/ "dll-reference scifeon_ui":
/*!*****************************!*\
  !*** external "scifeon_ui" ***!
  \*****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_ui;

/***/ }),

/***/ "dll-reference scifeon_vendor":
/*!*********************************!*\
  !*** external "scifeon_vendor" ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = scifeon_vendor;

/***/ }),

/***/ "module/app/about-dialog":
/*!****************************************!*\
  !*** ./SPA/module/app/about-dialog.ts ***!
  \****************************************/
/*! exports provided: AboutDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AboutDialog", function() { return AboutDialog; });
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");

class AboutDialog {
    constructor() {
        this.libraries = [
            {
                name: 'Aurelia',
                url: 'http://aurelia.io/'
            },
            {
                name: 'jQuery: ' + jQuery.fn.jquery,
                url: 'http://jquery.com/'
            },
            {
                name: 'Handsontable CE: ' + Handsontable.version,
                url: 'https://handsontable.com/'
            }
        ];
        const version = _scifeon_core__WEBPACK_IMPORTED_MODULE_0__["Config"].get().configuration.version.split('-');
        this.version = version[0];
    }
}


/***/ }),

/***/ "module/app/about-dialog.html":
/*!******************************************!*\
  !*** ./SPA/module/app/about-dialog.html ***!
  \******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog>\r\n        <ux-dialog-header>\r\n            About Scifeon\r\n        </ux-dialog-header>\r\n        <ux-dialog-body class=\"text-center\">\r\n            <p>\r\n                <a href=\"https://www.scifeon.com\" target=\"_blank\">scifeon (version ${version})</a>\r\n            </p>\r\n            <p>\r\n                <i class=\"fa fa-copyright\" aria-hidden=\"true\"></i> Scifeon, 2018\r\n            </p>\r\n            <p>\r\n                <b>Technologies:</b><br/>\r\n                <span repeat.for=\"lib of libraries\"><a href=\"${lib.url}\" target=\"_blank\">${lib.name}</a><br/></span>\r\n            </p>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <button click.trigger=\"dialog.cancel()\" class=\"btn-link\">Close</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "module/app/dev-bar":
/*!***********************************!*\
  !*** ./SPA/module/app/dev-bar.ts ***!
  \***********************************/
/*! exports provided: DevBar, TraverseObject */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DevBar", function() { return DevBar; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TraverseObject", function() { return TraverseObject; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! string-natural-compare */ "./node_modules/string-natural-compare/natural-compare.js");
/* harmony import */ var string_natural_compare__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(string_natural_compare__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _main_menu__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./main-menu */ "module/app/main-menu");

var DevBar_1;




let DevBar = DevBar_1 = class DevBar {
    constructor() {
        this.logLevels = [
            { name: 'none', value: aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.none },
            { name: 'error', value: aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.error },
            { name: 'warn', value: aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.warn },
            { name: 'info', value: aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.info },
            { name: 'debug', value: aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.debug }
        ];
        this.tabs = [
            { title: 'Plugins', tab: 'plugins' },
            { title: 'Page', tab: 'page' },
            { title: 'Loggers', tab: 'loggers' },
            { title: 'Configuration', tab: 'config' },
            { title: 'User', tab: 'user' },
            { title: 'Apps', tab: 'apps' },
            { title: 'Errors', tab: 'errors' }
        ];
        this.state = {
            logLevel: aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].getLevel(),
            visible: false,
            collapsed: false,
            renderLoggersIsDisabled: false,
            disabledLoggers: [],
            tab: 'plugins'
        };
        this.renderPlugins = [];
        this.errors = [];
        this.route = null;
        this.config = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].get();
        this.loggers = [];
        this.renderPluginLoggers = [];
        const state = localStorage.getItem(DevBar_1.KEY_STATE);
        if (state) {
            this.state = JSON.parse(state);
        }
        aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].setLevel(this.state.logLevel);
        if (!_main_menu__WEBPACK_IMPORTED_MODULE_4__["MainMenu"].allowDevTools) {
            this.state.visible = false;
        }
        this.changeTab(this.state.tab);
        DevBar_1.instance = this;
    }
    saveState() {
        localStorage.setItem(DevBar_1.KEY_STATE, JSON.stringify(this.state));
    }
    changeTab(tab = null) {
        this.state.tab = tab;
        this.saveState();
        for (const t of this.tabs) {
            t.active = t.tab === tab;
        }
    }
    toggleCollapsed() {
        this.state.collapsed = !this.state.collapsed;
        this.saveState();
    }
    toggleVisibility() {
        this.state.visible = !this.state.visible;
        if (!this.state.visible) {
            this.state.collapsed = false;
        }
        this.saveState();
    }
    addError(error) {
        if (!_main_menu__WEBPACK_IMPORTED_MODULE_4__["MainMenu"].allowDevTools)
            return;
        this.errors.push(error);
    }
    addRenderPlugin(renderPlugin) {
        if (!_main_menu__WEBPACK_IMPORTED_MODULE_4__["MainMenu"].allowDevTools)
            return;
        this.renderPlugins.push(renderPlugin);
    }
    removeRenderPlugin(renderPlugin) {
        this.renderPlugins = this.renderPlugins.filter(rp => rp.instanceNo !== renderPlugin.instanceNo);
        if (this.renderPlugin && this.renderPlugin.instanceNo === renderPlugin.instanceNo) {
            this.renderPlugin = null;
        }
    }
    selectRenderPlugin(renderPlugin) {
        if (this.renderPlugin) {
        }
        this.renderPlugin = renderPlugin;
    }
    addLogger(logger) {
        if (logger.id.startsWith('RenderPlugin')) {
            if (this.state.renderLoggersIsDisabled) {
                logger.setLevel(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.none);
            }
            this.renderPluginLoggers.push(logger);
        }
        else {
            if (!this.loggers.find(l => l.id === logger.id)) {
                logger.isEnabled = true;
                if (this.state.disabledLoggers.includes(logger.id)) {
                    logger.setLevel(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.none);
                    logger.isEnabled = false;
                }
                this.loggers.push(logger);
                this.loggers = this.loggers.sort((a, b) => string_natural_compare__WEBPACK_IMPORTED_MODULE_3__["caseInsensitive"](a.id, b.id));
            }
        }
    }
    toggleRenderPluginLoggers() {
        this.state.renderLoggersIsDisabled = !this.state.renderLoggersIsDisabled;
        for (const logger of this.renderPluginLoggers) {
            logger.setLevel(this.state.renderLoggersIsDisabled ? aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.none : this.state.logLevel);
        }
        this.saveState();
        return true;
    }
    logLevelChanged() {
        aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].setLevel(this.state.logLevel);
        for (const logger of this.renderPluginLoggers) {
            logger.setLevel(this.state.renderLoggersIsDisabled ? aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.none : this.state.logLevel);
        }
        for (const logger of this.loggers) {
            logger.setLevel(logger.isEnabled ? this.state.logLevel : aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.none);
        }
        this.saveState();
    }
    toggleLogger(logger) {
        if (!logger.isEnabled) {
            logger.setLevel(this.state.logLevel);
            this.state.disabledLoggers = this.state.disabledLoggers.filter(dl => dl !== logger.id);
            logger.isEnabled = true;
        }
        else {
            logger.setLevel(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["LogManager"].logLevel.none);
            this.state.disabledLoggers.push(logger.id);
            logger.isEnabled = false;
        }
        this.saveState();
        return true;
    }
    toggleAllLoggers() {
        const enableAll = this.state.disabledLoggers.length > 0;
        if (enableAll === this.state.renderLoggersIsDisabled) {
            this.toggleRenderPluginLoggers();
        }
        for (const logger of this.loggers.filter(l => l.isEnabled !== enableAll)) {
            this.toggleLogger(logger);
        }
    }
};
DevBar.KEY_STATE = 'DEV_BAR_STATE';
DevBar = DevBar_1 = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["containerless"],
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('dev-bar'),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [])
], DevBar);

let TraverseObject = class TraverseObject {
    constructor(observer) {
        this.observer = observer;
        this.objectValues = [];
    }
    bind() {
        this.setObjectValues();
    }
    objectChanged() {
        this.setObjectValues();
    }
    setObjectValues() {
        if (this.object) {
            this.objectValues = [];
            for (const key in this.object) {
                this.observer.getObserver(this.object, key).subscribe((n, o) => this.setObjectValue(key));
                this.setObjectValue(key);
            }
            this.objectValues = this.objectValues.sort((a, b) => string_natural_compare__WEBPACK_IMPORTED_MODULE_3__(a.key, b.key));
        }
    }
    setObjectValue(key) {
        const existing = this.objectValues.find(o => o.key === key);
        const objectValue = {
            expanded: false,
            key: key,
            isExpandable: this.isExpandable(key),
            value: this.getValue(key),
            type: this.getType(key),
            raw: this.object[key]
        };
        if (existing) {
            existing.isExpandable = objectValue.isExpandable;
            existing.expanded = existing.isExpandable && existing.expanded;
            existing.raw = objectValue.raw;
            existing.value = objectValue.value;
            existing.type = objectValue.type;
        }
        else {
            this.objectValues.push(objectValue);
        }
    }
    isExpandable(key) {
        const type = this.getType(key);
        return (type === 'Array' && this.object[key].length) || type === 'object';
    }
    getValue(key) {
        const type = this.getType(key);
        const value = this.object[key];
        if (type === 'number' || type === 'boolean') {
            return value;
        }
        else if (type === 'string') {
            return `'${value}'`;
        }
        return '';
    }
    getType(key) {
        const value = this.object[key];
        if (value instanceof Array) {
            return 'Array';
        }
        else if (value instanceof Date) {
            return 'Date';
        }
        return typeof value;
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], TraverseObject.prototype, "object", void 0);
TraverseObject = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('traverse-object'),
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["view"])(`<template>
    <div repeat.for="o of objectValues" style="margin-left:10px;">
        <span style="color:brown;">\${o.key}:</span> 
        <span title.bind="o.value">\${o.value}</span> 
        <span style="color:cadetblue;">(\${o.type})</span>
        <a if.bind="o.isExpandable" click.delegate="o.expanded = !o.expanded" class="fa fa-\${o.expanded ? 'minus' : 'plus'}"></a> 
        <traverse-object if.bind="o.expanded" object.bind="o.raw"></traverse-object>
    </div>
</template>`),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["containerless"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["ObserverLocator"]])
], TraverseObject);



/***/ }),

/***/ "module/app/dev-bar.html":
/*!*************************************!*\
  !*** ./SPA/module/app/dev-bar.html ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div if.bind=\"state.visible\" class=\"panel dev-bar\" css=\"z-index: 1000; position: fixed; right: 0; bottom: 0;${state.collapsed ? 'width:200px;z-index:1101' : ''};\">\r\n        <div class=\"panel-heading\">\r\n            Developer Tools\r\n            <span class=\"text-right\">\r\n                <a click.delegate=\"toggleCollapsed()\" title.bind=\"state.collapsed ? 'Maximize' : 'Minimize'\" class=\"fa fa-window-${ state.collapsed ? 'maximize' : 'minimize'}\"></a>\r\n                <a click.delegate=\"toggleVisibility()\" title=\"Close\" class=\"fa fa-window-close\"></a>\r\n            </span>\r\n        </div>\r\n        <div show.bind=\"!state.collapsed\" class=\"panel-body\" style=\"height:250px;display:flex;font-size:85%;\">  \r\n            <div>\r\n                <ul class=\"menu\" style=\"min-width:150px;\">\r\n                    <li repeat.for=\"tab of tabs\" class=\"menu-item\"><a click.delegate=\"changeTab(tab.tab)\" class.bind=\"tab.active ? 'active' : ''\">${tab.title}</a></li>\r\n                </ul>\r\n            </div>   \r\n            <div style=\"overflow:auto;white-space:nowrap;padding-left:5px;font-family: 'Courier New', Courier, monospace;width:100%;\">\r\n                <div if.bind=\"state.tab === 'loggers'\">\r\n                    LogLevel: <select value.bind=\"state.logLevel\" change.delegate=\"logLevelChanged()\" style=\"width:100px;\">\r\n                        <option value.bind=\"ll.value\" repeat.for=\"ll of logLevels\">${ll.name}</option>\r\n                    </select>\r\n                    <button class=\"sm\" if.bind=\"state.logLevel !== '0'\" click.delegate=\"toggleAllLoggers()\">Toggle All</button>\r\n                    <label if.bind=\"state.logLevel !== '0'\" style=\"display:block;\" title=\"RenderPlugins\">\r\n                        <input type=\"checkbox\" checked.bind=\"!state.renderLoggersIsDisabled\" click.delegate=\"toggleRenderPluginLoggers()\"/> \r\n                        RenderPlugins\r\n                    </label>\r\n                    <label repeat.for=\"logger of loggers\" if.bind=\"state.logLevel !== '0'\" style=\"display:block;\" title.bind=\"logger.id\">\r\n                        <input type=\"checkbox\" checked.bind=\"logger.isEnabled\" click.delegate=\"toggleLogger(logger)\"/> \r\n                        ${logger.id}\r\n                    </label>\r\n                </div>\r\n                <div if.bind=\"state.tab === 'config'\">\r\n                    <traverse-object object.bind=\"config.configuration\"></traverse-object>\r\n                </div>\r\n                <div if.bind=\"state.tab === 'user'\">\r\n                    <traverse-object object.bind=\"config.user\"></traverse-object>\r\n                </div>\r\n                <div if.bind=\"state.tab === 'apps'\">\r\n                    <traverse-object object.bind=\"config.apps\"></traverse-object>\r\n                </div>\r\n                <div if.bind=\"state.tab === 'errors'\">\r\n                    <traverse-object object.bind=\"errors\"></traverse-object>\r\n                </div>\r\n                <div if.bind=\"state.tab === 'page'\" style=\"display:flex;\">\r\n                    <div>\r\n                        <b>Route</b><br/>\r\n                        <traverse-object if.bind=\"route\" object.bind=\"route\"></traverse-object>\r\n                    </div>\r\n                    <div>\r\n                        <b>Component</b><br/>\r\n                        <traverse-object if.bind=\"route.viewPortInstructions.default.component\" object.bind=\"route.viewPortInstructions.default.component\"></traverse-object>\r\n                    </div>\r\n                </div>\r\n                <div if.bind=\"state.tab === 'plugins'\" style=\"display:flex;\">\r\n                    <table class=\"row-clickable\">\r\n                        <thead>\r\n                            <tr>\r\n                                <th>Loaded Plugins</th>\r\n                            </tr>\r\n                        </thead>\r\n                        <tbody>\r\n                            <tr repeat.for=\"rp of renderPlugins\" click.delegate=\"selectRenderPlugin(rp)\" css.bind=\"rp.instanceNo === renderPlugin.instanceNo ? 'background-color:#ff000020' : ''\">                            \r\n                                <td>${rp.plugin.metadata.id}</td>\r\n                            </tr>\r\n                        </tbody>\r\n                    </table>\r\n                    <div if.bind=\"renderPlugin\">\r\n                        <b>Plugin</b><br/>\r\n                        <traverse-object if.bind=\"renderPlugin\" object.bind=\"renderPlugin.plugin\"></traverse-object>\r\n                        <traverse-object if.bind=\"renderPlugin\" object.bind=\"{ instanceNo: renderPlugin.instanceNo, loading: renderPlugin.loading, largeLoadingIndicator: renderPlugin.largeLoadingIndicator }\"></traverse-object>\r\n        \r\n                        <div if.bind=\"renderPlugin.error\">\r\n                            <b>Error</b><br/>\r\n                            <traverse-object if.bind=\"renderPlugin\" object.bind=\"renderPlugin.error\"></traverse-object>\r\n                        </div>\r\n        \r\n                        <b>Context</b><br/>\r\n                        <traverse-object if.bind=\"renderPlugin\" object.bind=\"renderPlugin.context\"></traverse-object>\r\n                    </div>\r\n                    <div if.bind=\"renderPlugin\">\r\n                        <b>ViewModel</b><br/>\r\n                        <traverse-object if.bind=\"renderPlugin\" object.bind=\"renderPlugin.viewModel\"></traverse-object>\r\n        \r\n                        <b>View</b><br/>\r\n                        <traverse-object if.bind=\"renderPlugin\" object.bind=\"renderPlugin.inlineView\"></traverse-object>\r\n                    </div>\r\n                </div>\r\n            </div>            \r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/app/help-dialog":
/*!***************************************!*\
  !*** ./SPA/module/app/help-dialog.ts ***!
  \***************************************/
/*! exports provided: HelpDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "HelpDialog", function() { return HelpDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var _about_dialog__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./about-dialog */ "module/app/about-dialog");




let HelpDialog = class HelpDialog {
    constructor(dialog) {
        this.dialog = dialog;
    }
    open() {
        this.waitForCurrentUrl();
        this.scidocsIframe.contentWindow.postMessage('getUrl', '*');
    }
    init(src) {
        this.src = src || 'https://docs.scifeon.com/';
    }
    waitForCurrentUrl() {
        if (window.addEventListener) {
            window.addEventListener("message", this.openUrl, false);
        }
    }
    openUrl(event) {
        const url = event && event.data || this.src;
        const win = window.open(url, '_blank');
        win.focus();
    }
    openAboutDialog() {
        this.dialog.open({ viewModel: _about_dialog__WEBPACK_IMPORTED_MODULE_3__["AboutDialog"], view: __webpack_require__(/*! ./about-dialog.html */ "module/app/about-dialog.html") });
    }
};
HelpDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"]])
], HelpDialog);



/***/ }),

/***/ "module/app/help-dialog.html":
/*!*****************************************!*\
  !*** ./SPA/module/app/help-dialog.html ***!
  \*****************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog style=\"height:100%;margin:30px;\">\r\n        <ux-dialog-body style=\"padding:5px;max-height:none;\">\r\n            <iframe ref=\"scidocsIframe\" src.bind=\"src\" style=\"height:86vh;width:90vw;border:0;\"></iframe>  \r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <button click.delegate=\"openAboutDialog()\" class=\"btn-link float-left\">About</button>\r\n            <button click.trigger=\"open()\" class=\"primary\">Open in new window</button>\r\n            <button click.trigger=\"dialog.cancel()\" class=\"btn-link\">Close</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "module/app/main-menu":
/*!*************************************!*\
  !*** ./SPA/module/app/main-menu.ts ***!
  \*************************************/
/*! exports provided: MainMenu */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MainMenu", function() { return MainMenu; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-event-aggregator */ "aurelia-event-aggregator");
/* harmony import */ var aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var module_error_bug_report_service__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! module/error/bug-report-service */ "./SPA/module/error/bug-report-service.ts");
/* harmony import */ var services_auth__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! services/auth */ "./SPA/services/auth.ts");
/* harmony import */ var services_help__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! services/help */ "./SPA/services/help.js");
/* harmony import */ var services_help__WEBPACK_IMPORTED_MODULE_9___default = /*#__PURE__*/__webpack_require__.n(services_help__WEBPACK_IMPORTED_MODULE_9__);
/* harmony import */ var _eln_popups_create_experiment_popup__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ../eln/popups/create-experiment-popup */ "module/eln/popups/create-experiment-popup");
/* harmony import */ var _dev_bar__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./dev-bar */ "module/app/dev-bar");

var MainMenu_1;











let MainMenu = MainMenu_1 = class MainMenu {
    constructor(router, ea, auth, dialog, pluginLoader, reportService, user) {
        this.router = router;
        this.ea = ea;
        this.auth = auth;
        this.dialog = dialog;
        this.pluginLoader = pluginLoader;
        this.reportService = reportService;
        this.user = user;
        this.KEY_MAIN_MENU_STATE = 'MAIN_MENU_STATE';
        this.open = false;
        this.searchTerm = '';
        this.entries = [];
        this.config = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Config"].get();
        this.baseEntries = [
            {
                route: '/',
                text: 'Dashboards',
                rank: 100,
                iconFA: 'home'
            },
            {
                route: 'entity/browse',
                text: 'Browse Data',
                rank: 150,
                iconFA: 'database'
            },
            {
                route: 'module/data-upload',
                text: 'Upload Data',
                rank: 300,
                iconFA: 'upload'
            }
        ];
        const open = localStorage.getItem(this.KEY_MAIN_MENU_STATE);
        if (open) {
            this.open = JSON.parse(open);
        }
    }
    bind() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadEntries();
        });
    }
    attached() {
        this.eSearchInput.addEventListener('keydown', event => {
            if (event.key === 'Enter' && this.searchTerm) {
                event.preventDefault();
                this.search();
            }
        });
        this.ea.subscribe('router:navigation:success', response => {
            this.setIsActive();
        });
    }
    loadEntries() {
        const entries = this.baseEntries.concat(this.pluginLoader.getMenuItems('main'));
        entries.sort((a, b) => {
            return a.rank - b.rank;
        });
        let lastRank = 0;
        for (const entry of entries.filter(e => !e.roles || this.user.hasOneOfRoles(...e.roles))) {
            this.entries.push(this.generateEntry(entry, lastRank));
            lastRank = entry.rank;
        }
        this.setIsActive();
    }
    setIsActive() {
        for (const entry of this.entries.filter(e => !e.html)) {
            entry.isActive = ('/' + location.hash).startsWith(entry.href) && entry.href !== '/#/';
        }
    }
    generateEntry(entry, lastRank) {
        let menuEntry = {
            text: entry.text,
            rank: entry.rank || lastRank + 1,
            isActive: false,
            iconFA: entry.iconFA
        };
        if (entry.routeId) {
            let route = this.router.routes.filter((route) => {
                return route.name === entry.routeId;
            });
            if (route && route.length > 0) {
                menuEntry.href = `/#/${route[0].route}`;
            }
            else {
                menuEntry.href = `/#/${entry.routeId}`;
            }
        }
        else if (entry.route) {
            menuEntry.href = '/#/' + entry.route;
        }
        else if (entry.uri) {
            menuEntry.href = entry.uri;
        }
        else if (entry.url) {
            menuEntry.href = entry.url;
        }
        else if (entry.html) {
            menuEntry.html = entry.html;
        }
        return menuEntry;
    }
    hamburgerClick() {
        this.open = !this.open;
        localStorage.setItem(this.KEY_MAIN_MENU_STATE, JSON.stringify(this.open));
    }
    searchClick() {
        this.hamburgerClick();
        this.searchHasFocus = true;
    }
    search() {
        this.router.navigate('search?q=' + this.searchTerm);
        this.searchTerm = '';
        this.searchHasFocus = false;
    }
    createNewExperiment() {
        this.dialog.open({
            view: __webpack_require__(/*! ../eln/popups/create-experiment-popup.html */ "module/eln/popups/create-experiment-popup.html"),
            viewModel: _eln_popups_create_experiment_popup__WEBPACK_IMPORTED_MODULE_10__["CreateExperimentPopup"]
        }).whenClosed(value => {
            if (value.wasCancelled)
                return;
            let step = value.output;
        });
    }
    get isAdmin() {
        return this.user.isAdmin;
    }
    get isDevToolsAllowed() {
        return MainMenu_1.allowDevTools;
    }
    logout() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.auth.logout();
        });
    }
    openHelpDialog() {
        services_help__WEBPACK_IMPORTED_MODULE_9__["Help"].openContextUrl();
    }
    reportBug() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.reportService.report();
        });
    }
    toggleDeveloperTools() {
        _dev_bar__WEBPACK_IMPORTED_MODULE_11__["DevBar"].instance.toggleVisibility();
    }
};
MainMenu.allowDevTools = false;
MainMenu = MainMenu_1 = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["customElement"])('main-menu'),
    aurelia_framework__WEBPACK_IMPORTED_MODULE_5__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_router__WEBPACK_IMPORTED_MODULE_6__["Router"],
        aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_4__["EventAggregator"],
        services_auth__WEBPACK_IMPORTED_MODULE_8__["AuthService"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginLoader"],
        module_error_bug_report_service__WEBPACK_IMPORTED_MODULE_7__["BugReportService"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], MainMenu);



/***/ }),

/***/ "module/app/main-menu.html":
/*!***************************************!*\
  !*** ./SPA/module/app/main-menu.html ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template class.bind=\"open ? 'open' : ''\">\r\n    <nav id=\"main-menu\" role=\"navigation\" class.bind=\"open ? 'open' : ''\">\r\n        <ul class=\"menu\">\r\n            <li class=\"section-header top-header\">\r\n                scifeon\r\n                <a class=\"tooltip tooltip-right hide-menu\" data-tooltip=\"Hide menu\"><span class=\"fa fa-angle-double-left\" click.delegate=\"hamburgerClick()\"></span></a>\r\n            </li>\r\n\r\n            <li class=\"menu-item\" if.bind=\"!open\">\r\n                <a class=\"tooltip tooltip-right\" data-tooltip=\"Search all entities\" click.delegate=\"searchClick()\">&bnsp;<div class=\"icon fa fa-search\"></div></a>\r\n            </li>\r\n\r\n            <li class=\"menu-item search-group\" show.bind=\"open\">\r\n                <div class=\"search-input\">\r\n                    <input type=\"text\" focus.bind=\"searchHasFocus\" placeholder=\"Search by id, name, or barcode\" ref=\"eSearchInput\" value.bind=\"searchTerm\"/>\r\n                    <button class=\"fa fa-search\" title=\"Search\" click.delegate=\"search()\" disabled.bind=\"!searchTerm\"></button>\r\n                </div>\r\n            </li>\r\n\r\n            <li class=\"menu-item create-group\">\r\n                <div class=\"fill popover ${ open ? 'popover-below' : 'popover-right' }\">\r\n                    <a title=\"Create new\">\r\n                        <div class=\"icon fa fa-plus-circle\"></div>\r\n                        Create new\r\n                    </a> \r\n                    <div class=\"popover-container\">\r\n                        <div class=\"header\">Create new</div>\r\n                        <a click.delegate=\"createNewExperiment()\" title=\"Create new experiment\">Experiment</a>\r\n                        <a href=\"/#/entity/step/create\" title=\"Create new step\">Step</a>\r\n                    </div>\r\n                </div>\r\n            </li>\r\n            \r\n            <li repeat.for=\"entry of entries\" data-rank=\"${entry.rank}\" class=\"menu-item\">\r\n                <a if.bind=\"entry.href\" href.bind=\"entry.href\" class=\"${entry.isActive ? 'active' : ''} ${open ? '' : 'tooltip tooltip-right'}\" data-tooltip.bind=\"entry.text\" title.bind=\"entry.text\">\r\n                    <div if.bind=\"entry.iconFA\" class=\"icon fa fa-${entry.iconFA}\"></div>\r\n                    <div if.bind=\"!entry.iconFA\" class=\"icon\">${entry.text[0]}</div>\r\n                    ${entry.text}\r\n                </a>\r\n                <span if.bind=\"!entry.entries && entry.html\" innerhtml.bind=\"entry.html\"></span>                \r\n            </li>\r\n        </ul>\r\n\r\n        <div class=\"main-menu-bottom\">\r\n            <ul>\r\n                <li class=\"env\" if.bind=\"config.configuration.envSymbol\">\r\n                    <span class=\"tooltip ${ open ? '' : 'tooltip-right' }\" data-tooltip=\"Instance info: ${config.configuration.env}\">${config.configuration.envSymbol}</span>\r\n                </li>\r\n                <li if.bind=\"isDevToolsAllowed\">\r\n                    <a class=\"tooltip ${ open ? '' : 'tooltip-right' }\" data-tooltip=\"Developer Tools\" click.delegate=\"toggleDeveloperTools()\"><span class=\"fa fa-wrench\"></span></a>\r\n                </li>  \r\n                <li if.bind=\"isAdmin\">\r\n                    <a href=\"/#/admin\" class=\"tooltip ${ open ? '' : 'tooltip-right' }\" data-tooltip=\"Administration\"><span class=\"fa fa-cog\"></span></a>\r\n                </li>                \r\n                <li>\r\n                    <a click.delegate=\"reportBug()\" class=\"tooltip ${ open ? '' : 'tooltip-right' }\" data-tooltip=\"Report bugs\"><span class=\"fa fa-bug\"></span></a>\r\n                </li>\r\n                <li>\r\n                    <a click.delegate=\"openHelpDialog()\" class=\"tooltip ${ open ? '' : 'tooltip-right' }\" data-tooltip=\"Help and Documentation\"><span class=\"fa fa-question-circle\"></span></a>\r\n                </li>\r\n                <li style=\"margin-bottom: 20px\">\r\n                    <div class=\"popover ${ open ? 'popover-left' : 'popover-right' }\">\r\n                        <a>\r\n                            <span class=\"fa fa-user\"></span>\r\n                        </a> \r\n                        <div class=\"popover-container\">\r\n                            <a href=\"/#/user/profile\" title=\"Profile and Settings\">Profile and Settings</a>\r\n                            <a click.delegate=\"logout()\" title=\"Log out\">Log out</a>\r\n                        </div>\r\n                    </div>\r\n                </li>\r\n            </ul>\r\n        </div>\r\n    </nav>    \r\n\r\n    <div id=\"hamburger\" click.delegate=\"hamburgerClick()\" class=\"tooltip tooltip-right\" data-tooltip=\"Show Menu\"><span class=\"fa fa-bars\"></span></div>\r\n</template>";

/***/ }),

/***/ "module/eln/popups/create-experiment-popup":
/*!**********************************************************!*\
  !*** ./SPA/module/eln/popups/create-experiment-popup.ts ***!
  \**********************************************************/
/*! exports provided: CreateExperimentPopup */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CreateExperimentPopup", function() { return CreateExperimentPopup; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var module_data_upload_file_processor__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! module/data-upload/file-processor */ "./SPA/module/data-upload/file-processor.ts");






let CreateExperimentPopup = class CreateExperimentPopup {
    constructor(router, dialog, server, fileProcessor, user) {
        this.router = router;
        this.dialog = dialog;
        this.server = server;
        this.fileProcessor = fileProcessor;
        this.user = user;
        this.protocol = '';
        this.loading = false;
        this.formTypes = [
            { label: 'FACS', url: '/facs/exp-create' }
        ];
    }
    init(model) {
        this.experiment = {
            eClass: 'Experiment',
            name: "(auto-generated)",
            type: "Other",
            status: 'Initial',
            userID: this.user.id
        };
    }
    saveEmpty() {
        this.save([this.experiment]);
    }
    save(entities) {
        this.loading = true;
        this.experiment.name = '!auto';
        this.server.saveEntities(entities)
            .then(response => {
            this.dialog.cancel();
            var assignedID = response.newEntities[0].id;
            this.router.navigate('eln/' + assignedID);
        });
    }
    addUsingForm() {
        this.dialog.cancel();
        this.router.navigate(this.selectedForm.url);
    }
    saveUsingFile() {
        this.save(this.fileProcessingResult.entities);
    }
    filesDropped(event) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            let dataUploadInfo = yield this.fileProcessor.preprocessFiles(event.detail.files, { targetEClass: 'Experiment' });
            this.selectedPlugin = dataUploadInfo.plugins[0];
            this.fileProcessingResult = yield this.selectedPlugin.getResult();
            this.experimentFromFile = this.fileProcessingResult.entities[0];
        });
    }
};
CreateExperimentPopup = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        module_data_upload_file_processor__WEBPACK_IMPORTED_MODULE_5__["FileProcessor"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"]])
], CreateExperimentPopup);



/***/ }),

/***/ "module/eln/popups/create-experiment-popup.html":
/*!************************************************************!*\
  !*** ./SPA/module/eln/popups/create-experiment-popup.html ***!
  \************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n        <style>\r\n            .wrapper {\r\n                display: grid;\r\n                grid-template-columns: 1fr 1fr 1fr;\r\n                grid-gap: 20px;\r\n                margin-top: 15px;\r\n            }\r\n            .wrapper > div > div {\r\n                padding: 10px;\r\n            }\r\n            .wrapper > div:not(:first-child) > div {\r\n                margin-left: -10px;\r\n                padding-left: 20px;\r\n                border-left: 2px solid #d4e0ea;\r\n            }\r\n            select.listbox {\r\n                height: 100px;\r\n            }\r\n            .wrapper button {\r\n                margin: 0 auto;\r\n                display: block;\r\n            }\r\n            .dialog-header-content {\r\n                display: flex;\r\n            }\r\n        </style>\r\n        <ux-dialog>\r\n            <ux-dialog-header>\r\n                <h2 style=\"flex:1\">Create Experiment</h2>\r\n                <button class=\"small secondary\" click.delegate=\"dialog.cancel()\">Cancel</button>\r\n            </ux-dialog-header>\r\n            <ux-dialog-body style=\"width: 900px;\">\r\n                <h3>You can create an experiment in either of three ways:</h3>\r\n    \r\n                <div class=\"wrapper\">\r\n                    <div style=\"display: flex; height: 100%; flex-direction: column;\">\r\n                        <div style=\"flex: 1\">\r\n                            <h3>Create an Empty Experiment</h3>\r\n                            <div class=\"form-group\">\r\n                                <label>Experiment Name</label>\r\n                                <input value.bind=\"experiment.name\"/>\r\n                            </div>\r\n                            <div class=\"form-group\">\r\n                                <label>Experiment Type</label>\r\n                                <input value.bind=\"experiment.type\"/>\r\n                            </div>\r\n                        </div> \r\n                        <div>\r\n                            <div class=\"form-group\">\r\n                                <button click.delegate=\"saveEmpty()\">Create Experiment</button>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                        \r\n                    <div style=\"display: flex; height: 100%; flex-direction: column;\">\r\n                        <div style=\"flex: 1\">\r\n                            <h3>Use a Specific Web Page</h3>\r\n                            <div class=\"form-group\">\r\n                                <label>Experiment Type</label>\r\n                                <select size=\"5\" class=\"listbox\" value.bind=\"selectedForm\">\r\n                                    <option repeat.for=\"type of formTypes\" model.bind=\"type\">${type.label}</option>\r\n                                </select>\r\n                            </div>\r\n                        </div> \r\n                        <div>\r\n                            <div class=\"form-group\">\r\n                                <button click.delegate=\"addUsingForm()\" disabled.bind=\"!selectedForm\">Go To Form</button>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n    \r\n                    <div style=\"display: flex; height: 100%; flex-direction: column;\">\r\n                        <div style=\"flex: 1\">\r\n                            <h3>Upload a File</h3>\r\n                            <div class=\"form-group\">\r\n                                <dropzone dropfiles.trigger=\"filesDropped($event)\" title=\"Drop File Here\" style=\"height: 100%\"></dropzone>\r\n                            </div>\r\n                            <div class=\"view-group\">\r\n                                <label>Selected Data Loader</label>\r\n                                <p>${selectedPlugin.$METADATA.name}</p>\r\n                            </div>\r\n                            <div class=\"view-group\">\r\n                                <label>Experiment Type</label>\r\n                                <p>${experimentFromFile.type}</p>\r\n                            </div>\r\n                        </div> \r\n                        <div>\r\n                            <div class=\"form-group\">\r\n                                <button disabled.bind=\"!selectedPlugin\" click.delegate=\"saveUsingFile()\">Add Step</button>\r\n                            </div>\r\n                        </div>\r\n                    </div>\r\n                </div>\r\n            </ux-dialog-body>\r\n        </ux-dialog>\r\n    </template>\r\n    ";

/***/ }),

/***/ "module/error/report-dialog":
/*!*******************************************!*\
  !*** ./SPA/module/error/report-dialog.ts ***!
  \*******************************************/
/*! exports provided: ReportDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ReportDialog", function() { return ReportDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var module_data_upload_file_processor__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! module/data-upload/file-processor */ "./SPA/module/data-upload/file-processor.ts");





let ReportDialog = class ReportDialog {
    constructor(dialog, fileParser) {
        this.dialog = dialog;
        this.fileParser = fileParser;
        this.entity = {
            eClass: 'Error',
            severity: 'Medium'
        };
    }
    init(model) {
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        this.model = model;
        this.screenshots = model.screenshots;
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            try {
                this.loading = true;
                this.model.reportService.save({
                    severity: this.entity.severity,
                    type: 'Bug',
                    expected: this.entity.expected,
                    observed: this.entity.observed,
                    steps: this.entity.steps,
                    description: this.entity.description
                }, this.model.error, this.model.screenshots, this.files);
                this.loading = false;
                this.dialog.ok(this.entity);
            }
            catch (_a) {
                this.loading = false;
            }
        });
    }
    filesDropped(event) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.files = yield this.fileParser.preprocessFiles(event.detail.files, this.entity);
        });
    }
    removeFile(fileInfo) {
        this.files.fileInfos = this.files.fileInfos.filter(f => f !== fileInfo);
    }
};
ReportDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], module_data_upload_file_processor__WEBPACK_IMPORTED_MODULE_4__["FileProcessor"]])
], ReportDialog);



/***/ }),

/***/ "module/error/report-dialog.html":
/*!*********************************************!*\
  !*** ./SPA/module/error/report-dialog.html ***!
  \*********************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog style=\"min-width: 500px\">\r\n        <ux-dialog-header>\r\n            <h2>Report Bug</h2>\r\n        </ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <entity-form horizontal.bind=\"false\" \r\n                         fields=\"description\"\r\n                         e-class.bind=\"entity.eClass\" \r\n                         object.bind=\"entity\" \r\n                         valid.bind=\"canSave\"></entity-form>  \r\n            <br/>\r\n            <div class=\"panel simple\">\r\n                <div class=\"panel-heading\">Add Details <collapsible default=\"collapsed\"/></div>\r\n                <div class=\"panel-body\">\r\n                    <entity-form horizontal.bind=\"false\" \r\n                                 fields=\"steps, expected, observed\"\r\n                                 e-class.bind=\"entity.eClass\" \r\n                                 object.bind=\"entity\"></entity-form> \r\n                    <div class=\"form-group\">\r\n                        <label>Screenshot(s)</label>\r\n                        <img repeat.for=\"screenshot of screenshots\" src.bind=\"screenshot\" width=\"300\" />\r\n                    </div>\r\n                    <div class=\"form-group\">\r\n                        <dropzone title=\"Drop files to attach\" dropfiles.trigger=\"filesDropped($event)\"></dropzone>\r\n                        <table class=\"full-width\" if.bind=\"files && files.fileInfos.length\">\r\n                            <tr>\r\n                                <th colspan=\"2\">Files for upload</th>\r\n                            </tr>\r\n                            <tr repeat.for=\"fileInfo of files.fileInfos\">\r\n                                <td>${fileInfo.filename}</td>\r\n                                <td class=\"text-right\"><a click.delegate=\"removeFile(fileInfo)\" title=\"Remove file from upload\"><i class=\"fa fa-times\"></i></a></td>\r\n                            </tr>\r\n                        </table>\r\n                    </div>\r\n                </div>\r\n            </div>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <span class=\"loading\" if.bind=\"loading\">-</span>\r\n            <button click.delegate=\"save()\" disabled.bind=\"loading\">OK</button>\r\n            <button class=\"btn-link\" click.trigger=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "oribella-aurelia-sortable":
/*!***************************************************************************************************************************************!*\
  !*** delegated ./node_modules/oribella-aurelia-sortable/dist/commonjs/oribella-aurelia-sortable.js from dll-reference scifeon_vendor ***!
  \***************************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/oribella-aurelia-sortable/dist/commonjs/oribella-aurelia-sortable.js");

/***/ }),

/***/ "oribella-aurelia-sortable/sortable":
/*!**********************************************************************************************************************!*\
  !*** delegated ./node_modules/oribella-aurelia-sortable/dist/commonjs/sortable.js from dll-reference scifeon_vendor ***!
  \**********************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/oribella-aurelia-sortable/dist/commonjs/sortable.js");

/***/ })

/******/ });
//# sourceMappingURL=app.bundle.js.map