(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["eln~entity"],{

/***/ "./SPA/entity/sidebar/sidebar-file-upload-plugin.ts":
/*!**********************************************************!*\
  !*** ./SPA/entity/sidebar/sidebar-file-upload-plugin.ts ***!
  \**********************************************************/
/*! exports provided: SidebarFileUploadPlugin */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SidebarFileUploadPlugin", function() { return SidebarFileUploadPlugin; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var module_data_upload_data_loader_dialog__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! module/data-upload/data-loader-dialog */ "module/data-upload/data-loader-dialog");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! aurelia-event-aggregator */ "aurelia-event-aggregator");
/* harmony import */ var aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_5__);






let SidebarFileUploadPlugin = class SidebarFileUploadPlugin {
    constructor(server, dialog, ea) {
        this.server = server;
        this.dialog = dialog;
        this.ea = ea;
        this.uploading = false;
        this.view = (location) => `
<h1>Files</h1>
<dropzone class="hide-in-print" dropfiles.trigger="dropped($event)" title="Drop files to upload"></dropzone>
<table class="files">
    <tr repeat.for="file of files">
        <td style="width:100%">#{file.name}</td>
        <td class="text-right"><a href="/api/file/#{file.id}" title="Download file"><i class="fa fa-download"></i></a></td>
    </tr>
</table>`;
    }
    init(context) {
        this.context = context;
    }
    dropped(event) {
        const files = event.detail.files;
        if (files.length) {
            this.dialog.open({
                viewModel: module_data_upload_data_loader_dialog__WEBPACK_IMPORTED_MODULE_2__["DataLoaderDialog"],
                view: __webpack_require__(/*! module/data-upload/data-loader-dialog.html */ "module/data-upload/data-loader-dialog.html"),
                model: { context: this.context, files: files }
            })
                .whenClosed((result) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
                if (!result.wasCancelled) {
                    this.ea.publish(_scifeon_core__WEBPACK_IMPORTED_MODULE_3__["Event"].ELN.RELOAD);
                    yield this.loadFiles();
                }
            }));
        }
    }
    attached() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadFiles();
        });
    }
    loadFiles() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const result = yield this.server.getEntities('File', [{ field: 'SubjectClass', value: this.context.entity.eClass }, { field: 'SubjectID', value: this.context.entity.id }]);
            this.files = result.data;
            if (!this.context.entity.files) {
                this.context.entity.files = this.files;
            }
        });
    }
    static isMatch(context) {
        return ['Experiment'].includes(context.entity.eClass) &&
            (context.entity.type !== 'FACS' || context.entity.status === _scifeon_core__WEBPACK_IMPORTED_MODULE_3__["Status"].IN_PROGRESS);
    }
    static getConfig(location) {
        return { rank: 500 };
    }
};
SidebarFileUploadPlugin = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_3__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_4__["Dialog"], aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_5__["EventAggregator"]])
], SidebarFileUploadPlugin);



/***/ }),

/***/ "./SPA/entity/sidebar/sidebar-general-plugin.ts":
/*!******************************************************!*\
  !*** ./SPA/entity/sidebar/sidebar-general-plugin.ts ***!
  \******************************************************/
/*! exports provided: SidebarGeneralPlugin */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SidebarGeneralPlugin", function() { return SidebarGeneralPlugin; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-event-aggregator */ "aurelia-event-aggregator");
/* harmony import */ var aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _status_dialog__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../status-dialog */ "entity/status-dialog");






let SidebarGeneralPlugin = class SidebarGeneralPlugin {
    constructor(server, dialog, ea) {
        this.server = server;
        this.dialog = dialog;
        this.ea = ea;
        this.canChangeStatus = false;
        this.view = () => `
<div class="entity-metadata">
    <table id="entity-metadata-general">
        <tbody>
            <tr><td>ID</td><td id="scifeon-entity-id">#{entity.id}</td></tr>
            <tr if.bind="entity.externalID"><td>External ID</td><td>#{entity.externalID}</td></tr>
            <tr><td>User</td><td>#{entity.userID}</td></tr>
            <tr if.bind="entity.departmentID"><td>Department</td><td>#{entity.departmentID}</td></tr>
            <tr if.bind="entity.projectID"><td>Project</td><td><e-link e-class="Project" entity-id="#{entity.projectID}"></e-link></td></tr>
            <tr><td>Created</td><td title.bind="entity.createdUtc | dateTimeFormat">#{entity.createdDate | dateFormat}</td></tr>
            <tr if.bind="entity.modifiedDate"><td>Modified</td><td title.bind="entity.modifiedUtc | dateTimeFormat">#{entity.modifiedDate | dateFormat}</td></tr>
            <tr><td>Status</td><td>#{entity.status}</td></tr>
        </tbody>
    </table>
</div>`;
    }
    static isMatch() {
        return true;
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.entity = context.entity;
        });
    }
    static getConfig(location) {
        return { rank: 0 };
    }
    loadStatuses() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            const response = yield this.server.get('/api/query/status/' + this.entity.eClass + '/' + this.entity.id);
            this.availableStatuses = yield response.json();
            this.canChangeStatus = this.availableStatuses.length !== 0;
        });
    }
    openChangeStatusDialog() {
        this.dialog.open({
            viewModel: _status_dialog__WEBPACK_IMPORTED_MODULE_5__["StatusDialog"],
            view: __webpack_require__(/*! ../status-dialog.html */ "entity/status-dialog.html"),
            model: { entity: this.entity, statuses: this.availableStatuses }
        }).whenClosed((result) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!result.wasCancelled) {
                this.ea.publish(_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Event"].ELN.RELOAD);
                yield this.loadStatuses();
            }
        }));
    }
};
SidebarGeneralPlugin = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], aurelia_event_aggregator__WEBPACK_IMPORTED_MODULE_3__["EventAggregator"]])
], SidebarGeneralPlugin);



/***/ }),

/***/ "./SPA/module/data-upload/data-loaders/data-loader-final-report.ts":
/*!*************************************************************************!*\
  !*** ./SPA/module/data-upload/data-loaders/data-loader-final-report.ts ***!
  \*************************************************************************/
/*! exports provided: DataLoaderFinalReport */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataLoaderFinalReport", function() { return DataLoaderFinalReport; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");


let DataLoaderFinalReport = class DataLoaderFinalReport {
    constructor(context) {
        this.init(context);
    }
    init(context) {
        this.context = context;
        this.entity = context.entity;
        if (this.entity.requests && this.entity.requests.length) {
            this.selectedEntity = this.entity.requests[0];
        }
    }
    optionsView() {
        return `
<label repeat.for="request of entity.requests">
    <input type="radio" name="request" model.bind="request" checked.bind="selectedEntity" />
    Request: \${request.id}
</label>`;
    }
    getResult() {
        return {
            entities: this.context.fileInfos.map(fileInfo => {
                return {
                    eClass: 'File',
                    subjectClass: this.selectedEntity.eClass,
                    subjectID: this.selectedEntity.id,
                    name: fileInfo.filename,
                    content: window.btoa(fileInfo.content),
                    size: fileInfo.file.size,
                    mediaType: fileInfo.type,
                    type: 'RequestResult'
                };
            })
        };
    }
    entitiesView() {
        return null;
    }
};
DataLoaderFinalReport = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["scifeonPlugin"])({
        name: 'Attach file to request as final result',
        description: 'Attach the file to the selected request',
        type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].DATA_LOADER
    }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [Object])
], DataLoaderFinalReport);



/***/ }),

/***/ "./SPA/module/eln/panels/sidebar-experiment-type-plugin.ts":
/*!*****************************************************************!*\
  !*** ./SPA/module/eln/panels/sidebar-experiment-type-plugin.ts ***!
  \*****************************************************************/
/*! exports provided: SidebarExperimentTypePlugin */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SidebarExperimentTypePlugin", function() { return SidebarExperimentTypePlugin; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);





const getFilter = (experiment) => {
    const filter = { field: 'roles', op: 'contains' };
    if (experiment.name.toLowerCase().startsWith('facs-pd')) {
        filter.value = 'FACS-PD-Scientist';
    }
    else if (experiment.name.toLowerCase().startsWith('facs-gmp')) {
        filter.value = 'FACS-GMP-Scientist';
    }
    else {
        return [];
    }
    return [filter];
};
let SidebarExperimentTypePlugin = class SidebarExperimentTypePlugin {
    constructor(user, pluginManager, pluginLoader, dialog) {
        this.user = user;
        this.pluginManager = pluginManager;
        this.pluginLoader = pluginLoader;
        this.dialog = dialog;
        this.editable = false;
        this.view = () => `
<div class="entity-metadata">
    <h1>Experiment</h1>
    <table>
        <tr><td>Type</td><td>#{experiment.type}</td></tr>
        <tr><td>Scientist</td>
            <td>
                <span>
                    <span>#{experiment.scientistID}</span>
                    <a if.bind="canChangeScientist" click.delegate="changeScientist()" class="fa fa-pencil" style="margin-left:2px;color:#c9c9c9"></a>
                </span>
            </td>
        </tr>
        <tr><td>Analyst</td><td><inplace-edit-foreign-key e-class="User" entity.bind="experiment" key="analystID" editable.bind="experiment.editable"></inplace-edit-foreign-key></td></tr>
        <tr if.bind="experiment.requests.length"><td>Request(s)</td>
            <td><template repeat.for="request of experiment.requests"><a href="/#/entity/request/#{request.id}">#{request.id}</a><br/></template></td>
        </tr>
    </table>
</div>`;
    }
    get canChangeScientist() {
        const canChange = this.user.id === this.experiment.scientistID || this.user.isAdmin;
        return this.editable && (canChange || (this.accessPlugin ? this.accessPlugin.canWrite() : false));
    }
    get requiresAuditEvent() {
        return !!this.experiment.scientistID || this.experiment.scientistID && this.experiment.type === 'FACS';
    }
    static isMatch(context) {
        return context.entity.eClass === 'Experiment';
    }
    static getConfig(location) {
        return { rank: 50 };
    }
    init(context) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.experiment = context.entity;
            this.editable = context.editable;
            this.scientistFilter = getFilter(this.experiment);
            const plugins = yield this.pluginManager.getPlugins([_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].RLS_CHANGE_SCIENTIST], { entity: this.experiment });
            if (plugins.length) {
                this.accessPlugin = yield this.pluginLoader.getInstance(plugins[0], this.experiment);
            }
        });
    }
    changeScientist() {
        this.dialog.open({
            viewModel: ChangeScientistDialog,
            model: this.experiment
        }).whenClosed((result) => tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            Object.assign(this.experiment, result.output);
        }));
    }
};
SidebarExperimentTypePlugin = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginManager"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginLoader"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"]])
], SidebarExperimentTypePlugin);

let ChangeScientistDialog = class ChangeScientistDialog {
    constructor(server, dialog) {
        this.server = server;
        this.dialog = dialog;
        this.loading = false;
        this.view = () => `
<ux-dialog>
    <ux-dialog-header>
        <h2>Change Scientist</h2>
    </ux-dialog-header>
    <ux-dialog-body>
        <div class="form-group">
            <label>Scientist</label>
            <input-foreign-key e-class="User" filters.bind="scientistFilter" value.bind="scientistID"></input-foreign-key>
        </div>
        <div class="form-group">
            <label>Please, state a reason:</label>
            <textarea attach-focus="true" value.bind="reason" style="width: 400px;height: 140px;"></textarea>
        </div>
    </ux-dialog-body>
    <ux-dialog-footer>
        <span class="loading" if.bind="loading">-</span>
        <button disabled.bind="(!reason || oldScientist === scientistID) && oldScientist || !scientistID" click.delegate="ok()">OK</button>
        <button class="btn-link" click.delegate="dialog.cancel()">Cancel</button>
    </ux-dialog-footer>
</ux-dialog>`;
    }
    init(experiment) {
        this.experiment = experiment;
        this.scientistID = this.experiment.scientistID;
        this.oldScientist = this.experiment.scientistID;
        this.scientistFilter = getFilter(this.experiment);
    }
    ok() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading = true;
            const experiment = {
                id: this.experiment.id,
                eClass: 'Experiment',
                version: this.experiment.version,
                scientistID: this.scientistID,
                auditEvents: [{
                        report: this.reason,
                        type: 'ChangeScientist'
                    }]
            };
            let updatedExp = yield this.server.save(experiment);
            this.dialog.ok(updatedExp);
        });
    }
};
ChangeScientistDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"]])
], ChangeScientistDialog);


/***/ }),

/***/ "./SPA/module/pns/child-sample/child-sample-panel.ts":
/*!***********************************************************!*\
  !*** ./SPA/module/pns/child-sample/child-sample-panel.ts ***!
  \***********************************************************/
/*! exports provided: ChildSamplePanel */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ChildSamplePanel", function() { return ChildSamplePanel; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _child_sample_dialog__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./child-sample-dialog */ "module/pns/child-sample/child-sample-dialog");




let ChildSamplePanel = class ChildSamplePanel {
    constructor(dialog) {
        this.dialog = dialog;
        this.view = () => '<button click.delegate="showCreateChildSampleDialog()" style="width: 100%">Create Child Sample</button>';
        this.dialog = dialog;
    }
    static isMatch(context) {
        return context.entity.eClass === 'Sample';
    }
    init(context) {
        this.entity = context.entity;
    }
    getConfig(location) {
        return { rank: 350 };
    }
    showCreateChildSampleDialog() {
        this.dialog.open({
            viewModel: _child_sample_dialog__WEBPACK_IMPORTED_MODULE_3__["ChildSampleDialog"],
            model: this.entity
        });
    }
};
ChildSamplePanel = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_1__["Dialog"]])
], ChildSamplePanel);



/***/ }),

/***/ "./node_modules/aurelia-http-client/dist/commonjs/aurelia-http-client.js":
/*!***************************************************************************************************************************!*\
  !*** delegated ./node_modules/aurelia-http-client/dist/commonjs/aurelia-http-client.js from dll-reference scifeon_vendor ***!
  \***************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = (__webpack_require__(/*! dll-reference scifeon_vendor */ "dll-reference scifeon_vendor"))("./node_modules/aurelia-http-client/dist/commonjs/aurelia-http-client.js");

/***/ }),

/***/ "element/attributes":
/*!***********************************!*\
  !*** ./SPA/element/attributes.ts ***!
  \***********************************/
/*! exports provided: Attributes */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Attributes", function() { return Attributes; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__);


let Attributes = class Attributes {
    entityChanged() { this.update(); }
    kvpChanged() { this.update(); }
    update() {
        this.attributes = [];
        if (this.entity && this.entity.attributes) {
            for (let key in this.entity.attributes) {
                this.attributes.push({ label: key, value: this.entity.attributes[key] });
            }
        }
        if (this.kvp) {
            for (let key in this.kvp) {
                this.attributes.push({ label: key, value: this.kvp[key] });
            }
        }
        this.attributes.sort((a, b) => { return a > b ? -1 : 1; });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Attributes.prototype, "entity", void 0);
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Attributes.prototype, "kvp", void 0);
Attributes = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_1__["customElement"])('attributes')
], Attributes);



/***/ }),

/***/ "element/attributes.html":
/*!*************************************!*\
  !*** ./SPA/element/attributes.html ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <div class=\"view-group\" repeat.for=\"attribute of attributes\">\r\n        <label>${attribute.label}</label>\r\n        <p class.bind=\"attribute.label\">${attribute.value}</p>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "entity/edit-dialog":
/*!***********************************!*\
  !*** ./SPA/entity/edit-dialog.ts ***!
  \***********************************/
/*! exports provided: EditDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "EditDialog", function() { return EditDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_4__);





let EditDialog = class EditDialog {
    constructor(dialog, server, datamodel, element, user, pluginManager) {
        this.dialog = dialog;
        this.server = server;
        this.datamodel = datamodel;
        this.element = element;
        this.user = user;
        this.pluginManager = pluginManager;
        this.jsonPlugins = null;
        this.selectedPlugin = {};
        this.selectedPluginVM = {};
        this.entity = {};
        this.view = () => __webpack_require__(/*! ./edit-dialog.html */ "entity/edit-dialog.html");
    }
    init(model) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.table = this.datamodel.find(model.eClass);
            this.title = this.table.label;
            if (model.entity) {
                this.title = 'Edit ' + this.title;
                this.entity = Object.assign({}, model.entity);
            }
            else {
                this.title = 'Create ' + this.title;
                this.entity.eClass = model.eClass;
                this.entity.userID = this.user.id;
            }
            this.context = {
                entity: this.entity
            };
            this.loadedPlugins = yield this.pluginManager.getPlugins([_scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PLUGIN_TYPE"].JSON_FIELD_EDITOR], this.context);
            this.setJsonPlugins();
        });
    }
    setJsonPlugins() {
        if (this.loadedPlugins.length) {
            const jsonPlugins = {};
            for (const plugin of this.loadedPlugins) {
                const field = (plugin.options.field[0].toUpperCase() + plugin.options.field.substr(1).toLowerCase()).trim();
                if (!jsonPlugins[field]) {
                    jsonPlugins[field] = [];
                }
                jsonPlugins[field].push(plugin);
            }
            const fields = Object.keys(jsonPlugins);
            if (fields.length === 1 || !this.entity.type) {
                this.jsonPlugins = jsonPlugins;
            }
            else {
                this.jsonPlugins = {};
                for (const field of fields) {
                    this.jsonPlugins[field] = jsonPlugins[field].filter(p => p.options.entityType === this.entity.type);
                }
            }
        }
    }
    pluginChanged(field) {
        if (this.selectedPlugin[field]) {
            this.entity.type = this.selectedPlugin[field].options.entityType;
        }
        else {
            this.entity.type = null;
        }
        this.entity[field.toLowerCase()] = {};
        this.setJsonPlugins();
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading = true;
            if (this.entity.id) {
                const response = yield this.server.updateEntity(this.entity);
                this.entity = Object.assign({}, this.entity, response);
            }
            else {
                let newEntity = {};
                for (let key of Object.keys(this.entity)) {
                    if (this.entity[key]) {
                        newEntity[key] = this.entity[key];
                    }
                }
                const response = yield this.server.saveEntities([newEntity]);
                if (response.newEntities) {
                    this.entity = Object.assign({}, newEntity, response.newEntities[0]);
                }
            }
            this.dialog.ok(this.entity);
        });
    }
    get canSave() {
        return this.valid
            && Object.keys(this.selectedPluginVM)
                .every(field => !this.selectedPlugin[field] || this.selectedPluginVM[field].canSave);
    }
};
EditDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_4__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_3__["Dialog"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"],
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["DataModel"],
        Element,
        _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["User"],
        _scifeon_plugins__WEBPACK_IMPORTED_MODULE_2__["PluginManager"]])
], EditDialog);



/***/ }),

/***/ "entity/edit-dialog.html":
/*!*************************************!*\
  !*** ./SPA/entity/edit-dialog.html ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog css=\"max-width: 1000px; width: ${jsonPlugins ? '90vw' : '600px'};\">\r\n        <ux-dialog-header>\r\n            <h2>${title}</h2>\r\n        </ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <div style.bind=\"jsonPlugins ? 'display: grid;grid-template-columns: 50% 49%;grid-gap: 10px;' : ''\">\r\n                <div>\r\n                    <entity-form e-class.bind=\"entity.eClass\" object.bind=\"entity\" valid.bind=\"valid\"></entity-form>\r\n                </div>\r\n                <div if.bind=\"jsonPlugins\">\r\n                    <div repeat.for=\"key of jsonPlugins | objectKeys\" class=\"panel simple\" style=\"margin-bottom: 20px;\">\r\n                        <div class=\"panel-heading\">${key}</div>\r\n                        <div class=\"panel-body\">\r\n                            <div class=\"form-group\">\r\n                                <select value.bind=\"selectedPlugin[key]\" change.delegate=\"pluginChanged(key)\">\r\n                                    <option model.bind=\"null\">Select...</option>\r\n                                    <option model.bind=\"plugin\" repeat.for=\"plugin of jsonPlugins[key]\">${plugin.options.name || plugin.options.entityType}</option>\r\n                                </select>\r\n                            </div>\r\n                            <render-plugin if.bind=\"selectedPlugin[key]\" \r\n                                        plugin.bind=\"selectedPlugin[key]\" \r\n                                        context.bind=\"context\" \r\n                                        view-model.bind=\"selectedPluginVM[key]\"\r\n                                        view=\"editView\"></render-plugin>\r\n                        </div>\r\n                    </div>                    \r\n                </div>\r\n            </div>\r\n\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <span class=\"loading\" if.bind=\"loading\">-</span>\r\n            <button click.delegate=\"save()\" disabled.bind=\"!canSave\">OK</button>\r\n            <button class=\"btn-link\" click.trigger=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "entity/sidebar":
/*!*******************************!*\
  !*** ./SPA/entity/sidebar.ts ***!
  \*******************************/
/*! exports provided: Sidebar */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Sidebar", function() { return Sidebar; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/plugins */ "./packages/plugins/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var entity_edit_dialog__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! entity/edit-dialog */ "entity/edit-dialog");
/* harmony import */ var module_eln_panels_sidebar_experiment_type_plugin__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! module/eln/panels/sidebar-experiment-type-plugin */ "./SPA/module/eln/panels/sidebar-experiment-type-plugin.ts");
/* harmony import */ var module_pns_child_sample_child_sample_panel__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! module/pns/child-sample/child-sample-panel */ "./SPA/module/pns/child-sample/child-sample-panel.ts");
/* harmony import */ var _sidebar_sidebar_file_upload_plugin__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./sidebar/sidebar-file-upload-plugin */ "./SPA/entity/sidebar/sidebar-file-upload-plugin.ts");
/* harmony import */ var _sidebar_sidebar_general_plugin__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./sidebar/sidebar-general-plugin */ "./SPA/entity/sidebar/sidebar-general-plugin.ts");









let Sidebar = class Sidebar {
    constructor(pluginManager, dialog, bindingEngine) {
        this.pluginManager = pluginManager;
        this.dialog = dialog;
        this.bindingEngine = bindingEngine;
        this.plugins = [];
        this.loading = true;
        this.pluginManager.add(_sidebar_sidebar_general_plugin__WEBPACK_IMPORTED_MODULE_8__["SidebarGeneralPlugin"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].ENTITY_SIDEBAR]);
        this.pluginManager.add(module_eln_panels_sidebar_experiment_type_plugin__WEBPACK_IMPORTED_MODULE_5__["SidebarExperimentTypePlugin"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].ENTITY_SIDEBAR]);
        this.pluginManager.add(_sidebar_sidebar_file_upload_plugin__WEBPACK_IMPORTED_MODULE_7__["SidebarFileUploadPlugin"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].ENTITY_SIDEBAR]);
        this.pluginManager.add(module_pns_child_sample_child_sample_panel__WEBPACK_IMPORTED_MODULE_6__["ChildSamplePanel"], [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].ENTITY_SIDEBAR]);
    }
    contextChanged() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadPlugins();
            this.observerContext();
        });
    }
    bind() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            yield this.loadPlugins();
            this.observerContext();
        });
    }
    edit() {
        this.dialog.open({
            view: __webpack_require__(/*! ./edit-dialog.html */ "entity/edit-dialog.html"),
            viewModel: entity_edit_dialog__WEBPACK_IMPORTED_MODULE_4__["EditDialog"],
            model: { entity: this.context.entity, eClass: this.context.entity.eClass, context: this.context }
        }).whenClosed(result => {
            if (!result.wasCancelled) {
                this.context.entity = Object.assign({}, this.context.entity, result.output);
            }
        });
    }
    observerContext() {
        if (this.context && this.context.experiment) {
            this.bindingEngine.propertyObserver(this.context.loading, 'plates').subscribe(() => this.loadPlugins());
        }
    }
    loadPlugins() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!this.context || this.context.experiment && this.context.loading.steps)
                return;
            const loadedPlugins = [];
            const plugins = yield this.pluginManager.getPlugins(_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].ENTITY_SIDEBAR, this.context);
            for (let p = 0; p < plugins.length; p++) {
                loadedPlugins.push({
                    plugin: plugins[p],
                    config: this.pluginManager.getConfig(plugins[p], { type: _scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PLUGIN_TYPE"].ENTITY_SIDEBAR })
                });
            }
            this.plugins = loadedPlugins.sort((a, b) => {
                return a.config.rank < b.config.rank ? -1 : 1;
            });
            this.loading = false;
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["bindable"])({ defaultBindingMode: aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["bindingMode"].twoWay }),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Object)
], Sidebar.prototype, "context", void 0);
Sidebar = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_plugins__WEBPACK_IMPORTED_MODULE_1__["PluginManager"], _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["BindingEngine"]])
], Sidebar);



/***/ }),

/***/ "entity/sidebar.html":
/*!*********************************!*\
  !*** ./SPA/entity/sidebar.html ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = " <template>     \r\n    <div class=\"sidebar fixed\">           \r\n        <div class=\"heading\" if.bind=\"context.entity\">\r\n            <p class=\"eclass\"><a href=\"/#/entity/${context.entity.eClass}\">${context.entity.eClass}</a></p>\r\n            <h1>${context.entity.name}</h1>\r\n        </div>\r\n        <div class=\"content\">\r\n            <div class=\"loading loading-lg\" if.bind=\"loading\"></div>\r\n            <section else repeat.for=\"plugin of plugins\" data-rank.bind=\"plugin.config.rank\">\r\n                <render-plugin plugin.bind=\"plugin.plugin\" context.bind=\"context\"></render-plugin>\r\n            </section>\r\n        </div>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "entity/status-dialog":
/*!*************************************!*\
  !*** ./SPA/entity/status-dialog.ts ***!
  \*************************************/
/*! exports provided: StatusDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "StatusDialog", function() { return StatusDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);




let StatusDialog = class StatusDialog {
    constructor(dialog, server) {
        this.dialog = dialog;
        this.server = server;
        this.loading = false;
        this.statusOptions = [];
    }
    init(model) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!model.entity) {
                throw new Error('Entity not found on model input.');
            }
            this.entity = model.entity;
            this.status = this.entity.status;
            let statuses = model.statuses;
            if (!statuses) {
                this.loading = true;
                const response = yield this.server.get('/api/query/status/' + this.entity.eClass + '/' + this.entity.id);
                statuses = yield response.json();
                this.loading = false;
            }
            for (let status of statuses) {
                this.statusOptions.push({
                    name: status,
                    value: status
                });
            }
        });
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.loading = true;
            try {
                yield this.server.putJson('/api/update/status', [{
                        id: this.entity.id,
                        eClass: this.entity.eClass,
                        newStatus: this.status
                    }]);
                this.entity.status = this.status;
                this.dialog.ok();
            }
            catch (error) {
                this.error = error.message;
            }
        });
    }
    get canSave() {
        return !this.loading && this.statusOptions.length > 0 && !this.error;
    }
};
StatusDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"]])
], StatusDialog);



/***/ }),

/***/ "entity/status-dialog.html":
/*!***************************************!*\
  !*** ./SPA/entity/status-dialog.html ***!
  \***************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog>\r\n        <ux-dialog-header>\r\n            <h2>Change status</h2>\r\n        </ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <select value.bind=\"status\" if.bind=\"statusOptions.length\">\r\n                <option value.bind=\"option.value\" repeat.for=\"option of statusOptions\">${option.name}</option>\r\n            </select>\r\n            <i if.bind=\"!statusOptions.length && !loading\">You don't have permissions to change status for this entity.</i>\r\n            <p if.bind=\"error\" style=\"color: red;\">Error: ${error}</p>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <span if.bind=\"loading\" class=\"loading\">-</span>\r\n            <button click.delegate=\"save()\" disabled.bind=\"!canSave\">OK</button>\r\n            <button class=\"btn-link\" click.delegate=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "module/data-upload/data-loader-dialog":
/*!******************************************************!*\
  !*** ./SPA/module/data-upload/data-loader-dialog.ts ***!
  \******************************************************/
/*! exports provided: DataLoaderDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataLoaderDialog", function() { return DataLoaderDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_http_client__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-http-client */ "./node_modules/aurelia-http-client/dist/commonjs/aurelia-http-client.js");
/* harmony import */ var aurelia_http_client__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_http_client__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var module_error_error_manager__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! module/error/error-manager */ "./SPA/module/error/error-manager.ts");
/* harmony import */ var _data_loaders_data_loader_attach_file__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./data-loaders/data-loader-attach-file */ "./SPA/module/data-upload/data-loaders/data-loader-attach-file.ts");
/* harmony import */ var _data_loaders_data_loader_final_report__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./data-loaders/data-loader-final-report */ "./SPA/module/data-upload/data-loaders/data-loader-final-report.ts");
/* harmony import */ var _file_processor__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./file-processor */ "./SPA/module/data-upload/file-processor.ts");









let DataLoaderDialog = class DataLoaderDialog {
    constructor(fileProcessor, dialog, http, errorManager) {
        this.fileProcessor = fileProcessor;
        this.dialog = dialog;
        this.http = http;
        this.errorManager = errorManager;
        this.isSaving = false;
        this.saveProgressText = '';
        this.currentProgressPct = 0;
    }
    init(model) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].show();
            this.dataUploadInfo = yield this.fileProcessor.preprocessFiles(model.files, model.context);
            _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["LoadingSpinner"].hide(true);
        });
    }
    get canSave() {
        return !this.dataUploadInfo.error
            && this.dataUploadInfo.hasPluginExecuted
            && !this.isSaving
            && (this.dataUploadInfo.selectedPlugin.canSave === undefined || (this.dataUploadInfo.selectedPlugin.canSave !== undefined && this.dataUploadInfo.selectedPlugin.canSave));
    }
    save() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.isSaving = true;
            this.dataUploadInfo.error = null;
            if (this.dataUploadInfo.selectedPlugin instanceof _data_loaders_data_loader_attach_file__WEBPACK_IMPORTED_MODULE_6__["DataLoaderAttachFile"]) {
                yield this.attachFile(this.dataUploadInfo);
            }
            else if (this.dataUploadInfo.selectedPlugin instanceof _data_loaders_data_loader_final_report__WEBPACK_IMPORTED_MODULE_7__["DataLoaderFinalReport"]) {
                yield this.attachFile(this.dataUploadInfo, 'RequestResult');
            }
            else {
                yield this.saveEntities(this.dataUploadInfo);
            }
            if (!this.dataUploadInfo.error) {
                this.dialog.ok();
            }
            else {
                this.isSaving = false;
            }
        });
    }
    attachFile(dataUploadInfo, type = 'AttachedFile') {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.saveProgressText = 'Preparing...';
            const plugin = dataUploadInfo.selectedPlugin;
            for (let fileInfo of this.dataUploadInfo.fileInfos) {
                let formData = new FormData();
                formData.append('file', fileInfo.file);
                formData.append('subjectClass', plugin.selectedEntity.eClass);
                formData.append('subjectID', plugin.selectedEntity.id);
                formData.append('type', type);
                try {
                    yield this.http.createRequest('api/file')
                        .asPost()
                        .withContent(formData)
                        .withProgressCallback(event => this.setProgress(event))
                        .send();
                }
                catch (err) {
                    this.dataUploadInfo.error = err.response[0];
                }
            }
        });
    }
    saveEntities(dataUploadInfo) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.saveProgressText = 'Preparing...';
            try {
                const result = yield dataUploadInfo.selectedPlugin.getResult();
                if (result && result.entities) {
                    let payload = { entities: result.entities };
                    if (result.lookups) {
                        payload.lookups = result.lookups;
                    }
                    try {
                        yield this.http.createRequest('/api/entity')
                            .asPost()
                            .withHeader('Content-Type', 'application/json')
                            .withContent(payload)
                            .withProgressCallback(event => this.setProgress(event))
                            .send();
                    }
                    catch (err) {
                        this.dataUploadInfo.error = JSON.parse(err.response)[0];
                    }
                }
                else {
                    this.dataUploadInfo.error = new Error('The data loader did not return a result.');
                }
            }
            catch (e) {
                dataUploadInfo.error = e;
                console.error(e);
            }
        });
    }
    setProgress(event) {
        if (event.loaded === event.total) {
            this.currentProgressPct = 100;
            this.saveProgressText = 'Saving on server...';
        }
        else {
            this.currentProgressPct = event.loaded / event.total * 100;
            this.saveProgressText = `Uploading: ${(event.loaded / 1000 / 1000).toFixed(2)}MB / ${(event.total / 1000 / 1000).toFixed(2)}MB`;
        }
    }
};
DataLoaderDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_file_processor__WEBPACK_IMPORTED_MODULE_8__["FileProcessor"],
        _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"],
        aurelia_http_client__WEBPACK_IMPORTED_MODULE_4__["HttpClient"],
        module_error_error_manager__WEBPACK_IMPORTED_MODULE_5__["ErrorManager"]])
], DataLoaderDialog);



/***/ }),

/***/ "module/data-upload/data-loader-dialog.html":
/*!********************************************************!*\
  !*** ./SPA/module/data-upload/data-loader-dialog.html ***!
  \********************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = "<template>\r\n    <require from=\"module/data-upload/elements/data-loader-setup\"></require>\r\n    <ux-dialog>\r\n        <ux-dialog-header>\r\n            <h1>Upload file${dataUploadInfo.fileInfos.length > 1 ? 's' : ''}</h1>\r\n        </ux-dialog-header>\r\n        <ux-dialog-body class=\"data-loader-dialog\">\r\n            <div show.bind=\"!isSaving\" class=\"data-loader-file\">                \r\n                <data-loader-setup data-upload-info.bind=\"dataUploadInfo\"></data-loader-setup>\r\n            </div>\r\n            <div if.bind=\"isSaving\" class=\"text-center\">\r\n                ${saveProgressText}\r\n                <div if.bind=\"currentProgressPct < 100\" style=\"border:1px solid #bbb; height: 30px; width: 100%;\">\r\n                    <div css=\"height:100%; background-color:#bbb; width: ${currentProgressPct}%\"></div>    \r\n                </div>\r\n                <div class=\"loading\" if.bind=\"currentProgressPct === 100\"></div>\r\n            </div>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <button click.delegate=\"save()\" disabled.bind=\"!canSave\">OK</button>\r\n            <button class=\"btn-link\" disabled.bind=\"isSaving\" click.delegate=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ }),

/***/ "module/data-upload/elements/data-loader-setup":
/*!**************************************************************!*\
  !*** ./SPA/module/data-upload/elements/data-loader-setup.ts ***!
  \**************************************************************/
/*! exports provided: DataLoaderSetup */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataLoaderSetup", function() { return DataLoaderSetup; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _data_upload_info__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../data-upload-info */ "./SPA/module/data-upload/data-upload-info.ts");




let DataLoaderSetup = class DataLoaderSetup {
    bind() {
        this.dataUploadInfoChanged();
    }
    dataUploadInfoChanged() {
        if (this.dataUploadInfo.hasPlugins()) {
            this.dataUploadInfo.selectedPlugin = this.dataUploadInfo.plugins[0];
            this.updateViews(this.dataUploadInfo.selectedPlugin);
        }
    }
    pluginSelected(selectedPlugin) {
        this.updateViews(selectedPlugin);
        return true;
    }
    updateOptionsView(plugin) {
        if (plugin.optionsView) {
            let view = plugin.optionsView();
            if (view) {
                view = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["PluginUtils"].cleanView(view);
                this.optionsView = new aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["InlineViewStrategy"](`<template>${view}</template>`);
            }
        }
    }
    updateViews(plugin) {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            this.entitiesView = null;
            this.optionsView = null;
            try {
                this.dataUploadInfo.hasPluginExecuted = false;
                this.dataUploadInfo.error = null;
                if (plugin.readFiles) {
                    yield plugin.readFiles();
                }
                if (plugin.entitiesView) {
                    let view = plugin.entitiesView();
                    if (view) {
                        view = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["PluginUtils"].cleanView(view);
                        this.entitiesView = new aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["InlineViewStrategy"](`<template>${view}</template>`);
                    }
                }
                this.dataUploadInfo.hasPluginExecuted = true;
            }
            catch (error) {
                this.dataUploadInfo.error = error;
                console.error(error);
            }
            finally {
                this.updateOptionsView(plugin);
            }
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["bindable"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", _data_upload_info__WEBPACK_IMPORTED_MODULE_3__["DataUploadInfo"])
], DataLoaderSetup.prototype, "dataUploadInfo", void 0);
DataLoaderSetup = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    Object(aurelia_framework__WEBPACK_IMPORTED_MODULE_2__["customElement"])('data-loader-setup')
], DataLoaderSetup);



/***/ }),

/***/ "module/data-upload/elements/data-loader-setup.html":
/*!****************************************************************!*\
  !*** ./SPA/module/data-upload/elements/data-loader-setup.html ***!
  \****************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <form if.bind=\"dataUploadInfo.hasPlugins()\">\r\n        <div class=\"data-loader-settings\">\r\n            <div class=\"data-loader-select\" if.bind=\"dataUploadInfo.plugins.length > 1 || dataUploadInfo.selectedPlugin && dataUploadInfo.selectedPlugin.optionsView\">\r\n                <h4>Choose data loader</h4>\r\n                <div repeat.for=\"plugin of dataUploadInfo.plugins\">\r\n                    <label>\r\n                        <input type=\"radio\" name=\"dataLoader\" model.bind=\"plugin\" checked.bind=\"dataUploadInfo.selectedPlugin\" click.delegate=\"pluginSelected(plugin)\" />\r\n                        ${plugin.$METADATA.name}\r\n                    </label>\r\n                    <span class=\"plugin-description\">\r\n                        ${plugin.$METADATA.description}\r\n                    </span>\r\n                </div>\r\n            </div>\r\n            <div class=\"data-loader-options\" if.bind=\"optionsView\">\r\n                <form>\r\n                    <compose repeat.for=\"plugin of dataUploadInfo.plugins\" \r\n                        if.bind=\"plugin === dataUploadInfo.selectedPlugin\" \r\n                        view-model.bind=\"plugin\" \r\n                        view.bind=\"optionsView\"\r\n                        containerLess></compose>\r\n                </form>\r\n            </div>\r\n            <div class=\"loading\" if.bind=\"!optionsView && !dataUploadInfo.hasPluginExecuted && !dataUploadInfo.error\"></div>\r\n        </div>\r\n    </form>\r\n    <div class=\"data-loader-no-plugins\" else>\r\n        <br/>\r\n        No matching data loaders for file(s).\r\n    </div>\r\n    \r\n    <br/>\r\n    <div class=\"error\" if.bind=\"dataUploadInfo.error\">\r\n        <label>Error</label>\r\n        <p innerhtml.bind=\"dataUploadInfo.error.message\"></p>\r\n    </div>\r\n\r\n    <div if.bind=\"!dataUploadInfo.error && entitiesView\">\r\n        <br/>\r\n        <compose repeat.for=\"plugin of dataUploadInfo.plugins\" \r\n                    if.bind=\"plugin === dataUploadInfo.selectedPlugin\" \r\n                    view-model.bind=\"plugin\" \r\n                    view.bind=\"entitiesView\"\r\n                    containerLess></compose>\r\n    </div>\r\n    \r\n    <br/>\r\n    <div style=\"background-color: #dddddd; border-radius: 5px; padding: 8px;\">\r\n        <table class=\"full-width\" style=\"font-size:90%;\">\r\n            <thead>\r\n                <tr>\r\n                    <th>Filename</th>\r\n                    <th>Date modified</th>\r\n                    <th class=\"number\">Size</th>\r\n                </tr>\r\n            </thead>\r\n            <tbody>\r\n                <tr repeat.for=\"fileInfo of dataUploadInfo.context.fileInfos\">\r\n                    <td>${fileInfo.filename}</td>\r\n                    <td>${fileInfo.file.lastModifiedDate | dateTimeFormat }</td>\r\n                    <td class=\"number\">${fileInfo.file.size / 1000 | fixed: 1} KB</td>\r\n                </tr>\r\n            </tbody>\r\n        </table>\r\n    </div>\r\n</template>";

/***/ }),

/***/ "module/pns/child-sample/child-sample-dialog":
/*!************************************************************!*\
  !*** ./SPA/module/pns/child-sample/child-sample-dialog.ts ***!
  \************************************************************/
/*! exports provided: ChildSampleDialog */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(Promise) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ChildSampleDialog", function() { return ChildSampleDialog; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "./node_modules/tslib/tslib.es6.js");
/* harmony import */ var _scifeon_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @scifeon/core */ "./packages/core/index.ts");
/* harmony import */ var _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @scifeon/ui */ "./packages/ui/index.ts");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! aurelia-framework */ "aurelia-framework");
/* harmony import */ var aurelia_framework__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(aurelia_framework__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! aurelia-router */ "./node_modules/aurelia-router/dist/commonjs/aurelia-router.js");
/* harmony import */ var aurelia_router__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(aurelia_router__WEBPACK_IMPORTED_MODULE_4__);





let ChildSampleDialog = class ChildSampleDialog {
    constructor(dialog, server, router) {
        this.dialog = dialog;
        this.server = server;
        this.router = router;
        this.newChildSample = {};
        this.view = () => __webpack_require__(/*! ./child-sample-dialog.html */ "module/pns/child-sample/child-sample-dialog.html");
    }
    init(model) {
        this.model = model;
        this.newChildSample.type = this.model.type;
        this.newChildSample.status = _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["Status"].INITIAL;
        this.initializeForm();
    }
    initializeForm() {
        const smpFormats = ['Vial', 'Tube'];
        if (this.model.plateID !== null)
            smpFormats.push('Well');
        this.columns = [
            {
                name: 'name',
                form: {
                    label: 'Name',
                    editor: 'text',
                    isRequired: true
                }
            },
            {
                name: 'format',
                form: {
                    label: 'Format',
                    editor: 'select',
                    isRequired: true,
                    options: 'options:' + smpFormats.join(',')
                }
            },
            {
                name: 'type',
                form: {
                    label: 'Type',
                    editor: 'autocomplete',
                    isRequired: true
                }
            },
            {
                name: 'status',
                form: {
                    label: 'Status',
                    editor: 'autocomplete',
                    isRequired: true
                }
            }
        ];
    }
    create() {
        return tslib__WEBPACK_IMPORTED_MODULE_0__["__awaiter"](this, void 0, void 0, function* () {
            if (!this.canSave)
                return;
            this.loading = true;
            this.newChildSample.id = '#idSmp';
            this.newChildSample.parentID = this.model.id;
            this.newChildSample.eClass = this.model.eClass;
            const response = yield this.server.saveEntities([this.newChildSample]);
            let smp = response.newEntities.find(e => e.eClass === 'Sample');
            this.router.navigate('/entity/Sample/' + smp.id);
        });
    }
};
tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    _scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"].enterKeyPressedAction,
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:type", Function),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", []),
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:returntype", Promise)
], ChildSampleDialog.prototype, "create", null);
ChildSampleDialog = tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"]([
    aurelia_framework__WEBPACK_IMPORTED_MODULE_3__["autoinject"],
    tslib__WEBPACK_IMPORTED_MODULE_0__["__metadata"]("design:paramtypes", [_scifeon_ui__WEBPACK_IMPORTED_MODULE_2__["Dialog"], _scifeon_core__WEBPACK_IMPORTED_MODULE_1__["ServerAPI"], aurelia_router__WEBPACK_IMPORTED_MODULE_4__["Router"]])
], ChildSampleDialog);


/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(/*! bluebird */ "./node_modules/bluebird/js/browser/bluebird.js")))

/***/ }),

/***/ "module/pns/child-sample/child-sample-dialog.html":
/*!**************************************************************!*\
  !*** ./SPA/module/pns/child-sample/child-sample-dialog.html ***!
  \**************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = "<template>\r\n    <ux-dialog style=\"width:500px\">\r\n        <ux-dialog-header>\r\n            <h2>Create Child Sample</h2>\r\n        </ux-dialog-header>\r\n        <ux-dialog-body>\r\n            <entity-form e-class=\"sample\" horizontal=\"false\" columns.bind=\"columns\" object.bind=\"newChildSample\" valid.bind=\"canSave\"></entity-form>\r\n        </ux-dialog-body>\r\n        <ux-dialog-footer>\r\n            <span class=\"loading\" if.bind=\"loading\">-</span>\r\n            <button click.delegate=\"create()\" disabled.bind=\"!canSave && !loading\">OK</button>\r\n            <button class=\"btn-link\" click.trigger=\"dialog.cancel()\">Cancel</button>\r\n        </ux-dialog-footer>\r\n    </ux-dialog>\r\n</template>";

/***/ })

}]);
//# sourceMappingURL=eln~entity.7d2e17d8ae74be98b4b6.js.map